/* Include files */

#include "NonlinLuenbergObs_sfun.h"
#include "NonlinLuenbergObs_sfun_debug_macros.h"
#include "c1_NonlinLuenbergObs.h"
#include "c2_NonlinLuenbergObs.h"
#include "c3_NonlinLuenbergObs.h"
#include "c4_NonlinLuenbergObs.h"
#include "c5_NonlinLuenbergObs.h"
#include "c6_NonlinLuenbergObs.h"
#include "c22_NonlinLuenbergObs.h"
#include "c23_NonlinLuenbergObs.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
uint32_T _NonlinLuenbergObsMachineNumber_;
real_T _sfTime_;

/* Function Declarations */

/* Function Definitions */
void NonlinLuenbergObs_initializer(void)
{
}

void NonlinLuenbergObs_terminator(void)
{
}

/* SFunction Glue Code */
unsigned int sf_NonlinLuenbergObs_method_dispatcher(SimStruct *simstructPtr,
  unsigned int chartFileNumber, const char* specsCksum, int_T method, void *data)
{
  if (chartFileNumber==1) {
    c1_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==2) {
    c2_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==3) {
    c3_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==4) {
    c4_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==5) {
    c5_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==6) {
    c6_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==22) {
    c22_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  if (chartFileNumber==23) {
    c23_NonlinLuenbergObs_method_dispatcher(simstructPtr, method, data);
    return 1;
  }

  return 0;
}

unsigned int sf_NonlinLuenbergObs_process_check_sum_call( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[20];
  if (nrhs<1 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the checksum */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"sf_get_check_sum"))
    return 0;
  plhs[0] = mxCreateDoubleMatrix( 1,4,mxREAL);
  if (nrhs>1 && mxIsChar(prhs[1])) {
    mxGetString(prhs[1], commandName,sizeof(commandName)/sizeof(char));
    commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
    if (!strcmp(commandName,"machine")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(201663500U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4176617125U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3647388549U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1646565235U);
    } else if (!strcmp(commandName,"exportedFcn")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0U);
    } else if (!strcmp(commandName,"makefile")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1624798857U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(676473282U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1036395877U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1024666756U);
    } else if (nrhs==3 && !strcmp(commandName,"chart")) {
      unsigned int chartFileNumber;
      chartFileNumber = (unsigned int)mxGetScalar(prhs[2]);
      switch (chartFileNumber) {
       case 1:
        {
          extern void sf_c1_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c1_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 2:
        {
          extern void sf_c2_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c2_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 3:
        {
          extern void sf_c3_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c3_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 4:
        {
          extern void sf_c4_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c4_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 5:
        {
          extern void sf_c5_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c5_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 6:
        {
          extern void sf_c6_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c6_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 22:
        {
          extern void sf_c22_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c22_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       case 23:
        {
          extern void sf_c23_NonlinLuenbergObs_get_check_sum(mxArray *plhs[]);
          sf_c23_NonlinLuenbergObs_get_check_sum(plhs);
          break;
        }

       default:
        ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(0.0);
        ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(0.0);
      }
    } else if (!strcmp(commandName,"target")) {
      ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3564696471U);
      ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(678668628U);
      ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1090454852U);
      ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3896867807U);
    } else {
      return 0;
    }
  } else {
    ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2233295870U);
    ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3773486411U);
    ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3405361643U);
    ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2260621697U);
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_NonlinLuenbergObs_autoinheritance_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[32];
  char aiChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]) )
    return 0;

  /* Possible call to get the autoinheritance_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_autoinheritance_info"))
    return 0;
  mxGetString(prhs[2], aiChksum,sizeof(aiChksum)/sizeof(char));
  aiChksum[(sizeof(aiChksum)/sizeof(char)-1)] = '\0';

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        if (strcmp(aiChksum, "I3iT8DFmKra05Dul3XGTwF") == 0) {
          extern mxArray *sf_c1_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c1_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 2:
      {
        if (strcmp(aiChksum, "lHcXMl1odpTJGai646y3AD") == 0) {
          extern mxArray *sf_c2_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c2_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 3:
      {
        if (strcmp(aiChksum, "s7kPxkGmHXGd9pfQhEnSZG") == 0) {
          extern mxArray *sf_c3_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c3_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 4:
      {
        if (strcmp(aiChksum, "1PR9WiUpGvbN1dLKvpHfdD") == 0) {
          extern mxArray *sf_c4_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c4_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 5:
      {
        if (strcmp(aiChksum, "Ghl4xKAeifkfSpAFBt7c2C") == 0) {
          extern mxArray *sf_c5_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c5_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 6:
      {
        if (strcmp(aiChksum, "JqmsaSmeG8hB6JJRhK1TgC") == 0) {
          extern mxArray *sf_c6_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c6_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 22:
      {
        if (strcmp(aiChksum, "Toc5ImqAmxTFieMhpldWQ") == 0) {
          extern mxArray *sf_c22_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c22_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     case 23:
      {
        if (strcmp(aiChksum, "8WZDrGS3fAvVZTbiIEfzHG") == 0) {
          extern mxArray *sf_c23_NonlinLuenbergObs_get_autoinheritance_info(void);
          plhs[0] = sf_c23_NonlinLuenbergObs_get_autoinheritance_info();
          break;
        }

        plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_NonlinLuenbergObs_get_eml_resolved_functions_info( int nlhs,
  mxArray * plhs[], int nrhs, const mxArray * prhs[] )
{

#ifdef MATLAB_MEX_FILE

  char commandName[64];
  if (nrhs<2 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the get_eml_resolved_functions_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_eml_resolved_functions_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        extern const mxArray
          *sf_c1_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c1_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 2:
      {
        extern const mxArray
          *sf_c2_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c2_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 3:
      {
        extern const mxArray
          *sf_c3_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c3_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 4:
      {
        extern const mxArray
          *sf_c4_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c4_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 5:
      {
        extern const mxArray
          *sf_c5_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c5_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 6:
      {
        extern const mxArray
          *sf_c6_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c6_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 22:
      {
        extern const mxArray
          *sf_c22_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c22_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     case 23:
      {
        extern const mxArray
          *sf_c23_NonlinLuenbergObs_get_eml_resolved_functions_info(void);
        mxArray *persistentMxArray = (mxArray *)
          sf_c23_NonlinLuenbergObs_get_eml_resolved_functions_info();
        plhs[0] = mxDuplicateArray(persistentMxArray);
        mxDestroyArray(persistentMxArray);
        break;
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;

#else

  return 0;

#endif

}

unsigned int sf_NonlinLuenbergObs_third_party_uses_info( int nlhs, mxArray *
  plhs[], int nrhs, const mxArray * prhs[] )
{
  char commandName[64];
  char tpChksum[64];
  if (nrhs<3 || !mxIsChar(prhs[0]))
    return 0;

  /* Possible call to get the third_party_uses_info */
  mxGetString(prhs[0], commandName,sizeof(commandName)/sizeof(char));
  commandName[(sizeof(commandName)/sizeof(char)-1)] = '\0';
  mxGetString(prhs[2], tpChksum,sizeof(tpChksum)/sizeof(char));
  tpChksum[(sizeof(tpChksum)/sizeof(char)-1)] = '\0';
  if (strcmp(commandName,"get_third_party_uses_info"))
    return 0;

  {
    unsigned int chartFileNumber;
    chartFileNumber = (unsigned int)mxGetScalar(prhs[1]);
    switch (chartFileNumber) {
     case 1:
      {
        if (strcmp(tpChksum, "iRw19unXVdlnBIOKwr6weC") == 0) {
          extern mxArray *sf_c1_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c1_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 2:
      {
        if (strcmp(tpChksum, "ZSmO25tPnaFLSGiF5PZj2G") == 0) {
          extern mxArray *sf_c2_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c2_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 3:
      {
        if (strcmp(tpChksum, "wPYKaYILQh1NbjiLN0x71") == 0) {
          extern mxArray *sf_c3_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c3_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 4:
      {
        if (strcmp(tpChksum, "Dq9zP2ysvvVSk17bU9W2tH") == 0) {
          extern mxArray *sf_c4_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c4_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 5:
      {
        if (strcmp(tpChksum, "YLIEQVRUPAbRUD6vHIV31F") == 0) {
          extern mxArray *sf_c5_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c5_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 6:
      {
        if (strcmp(tpChksum, "4a9p7CeRYKKzCkDdkdJ3bE") == 0) {
          extern mxArray *sf_c6_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c6_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 22:
      {
        if (strcmp(tpChksum, "9jUmRtOhktq3vJ6f8VjeFD") == 0) {
          extern mxArray *sf_c22_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c22_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     case 23:
      {
        if (strcmp(tpChksum, "Y1e8hRroABckeFXUhbYOdE") == 0) {
          extern mxArray *sf_c23_NonlinLuenbergObs_third_party_uses_info(void);
          plhs[0] = sf_c23_NonlinLuenbergObs_third_party_uses_info();
          break;
        }
      }

     default:
      plhs[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    }
  }

  return 1;
}

void NonlinLuenbergObs_debug_initialize(struct SfDebugInstanceStruct*
  debugInstance)
{
  _NonlinLuenbergObsMachineNumber_ = sf_debug_initialize_machine(debugInstance,
    "NonlinLuenbergObs","sfun",0,8,0,0,0);
  sf_debug_set_machine_event_thresholds(debugInstance,
    _NonlinLuenbergObsMachineNumber_,0,0);
  sf_debug_set_machine_data_thresholds(debugInstance,
    _NonlinLuenbergObsMachineNumber_,0);
}

void NonlinLuenbergObs_register_exported_symbols(SimStruct* S)
{
}

static mxArray* sRtwOptimizationInfoStruct= NULL;
mxArray* load_NonlinLuenbergObs_optimization_info(void)
{
  if (sRtwOptimizationInfoStruct==NULL) {
    sRtwOptimizationInfoStruct = sf_load_rtw_optimization_info(
      "NonlinLuenbergObs", "NonlinLuenbergObs");
    mexMakeArrayPersistent(sRtwOptimizationInfoStruct);
  }

  return(sRtwOptimizationInfoStruct);
}

void unload_NonlinLuenbergObs_optimization_info(void)
{
  if (sRtwOptimizationInfoStruct!=NULL) {
    mxDestroyArray(sRtwOptimizationInfoStruct);
    sRtwOptimizationInfoStruct = NULL;
  }
}
