/* Include files */

#include <stddef.h>
#include "blas.h"
#include "NonlinLuenbergObs_sfun.h"
#include "c3_NonlinLuenbergObs.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "NonlinLuenbergObs_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c3_debug_family_names[42] = { "H", "D_fw", "T_e", "T_f",
  "r_f", "r_s", "x_s", "omega0", "i_f0", "omega", "p", "q", "abs_v_ll", "L", "A",
  "B", "f_uy", "C", "D", "hat_y", "tilde_y", "nargin", "nargout", "y",
  "u_vector", "hat_x", "x_0", "H_G", "D_fw_G", "z_G", "tau_e_G", "tau_f_G",
  "r_f_G", "GeneratorNumber", "omega_b", "hat_omega", "hat_p", "hat_q",
  "tilde_omega", "tilde_p", "tilde_q", "d_hat_x" };

/* Function Declarations */
static void initialize_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void initialize_params_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static void enable_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void disable_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void c3_update_debugger_state_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static void set_sim_state_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance, const mxArray *c3_st);
static void finalize_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void sf_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void c3_chartstep_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static void initSimStructsc3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static void registerMessagesc3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber);
static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData);
static void c3_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_d_hat_x, const char_T *c3_identifier, real_T
  c3_y[4]);
static void c3_b_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[4]);
static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static real_T c3_c_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_tilde_q, const char_T *c3_identifier);
static real_T c3_d_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_c_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_e_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[3]);
static void c3_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_d_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_f_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[6]);
static void c3_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_e_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_g_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[12]);
static void c3_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_f_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_h_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[16]);
static void c3_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_g_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[21]);
static real_T c3_mpower(SFc3_NonlinLuenbergObsInstanceStruct *chartInstance,
  real_T c3_a);
static void c3_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct *chartInstance);
static void c3_b_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void c3_c_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static void c3_d_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);
static const mxArray *c3_h_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static int32_T c3_i_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static uint8_T c3_j_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_b_is_active_c3_NonlinLuenbergObs, const
  char_T *c3_identifier);
static uint8_T c3_k_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void init_dsm_address_info(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
  chartInstance->c3_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c3_is_active_c3_NonlinLuenbergObs = 0U;
}

static void initialize_params_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
  real_T c3_dv0[4];
  int32_T c3_i0;
  real_T c3_dv1[3];
  int32_T c3_i1;
  real_T c3_dv2[3];
  int32_T c3_i2;
  real_T c3_dv3[6];
  int32_T c3_i3;
  real_T c3_dv4[3];
  int32_T c3_i4;
  real_T c3_dv5[3];
  int32_T c3_i5;
  real_T c3_dv6[3];
  int32_T c3_i6;
  real_T c3_d0;
  real_T c3_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'x_0' in the parent workspace.\n");
  sf_mex_import_named("x_0", sf_mex_get_sfun_param(chartInstance->S, 7, 0),
                      c3_dv0, 0, 0, 0U, 1, 0U, 1, 4);
  for (c3_i0 = 0; c3_i0 < 4; c3_i0++) {
    chartInstance->c3_x_0[c3_i0] = c3_dv0[c3_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'H_G' in the parent workspace.\n");
  sf_mex_import_named("H_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c3_dv1, 0, 0, 0U, 1, 0U, 1, 3);
  for (c3_i1 = 0; c3_i1 < 3; c3_i1++) {
    chartInstance->c3_H_G[c3_i1] = c3_dv1[c3_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_fw_G' in the parent workspace.\n");
  sf_mex_import_named("D_fw_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c3_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c3_i2 = 0; c3_i2 < 3; c3_i2++) {
    chartInstance->c3_D_fw_G[c3_i2] = c3_dv2[c3_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'z_G' in the parent workspace.\n");
  sf_mex_import_named("z_G", sf_mex_get_sfun_param(chartInstance->S, 8, 0),
                      c3_dv3, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c3_i3 = 0; c3_i3 < 6; c3_i3++) {
    chartInstance->c3_z_G[c3_i3] = c3_dv3[c3_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_e_G' in the parent workspace.\n");
  sf_mex_import_named("tau_e_G", sf_mex_get_sfun_param(chartInstance->S, 5, 0),
                      c3_dv4, 0, 0, 0U, 1, 0U, 1, 3);
  for (c3_i4 = 0; c3_i4 < 3; c3_i4++) {
    chartInstance->c3_tau_e_G[c3_i4] = c3_dv4[c3_i4];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_f_G' in the parent workspace.\n");
  sf_mex_import_named("tau_f_G", sf_mex_get_sfun_param(chartInstance->S, 6, 0),
                      c3_dv5, 0, 0, 0U, 1, 0U, 1, 3);
  for (c3_i5 = 0; c3_i5 < 3; c3_i5++) {
    chartInstance->c3_tau_f_G[c3_i5] = c3_dv5[c3_i5];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'r_f_G' in the parent workspace.\n");
  sf_mex_import_named("r_f_G", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      c3_dv6, 0, 0, 0U, 1, 0U, 1, 3);
  for (c3_i6 = 0; c3_i6 < 3; c3_i6++) {
    chartInstance->c3_r_f_G[c3_i6] = c3_dv6[c3_i6];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), &c3_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c3_GeneratorNumber = c3_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'omega_b' in the parent workspace.\n");
  sf_mex_import_named("omega_b", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c3_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c3_omega_b = c3_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c3_update_debugger_state_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
  const mxArray *c3_st;
  const mxArray *c3_y = NULL;
  int32_T c3_i7;
  real_T c3_u[4];
  const mxArray *c3_b_y = NULL;
  real_T c3_hoistedGlobal;
  real_T c3_b_u;
  const mxArray *c3_c_y = NULL;
  real_T c3_b_hoistedGlobal;
  real_T c3_c_u;
  const mxArray *c3_d_y = NULL;
  real_T c3_c_hoistedGlobal;
  real_T c3_d_u;
  const mxArray *c3_e_y = NULL;
  real_T c3_d_hoistedGlobal;
  real_T c3_e_u;
  const mxArray *c3_f_y = NULL;
  real_T c3_e_hoistedGlobal;
  real_T c3_f_u;
  const mxArray *c3_g_y = NULL;
  real_T c3_f_hoistedGlobal;
  real_T c3_g_u;
  const mxArray *c3_h_y = NULL;
  uint8_T c3_g_hoistedGlobal;
  uint8_T c3_h_u;
  const mxArray *c3_i_y = NULL;
  real_T *c3_hat_omega;
  real_T *c3_hat_p;
  real_T *c3_hat_q;
  real_T *c3_tilde_omega;
  real_T *c3_tilde_p;
  real_T *c3_tilde_q;
  real_T (*c3_d_hat_x)[4];
  c3_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c3_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c3_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c3_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_st = NULL;
  c3_st = NULL;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_createcellarray(8), FALSE);
  for (c3_i7 = 0; c3_i7 < 4; c3_i7++) {
    c3_u[c3_i7] = (*c3_d_hat_x)[c3_i7];
  }

  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c3_y, 0, c3_b_y);
  c3_hoistedGlobal = *c3_hat_omega;
  c3_b_u = c3_hoistedGlobal;
  c3_c_y = NULL;
  sf_mex_assign(&c3_c_y, sf_mex_create("y", &c3_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 1, c3_c_y);
  c3_b_hoistedGlobal = *c3_hat_p;
  c3_c_u = c3_b_hoistedGlobal;
  c3_d_y = NULL;
  sf_mex_assign(&c3_d_y, sf_mex_create("y", &c3_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 2, c3_d_y);
  c3_c_hoistedGlobal = *c3_hat_q;
  c3_d_u = c3_c_hoistedGlobal;
  c3_e_y = NULL;
  sf_mex_assign(&c3_e_y, sf_mex_create("y", &c3_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 3, c3_e_y);
  c3_d_hoistedGlobal = *c3_tilde_omega;
  c3_e_u = c3_d_hoistedGlobal;
  c3_f_y = NULL;
  sf_mex_assign(&c3_f_y, sf_mex_create("y", &c3_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 4, c3_f_y);
  c3_e_hoistedGlobal = *c3_tilde_p;
  c3_f_u = c3_e_hoistedGlobal;
  c3_g_y = NULL;
  sf_mex_assign(&c3_g_y, sf_mex_create("y", &c3_f_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 5, c3_g_y);
  c3_f_hoistedGlobal = *c3_tilde_q;
  c3_g_u = c3_f_hoistedGlobal;
  c3_h_y = NULL;
  sf_mex_assign(&c3_h_y, sf_mex_create("y", &c3_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 6, c3_h_y);
  c3_g_hoistedGlobal = chartInstance->c3_is_active_c3_NonlinLuenbergObs;
  c3_h_u = c3_g_hoistedGlobal;
  c3_i_y = NULL;
  sf_mex_assign(&c3_i_y, sf_mex_create("y", &c3_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 7, c3_i_y);
  sf_mex_assign(&c3_st, c3_y, FALSE);
  return c3_st;
}

static void set_sim_state_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance, const mxArray *c3_st)
{
  const mxArray *c3_u;
  real_T c3_dv7[4];
  int32_T c3_i8;
  real_T *c3_hat_omega;
  real_T *c3_hat_p;
  real_T *c3_hat_q;
  real_T *c3_tilde_omega;
  real_T *c3_tilde_p;
  real_T *c3_tilde_q;
  real_T (*c3_d_hat_x)[4];
  c3_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c3_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c3_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c3_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c3_doneDoubleBufferReInit = TRUE;
  c3_u = sf_mex_dup(c3_st);
  c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 0)),
                      "d_hat_x", c3_dv7);
  for (c3_i8 = 0; c3_i8 < 4; c3_i8++) {
    (*c3_d_hat_x)[c3_i8] = c3_dv7[c3_i8];
  }

  *c3_hat_omega = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c3_u, 1)), "hat_omega");
  *c3_hat_p = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c3_u, 2)), "hat_p");
  *c3_hat_q = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c3_u, 3)), "hat_q");
  *c3_tilde_omega = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c3_u, 4)), "tilde_omega");
  *c3_tilde_p = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c3_u, 5)), "tilde_p");
  *c3_tilde_q = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c3_u, 6)), "tilde_q");
  chartInstance->c3_is_active_c3_NonlinLuenbergObs = c3_j_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 7)),
     "is_active_c3_NonlinLuenbergObs");
  sf_mex_destroy(&c3_u);
  c3_update_debugger_state_c3_NonlinLuenbergObs(chartInstance);
  sf_mex_destroy(&c3_st);
}

static void finalize_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
}

static void sf_c3_NonlinLuenbergObs(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
  int32_T c3_i9;
  int32_T c3_i10;
  int32_T c3_i11;
  int32_T c3_i12;
  int32_T c3_i13;
  int32_T c3_i14;
  int32_T c3_i15;
  int32_T c3_i16;
  int32_T c3_i17;
  int32_T c3_i18;
  int32_T c3_i19;
  real_T *c3_hat_omega;
  real_T *c3_hat_p;
  real_T *c3_hat_q;
  real_T *c3_tilde_omega;
  real_T *c3_tilde_p;
  real_T *c3_tilde_q;
  real_T (*c3_d_hat_x)[4];
  real_T (*c3_hat_x)[4];
  real_T (*c3_u_vector)[4];
  real_T (*c3_y)[3];
  c3_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c3_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c3_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c3_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c3_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c3_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c3_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c3_hat_omega, 0U);
  _SFD_DATA_RANGE_CHECK(*c3_hat_p, 1U);
  _SFD_DATA_RANGE_CHECK(*c3_hat_q, 2U);
  _SFD_DATA_RANGE_CHECK(*c3_tilde_omega, 3U);
  _SFD_DATA_RANGE_CHECK(*c3_tilde_p, 4U);
  _SFD_DATA_RANGE_CHECK(*c3_tilde_q, 5U);
  for (c3_i9 = 0; c3_i9 < 3; c3_i9++) {
    _SFD_DATA_RANGE_CHECK((*c3_y)[c3_i9], 6U);
  }

  for (c3_i10 = 0; c3_i10 < 4; c3_i10++) {
    _SFD_DATA_RANGE_CHECK((*c3_u_vector)[c3_i10], 7U);
  }

  for (c3_i11 = 0; c3_i11 < 4; c3_i11++) {
    _SFD_DATA_RANGE_CHECK((*c3_hat_x)[c3_i11], 8U);
  }

  for (c3_i12 = 0; c3_i12 < 4; c3_i12++) {
    _SFD_DATA_RANGE_CHECK((*c3_d_hat_x)[c3_i12], 9U);
  }

  for (c3_i13 = 0; c3_i13 < 4; c3_i13++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_x_0[c3_i13], 10U);
  }

  for (c3_i14 = 0; c3_i14 < 3; c3_i14++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_H_G[c3_i14], 11U);
  }

  for (c3_i15 = 0; c3_i15 < 3; c3_i15++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_D_fw_G[c3_i15], 12U);
  }

  for (c3_i16 = 0; c3_i16 < 6; c3_i16++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_z_G[c3_i16], 13U);
  }

  for (c3_i17 = 0; c3_i17 < 3; c3_i17++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_tau_e_G[c3_i17], 14U);
  }

  for (c3_i18 = 0; c3_i18 < 3; c3_i18++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_tau_f_G[c3_i18], 15U);
  }

  for (c3_i19 = 0; c3_i19 < 3; c3_i19++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c3_r_f_G[c3_i19], 16U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c3_GeneratorNumber, 17U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c3_omega_b, 18U);
  chartInstance->c3_sfEvent = CALL_EVENT;
  c3_chartstep_c3_NonlinLuenbergObs(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_NonlinLuenbergObsMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c3_chartstep_c3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
  real_T c3_hoistedGlobal;
  real_T c3_b_hoistedGlobal;
  int32_T c3_i20;
  real_T c3_y[3];
  int32_T c3_i21;
  real_T c3_u_vector[4];
  int32_T c3_i22;
  real_T c3_hat_x[4];
  int32_T c3_i23;
  real_T c3_b_x_0[4];
  int32_T c3_i24;
  real_T c3_b_H_G[3];
  int32_T c3_i25;
  real_T c3_b_D_fw_G[3];
  int32_T c3_i26;
  real_T c3_b_z_G[6];
  int32_T c3_i27;
  real_T c3_b_tau_e_G[3];
  int32_T c3_i28;
  real_T c3_b_tau_f_G[3];
  int32_T c3_i29;
  real_T c3_b_r_f_G[3];
  real_T c3_b_GeneratorNumber;
  real_T c3_b_omega_b;
  uint32_T c3_debug_family_var_map[42];
  real_T c3_H;
  real_T c3_D_fw;
  real_T c3_T_e;
  real_T c3_T_f;
  real_T c3_r_f;
  real_T c3_r_s;
  real_T c3_x_s;
  real_T c3_omega0;
  real_T c3_i_f0;
  real_T c3_omega;
  real_T c3_p;
  real_T c3_q;
  real_T c3_abs_v_ll;
  real_T c3_L[12];
  real_T c3_A[16];
  real_T c3_B[16];
  real_T c3_f_uy[4];
  real_T c3_C[12];
  real_T c3_D[12];
  real_T c3_hat_y[3];
  real_T c3_tilde_y[3];
  real_T c3_nargin = 12.0;
  real_T c3_nargout = 7.0;
  real_T c3_hat_omega;
  real_T c3_hat_p;
  real_T c3_hat_q;
  real_T c3_tilde_omega;
  real_T c3_tilde_p;
  real_T c3_tilde_q;
  real_T c3_d_hat_x[4];
  int32_T c3_i30;
  real_T c3_b;
  real_T c3_b_y;
  real_T c3_b_B;
  real_T c3_c_y;
  real_T c3_d_y;
  real_T c3_e_y;
  real_T c3_a;
  real_T c3_b_b;
  real_T c3_f_y;
  real_T c3_c_b;
  real_T c3_g_y;
  real_T c3_c_B;
  real_T c3_h_y;
  real_T c3_i_y;
  real_T c3_j_y;
  real_T c3_d_B;
  real_T c3_k_y;
  real_T c3_l_y;
  real_T c3_m_y;
  real_T c3_e_B;
  real_T c3_n_y;
  real_T c3_o_y;
  real_T c3_p_y;
  real_T c3_b_A;
  real_T c3_f_B;
  real_T c3_x;
  real_T c3_q_y;
  real_T c3_b_x;
  real_T c3_r_y;
  real_T c3_s_y;
  real_T c3_b_a;
  real_T c3_d_b;
  real_T c3_t_y;
  real_T c3_g_B;
  real_T c3_u_y;
  real_T c3_v_y;
  real_T c3_w_y;
  int32_T c3_i31;
  int32_T c3_i32;
  real_T c3_e_b;
  real_T c3_x_y;
  real_T c3_h_B;
  real_T c3_y_y;
  real_T c3_ab_y;
  real_T c3_bb_y;
  real_T c3_c_A;
  real_T c3_i_B;
  real_T c3_c_x;
  real_T c3_cb_y;
  real_T c3_d_x;
  real_T c3_db_y;
  real_T c3_eb_y;
  real_T c3_c_a;
  real_T c3_f_b;
  real_T c3_fb_y;
  real_T c3_d_a;
  real_T c3_g_b;
  real_T c3_gb_y;
  real_T c3_d_A;
  real_T c3_j_B;
  real_T c3_e_x;
  real_T c3_hb_y;
  real_T c3_f_x;
  real_T c3_ib_y;
  real_T c3_jb_y;
  real_T c3_e_a;
  real_T c3_h_b;
  real_T c3_kb_y;
  real_T c3_k_B;
  real_T c3_lb_y;
  real_T c3_mb_y;
  real_T c3_nb_y;
  real_T c3_l_B;
  real_T c3_ob_y;
  real_T c3_pb_y;
  real_T c3_qb_y;
  real_T c3_f_a;
  real_T c3_i_b;
  real_T c3_rb_y;
  real_T c3_g_a;
  real_T c3_j_b;
  real_T c3_sb_y;
  real_T c3_m_B;
  real_T c3_tb_y;
  real_T c3_ub_y;
  real_T c3_vb_y;
  real_T c3_h_a;
  real_T c3_k_b;
  real_T c3_wb_y;
  real_T c3_i_a;
  real_T c3_l_b;
  real_T c3_xb_y;
  int32_T c3_i33;
  int32_T c3_i34;
  static real_T c3_dv8[4] = { 0.0, 1.0, 0.0, 0.0 };

  real_T c3_n_B;
  real_T c3_yb_y;
  real_T c3_ac_y;
  real_T c3_bc_y;
  int32_T c3_i35;
  int32_T c3_i36;
  int32_T c3_i37;
  int32_T c3_i38;
  int32_T c3_i39;
  real_T c3_j_a[12];
  int32_T c3_i40;
  real_T c3_m_b[4];
  int32_T c3_i41;
  real_T c3_cc_y[3];
  int32_T c3_i42;
  int32_T c3_i43;
  int32_T c3_i44;
  int32_T c3_i45;
  int32_T c3_i46;
  real_T c3_dc_y[3];
  int32_T c3_i47;
  int32_T c3_i48;
  int32_T c3_i49;
  int32_T c3_i50;
  int32_T c3_i51;
  real_T c3_k_a[16];
  int32_T c3_i52;
  int32_T c3_i53;
  real_T c3_ec_y[4];
  int32_T c3_i54;
  int32_T c3_i55;
  int32_T c3_i56;
  int32_T c3_i57;
  int32_T c3_i58;
  real_T c3_fc_y[4];
  int32_T c3_i59;
  int32_T c3_i60;
  int32_T c3_i61;
  int32_T c3_i62;
  int32_T c3_i63;
  int32_T c3_i64;
  int32_T c3_i65;
  real_T *c3_b_hat_omega;
  real_T *c3_b_hat_p;
  real_T *c3_b_hat_q;
  real_T *c3_b_tilde_omega;
  real_T *c3_b_tilde_p;
  real_T *c3_b_tilde_q;
  real_T (*c3_b_d_hat_x)[4];
  real_T (*c3_b_hat_x)[4];
  real_T (*c3_b_u_vector)[4];
  real_T (*c3_gc_y)[3];
  c3_b_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c3_b_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c3_b_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c3_gc_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c3_b_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c3_b_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c3_b_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_b_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_b_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_b_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  c3_hoistedGlobal = chartInstance->c3_GeneratorNumber;
  c3_b_hoistedGlobal = chartInstance->c3_omega_b;
  for (c3_i20 = 0; c3_i20 < 3; c3_i20++) {
    c3_y[c3_i20] = (*c3_gc_y)[c3_i20];
  }

  for (c3_i21 = 0; c3_i21 < 4; c3_i21++) {
    c3_u_vector[c3_i21] = (*c3_b_u_vector)[c3_i21];
  }

  for (c3_i22 = 0; c3_i22 < 4; c3_i22++) {
    c3_hat_x[c3_i22] = (*c3_b_hat_x)[c3_i22];
  }

  for (c3_i23 = 0; c3_i23 < 4; c3_i23++) {
    c3_b_x_0[c3_i23] = chartInstance->c3_x_0[c3_i23];
  }

  for (c3_i24 = 0; c3_i24 < 3; c3_i24++) {
    c3_b_H_G[c3_i24] = chartInstance->c3_H_G[c3_i24];
  }

  for (c3_i25 = 0; c3_i25 < 3; c3_i25++) {
    c3_b_D_fw_G[c3_i25] = chartInstance->c3_D_fw_G[c3_i25];
  }

  for (c3_i26 = 0; c3_i26 < 6; c3_i26++) {
    c3_b_z_G[c3_i26] = chartInstance->c3_z_G[c3_i26];
  }

  for (c3_i27 = 0; c3_i27 < 3; c3_i27++) {
    c3_b_tau_e_G[c3_i27] = chartInstance->c3_tau_e_G[c3_i27];
  }

  for (c3_i28 = 0; c3_i28 < 3; c3_i28++) {
    c3_b_tau_f_G[c3_i28] = chartInstance->c3_tau_f_G[c3_i28];
  }

  for (c3_i29 = 0; c3_i29 < 3; c3_i29++) {
    c3_b_r_f_G[c3_i29] = chartInstance->c3_r_f_G[c3_i29];
  }

  c3_b_GeneratorNumber = c3_hoistedGlobal;
  c3_b_omega_b = c3_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 42U, 42U, c3_debug_family_names,
    c3_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_H, 0U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_D_fw, 1U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_T_e, 2U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_T_f, 3U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_r_f, 4U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_r_s, 5U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_x_s, 6U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_omega0, 7U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_i_f0, 8U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_omega, 9U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_p, 10U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_q, 11U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_abs_v_ll, 12U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c3_L, 13U, c3_g_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_A, 14U, c3_f_sf_marshallOut,
    c3_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_B, 15U, c3_f_sf_marshallOut,
    c3_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_f_uy, 16U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_C, 17U, c3_e_sf_marshallOut,
    c3_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_D, 18U, c3_e_sf_marshallOut,
    c3_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_hat_y, 19U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_tilde_y, 20U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_nargin, 21U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_nargout, 22U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c3_y, 23U, c3_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c3_u_vector, 24U, c3_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c3_hat_x, 25U, c3_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_x_0, 26U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_H_G, 27U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_D_fw_G, 28U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_z_G, 29U, c3_d_sf_marshallOut,
    c3_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_tau_e_G, 30U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_tau_f_G, 31U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_b_r_f_G, 32U, c3_c_sf_marshallOut,
    c3_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_b_GeneratorNumber, 33U,
    c3_b_sf_marshallOut, c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_b_omega_b, 34U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_hat_omega, 35U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_hat_p, 36U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_hat_q, 37U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_tilde_omega, 38U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_tilde_p, 39U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c3_tilde_q, 40U, c3_b_sf_marshallOut,
    c3_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c3_d_hat_x, 41U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 5);
  c3_H = c3_b_H_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("H_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 6);
  c3_D_fw = c3_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 7);
  c3_T_e = c3_b_tau_e_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_e_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 8);
  c3_T_f = c3_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 9);
  c3_r_f = c3_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 10);
  c3_r_s = c3_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 11);
  c3_x_s = c3_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c3_b_GeneratorNumber), 1, 3, 1, 0) + 2];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 12);
  c3_omega0 = c3_b_x_0[1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 13);
  c3_i_f0 = c3_b_x_0[3];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 15);
  c3_omega = c3_y[0];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 16);
  c3_p = c3_y[1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 17);
  c3_q = c3_y[2];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 18);
  c3_abs_v_ll = c3_u_vector[1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 20);
  for (c3_i30 = 0; c3_i30 < 12; c3_i30++) {
    c3_L[c3_i30] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 22);
  c3_b = c3_H;
  c3_b_y = 2.0 * c3_b;
  c3_b_B = c3_b_y;
  c3_c_y = c3_b_B;
  c3_d_y = c3_c_y;
  c3_e_y = 1.0 / c3_d_y;
  c3_a = -c3_e_y;
  c3_b_b = c3_D_fw;
  c3_f_y = c3_a * c3_b_b;
  c3_c_b = c3_H;
  c3_g_y = 2.0 * c3_c_b;
  c3_c_B = c3_g_y;
  c3_h_y = c3_c_B;
  c3_i_y = c3_h_y;
  c3_j_y = 1.0 / c3_i_y;
  c3_d_B = c3_T_e;
  c3_k_y = c3_d_B;
  c3_l_y = c3_k_y;
  c3_m_y = -1.0 / c3_l_y;
  c3_e_B = c3_T_f;
  c3_n_y = c3_e_B;
  c3_o_y = c3_n_y;
  c3_p_y = -1.0 / c3_o_y;
  c3_A[0] = 0.0;
  c3_A[4] = c3_b_omega_b;
  c3_A[8] = 0.0;
  c3_A[12] = 0.0;
  c3_A[1] = 0.0;
  c3_A[5] = c3_f_y;
  c3_A[9] = c3_j_y;
  c3_A[13] = 0.0;
  c3_A[2] = 0.0;
  c3_A[6] = 0.0;
  c3_A[10] = c3_m_y;
  c3_A[14] = 0.0;
  c3_A[3] = 0.0;
  c3_A[7] = 0.0;
  c3_A[11] = 0.0;
  c3_A[15] = c3_p_y;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 27);
  c3_b_A = c3_D_fw + 1.0;
  c3_f_B = c3_T_e;
  c3_x = c3_b_A;
  c3_q_y = c3_f_B;
  c3_b_x = c3_x;
  c3_r_y = c3_q_y;
  c3_s_y = c3_b_x / c3_r_y;
  c3_b_a = c3_T_f;
  c3_d_b = c3_r_f;
  c3_t_y = c3_b_a * c3_d_b;
  c3_g_B = c3_t_y;
  c3_u_y = c3_g_B;
  c3_v_y = c3_u_y;
  c3_w_y = 1.0 / c3_v_y;
  c3_B[0] = -c3_b_omega_b;
  c3_B[4] = 0.0;
  c3_B[8] = 0.0;
  c3_B[12] = 0.0;
  c3_i31 = 0;
  for (c3_i32 = 0; c3_i32 < 4; c3_i32++) {
    c3_B[c3_i31 + 1] = 0.0;
    c3_i31 += 4;
  }

  c3_B[2] = 0.0;
  c3_B[6] = 0.0;
  c3_B[10] = c3_s_y;
  c3_B[14] = 0.0;
  c3_B[3] = 0.0;
  c3_B[7] = 0.0;
  c3_B[11] = 0.0;
  c3_B[15] = c3_w_y;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 32);
  c3_e_b = c3_H;
  c3_x_y = 2.0 * c3_e_b;
  c3_h_B = c3_x_y;
  c3_y_y = c3_h_B;
  c3_ab_y = c3_y_y;
  c3_bb_y = 1.0 / c3_ab_y;
  c3_c_A = -c3_p;
  c3_i_B = c3_omega;
  c3_c_x = c3_c_A;
  c3_cb_y = c3_i_B;
  c3_d_x = c3_c_x;
  c3_db_y = c3_cb_y;
  c3_eb_y = c3_d_x / c3_db_y;
  c3_c_a = c3_r_s;
  c3_f_b = c3_mpower(chartInstance, c3_p) + c3_mpower(chartInstance, c3_q);
  c3_fb_y = c3_c_a * c3_f_b;
  c3_d_a = c3_omega;
  c3_g_b = c3_mpower(chartInstance, c3_abs_v_ll);
  c3_gb_y = c3_d_a * c3_g_b;
  c3_d_A = c3_fb_y;
  c3_j_B = c3_gb_y;
  c3_e_x = c3_d_A;
  c3_hb_y = c3_j_B;
  c3_f_x = c3_e_x;
  c3_ib_y = c3_hb_y;
  c3_jb_y = c3_f_x / c3_ib_y;
  c3_e_a = c3_bb_y;
  c3_h_b = c3_eb_y - c3_jb_y;
  c3_kb_y = c3_e_a * c3_h_b;
  c3_f_uy[0] = 0.0;
  c3_f_uy[1] = c3_kb_y;
  c3_f_uy[2] = 0.0;
  c3_f_uy[3] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 34);
  c3_k_B = c3_x_s;
  c3_lb_y = c3_k_B;
  c3_mb_y = c3_lb_y;
  c3_nb_y = 1.0 / c3_mb_y;
  c3_l_B = c3_x_s;
  c3_ob_y = c3_l_B;
  c3_pb_y = c3_ob_y;
  c3_qb_y = 1.0 / c3_pb_y;
  c3_f_a = c3_qb_y;
  c3_i_b = c3_r_f;
  c3_rb_y = c3_f_a * c3_i_b;
  c3_g_a = c3_rb_y;
  c3_j_b = c3_i_f0;
  c3_sb_y = c3_g_a * c3_j_b;
  c3_m_B = c3_x_s;
  c3_tb_y = c3_m_B;
  c3_ub_y = c3_tb_y;
  c3_vb_y = 1.0 / c3_ub_y;
  c3_h_a = c3_vb_y;
  c3_k_b = c3_r_f;
  c3_wb_y = c3_h_a * c3_k_b;
  c3_i_a = c3_wb_y;
  c3_l_b = c3_omega0;
  c3_xb_y = c3_i_a * c3_l_b;
  c3_i33 = 0;
  for (c3_i34 = 0; c3_i34 < 4; c3_i34++) {
    c3_C[c3_i33] = c3_dv8[c3_i34];
    c3_i33 += 3;
  }

  c3_C[1] = c3_nb_y;
  c3_C[4] = 0.0;
  c3_C[7] = 0.0;
  c3_C[10] = 0.0;
  c3_C[2] = 0.0;
  c3_C[5] = c3_sb_y;
  c3_C[8] = 0.0;
  c3_C[11] = c3_xb_y;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 38);
  c3_n_B = c3_x_s;
  c3_yb_y = c3_n_B;
  c3_ac_y = c3_yb_y;
  c3_bc_y = -1.0 / c3_ac_y;
  c3_i35 = 0;
  for (c3_i36 = 0; c3_i36 < 4; c3_i36++) {
    c3_D[c3_i35] = 0.0;
    c3_i35 += 3;
  }

  c3_i37 = 0;
  for (c3_i38 = 0; c3_i38 < 4; c3_i38++) {
    c3_D[c3_i37 + 1] = 0.0;
    c3_i37 += 3;
  }

  c3_D[2] = 0.0;
  c3_D[5] = c3_bc_y;
  c3_D[8] = 0.0;
  c3_D[11] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 42);
  for (c3_i39 = 0; c3_i39 < 12; c3_i39++) {
    c3_j_a[c3_i39] = c3_C[c3_i39];
  }

  for (c3_i40 = 0; c3_i40 < 4; c3_i40++) {
    c3_m_b[c3_i40] = c3_hat_x[c3_i40];
  }

  c3_b_eml_scalar_eg(chartInstance);
  c3_b_eml_scalar_eg(chartInstance);
  for (c3_i41 = 0; c3_i41 < 3; c3_i41++) {
    c3_cc_y[c3_i41] = 0.0;
    c3_i42 = 0;
    for (c3_i43 = 0; c3_i43 < 4; c3_i43++) {
      c3_cc_y[c3_i41] += c3_j_a[c3_i42 + c3_i41] * c3_m_b[c3_i43];
      c3_i42 += 3;
    }
  }

  for (c3_i44 = 0; c3_i44 < 12; c3_i44++) {
    c3_j_a[c3_i44] = c3_D[c3_i44];
  }

  for (c3_i45 = 0; c3_i45 < 4; c3_i45++) {
    c3_m_b[c3_i45] = c3_u_vector[c3_i45];
  }

  c3_b_eml_scalar_eg(chartInstance);
  c3_b_eml_scalar_eg(chartInstance);
  for (c3_i46 = 0; c3_i46 < 3; c3_i46++) {
    c3_dc_y[c3_i46] = 0.0;
    c3_i47 = 0;
    for (c3_i48 = 0; c3_i48 < 4; c3_i48++) {
      c3_dc_y[c3_i46] += c3_j_a[c3_i47 + c3_i46] * c3_m_b[c3_i48];
      c3_i47 += 3;
    }
  }

  for (c3_i49 = 0; c3_i49 < 3; c3_i49++) {
    c3_hat_y[c3_i49] = c3_cc_y[c3_i49] + c3_dc_y[c3_i49];
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 43);
  for (c3_i50 = 0; c3_i50 < 3; c3_i50++) {
    c3_tilde_y[c3_i50] = c3_y[c3_i50] - c3_hat_y[c3_i50];
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 45);
  for (c3_i51 = 0; c3_i51 < 16; c3_i51++) {
    c3_k_a[c3_i51] = c3_A[c3_i51];
  }

  for (c3_i52 = 0; c3_i52 < 4; c3_i52++) {
    c3_m_b[c3_i52] = c3_hat_x[c3_i52];
  }

  c3_c_eml_scalar_eg(chartInstance);
  c3_c_eml_scalar_eg(chartInstance);
  for (c3_i53 = 0; c3_i53 < 4; c3_i53++) {
    c3_ec_y[c3_i53] = 0.0;
    c3_i54 = 0;
    for (c3_i55 = 0; c3_i55 < 4; c3_i55++) {
      c3_ec_y[c3_i53] += c3_k_a[c3_i54 + c3_i53] * c3_m_b[c3_i55];
      c3_i54 += 4;
    }
  }

  for (c3_i56 = 0; c3_i56 < 16; c3_i56++) {
    c3_k_a[c3_i56] = c3_B[c3_i56];
  }

  for (c3_i57 = 0; c3_i57 < 4; c3_i57++) {
    c3_m_b[c3_i57] = c3_u_vector[c3_i57];
  }

  c3_c_eml_scalar_eg(chartInstance);
  c3_c_eml_scalar_eg(chartInstance);
  for (c3_i58 = 0; c3_i58 < 4; c3_i58++) {
    c3_fc_y[c3_i58] = 0.0;
    c3_i59 = 0;
    for (c3_i60 = 0; c3_i60 < 4; c3_i60++) {
      c3_fc_y[c3_i58] += c3_k_a[c3_i59 + c3_i58] * c3_m_b[c3_i60];
      c3_i59 += 4;
    }
  }

  for (c3_i61 = 0; c3_i61 < 3; c3_i61++) {
    c3_cc_y[c3_i61] = c3_tilde_y[c3_i61];
  }

  c3_d_eml_scalar_eg(chartInstance);
  c3_d_eml_scalar_eg(chartInstance);
  for (c3_i62 = 0; c3_i62 < 4; c3_i62++) {
    c3_m_b[c3_i62] = 0.0;
    for (c3_i63 = 0; c3_i63 < 3; c3_i63++) {
      c3_m_b[c3_i62] += 0.0 * c3_cc_y[c3_i63];
    }
  }

  for (c3_i64 = 0; c3_i64 < 4; c3_i64++) {
    c3_d_hat_x[c3_i64] = ((c3_ec_y[c3_i64] + c3_fc_y[c3_i64]) + c3_f_uy[c3_i64])
      + c3_m_b[c3_i64];
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 47);
  c3_hat_omega = c3_hat_y[0];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 48);
  c3_hat_p = c3_hat_y[1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 49);
  c3_hat_q = c3_hat_y[2];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 51);
  c3_tilde_omega = c3_tilde_y[0];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 52);
  c3_tilde_p = c3_tilde_y[1];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 53);
  c3_tilde_q = c3_tilde_y[2];
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, -53);
  _SFD_SYMBOL_SCOPE_POP();
  *c3_b_hat_omega = c3_hat_omega;
  *c3_b_hat_p = c3_hat_p;
  *c3_b_hat_q = c3_hat_q;
  *c3_b_tilde_omega = c3_tilde_omega;
  *c3_b_tilde_p = c3_tilde_p;
  *c3_b_tilde_q = c3_tilde_q;
  for (c3_i65 = 0; c3_i65 < 4; c3_i65++) {
    (*c3_b_d_hat_x)[c3_i65] = c3_d_hat_x[c3_i65];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
}

static void initSimStructsc3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
}

static void registerMessagesc3_NonlinLuenbergObs
  (SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber)
{
}

static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i66;
  real_T c3_b_inData[4];
  int32_T c3_i67;
  real_T c3_u[4];
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  for (c3_i66 = 0; c3_i66 < 4; c3_i66++) {
    c3_b_inData[c3_i66] = (*(real_T (*)[4])c3_inData)[c3_i66];
  }

  for (c3_i67 = 0; c3_i67 < 4; c3_i67++) {
    c3_u[c3_i67] = c3_b_inData[c3_i67];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_d_hat_x, const char_T *c3_identifier, real_T
  c3_y[4])
{
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_d_hat_x), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_d_hat_x);
}

static void c3_b_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[4])
{
  real_T c3_dv9[4];
  int32_T c3_i68;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv9, 1, 0, 0U, 1, 0U, 1, 4);
  for (c3_i68 = 0; c3_i68 < 4; c3_i68++) {
    c3_y[c3_i68] = c3_dv9[c3_i68];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_d_hat_x;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[4];
  int32_T c3_i69;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_d_hat_x = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_d_hat_x), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_d_hat_x);
  for (c3_i69 = 0; c3_i69 < 4; c3_i69++) {
    (*(real_T (*)[4])c3_outData)[c3_i69] = c3_y[c3_i69];
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_c_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_tilde_q, const char_T *c3_identifier)
{
  real_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_tilde_q), &c3_thisId);
  sf_mex_destroy(&c3_tilde_q);
  return c3_y;
}

static real_T c3_d_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d2;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d2, 1, 0, 0U, 0, 0U, 0);
  c3_y = c3_d2;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_tilde_q;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_tilde_q = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_tilde_q), &c3_thisId);
  sf_mex_destroy(&c3_tilde_q);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_c_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i70;
  real_T c3_b_inData[3];
  int32_T c3_i71;
  real_T c3_u[3];
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  for (c3_i70 = 0; c3_i70 < 3; c3_i70++) {
    c3_b_inData[c3_i70] = (*(real_T (*)[3])c3_inData)[c3_i70];
  }

  for (c3_i71 = 0; c3_i71 < 3; c3_i71++) {
    c3_u[c3_i71] = c3_b_inData[c3_i71];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_e_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[3])
{
  real_T c3_dv10[3];
  int32_T c3_i72;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv10, 1, 0, 0U, 1, 0U, 1, 3);
  for (c3_i72 = 0; c3_i72 < 3; c3_i72++) {
    c3_y[c3_i72] = c3_dv10[c3_i72];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_r_f_G;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[3];
  int32_T c3_i73;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_b_r_f_G = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_r_f_G), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_b_r_f_G);
  for (c3_i73 = 0; c3_i73 < 3; c3_i73++) {
    (*(real_T (*)[3])c3_outData)[c3_i73] = c3_y[c3_i73];
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_d_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i74;
  int32_T c3_i75;
  int32_T c3_i76;
  real_T c3_b_inData[6];
  int32_T c3_i77;
  int32_T c3_i78;
  int32_T c3_i79;
  real_T c3_u[6];
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_i74 = 0;
  for (c3_i75 = 0; c3_i75 < 2; c3_i75++) {
    for (c3_i76 = 0; c3_i76 < 3; c3_i76++) {
      c3_b_inData[c3_i76 + c3_i74] = (*(real_T (*)[6])c3_inData)[c3_i76 + c3_i74];
    }

    c3_i74 += 3;
  }

  c3_i77 = 0;
  for (c3_i78 = 0; c3_i78 < 2; c3_i78++) {
    for (c3_i79 = 0; c3_i79 < 3; c3_i79++) {
      c3_u[c3_i79 + c3_i77] = c3_b_inData[c3_i79 + c3_i77];
    }

    c3_i77 += 3;
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_f_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[6])
{
  real_T c3_dv11[6];
  int32_T c3_i80;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv11, 1, 0, 0U, 1, 0U, 2, 3, 2);
  for (c3_i80 = 0; c3_i80 < 6; c3_i80++) {
    c3_y[c3_i80] = c3_dv11[c3_i80];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_z_G;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[6];
  int32_T c3_i81;
  int32_T c3_i82;
  int32_T c3_i83;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_b_z_G = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_z_G), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_b_z_G);
  c3_i81 = 0;
  for (c3_i82 = 0; c3_i82 < 2; c3_i82++) {
    for (c3_i83 = 0; c3_i83 < 3; c3_i83++) {
      (*(real_T (*)[6])c3_outData)[c3_i83 + c3_i81] = c3_y[c3_i83 + c3_i81];
    }

    c3_i81 += 3;
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_e_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i84;
  int32_T c3_i85;
  int32_T c3_i86;
  real_T c3_b_inData[12];
  int32_T c3_i87;
  int32_T c3_i88;
  int32_T c3_i89;
  real_T c3_u[12];
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_i84 = 0;
  for (c3_i85 = 0; c3_i85 < 4; c3_i85++) {
    for (c3_i86 = 0; c3_i86 < 3; c3_i86++) {
      c3_b_inData[c3_i86 + c3_i84] = (*(real_T (*)[12])c3_inData)[c3_i86 +
        c3_i84];
    }

    c3_i84 += 3;
  }

  c3_i87 = 0;
  for (c3_i88 = 0; c3_i88 < 4; c3_i88++) {
    for (c3_i89 = 0; c3_i89 < 3; c3_i89++) {
      c3_u[c3_i89 + c3_i87] = c3_b_inData[c3_i89 + c3_i87];
    }

    c3_i87 += 3;
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_g_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[12])
{
  real_T c3_dv12[12];
  int32_T c3_i90;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv12, 1, 0, 0U, 1, 0U, 2, 3, 4);
  for (c3_i90 = 0; c3_i90 < 12; c3_i90++) {
    c3_y[c3_i90] = c3_dv12[c3_i90];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_D;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[12];
  int32_T c3_i91;
  int32_T c3_i92;
  int32_T c3_i93;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_D = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_D), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_D);
  c3_i91 = 0;
  for (c3_i92 = 0; c3_i92 < 4; c3_i92++) {
    for (c3_i93 = 0; c3_i93 < 3; c3_i93++) {
      (*(real_T (*)[12])c3_outData)[c3_i93 + c3_i91] = c3_y[c3_i93 + c3_i91];
    }

    c3_i91 += 3;
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_f_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i94;
  int32_T c3_i95;
  int32_T c3_i96;
  real_T c3_b_inData[16];
  int32_T c3_i97;
  int32_T c3_i98;
  int32_T c3_i99;
  real_T c3_u[16];
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_i94 = 0;
  for (c3_i95 = 0; c3_i95 < 4; c3_i95++) {
    for (c3_i96 = 0; c3_i96 < 4; c3_i96++) {
      c3_b_inData[c3_i96 + c3_i94] = (*(real_T (*)[16])c3_inData)[c3_i96 +
        c3_i94];
    }

    c3_i94 += 4;
  }

  c3_i97 = 0;
  for (c3_i98 = 0; c3_i98 < 4; c3_i98++) {
    for (c3_i99 = 0; c3_i99 < 4; c3_i99++) {
      c3_u[c3_i99 + c3_i97] = c3_b_inData[c3_i99 + c3_i97];
    }

    c3_i97 += 4;
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 4, 4), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_h_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId,
  real_T c3_y[16])
{
  real_T c3_dv13[16];
  int32_T c3_i100;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv13, 1, 0, 0U, 1, 0U, 2, 4, 4);
  for (c3_i100 = 0; c3_i100 < 16; c3_i100++) {
    c3_y[c3_i100] = c3_dv13[c3_i100];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_B;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[16];
  int32_T c3_i101;
  int32_T c3_i102;
  int32_T c3_i103;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_B = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_B), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_B);
  c3_i101 = 0;
  for (c3_i102 = 0; c3_i102 < 4; c3_i102++) {
    for (c3_i103 = 0; c3_i103 < 4; c3_i103++) {
      (*(real_T (*)[16])c3_outData)[c3_i103 + c3_i101] = c3_y[c3_i103 + c3_i101];
    }

    c3_i101 += 4;
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_g_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i104;
  int32_T c3_i105;
  int32_T c3_i106;
  real_T c3_b_inData[12];
  int32_T c3_i107;
  int32_T c3_i108;
  int32_T c3_i109;
  real_T c3_u[12];
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_i104 = 0;
  for (c3_i105 = 0; c3_i105 < 3; c3_i105++) {
    for (c3_i106 = 0; c3_i106 < 4; c3_i106++) {
      c3_b_inData[c3_i106 + c3_i104] = (*(real_T (*)[12])c3_inData)[c3_i106 +
        c3_i104];
    }

    c3_i104 += 4;
  }

  c3_i107 = 0;
  for (c3_i108 = 0; c3_i108 < 3; c3_i108++) {
    for (c3_i109 = 0; c3_i109 < 4; c3_i109++) {
      c3_u[c3_i109 + c3_i107] = c3_b_inData[c3_i109 + c3_i107];
    }

    c3_i107 += 4;
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 4, 3), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

const mxArray *sf_c3_NonlinLuenbergObs_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo;
  c3_ResolvedFunctionInfo c3_info[21];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i110;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  c3_info_helper(c3_info);
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 21), FALSE);
  for (c3_i110 = 0; c3_i110 < 21; c3_i110++) {
    c3_r0 = &c3_info[c3_i110];
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->context)), "context", "nameCaptureInfo",
                    c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c3_r0->name)), "name", "nameCaptureInfo", c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved", "nameCaptureInfo",
                    c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c3_i110);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c3_i110);
  }

  sf_mex_assign(&c3_nameCaptureInfo, c3_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c3_nameCaptureInfo);
  return c3_nameCaptureInfo;
}

static void c3_info_helper(c3_ResolvedFunctionInfo c3_info[21])
{
  c3_info[0].context = "";
  c3_info[0].name = "mtimes";
  c3_info[0].dominantType = "double";
  c3_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[0].fileTimeLo = 1289519692U;
  c3_info[0].fileTimeHi = 0U;
  c3_info[0].mFileTimeLo = 0U;
  c3_info[0].mFileTimeHi = 0U;
  c3_info[1].context = "";
  c3_info[1].name = "mrdivide";
  c3_info[1].dominantType = "double";
  c3_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c3_info[1].fileTimeLo = 1357951548U;
  c3_info[1].fileTimeHi = 0U;
  c3_info[1].mFileTimeLo = 1319729966U;
  c3_info[1].mFileTimeHi = 0U;
  c3_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c3_info[2].name = "rdivide";
  c3_info[2].dominantType = "double";
  c3_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[2].fileTimeLo = 1346510388U;
  c3_info[2].fileTimeHi = 0U;
  c3_info[2].mFileTimeLo = 0U;
  c3_info[2].mFileTimeHi = 0U;
  c3_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[3].name = "eml_scalexp_compatible";
  c3_info[3].dominantType = "double";
  c3_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c3_info[3].fileTimeLo = 1286818796U;
  c3_info[3].fileTimeHi = 0U;
  c3_info[3].mFileTimeLo = 0U;
  c3_info[3].mFileTimeHi = 0U;
  c3_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c3_info[4].name = "eml_div";
  c3_info[4].dominantType = "double";
  c3_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c3_info[4].fileTimeLo = 1313347810U;
  c3_info[4].fileTimeHi = 0U;
  c3_info[4].mFileTimeLo = 0U;
  c3_info[4].mFileTimeHi = 0U;
  c3_info[5].context = "";
  c3_info[5].name = "mpower";
  c3_info[5].dominantType = "double";
  c3_info[5].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[5].fileTimeLo = 1286818842U;
  c3_info[5].fileTimeHi = 0U;
  c3_info[5].mFileTimeLo = 0U;
  c3_info[5].mFileTimeHi = 0U;
  c3_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c3_info[6].name = "power";
  c3_info[6].dominantType = "double";
  c3_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c3_info[6].fileTimeLo = 1348191930U;
  c3_info[6].fileTimeHi = 0U;
  c3_info[6].mFileTimeLo = 0U;
  c3_info[6].mFileTimeHi = 0U;
  c3_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c3_info[7].name = "eml_scalar_eg";
  c3_info[7].dominantType = "double";
  c3_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[7].fileTimeLo = 1286818796U;
  c3_info[7].fileTimeHi = 0U;
  c3_info[7].mFileTimeLo = 0U;
  c3_info[7].mFileTimeHi = 0U;
  c3_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c3_info[8].name = "eml_scalexp_alloc";
  c3_info[8].dominantType = "double";
  c3_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c3_info[8].fileTimeLo = 1352424860U;
  c3_info[8].fileTimeHi = 0U;
  c3_info[8].mFileTimeLo = 0U;
  c3_info[8].mFileTimeHi = 0U;
  c3_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c3_info[9].name = "floor";
  c3_info[9].dominantType = "double";
  c3_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c3_info[9].fileTimeLo = 1343830380U;
  c3_info[9].fileTimeHi = 0U;
  c3_info[9].mFileTimeLo = 0U;
  c3_info[9].mFileTimeHi = 0U;
  c3_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c3_info[10].name = "eml_scalar_floor";
  c3_info[10].dominantType = "double";
  c3_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c3_info[10].fileTimeLo = 1286818726U;
  c3_info[10].fileTimeHi = 0U;
  c3_info[10].mFileTimeLo = 0U;
  c3_info[10].mFileTimeHi = 0U;
  c3_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c3_info[11].name = "eml_scalar_eg";
  c3_info[11].dominantType = "double";
  c3_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[11].fileTimeLo = 1286818796U;
  c3_info[11].fileTimeHi = 0U;
  c3_info[11].mFileTimeLo = 0U;
  c3_info[11].mFileTimeHi = 0U;
  c3_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c3_info[12].name = "mtimes";
  c3_info[12].dominantType = "double";
  c3_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[12].fileTimeLo = 1289519692U;
  c3_info[12].fileTimeHi = 0U;
  c3_info[12].mFileTimeLo = 0U;
  c3_info[12].mFileTimeHi = 0U;
  c3_info[13].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[13].name = "eml_index_class";
  c3_info[13].dominantType = "";
  c3_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[13].fileTimeLo = 1323170578U;
  c3_info[13].fileTimeHi = 0U;
  c3_info[13].mFileTimeLo = 0U;
  c3_info[13].mFileTimeHi = 0U;
  c3_info[14].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[14].name = "eml_scalar_eg";
  c3_info[14].dominantType = "double";
  c3_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[14].fileTimeLo = 1286818796U;
  c3_info[14].fileTimeHi = 0U;
  c3_info[14].mFileTimeLo = 0U;
  c3_info[14].mFileTimeHi = 0U;
  c3_info[15].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[15].name = "eml_xgemm";
  c3_info[15].dominantType = "char";
  c3_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c3_info[15].fileTimeLo = 1299076772U;
  c3_info[15].fileTimeHi = 0U;
  c3_info[15].mFileTimeLo = 0U;
  c3_info[15].mFileTimeHi = 0U;
  c3_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c3_info[16].name = "eml_blas_inline";
  c3_info[16].dominantType = "";
  c3_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c3_info[16].fileTimeLo = 1299076768U;
  c3_info[16].fileTimeHi = 0U;
  c3_info[16].mFileTimeLo = 0U;
  c3_info[16].mFileTimeHi = 0U;
  c3_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c3_info[17].name = "mtimes";
  c3_info[17].dominantType = "double";
  c3_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c3_info[17].fileTimeLo = 1289519692U;
  c3_info[17].fileTimeHi = 0U;
  c3_info[17].mFileTimeLo = 0U;
  c3_info[17].mFileTimeHi = 0U;
  c3_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c3_info[18].name = "eml_index_class";
  c3_info[18].dominantType = "";
  c3_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c3_info[18].fileTimeLo = 1323170578U;
  c3_info[18].fileTimeHi = 0U;
  c3_info[18].mFileTimeLo = 0U;
  c3_info[18].mFileTimeHi = 0U;
  c3_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c3_info[19].name = "eml_scalar_eg";
  c3_info[19].dominantType = "double";
  c3_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c3_info[19].fileTimeLo = 1286818796U;
  c3_info[19].fileTimeHi = 0U;
  c3_info[19].mFileTimeLo = 0U;
  c3_info[19].mFileTimeHi = 0U;
  c3_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c3_info[20].name = "eml_refblas_xgemm";
  c3_info[20].dominantType = "char";
  c3_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c3_info[20].fileTimeLo = 1299076774U;
  c3_info[20].fileTimeHi = 0U;
  c3_info[20].mFileTimeLo = 0U;
  c3_info[20].mFileTimeHi = 0U;
}

static real_T c3_mpower(SFc3_NonlinLuenbergObsInstanceStruct *chartInstance,
  real_T c3_a)
{
  real_T c3_b_a;
  real_T c3_c_a;
  real_T c3_ak;
  real_T c3_d_a;
  real_T c3_e_a;
  real_T c3_b;
  c3_b_a = c3_a;
  c3_c_a = c3_b_a;
  c3_eml_scalar_eg(chartInstance);
  c3_ak = c3_c_a;
  c3_d_a = c3_ak;
  c3_eml_scalar_eg(chartInstance);
  c3_e_a = c3_d_a;
  c3_b = c3_d_a;
  return c3_e_a * c3_b;
}

static void c3_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct *chartInstance)
{
}

static void c3_b_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
}

static void c3_c_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
}

static void c3_d_eml_scalar_eg(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
}

static const mxArray *c3_h_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(int32_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static int32_T c3_i_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  int32_T c3_y;
  int32_T c3_i111;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_i111, 1, 6, 0U, 0, 0U, 0);
  c3_y = c3_i111;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_sfEvent;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  int32_T c3_y;
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)chartInstanceVoid;
  c3_b_sfEvent = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_i_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_sfEvent),
    &c3_thisId);
  sf_mex_destroy(&c3_b_sfEvent);
  *(int32_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static uint8_T c3_j_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_b_is_active_c3_NonlinLuenbergObs, const
  char_T *c3_identifier)
{
  uint8_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_k_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c3_b_is_active_c3_NonlinLuenbergObs), &c3_thisId);
  sf_mex_destroy(&c3_b_is_active_c3_NonlinLuenbergObs);
  return c3_y;
}

static uint8_T c3_k_emlrt_marshallIn(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  uint8_T c3_y;
  uint8_T c3_u0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_u0, 1, 3, 0U, 0, 0U, 0);
  c3_y = c3_u0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void init_dsm_address_info(SFc3_NonlinLuenbergObsInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c3_NonlinLuenbergObs_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(647664109U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(921215601U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3465970968U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3687640787U);
}

mxArray *sf_c3_NonlinLuenbergObs_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("s7kPxkGmHXGd9pfQhEnSZG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,9,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c3_NonlinLuenbergObs_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c3_NonlinLuenbergObs(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[21],T\"d_hat_x\",},{M[1],M[51],T\"hat_omega\",},{M[1],M[52],T\"hat_p\",},{M[1],M[53],T\"hat_q\",},{M[1],M[47],T\"tilde_omega\",},{M[1],M[49],T\"tilde_p\",},{M[1],M[50],T\"tilde_q\",},{M[8],M[0],T\"is_active_c3_NonlinLuenbergObs\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c3_NonlinLuenbergObs_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
    chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _NonlinLuenbergObsMachineNumber_,
           3,
           1,
           1,
           19,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_NonlinLuenbergObsMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,_NonlinLuenbergObsMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _NonlinLuenbergObsMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"hat_omega");
          _SFD_SET_DATA_PROPS(1,2,0,1,"hat_p");
          _SFD_SET_DATA_PROPS(2,2,0,1,"hat_q");
          _SFD_SET_DATA_PROPS(3,2,0,1,"tilde_omega");
          _SFD_SET_DATA_PROPS(4,2,0,1,"tilde_p");
          _SFD_SET_DATA_PROPS(5,2,0,1,"tilde_q");
          _SFD_SET_DATA_PROPS(6,1,1,0,"y");
          _SFD_SET_DATA_PROPS(7,1,1,0,"u_vector");
          _SFD_SET_DATA_PROPS(8,1,1,0,"hat_x");
          _SFD_SET_DATA_PROPS(9,2,0,1,"d_hat_x");
          _SFD_SET_DATA_PROPS(10,10,0,0,"x_0");
          _SFD_SET_DATA_PROPS(11,10,0,0,"H_G");
          _SFD_SET_DATA_PROPS(12,10,0,0,"D_fw_G");
          _SFD_SET_DATA_PROPS(13,10,0,0,"z_G");
          _SFD_SET_DATA_PROPS(14,10,0,0,"tau_e_G");
          _SFD_SET_DATA_PROPS(15,10,0,0,"tau_f_G");
          _SFD_SET_DATA_PROPS(16,10,0,0,"r_f_G");
          _SFD_SET_DATA_PROPS(17,10,0,0,"GeneratorNumber");
          _SFD_SET_DATA_PROPS(18,10,0,0,"omega_b");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1150);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)
            c3_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)
            c3_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)
            c3_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)
            c3_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_d_sf_marshallOut,(MexInFcnForType)
            c3_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)
            c3_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)
            c3_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_c_sf_marshallOut,(MexInFcnForType)
            c3_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(18,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_b_sf_marshallOut,(MexInFcnForType)c3_b_sf_marshallIn);

        {
          real_T *c3_hat_omega;
          real_T *c3_hat_p;
          real_T *c3_hat_q;
          real_T *c3_tilde_omega;
          real_T *c3_tilde_p;
          real_T *c3_tilde_q;
          real_T (*c3_y)[3];
          real_T (*c3_u_vector)[4];
          real_T (*c3_hat_x)[4];
          real_T (*c3_d_hat_x)[4];
          c3_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
          c3_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
          c3_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c3_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          c3_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c3_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c3_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c3_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c3_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c3_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c3_hat_omega);
          _SFD_SET_DATA_VALUE_PTR(1U, c3_hat_p);
          _SFD_SET_DATA_VALUE_PTR(2U, c3_hat_q);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_tilde_omega);
          _SFD_SET_DATA_VALUE_PTR(4U, c3_tilde_p);
          _SFD_SET_DATA_VALUE_PTR(5U, c3_tilde_q);
          _SFD_SET_DATA_VALUE_PTR(6U, *c3_y);
          _SFD_SET_DATA_VALUE_PTR(7U, *c3_u_vector);
          _SFD_SET_DATA_VALUE_PTR(8U, *c3_hat_x);
          _SFD_SET_DATA_VALUE_PTR(9U, *c3_d_hat_x);
          _SFD_SET_DATA_VALUE_PTR(10U, chartInstance->c3_x_0);
          _SFD_SET_DATA_VALUE_PTR(11U, chartInstance->c3_H_G);
          _SFD_SET_DATA_VALUE_PTR(12U, chartInstance->c3_D_fw_G);
          _SFD_SET_DATA_VALUE_PTR(13U, chartInstance->c3_z_G);
          _SFD_SET_DATA_VALUE_PTR(14U, chartInstance->c3_tau_e_G);
          _SFD_SET_DATA_VALUE_PTR(15U, chartInstance->c3_tau_f_G);
          _SFD_SET_DATA_VALUE_PTR(16U, chartInstance->c3_r_f_G);
          _SFD_SET_DATA_VALUE_PTR(17U, &chartInstance->c3_GeneratorNumber);
          _SFD_SET_DATA_VALUE_PTR(18U, &chartInstance->c3_omega_b);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _NonlinLuenbergObsMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "wPYKaYILQh1NbjiLN0x71";
}

static void sf_opaque_initialize_c3_NonlinLuenbergObs(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar);
  initialize_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c3_NonlinLuenbergObs(void *chartInstanceVar)
{
  enable_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c3_NonlinLuenbergObs(void *chartInstanceVar)
{
  disable_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c3_NonlinLuenbergObs(void *chartInstanceVar)
{
  sf_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c3_NonlinLuenbergObs(SimStruct*
  S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c3_NonlinLuenbergObs
    ((SFc3_NonlinLuenbergObsInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_NonlinLuenbergObs();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c3_NonlinLuenbergObs(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_NonlinLuenbergObs();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c3_NonlinLuenbergObs(SimStruct* S)
{
  return sf_internal_get_sim_state_c3_NonlinLuenbergObs(S);
}

static void sf_opaque_set_sim_state_c3_NonlinLuenbergObs(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c3_NonlinLuenbergObs(S, st);
}

static void sf_opaque_terminate_c3_NonlinLuenbergObs(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc3_NonlinLuenbergObsInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_NonlinLuenbergObs_optimization_info();
    }

    finalize_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
      chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_NonlinLuenbergObs(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c3_NonlinLuenbergObs((SFc3_NonlinLuenbergObsInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c3_NonlinLuenbergObs(SimStruct *S)
{
  /* Actual parameters from chart:
     D_fw_G GeneratorNumber H_G omega_b r_f_G tau_e_G tau_f_G x_0 z_G
   */
  const char_T *rtParamNames[] = { "D_fw_G", "GeneratorNumber", "H_G", "omega_b",
    "r_f_G", "tau_e_G", "tau_f_G", "x_0", "z_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for D_fw_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for H_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for omega_b*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for r_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for tau_e_G*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);

  /* registration for tau_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 6, 6, rtParamNames[6], SS_DOUBLE);

  /* registration for x_0*/
  ssRegDlgParamAsRunTimeParam(S, 7, 7, rtParamNames[7], SS_DOUBLE);

  /* registration for z_G*/
  ssRegDlgParamAsRunTimeParam(S, 8, 8, rtParamNames[8], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_NonlinLuenbergObs_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,3,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,3,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,3);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,3,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,3,7);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=7; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(186079045U));
  ssSetChecksum1(S,(2806723519U));
  ssSetChecksum2(S,(566582204U));
  ssSetChecksum3(S,(4239225312U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c3_NonlinLuenbergObs(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_NonlinLuenbergObs(SimStruct *S)
{
  SFc3_NonlinLuenbergObsInstanceStruct *chartInstance;
  chartInstance = (SFc3_NonlinLuenbergObsInstanceStruct *)utMalloc(sizeof
    (SFc3_NonlinLuenbergObsInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc3_NonlinLuenbergObsInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.mdlStart = mdlStart_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c3_NonlinLuenbergObs;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c3_NonlinLuenbergObs_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_NonlinLuenbergObs(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_NonlinLuenbergObs(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_NonlinLuenbergObs(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c3_NonlinLuenbergObs_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
