/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_CommercialSystem_sfun.h"
#include "c24_SimulationPlantModel_CommercialSystem.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_CommercialSystem_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c24_debug_family_names[11] = { "N_faults", "u_0", "u_min",
  "u_max", "nargin", "nargout", "u", "f_u_matrix", "f_u_magnitudes",
  "GeneratorNumber", "f_u" };

/* Function Declarations */
static void initialize_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void initialize_params_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void enable_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void disable_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void c24_update_debugger_state_c24_SimulationPlantModel_CommercialSys
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void set_sim_state_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_st);
static void finalize_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void sf_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void initSimStructsc24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void registerMessagesc24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c24_machineNumber, uint32_T
  c24_chartNumber);
static const mxArray *c24_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static real_T c24_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_f_u, const char_T *c24_identifier);
static real_T c24_b_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_b_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static void c24_c_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[9]);
static void c24_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_c_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static void c24_d_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[12]);
static void c24_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static const mxArray *c24_d_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData);
static int32_T c24_e_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void c24_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData);
static uint8_T c24_f_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_b_is_active_c24_SimulationPlantModel_CommercialSystem,
   const char_T *c24_identifier);
static uint8_T c24_g_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId);
static void init_dsm_address_info
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  chartInstance->c24_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c24_is_active_c24_SimulationPlantModel_CommercialSystem = 0U;
}

static void initialize_params_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  real_T c24_dv0[12];
  int32_T c24_i0;
  real_T c24_dv1[9];
  int32_T c24_i1;
  real_T c24_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'f_u_matrix' in the parent workspace.\n");
  sf_mex_import_named("f_u_matrix", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c24_dv0, 0, 0, 0U, 1, 0U, 2, 3, 4);
  for (c24_i0 = 0; c24_i0 < 12; c24_i0++) {
    chartInstance->c24_f_u_matrix[c24_i0] = c24_dv0[c24_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'f_u_magnitudes' in the parent workspace.\n");
  sf_mex_import_named("f_u_magnitudes", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), c24_dv1, 0, 0, 0U, 1, 0U, 2, 3, 3);
  for (c24_i1 = 0; c24_i1 < 9; c24_i1++) {
    chartInstance->c24_f_u_magnitudes[c24_i1] = c24_dv1[c24_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    0, 0), &c24_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c24_GeneratorNumber = c24_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c24_update_debugger_state_c24_SimulationPlantModel_CommercialSys
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  const mxArray *c24_st;
  const mxArray *c24_y = NULL;
  real_T c24_hoistedGlobal;
  real_T c24_u;
  const mxArray *c24_b_y = NULL;
  uint8_T c24_b_hoistedGlobal;
  uint8_T c24_b_u;
  const mxArray *c24_c_y = NULL;
  real_T *c24_f_u;
  c24_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c24_st = NULL;
  c24_st = NULL;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_createcellarray(2), FALSE);
  c24_hoistedGlobal = *c24_f_u;
  c24_u = c24_hoistedGlobal;
  c24_b_y = NULL;
  sf_mex_assign(&c24_b_y, sf_mex_create("y", &c24_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c24_y, 0, c24_b_y);
  c24_b_hoistedGlobal =
    chartInstance->c24_is_active_c24_SimulationPlantModel_CommercialSystem;
  c24_b_u = c24_b_hoistedGlobal;
  c24_c_y = NULL;
  sf_mex_assign(&c24_c_y, sf_mex_create("y", &c24_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c24_y, 1, c24_c_y);
  sf_mex_assign(&c24_st, c24_y, FALSE);
  return c24_st;
}

static void set_sim_state_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_st)
{
  const mxArray *c24_u;
  real_T *c24_f_u;
  c24_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c24_doneDoubleBufferReInit = TRUE;
  c24_u = sf_mex_dup(c24_st);
  *c24_f_u = c24_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c24_u,
    0)), "f_u");
  chartInstance->c24_is_active_c24_SimulationPlantModel_CommercialSystem =
    c24_f_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c24_u, 1)),
    "is_active_c24_SimulationPlantModel_CommercialSystem");
  sf_mex_destroy(&c24_u);
  c24_update_debugger_state_c24_SimulationPlantModel_CommercialSys(chartInstance);
  sf_mex_destroy(&c24_st);
}

static void finalize_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void sf_c24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  int32_T c24_i2;
  int32_T c24_i3;
  real_T c24_hoistedGlobal;
  real_T c24_b_hoistedGlobal;
  real_T c24_u;
  int32_T c24_i4;
  real_T c24_b_f_u_matrix[12];
  int32_T c24_i5;
  real_T c24_b_f_u_magnitudes[9];
  real_T c24_b_GeneratorNumber;
  uint32_T c24_debug_family_var_map[11];
  real_T c24_N_faults;
  real_T c24_u_0;
  real_T c24_u_min;
  real_T c24_u_max;
  real_T c24_nargin = 4.0;
  real_T c24_nargout = 1.0;
  real_T c24_f_u;
  real_T *c24_b_u;
  real_T *c24_b_f_u;
  c24_b_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c24_b_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 23U, chartInstance->c24_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c24_b_u, 0U);
  for (c24_i2 = 0; c24_i2 < 12; c24_i2++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c24_f_u_matrix[c24_i2], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c24_b_f_u, 2U);
  for (c24_i3 = 0; c24_i3 < 9; c24_i3++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c24_f_u_magnitudes[c24_i3], 3U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c24_GeneratorNumber, 4U);
  chartInstance->c24_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 23U, chartInstance->c24_sfEvent);
  c24_hoistedGlobal = *c24_b_u;
  c24_b_hoistedGlobal = chartInstance->c24_GeneratorNumber;
  c24_u = c24_hoistedGlobal;
  for (c24_i4 = 0; c24_i4 < 12; c24_i4++) {
    c24_b_f_u_matrix[c24_i4] = chartInstance->c24_f_u_matrix[c24_i4];
  }

  for (c24_i5 = 0; c24_i5 < 9; c24_i5++) {
    c24_b_f_u_magnitudes[c24_i5] = chartInstance->c24_f_u_magnitudes[c24_i5];
  }

  c24_b_GeneratorNumber = c24_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c24_debug_family_names,
    c24_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_N_faults, 0U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_u_0, 1U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_u_min, 2U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_u_max, 3U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_nargin, 4U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_nargout, 5U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c24_u, 6U, c24_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c24_b_f_u_matrix, 7U,
    c24_c_sf_marshallOut, c24_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c24_b_f_u_magnitudes, 8U,
    c24_b_sf_marshallOut, c24_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_b_GeneratorNumber, 9U,
    c24_sf_marshallOut, c24_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c24_f_u, 10U, c24_sf_marshallOut,
    c24_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 5);
  c24_N_faults = ((c24_b_f_u_matrix[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK
                   ("f_u_matrix", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c24_b_GeneratorNumber), 1, 3, 1, 0) - 1] + c24_b_f_u_matrix[(int32_T)(real_T)
                   _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c24_b_GeneratorNumber), 1, 3, 1, 0) +
                   2]) + c24_b_f_u_matrix[(int32_T)(real_T)
                  _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c24_b_GeneratorNumber), 1, 3, 1, 0) +
                  5]) + c24_b_f_u_matrix[(int32_T)(real_T)
    _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)_SFD_INTEGER_CHECK(
    "GeneratorNumber", c24_b_GeneratorNumber), 1, 3, 1, 0) + 8];
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 6);
  c24_u_0 = c24_b_f_u_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_u_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c24_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 7);
  c24_u_min = c24_b_f_u_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_u_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c24_b_GeneratorNumber), 1, 3, 1, 0) + 2];
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 8);
  c24_u_max = c24_b_f_u_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_u_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c24_b_GeneratorNumber), 1, 3, 1, 0) + 5];
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 11);
  c24_f_u = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 12);
  if (CV_EML_IF(0, 1, 0, c24_N_faults >= 2.0)) {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 13);
    c24_f_u = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 14);
    if (CV_EML_IF(0, 1, 1, c24_b_f_u_matrix[(int32_T)(real_T)
                  _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
          _SFD_INTEGER_CHECK("GeneratorNumber", c24_b_GeneratorNumber), 1, 3, 1,
          0) - 1] == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 15);
      c24_f_u = 0.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 16);
      if (CV_EML_IF(0, 1, 2, c24_b_f_u_matrix[(int32_T)(real_T)
                    _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
            _SFD_INTEGER_CHECK("GeneratorNumber", c24_b_GeneratorNumber), 1, 3,
            1, 0) + 2] == 1.0)) {
        _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 17);
        c24_f_u = c24_u_0 - c24_u;
      } else {
        _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 18);
        if (CV_EML_IF(0, 1, 3, c24_b_f_u_matrix[(int32_T)(real_T)
                      _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
              _SFD_INTEGER_CHECK("GeneratorNumber", c24_b_GeneratorNumber), 1, 3,
              1, 0) + 5] == 1.0)) {
          _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 19);
          c24_f_u = c24_u_min - c24_u;
        } else {
          _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 20);
          if (CV_EML_IF(0, 1, 4, c24_b_f_u_matrix[(int32_T)(real_T)
                        _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
                _SFD_INTEGER_CHECK("GeneratorNumber", c24_b_GeneratorNumber), 1,
                3, 1, 0) + 8] == 1.0)) {
            _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, 21);
            c24_f_u = c24_u_max - c24_u;
          }
        }
      }
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c24_sfEvent, -21);
  _SFD_SYMBOL_SCOPE_POP();
  *c24_b_f_u = c24_f_u;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 23U, chartInstance->c24_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_CommercialSystemMachineNumber_,
     chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void registerMessagesc24_SimulationPlantModel_CommercialSystem
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c24_machineNumber, uint32_T
  c24_chartNumber)
{
}

static const mxArray *c24_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  real_T c24_u;
  const mxArray *c24_y = NULL;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_u = *(real_T *)c24_inData;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", &c24_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static real_T c24_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_f_u, const char_T *c24_identifier)
{
  real_T c24_y;
  emlrtMsgIdentifier c24_thisId;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_f_u), &c24_thisId);
  sf_mex_destroy(&c24_f_u);
  return c24_y;
}

static real_T c24_b_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  real_T c24_y;
  real_T c24_d1;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_d1, 1, 0, 0U, 0, 0U, 0);
  c24_y = c24_d1;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_f_u;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_f_u = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_f_u), &c24_thisId);
  sf_mex_destroy(&c24_f_u);
  *(real_T *)c24_outData = c24_y;
  sf_mex_destroy(&c24_mxArrayInData);
}

static const mxArray *c24_b_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_i6;
  int32_T c24_i7;
  int32_T c24_i8;
  real_T c24_b_inData[9];
  int32_T c24_i9;
  int32_T c24_i10;
  int32_T c24_i11;
  real_T c24_u[9];
  const mxArray *c24_y = NULL;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_i6 = 0;
  for (c24_i7 = 0; c24_i7 < 3; c24_i7++) {
    for (c24_i8 = 0; c24_i8 < 3; c24_i8++) {
      c24_b_inData[c24_i8 + c24_i6] = (*(real_T (*)[9])c24_inData)[c24_i8 +
        c24_i6];
    }

    c24_i6 += 3;
  }

  c24_i9 = 0;
  for (c24_i10 = 0; c24_i10 < 3; c24_i10++) {
    for (c24_i11 = 0; c24_i11 < 3; c24_i11++) {
      c24_u[c24_i11 + c24_i9] = c24_b_inData[c24_i11 + c24_i9];
    }

    c24_i9 += 3;
  }

  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static void c24_c_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[9])
{
  real_T c24_dv2[9];
  int32_T c24_i12;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), c24_dv2, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c24_i12 = 0; c24_i12 < 9; c24_i12++) {
    c24_y[c24_i12] = c24_dv2[c24_i12];
  }

  sf_mex_destroy(&c24_u);
}

static void c24_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_b_f_u_magnitudes;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y[9];
  int32_T c24_i13;
  int32_T c24_i14;
  int32_T c24_i15;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_b_f_u_magnitudes = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_b_f_u_magnitudes),
    &c24_thisId, c24_y);
  sf_mex_destroy(&c24_b_f_u_magnitudes);
  c24_i13 = 0;
  for (c24_i14 = 0; c24_i14 < 3; c24_i14++) {
    for (c24_i15 = 0; c24_i15 < 3; c24_i15++) {
      (*(real_T (*)[9])c24_outData)[c24_i15 + c24_i13] = c24_y[c24_i15 + c24_i13];
    }

    c24_i13 += 3;
  }

  sf_mex_destroy(&c24_mxArrayInData);
}

static const mxArray *c24_c_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_i16;
  int32_T c24_i17;
  int32_T c24_i18;
  real_T c24_b_inData[12];
  int32_T c24_i19;
  int32_T c24_i20;
  int32_T c24_i21;
  real_T c24_u[12];
  const mxArray *c24_y = NULL;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_i16 = 0;
  for (c24_i17 = 0; c24_i17 < 4; c24_i17++) {
    for (c24_i18 = 0; c24_i18 < 3; c24_i18++) {
      c24_b_inData[c24_i18 + c24_i16] = (*(real_T (*)[12])c24_inData)[c24_i18 +
        c24_i16];
    }

    c24_i16 += 3;
  }

  c24_i19 = 0;
  for (c24_i20 = 0; c24_i20 < 4; c24_i20++) {
    for (c24_i21 = 0; c24_i21 < 3; c24_i21++) {
      c24_u[c24_i21 + c24_i19] = c24_b_inData[c24_i21 + c24_i19];
    }

    c24_i19 += 3;
  }

  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", c24_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static void c24_d_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId, real_T c24_y[12])
{
  real_T c24_dv3[12];
  int32_T c24_i22;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), c24_dv3, 1, 0, 0U, 1, 0U, 2, 3,
                4);
  for (c24_i22 = 0; c24_i22 < 12; c24_i22++) {
    c24_y[c24_i22] = c24_dv3[c24_i22];
  }

  sf_mex_destroy(&c24_u);
}

static void c24_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_b_f_u_matrix;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  real_T c24_y[12];
  int32_T c24_i23;
  int32_T c24_i24;
  int32_T c24_i25;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_b_f_u_matrix = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_b_f_u_matrix),
    &c24_thisId, c24_y);
  sf_mex_destroy(&c24_b_f_u_matrix);
  c24_i23 = 0;
  for (c24_i24 = 0; c24_i24 < 4; c24_i24++) {
    for (c24_i25 = 0; c24_i25 < 3; c24_i25++) {
      (*(real_T (*)[12])c24_outData)[c24_i25 + c24_i23] = c24_y[c24_i25 +
        c24_i23];
    }

    c24_i23 += 3;
  }

  sf_mex_destroy(&c24_mxArrayInData);
}

const mxArray
  *sf_c24_SimulationPlantModel_CommercialSystem_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c24_nameCaptureInfo = NULL;
  c24_nameCaptureInfo = NULL;
  sf_mex_assign(&c24_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c24_nameCaptureInfo;
}

static const mxArray *c24_d_sf_marshallOut(void *chartInstanceVoid, void
  *c24_inData)
{
  const mxArray *c24_mxArrayOutData = NULL;
  int32_T c24_u;
  const mxArray *c24_y = NULL;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_mxArrayOutData = NULL;
  c24_u = *(int32_T *)c24_inData;
  c24_y = NULL;
  sf_mex_assign(&c24_y, sf_mex_create("y", &c24_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c24_mxArrayOutData, c24_y, FALSE);
  return c24_mxArrayOutData;
}

static int32_T c24_e_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  int32_T c24_y;
  int32_T c24_i26;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_i26, 1, 6, 0U, 0, 0U, 0);
  c24_y = c24_i26;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void c24_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c24_mxArrayInData, const char_T *c24_varName, void *c24_outData)
{
  const mxArray *c24_b_sfEvent;
  const char_T *c24_identifier;
  emlrtMsgIdentifier c24_thisId;
  int32_T c24_y;
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c24_b_sfEvent = sf_mex_dup(c24_mxArrayInData);
  c24_identifier = c24_varName;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c24_b_sfEvent),
    &c24_thisId);
  sf_mex_destroy(&c24_b_sfEvent);
  *(int32_T *)c24_outData = c24_y;
  sf_mex_destroy(&c24_mxArrayInData);
}

static uint8_T c24_f_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_b_is_active_c24_SimulationPlantModel_CommercialSystem,
   const char_T *c24_identifier)
{
  uint8_T c24_y;
  emlrtMsgIdentifier c24_thisId;
  c24_thisId.fIdentifier = c24_identifier;
  c24_thisId.fParent = NULL;
  c24_y = c24_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c24_b_is_active_c24_SimulationPlantModel_CommercialSystem), &c24_thisId);
  sf_mex_destroy(&c24_b_is_active_c24_SimulationPlantModel_CommercialSystem);
  return c24_y;
}

static uint8_T c24_g_emlrt_marshallIn
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c24_u, const emlrtMsgIdentifier *c24_parentId)
{
  uint8_T c24_y;
  uint8_T c24_u0;
  sf_mex_import(c24_parentId, sf_mex_dup(c24_u), &c24_u0, 1, 3, 0U, 0, 0U, 0);
  c24_y = c24_u0;
  sf_mex_destroy(&c24_u);
  return c24_y;
}

static void init_dsm_address_info
  (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c24_SimulationPlantModel_CommercialSystem_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1966940270U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(114620451U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3021224464U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3737718114U);
}

mxArray *sf_c24_SimulationPlantModel_CommercialSystem_get_autoinheritance_info
  (void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("u89xqnGgjiZysvC9cmrAq");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(4);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c24_SimulationPlantModel_CommercialSystem_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray
  *sf_get_sim_state_info_c24_SimulationPlantModel_CommercialSystem(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"f_u\",},{M[8],M[0],T\"is_active_c24_SimulationPlantModel_CommercialSystem\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c24_SimulationPlantModel_CommercialSystem_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
    chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_CommercialSystemMachineNumber_,
           24,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_CommercialSystemMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_CommercialSystemMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_CommercialSystemMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"u");
          _SFD_SET_DATA_PROPS(1,10,0,0,"f_u_matrix");
          _SFD_SET_DATA_PROPS(2,2,0,1,"f_u");
          _SFD_SET_DATA_PROPS(3,10,0,0,"f_u_magnitudes");
          _SFD_SET_DATA_PROPS(4,10,0,0,"GeneratorNumber");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,5,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,738);
        _SFD_CV_INIT_EML_IF(0,1,0,462,478,492,533);
        _SFD_CV_INIT_EML_IF(0,1,1,492,533,547,737);
        _SFD_CV_INIT_EML_IF(0,1,2,547,588,608,737);
        _SFD_CV_INIT_EML_IF(0,1,3,608,649,671,737);
        _SFD_CV_INIT_EML_IF(0,1,4,671,712,-1,712);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_c_sf_marshallOut,(MexInFcnForType)
            c24_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)c24_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c24_b_sf_marshallOut,(MexInFcnForType)
            c24_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c24_sf_marshallOut,(MexInFcnForType)c24_sf_marshallIn);

        {
          real_T *c24_u;
          real_T *c24_f_u;
          c24_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c24_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c24_u);
          _SFD_SET_DATA_VALUE_PTR(1U, chartInstance->c24_f_u_matrix);
          _SFD_SET_DATA_VALUE_PTR(2U, c24_f_u);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c24_f_u_magnitudes);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c24_GeneratorNumber);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_CommercialSystemMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "CFMsXbEyXt0MXfeRQnxlpH";
}

static void sf_opaque_initialize_c24_SimulationPlantModel_CommercialSystem(void *
  chartInstanceVar)
{
  chart_debug_initialization
    (((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
      chartInstanceVar)->S,0);
  initialize_params_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
  initialize_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_enable_c24_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  enable_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_disable_c24_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  disable_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_gateway_c24_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  sf_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c24_SimulationPlantModel_CommercialSystem(SimStruct*
  S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c24_SimulationPlantModel_CommercialSystem();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c24_SimulationPlantModel_CommercialSystem
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c24_SimulationPlantModel_CommercialSystem();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray*
  sf_opaque_get_sim_state_c24_SimulationPlantModel_CommercialSystem(SimStruct* S)
{
  return sf_internal_get_sim_state_c24_SimulationPlantModel_CommercialSystem(S);
}

static void sf_opaque_set_sim_state_c24_SimulationPlantModel_CommercialSystem
  (SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c24_SimulationPlantModel_CommercialSystem(S, st);
}

static void sf_opaque_terminate_c24_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_CommercialSystem_optimization_info();
    }

    finalize_c24_SimulationPlantModel_CommercialSystem
      ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
       chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc24_SimulationPlantModel_CommercialSystem
    ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c24_SimulationPlantModel_CommercialSystem
  (SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c24_SimulationPlantModel_CommercialSystem
      ((SFc24_SimulationPlantModel_CommercialSystemInstanceStruct*)
       (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c24_SimulationPlantModel_CommercialSystem(SimStruct
  *S)
{
  /* Actual parameters from chart:
     GeneratorNumber f_u_magnitudes f_u_matrix
   */
  const char_T *rtParamNames[] = { "GeneratorNumber", "f_u_magnitudes",
    "f_u_matrix" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for f_u_magnitudes*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for f_u_matrix*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct =
      load_SimulationPlantModel_CommercialSystem_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      24);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,24,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,24,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,24);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,24,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,24,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 1; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,24);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2717600963U));
  ssSetChecksum1(S,(68735232U));
  ssSetChecksum2(S,(1109376266U));
  ssSetChecksum3(S,(2466876541U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c24_SimulationPlantModel_CommercialSystem(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c24_SimulationPlantModel_CommercialSystem(SimStruct *S)
{
  SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct *)
    utMalloc(sizeof(SFc24_SimulationPlantModel_CommercialSystemInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc24_SimulationPlantModel_CommercialSystemInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW =
    mdlRTW_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.mdlStart =
    mdlStart_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c24_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c24_SimulationPlantModel_CommercialSystem_method_dispatcher(SimStruct *S,
  int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c24_SimulationPlantModel_CommercialSystem(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c24_SimulationPlantModel_CommercialSystem(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c24_SimulationPlantModel_CommercialSystem(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c24_SimulationPlantModel_CommercialSystem_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
