/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_CommercialSystem_sfun.h"
#include "c9_SimulationPlantModel_CommercialSystem.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_CommercialSystem_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c9_debug_family_names[17] = { "AF_n", "AF_low", "AF_high",
  "m_a0", "nargin", "nargout", "omega_t", "u", "omega", "AF_n_G", "AF_low_G",
  "AF_high_G", "m_a0_G", "GeneratorNumber", "t_m", "eta_c", "AF" };

/* Function Declarations */
static void initialize_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void initialize_params_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void enable_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void disable_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void c9_update_debugger_state_c9_SimulationPlantModel_CommercialSyste
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void set_sim_state_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_st);
static void finalize_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void sf_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void initSimStructsc9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void registerMessagesc9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c9_machineNumber, uint32_T
  c9_chartNumber);
static const mxArray *c9_sf_marshallOut(void *chartInstanceVoid, void *c9_inData);
static real_T c9_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_AF, const char_T *c9_identifier);
static real_T c9_b_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void c9_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static const mxArray *c9_b_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData);
static void c9_c_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId, real_T c9_y[3]);
static void c9_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static const mxArray *c9_c_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData);
static int32_T c9_d_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void c9_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData);
static uint8_T c9_e_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_b_is_active_c9_SimulationPlantModel_CommercialSystem, const
   char_T *c9_identifier);
static uint8_T c9_f_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId);
static void init_dsm_address_info
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  chartInstance->c9_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c9_is_active_c9_SimulationPlantModel_CommercialSystem = 0U;
}

static void initialize_params_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  real_T c9_dv0[3];
  int32_T c9_i0;
  real_T c9_dv1[3];
  int32_T c9_i1;
  real_T c9_dv2[3];
  int32_T c9_i2;
  real_T c9_dv3[3];
  int32_T c9_i3;
  real_T c9_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'AF_n_G' in the parent workspace.\n");
  sf_mex_import_named("AF_n_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c9_dv0, 0, 0, 0U, 1, 0U, 1, 3);
  for (c9_i0 = 0; c9_i0 < 3; c9_i0++) {
    chartInstance->c9_AF_n_G[c9_i0] = c9_dv0[c9_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'AF_low_G' in the parent workspace.\n");
  sf_mex_import_named("AF_low_G", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c9_dv1, 0, 0, 0U, 1, 0U, 1, 3);
  for (c9_i1 = 0; c9_i1 < 3; c9_i1++) {
    chartInstance->c9_AF_low_G[c9_i1] = c9_dv1[c9_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'AF_high_G' in the parent workspace.\n");
  sf_mex_import_named("AF_high_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c9_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c9_i2 = 0; c9_i2 < 3; c9_i2++) {
    chartInstance->c9_AF_high_G[c9_i2] = c9_dv2[c9_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'm_a0_G' in the parent workspace.\n");
  sf_mex_import_named("m_a0_G", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      c9_dv3, 0, 0, 0U, 1, 0U, 1, 3);
  for (c9_i3 = 0; c9_i3 < 3; c9_i3++) {
    chartInstance->c9_m_a0_G[c9_i3] = c9_dv3[c9_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    3, 0), &c9_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c9_GeneratorNumber = c9_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c9_update_debugger_state_c9_SimulationPlantModel_CommercialSyste
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  const mxArray *c9_st;
  const mxArray *c9_y = NULL;
  real_T c9_hoistedGlobal;
  real_T c9_u;
  const mxArray *c9_b_y = NULL;
  real_T c9_b_hoistedGlobal;
  real_T c9_b_u;
  const mxArray *c9_c_y = NULL;
  real_T c9_c_hoistedGlobal;
  real_T c9_c_u;
  const mxArray *c9_d_y = NULL;
  uint8_T c9_d_hoistedGlobal;
  uint8_T c9_d_u;
  const mxArray *c9_e_y = NULL;
  real_T *c9_AF;
  real_T *c9_eta_c;
  real_T *c9_t_m;
  c9_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c9_st = NULL;
  c9_st = NULL;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_createcellarray(4), FALSE);
  c9_hoistedGlobal = *c9_AF;
  c9_u = c9_hoistedGlobal;
  c9_b_y = NULL;
  sf_mex_assign(&c9_b_y, sf_mex_create("y", &c9_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 0, c9_b_y);
  c9_b_hoistedGlobal = *c9_eta_c;
  c9_b_u = c9_b_hoistedGlobal;
  c9_c_y = NULL;
  sf_mex_assign(&c9_c_y, sf_mex_create("y", &c9_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 1, c9_c_y);
  c9_c_hoistedGlobal = *c9_t_m;
  c9_c_u = c9_c_hoistedGlobal;
  c9_d_y = NULL;
  sf_mex_assign(&c9_d_y, sf_mex_create("y", &c9_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 2, c9_d_y);
  c9_d_hoistedGlobal =
    chartInstance->c9_is_active_c9_SimulationPlantModel_CommercialSystem;
  c9_d_u = c9_d_hoistedGlobal;
  c9_e_y = NULL;
  sf_mex_assign(&c9_e_y, sf_mex_create("y", &c9_d_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c9_y, 3, c9_e_y);
  sf_mex_assign(&c9_st, c9_y, FALSE);
  return c9_st;
}

static void set_sim_state_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_st)
{
  const mxArray *c9_u;
  real_T *c9_AF;
  real_T *c9_eta_c;
  real_T *c9_t_m;
  c9_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c9_doneDoubleBufferReInit = TRUE;
  c9_u = sf_mex_dup(c9_st);
  *c9_AF = c9_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u, 0)),
    "AF");
  *c9_eta_c = c9_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u,
    1)), "eta_c");
  *c9_t_m = c9_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u, 2)),
    "t_m");
  chartInstance->c9_is_active_c9_SimulationPlantModel_CommercialSystem =
    c9_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c9_u, 3)),
    "is_active_c9_SimulationPlantModel_CommercialSystem");
  sf_mex_destroy(&c9_u);
  c9_update_debugger_state_c9_SimulationPlantModel_CommercialSyste(chartInstance);
  sf_mex_destroy(&c9_st);
}

static void finalize_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void sf_c9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  int32_T c9_i4;
  int32_T c9_i5;
  int32_T c9_i6;
  int32_T c9_i7;
  real_T c9_hoistedGlobal;
  real_T c9_b_hoistedGlobal;
  real_T c9_c_hoistedGlobal;
  real_T c9_d_hoistedGlobal;
  real_T c9_omega_t;
  real_T c9_u;
  real_T c9_omega;
  int32_T c9_i8;
  real_T c9_b_AF_n_G[3];
  int32_T c9_i9;
  real_T c9_b_AF_low_G[3];
  int32_T c9_i10;
  real_T c9_b_AF_high_G[3];
  int32_T c9_i11;
  real_T c9_b_m_a0_G[3];
  real_T c9_b_GeneratorNumber;
  uint32_T c9_debug_family_var_map[17];
  real_T c9_AF_n;
  real_T c9_AF_low;
  real_T c9_AF_high;
  real_T c9_m_a0;
  real_T c9_nargin = 8.0;
  real_T c9_nargout = 3.0;
  real_T c9_t_m;
  real_T c9_eta_c;
  real_T c9_AF;
  real_T c9_a;
  real_T c9_b;
  real_T c9_y;
  real_T c9_b_a;
  real_T c9_b_b;
  real_T c9_b_y;
  real_T c9_A;
  real_T c9_B;
  real_T c9_x;
  real_T c9_c_y;
  real_T c9_b_x;
  real_T c9_d_y;
  real_T c9_b_A;
  real_T c9_b_B;
  real_T c9_c_x;
  real_T c9_e_y;
  real_T c9_d_x;
  real_T c9_f_y;
  real_T c9_c_a;
  real_T c9_c_b;
  real_T c9_g_y;
  real_T c9_c_A;
  real_T c9_c_B;
  real_T c9_e_x;
  real_T c9_h_y;
  real_T c9_f_x;
  real_T c9_i_y;
  real_T *c9_b_AF;
  real_T *c9_b_eta_c;
  real_T *c9_b_t_m;
  real_T *c9_b_omega;
  real_T *c9_b_u;
  real_T *c9_b_omega_t;
  c9_b_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c9_b_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c9_b_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c9_b_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c9_b_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c9_b_omega_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 8U, chartInstance->c9_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c9_b_omega_t, 0U);
  _SFD_DATA_RANGE_CHECK(*c9_b_u, 1U);
  _SFD_DATA_RANGE_CHECK(*c9_b_omega, 2U);
  for (c9_i4 = 0; c9_i4 < 3; c9_i4++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c9_AF_n_G[c9_i4], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c9_b_t_m, 4U);
  for (c9_i5 = 0; c9_i5 < 3; c9_i5++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c9_AF_low_G[c9_i5], 5U);
  }

  for (c9_i6 = 0; c9_i6 < 3; c9_i6++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c9_AF_high_G[c9_i6], 6U);
  }

  for (c9_i7 = 0; c9_i7 < 3; c9_i7++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c9_m_a0_G[c9_i7], 7U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c9_GeneratorNumber, 8U);
  _SFD_DATA_RANGE_CHECK(*c9_b_eta_c, 9U);
  _SFD_DATA_RANGE_CHECK(*c9_b_AF, 10U);
  chartInstance->c9_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 8U, chartInstance->c9_sfEvent);
  c9_hoistedGlobal = *c9_b_omega_t;
  c9_b_hoistedGlobal = *c9_b_u;
  c9_c_hoistedGlobal = *c9_b_omega;
  c9_d_hoistedGlobal = chartInstance->c9_GeneratorNumber;
  c9_omega_t = c9_hoistedGlobal;
  c9_u = c9_b_hoistedGlobal;
  c9_omega = c9_c_hoistedGlobal;
  for (c9_i8 = 0; c9_i8 < 3; c9_i8++) {
    c9_b_AF_n_G[c9_i8] = chartInstance->c9_AF_n_G[c9_i8];
  }

  for (c9_i9 = 0; c9_i9 < 3; c9_i9++) {
    c9_b_AF_low_G[c9_i9] = chartInstance->c9_AF_low_G[c9_i9];
  }

  for (c9_i10 = 0; c9_i10 < 3; c9_i10++) {
    c9_b_AF_high_G[c9_i10] = chartInstance->c9_AF_high_G[c9_i10];
  }

  for (c9_i11 = 0; c9_i11 < 3; c9_i11++) {
    c9_b_m_a0_G[c9_i11] = chartInstance->c9_m_a0_G[c9_i11];
  }

  c9_b_GeneratorNumber = c9_d_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 17U, 17U, c9_debug_family_names,
    c9_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_AF_n, 0U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_AF_low, 1U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_AF_high, 2U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_m_a0, 3U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_nargin, 4U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_nargout, 5U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c9_omega_t, 6U, c9_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c9_u, 7U, c9_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c9_omega, 8U, c9_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c9_b_AF_n_G, 9U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c9_b_AF_low_G, 10U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c9_b_AF_high_G, 11U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c9_b_m_a0_G, 12U, c9_b_sf_marshallOut,
    c9_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_b_GeneratorNumber, 13U,
    c9_sf_marshallOut, c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_t_m, 14U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_eta_c, 15U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c9_AF, 16U, c9_sf_marshallOut,
    c9_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 5);
  c9_AF_n = c9_b_AF_n_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("AF_n_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c9_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 6);
  c9_AF_low = c9_b_AF_low_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "AF_low_G", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c9_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 7);
  c9_AF_high = c9_b_AF_high_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "AF_high_G", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c9_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 8);
  c9_m_a0 = c9_b_m_a0_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("m_a0_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c9_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 11);
  if (CV_EML_IF(0, 1, 0, c9_u <= 0.0001)) {
    _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 12);
    c9_AF = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 14);
    c9_a = 1.0 - c9_m_a0;
    c9_b = c9_omega_t;
    c9_y = c9_a * c9_b;
    c9_b_a = c9_AF_n;
    c9_b_b = c9_m_a0 + c9_y;
    c9_b_y = c9_b_a * c9_b_b;
    c9_A = c9_b_y;
    c9_B = c9_u;
    c9_x = c9_A;
    c9_c_y = c9_B;
    c9_b_x = c9_x;
    c9_d_y = c9_c_y;
    c9_AF = c9_b_x / c9_d_y;
  }

  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 17);
  if (CV_EML_IF(0, 1, 1, c9_AF >= c9_AF_high)) {
    _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 18);
    c9_eta_c = 1.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 19);
    if (CV_EML_IF(0, 1, 2, c9_AF <= c9_AF_low)) {
      _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 20);
      c9_eta_c = 0.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 22);
      c9_b_A = c9_AF - c9_AF_low;
      c9_b_B = c9_AF_high - c9_AF_low;
      c9_c_x = c9_b_A;
      c9_e_y = c9_b_B;
      c9_d_x = c9_c_x;
      c9_f_y = c9_e_y;
      c9_eta_c = c9_d_x / c9_f_y;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, 25);
  c9_c_a = c9_eta_c;
  c9_c_b = c9_u;
  c9_g_y = c9_c_a * c9_c_b;
  c9_c_A = c9_g_y;
  c9_c_B = c9_omega;
  c9_e_x = c9_c_A;
  c9_h_y = c9_c_B;
  c9_f_x = c9_e_x;
  c9_i_y = c9_h_y;
  c9_t_m = c9_f_x / c9_i_y;
  _SFD_EML_CALL(0U, chartInstance->c9_sfEvent, -25);
  _SFD_SYMBOL_SCOPE_POP();
  *c9_b_t_m = c9_t_m;
  *c9_b_eta_c = c9_eta_c;
  *c9_b_AF = c9_AF;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 8U, chartInstance->c9_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_CommercialSystemMachineNumber_,
     chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void registerMessagesc9_SimulationPlantModel_CommercialSystem
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c9_machineNumber, uint32_T
  c9_chartNumber)
{
}

static const mxArray *c9_sf_marshallOut(void *chartInstanceVoid, void *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  real_T c9_u;
  const mxArray *c9_y = NULL;
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  c9_u = *(real_T *)c9_inData;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static real_T c9_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_AF, const char_T *c9_identifier)
{
  real_T c9_y;
  emlrtMsgIdentifier c9_thisId;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_AF), &c9_thisId);
  sf_mex_destroy(&c9_AF);
  return c9_y;
}

static real_T c9_b_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  real_T c9_y;
  real_T c9_d1;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_d1, 1, 0, 0U, 0, 0U, 0);
  c9_y = c9_d1;
  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void c9_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_AF;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  real_T c9_y;
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c9_AF = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_AF), &c9_thisId);
  sf_mex_destroy(&c9_AF);
  *(real_T *)c9_outData = c9_y;
  sf_mex_destroy(&c9_mxArrayInData);
}

static const mxArray *c9_b_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  int32_T c9_i12;
  real_T c9_b_inData[3];
  int32_T c9_i13;
  real_T c9_u[3];
  const mxArray *c9_y = NULL;
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  for (c9_i12 = 0; c9_i12 < 3; c9_i12++) {
    c9_b_inData[c9_i12] = (*(real_T (*)[3])c9_inData)[c9_i12];
  }

  for (c9_i13 = 0; c9_i13 < 3; c9_i13++) {
    c9_u[c9_i13] = c9_b_inData[c9_i13];
  }

  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", c9_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static void c9_c_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId, real_T c9_y[3])
{
  real_T c9_dv4[3];
  int32_T c9_i14;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), c9_dv4, 1, 0, 0U, 1, 0U, 1, 3);
  for (c9_i14 = 0; c9_i14 < 3; c9_i14++) {
    c9_y[c9_i14] = c9_dv4[c9_i14];
  }

  sf_mex_destroy(&c9_u);
}

static void c9_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_b_m_a0_G;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  real_T c9_y[3];
  int32_T c9_i15;
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c9_b_m_a0_G = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_b_m_a0_G), &c9_thisId, c9_y);
  sf_mex_destroy(&c9_b_m_a0_G);
  for (c9_i15 = 0; c9_i15 < 3; c9_i15++) {
    (*(real_T (*)[3])c9_outData)[c9_i15] = c9_y[c9_i15];
  }

  sf_mex_destroy(&c9_mxArrayInData);
}

const mxArray
  *sf_c9_SimulationPlantModel_CommercialSystem_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c9_nameCaptureInfo;
  c9_ResolvedFunctionInfo c9_info[5];
  c9_ResolvedFunctionInfo (*c9_b_info)[5];
  const mxArray *c9_m0 = NULL;
  int32_T c9_i16;
  c9_ResolvedFunctionInfo *c9_r0;
  c9_nameCaptureInfo = NULL;
  c9_nameCaptureInfo = NULL;
  c9_b_info = (c9_ResolvedFunctionInfo (*)[5])c9_info;
  (*c9_b_info)[0].context = "";
  (*c9_b_info)[0].name = "mtimes";
  (*c9_b_info)[0].dominantType = "double";
  (*c9_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c9_b_info)[0].fileTimeLo = 1289519692U;
  (*c9_b_info)[0].fileTimeHi = 0U;
  (*c9_b_info)[0].mFileTimeLo = 0U;
  (*c9_b_info)[0].mFileTimeHi = 0U;
  (*c9_b_info)[1].context = "";
  (*c9_b_info)[1].name = "mrdivide";
  (*c9_b_info)[1].dominantType = "double";
  (*c9_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c9_b_info)[1].fileTimeLo = 1357951548U;
  (*c9_b_info)[1].fileTimeHi = 0U;
  (*c9_b_info)[1].mFileTimeLo = 1319729966U;
  (*c9_b_info)[1].mFileTimeHi = 0U;
  (*c9_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c9_b_info)[2].name = "rdivide";
  (*c9_b_info)[2].dominantType = "double";
  (*c9_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c9_b_info)[2].fileTimeLo = 1346510388U;
  (*c9_b_info)[2].fileTimeHi = 0U;
  (*c9_b_info)[2].mFileTimeLo = 0U;
  (*c9_b_info)[2].mFileTimeHi = 0U;
  (*c9_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c9_b_info)[3].name = "eml_scalexp_compatible";
  (*c9_b_info)[3].dominantType = "double";
  (*c9_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  (*c9_b_info)[3].fileTimeLo = 1286818796U;
  (*c9_b_info)[3].fileTimeHi = 0U;
  (*c9_b_info)[3].mFileTimeLo = 0U;
  (*c9_b_info)[3].mFileTimeHi = 0U;
  (*c9_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c9_b_info)[4].name = "eml_div";
  (*c9_b_info)[4].dominantType = "double";
  (*c9_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c9_b_info)[4].fileTimeLo = 1313347810U;
  (*c9_b_info)[4].fileTimeHi = 0U;
  (*c9_b_info)[4].mFileTimeLo = 0U;
  (*c9_b_info)[4].mFileTimeHi = 0U;
  sf_mex_assign(&c9_m0, sf_mex_createstruct("nameCaptureInfo", 1, 5), FALSE);
  for (c9_i16 = 0; c9_i16 < 5; c9_i16++) {
    c9_r0 = &c9_info[c9_i16];
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c9_r0->context)), "context", "nameCaptureInfo",
                    c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c9_r0->name)), "name", "nameCaptureInfo", c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c9_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", c9_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c9_r0->resolved)), "resolved", "nameCaptureInfo",
                    c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c9_i16);
    sf_mex_addfield(c9_m0, sf_mex_create("nameCaptureInfo", &c9_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c9_i16);
  }

  sf_mex_assign(&c9_nameCaptureInfo, c9_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c9_nameCaptureInfo);
  return c9_nameCaptureInfo;
}

static const mxArray *c9_c_sf_marshallOut(void *chartInstanceVoid, void
  *c9_inData)
{
  const mxArray *c9_mxArrayOutData = NULL;
  int32_T c9_u;
  const mxArray *c9_y = NULL;
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c9_mxArrayOutData = NULL;
  c9_u = *(int32_T *)c9_inData;
  c9_y = NULL;
  sf_mex_assign(&c9_y, sf_mex_create("y", &c9_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c9_mxArrayOutData, c9_y, FALSE);
  return c9_mxArrayOutData;
}

static int32_T c9_d_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  int32_T c9_y;
  int32_T c9_i17;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_i17, 1, 6, 0U, 0, 0U, 0);
  c9_y = c9_i17;
  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void c9_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c9_mxArrayInData, const char_T *c9_varName, void *c9_outData)
{
  const mxArray *c9_b_sfEvent;
  const char_T *c9_identifier;
  emlrtMsgIdentifier c9_thisId;
  int32_T c9_y;
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c9_b_sfEvent = sf_mex_dup(c9_mxArrayInData);
  c9_identifier = c9_varName;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c9_b_sfEvent),
    &c9_thisId);
  sf_mex_destroy(&c9_b_sfEvent);
  *(int32_T *)c9_outData = c9_y;
  sf_mex_destroy(&c9_mxArrayInData);
}

static uint8_T c9_e_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_b_is_active_c9_SimulationPlantModel_CommercialSystem, const
   char_T *c9_identifier)
{
  uint8_T c9_y;
  emlrtMsgIdentifier c9_thisId;
  c9_thisId.fIdentifier = c9_identifier;
  c9_thisId.fParent = NULL;
  c9_y = c9_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c9_b_is_active_c9_SimulationPlantModel_CommercialSystem), &c9_thisId);
  sf_mex_destroy(&c9_b_is_active_c9_SimulationPlantModel_CommercialSystem);
  return c9_y;
}

static uint8_T c9_f_emlrt_marshallIn
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c9_u, const emlrtMsgIdentifier *c9_parentId)
{
  uint8_T c9_y;
  uint8_T c9_u0;
  sf_mex_import(c9_parentId, sf_mex_dup(c9_u), &c9_u0, 1, 3, 0U, 0, 0U, 0);
  c9_y = c9_u0;
  sf_mex_destroy(&c9_u);
  return c9_y;
}

static void init_dsm_address_info
  (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c9_SimulationPlantModel_CommercialSystem_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(918619566U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1578789694U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2320763109U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3224352566U);
}

mxArray *sf_c9_SimulationPlantModel_CommercialSystem_get_autoinheritance_info
  (void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("DVE0rNtHWGZFsWHYAJ7ffG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c9_SimulationPlantModel_CommercialSystem_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray
  *sf_get_sim_state_info_c9_SimulationPlantModel_CommercialSystem(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[25],T\"AF\",},{M[1],M[24],T\"eta_c\",},{M[1],M[5],T\"t_m\",},{M[8],M[0],T\"is_active_c9_SimulationPlantModel_CommercialSystem\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c9_SimulationPlantModel_CommercialSystem_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
    chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_CommercialSystemMachineNumber_,
           9,
           1,
           1,
           11,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_CommercialSystemMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_CommercialSystemMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_CommercialSystemMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"omega_t");
          _SFD_SET_DATA_PROPS(1,1,1,0,"u");
          _SFD_SET_DATA_PROPS(2,1,1,0,"omega");
          _SFD_SET_DATA_PROPS(3,10,0,0,"AF_n_G");
          _SFD_SET_DATA_PROPS(4,2,0,1,"t_m");
          _SFD_SET_DATA_PROPS(5,10,0,0,"AF_low_G");
          _SFD_SET_DATA_PROPS(6,10,0,0,"AF_high_G");
          _SFD_SET_DATA_PROPS(7,10,0,0,"m_a0_G");
          _SFD_SET_DATA_PROPS(8,10,0,0,"GeneratorNumber");
          _SFD_SET_DATA_PROPS(9,2,0,1,"eta_c");
          _SFD_SET_DATA_PROPS(10,2,0,1,"AF");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,582);
        _SFD_CV_INIT_EML_IF(0,1,0,336,350,363,414);
        _SFD_CV_INIT_EML_IF(0,1,1,416,432,448,537);
        _SFD_CV_INIT_EML_IF(0,1,2,448,467,483,537);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)
            c9_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)c9_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)
            c9_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)
            c9_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c9_b_sf_marshallOut,(MexInFcnForType)
            c9_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)c9_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)c9_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c9_sf_marshallOut,(MexInFcnForType)c9_sf_marshallIn);

        {
          real_T *c9_omega_t;
          real_T *c9_u;
          real_T *c9_omega;
          real_T *c9_t_m;
          real_T *c9_eta_c;
          real_T *c9_AF;
          c9_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c9_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c9_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c9_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c9_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c9_omega_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c9_omega_t);
          _SFD_SET_DATA_VALUE_PTR(1U, c9_u);
          _SFD_SET_DATA_VALUE_PTR(2U, c9_omega);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c9_AF_n_G);
          _SFD_SET_DATA_VALUE_PTR(4U, c9_t_m);
          _SFD_SET_DATA_VALUE_PTR(5U, chartInstance->c9_AF_low_G);
          _SFD_SET_DATA_VALUE_PTR(6U, chartInstance->c9_AF_high_G);
          _SFD_SET_DATA_VALUE_PTR(7U, chartInstance->c9_m_a0_G);
          _SFD_SET_DATA_VALUE_PTR(8U, &chartInstance->c9_GeneratorNumber);
          _SFD_SET_DATA_VALUE_PTR(9U, c9_eta_c);
          _SFD_SET_DATA_VALUE_PTR(10U, c9_AF);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_CommercialSystemMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "iulGg6J4ZVeT3Bo8qp41PG";
}

static void sf_opaque_initialize_c9_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  chart_debug_initialization
    (((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
      chartInstanceVar)->S,0);
  initialize_params_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
  initialize_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_enable_c9_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  enable_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_disable_c9_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  disable_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_gateway_c9_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  sf_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c9_SimulationPlantModel_CommercialSystem(SimStruct*
  S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c9_SimulationPlantModel_CommercialSystem();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c9_SimulationPlantModel_CommercialSystem
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c9_SimulationPlantModel_CommercialSystem();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray*
  sf_opaque_get_sim_state_c9_SimulationPlantModel_CommercialSystem(SimStruct* S)
{
  return sf_internal_get_sim_state_c9_SimulationPlantModel_CommercialSystem(S);
}

static void sf_opaque_set_sim_state_c9_SimulationPlantModel_CommercialSystem
  (SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c9_SimulationPlantModel_CommercialSystem(S, st);
}

static void sf_opaque_terminate_c9_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_CommercialSystem_optimization_info();
    }

    finalize_c9_SimulationPlantModel_CommercialSystem
      ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
       chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc9_SimulationPlantModel_CommercialSystem
    ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c9_SimulationPlantModel_CommercialSystem
  (SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c9_SimulationPlantModel_CommercialSystem
      ((SFc9_SimulationPlantModel_CommercialSystemInstanceStruct*)
       (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c9_SimulationPlantModel_CommercialSystem(SimStruct *
  S)
{
  /* Actual parameters from chart:
     AF_high_G AF_low_G AF_n_G GeneratorNumber m_a0_G
   */
  const char_T *rtParamNames[] = { "AF_high_G", "AF_low_G", "AF_n_G",
    "GeneratorNumber", "m_a0_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for AF_high_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for AF_low_G*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for AF_n_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for m_a0_G*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct =
      load_SimulationPlantModel_CommercialSystem_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      9);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,9,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,9,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,9);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,9,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,9,3);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=3; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,9);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2713244582U));
  ssSetChecksum1(S,(1913940759U));
  ssSetChecksum2(S,(935698120U));
  ssSetChecksum3(S,(2252210295U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c9_SimulationPlantModel_CommercialSystem(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c9_SimulationPlantModel_CommercialSystem(SimStruct *S)
{
  SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct *)
    utMalloc(sizeof(SFc9_SimulationPlantModel_CommercialSystemInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc9_SimulationPlantModel_CommercialSystemInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW =
    mdlRTW_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.mdlStart =
    mdlStart_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c9_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c9_SimulationPlantModel_CommercialSystem_method_dispatcher(SimStruct *S,
  int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c9_SimulationPlantModel_CommercialSystem(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c9_SimulationPlantModel_CommercialSystem(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c9_SimulationPlantModel_CommercialSystem(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c9_SimulationPlantModel_CommercialSystem_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
