#ifndef __c25_SimulationPlantModel_h__
#define __c25_SimulationPlantModel_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_SFc25_SimulationPlantModelInstanceStruct
#define typedef_SFc25_SimulationPlantModelInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c25_sfEvent;
  boolean_T c25_isStable;
  boolean_T c25_doneDoubleBufferReInit;
  uint8_T c25_is_active_c25_SimulationPlantModel;
  real_T c25_f_vf_matrix[12];
  real_T c25_f_vf_magnitudes[9];
  real_T c25_GeneratorNumber;
} SFc25_SimulationPlantModelInstanceStruct;

#endif                                 /*typedef_SFc25_SimulationPlantModelInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c25_SimulationPlantModel_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c25_SimulationPlantModel_get_check_sum(mxArray *plhs[]);
extern void c25_SimulationPlantModel_method_dispatcher(SimStruct *S, int_T
  method, void *data);

#endif
