#ifndef __c9_SimulationPlantModel_h__
#define __c9_SimulationPlantModel_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c9_ResolvedFunctionInfo
#define typedef_c9_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c9_ResolvedFunctionInfo;

#endif                                 /*typedef_c9_ResolvedFunctionInfo*/

#ifndef typedef_SFc9_SimulationPlantModelInstanceStruct
#define typedef_SFc9_SimulationPlantModelInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c9_sfEvent;
  boolean_T c9_isStable;
  boolean_T c9_doneDoubleBufferReInit;
  uint8_T c9_is_active_c9_SimulationPlantModel;
  real_T c9_AF_n_G[3];
  real_T c9_AF_low_G[3];
  real_T c9_AF_high_G[3];
  real_T c9_m_a0_G[3];
  real_T c9_GeneratorNumber;
} SFc9_SimulationPlantModelInstanceStruct;

#endif                                 /*typedef_SFc9_SimulationPlantModelInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c9_SimulationPlantModel_get_eml_resolved_functions_info
  (void);

/* Function Definitions */
extern void sf_c9_SimulationPlantModel_get_check_sum(mxArray *plhs[]);
extern void c9_SimulationPlantModel_method_dispatcher(SimStruct *S, int_T method,
  void *data);

#endif
