/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Kalman_sfun.h"
#include "c1_SimulationPlantModel_Kalman.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Kalman_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c1_debug_family_names[10] = { "tau_f", "r_f", "nargin",
  "nargout", "v_f", "i_f", "tau_f_G", "r_f_G", "GeneratorNumber", "d_i_f" };

/* Function Declarations */
static void initialize_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initialize_params_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void enable_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void disable_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c1_update_debugger_state_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void set_sim_state_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_st);
static void finalize_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void sf_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initSimStructsc1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void registerMessagesc1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData);
static real_T c1_emlrt_marshallIn(SFc1_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c1_d_i_f, const char_T *c1_identifier);
static real_T c1_b_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_c_emlrt_marshallIn(SFc1_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId,
  real_T c1_y[3]);
static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static int32_T c1_d_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static uint8_T c1_e_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_b_is_active_c1_SimulationPlantModel_Kalman, const char_T *c1_identifier);
static uint8_T c1_f_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_u, const emlrtMsgIdentifier *c1_parentId);
static void init_dsm_address_info(SFc1_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  chartInstance->c1_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c1_is_active_c1_SimulationPlantModel_Kalman = 0U;
}

static void initialize_params_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c1_dv0[3];
  int32_T c1_i0;
  real_T c1_dv1[3];
  int32_T c1_i1;
  real_T c1_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_f_G' in the parent workspace.\n");
  sf_mex_import_named("tau_f_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c1_dv0, 0, 0, 0U, 1, 0U, 1, 3);
  for (c1_i0 = 0; c1_i0 < 3; c1_i0++) {
    chartInstance->c1_tau_f_G[c1_i0] = c1_dv0[c1_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'r_f_G' in the parent workspace.\n");
  sf_mex_import_named("r_f_G", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c1_dv1, 0, 0, 0U, 1, 0U, 1, 3);
  for (c1_i1 = 0; c1_i1 < 3; c1_i1++) {
    chartInstance->c1_r_f_G[c1_i1] = c1_dv1[c1_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    0, 0), &c1_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c1_GeneratorNumber = c1_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c1_update_debugger_state_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  const mxArray *c1_st;
  const mxArray *c1_y = NULL;
  real_T c1_hoistedGlobal;
  real_T c1_u;
  const mxArray *c1_b_y = NULL;
  uint8_T c1_b_hoistedGlobal;
  uint8_T c1_b_u;
  const mxArray *c1_c_y = NULL;
  real_T *c1_d_i_f;
  c1_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_st = NULL;
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(2), FALSE);
  c1_hoistedGlobal = *c1_d_i_f;
  c1_u = c1_hoistedGlobal;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 0, c1_b_y);
  c1_b_hoistedGlobal =
    chartInstance->c1_is_active_c1_SimulationPlantModel_Kalman;
  c1_b_u = c1_b_hoistedGlobal;
  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 1, c1_c_y);
  sf_mex_assign(&c1_st, c1_y, FALSE);
  return c1_st;
}

static void set_sim_state_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_st)
{
  const mxArray *c1_u;
  real_T *c1_d_i_f;
  c1_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c1_doneDoubleBufferReInit = TRUE;
  c1_u = sf_mex_dup(c1_st);
  *c1_d_i_f = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u,
    0)), "d_i_f");
  chartInstance->c1_is_active_c1_SimulationPlantModel_Kalman =
    c1_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 1)),
    "is_active_c1_SimulationPlantModel_Kalman");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_SimulationPlantModel_Kalman(chartInstance);
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void sf_c1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  int32_T c1_i2;
  int32_T c1_i3;
  real_T c1_hoistedGlobal;
  real_T c1_b_hoistedGlobal;
  real_T c1_c_hoistedGlobal;
  real_T c1_v_f;
  real_T c1_i_f;
  int32_T c1_i4;
  real_T c1_b_tau_f_G[3];
  int32_T c1_i5;
  real_T c1_b_r_f_G[3];
  real_T c1_b_GeneratorNumber;
  uint32_T c1_debug_family_var_map[10];
  real_T c1_tau_f;
  real_T c1_r_f;
  real_T c1_nargin = 5.0;
  real_T c1_nargout = 1.0;
  real_T c1_d_i_f;
  real_T c1_B;
  real_T c1_y;
  real_T c1_b_y;
  real_T c1_c_y;
  real_T c1_A;
  real_T c1_b_B;
  real_T c1_x;
  real_T c1_d_y;
  real_T c1_b_x;
  real_T c1_e_y;
  real_T c1_f_y;
  real_T c1_a;
  real_T c1_b;
  real_T *c1_b_i_f;
  real_T *c1_b_v_f;
  real_T *c1_b_d_i_f;
  c1_b_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_b_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c1_b_v_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c1_b_v_f, 0U);
  _SFD_DATA_RANGE_CHECK(*c1_b_i_f, 1U);
  _SFD_DATA_RANGE_CHECK(*c1_b_d_i_f, 2U);
  for (c1_i2 = 0; c1_i2 < 3; c1_i2++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c1_tau_f_G[c1_i2], 3U);
  }

  for (c1_i3 = 0; c1_i3 < 3; c1_i3++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c1_r_f_G[c1_i3], 4U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c1_GeneratorNumber, 5U);
  chartInstance->c1_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  c1_hoistedGlobal = *c1_b_v_f;
  c1_b_hoistedGlobal = *c1_b_i_f;
  c1_c_hoistedGlobal = chartInstance->c1_GeneratorNumber;
  c1_v_f = c1_hoistedGlobal;
  c1_i_f = c1_b_hoistedGlobal;
  for (c1_i4 = 0; c1_i4 < 3; c1_i4++) {
    c1_b_tau_f_G[c1_i4] = chartInstance->c1_tau_f_G[c1_i4];
  }

  for (c1_i5 = 0; c1_i5 < 3; c1_i5++) {
    c1_b_r_f_G[c1_i5] = chartInstance->c1_r_f_G[c1_i5];
  }

  c1_b_GeneratorNumber = c1_c_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 10U, 10U, c1_debug_family_names,
    c1_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_tau_f, 0U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_r_f, 1U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargin, 2U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargout, 3U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_v_f, 4U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_i_f, 5U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_b_tau_f_G, 6U, c1_b_sf_marshallOut,
    c1_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_b_r_f_G, 7U, c1_b_sf_marshallOut,
    c1_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_b_GeneratorNumber, 8U,
    c1_sf_marshallOut, c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_d_i_f, 9U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 3);
  c1_tau_f = c1_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c1_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 4);
  c1_r_f = c1_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c1_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 7);
  c1_B = c1_tau_f;
  c1_y = c1_B;
  c1_b_y = c1_y;
  c1_c_y = 1.0 / c1_b_y;
  c1_A = c1_v_f;
  c1_b_B = c1_r_f;
  c1_x = c1_A;
  c1_d_y = c1_b_B;
  c1_b_x = c1_x;
  c1_e_y = c1_d_y;
  c1_f_y = c1_b_x / c1_e_y;
  c1_a = -c1_c_y;
  c1_b = c1_i_f - c1_f_y;
  c1_d_i_f = c1_a * c1_b;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, -7);
  _SFD_SYMBOL_SCOPE_POP();
  *c1_b_d_i_f = c1_d_i_f;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_SimulationPlantModel_KalmanMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void registerMessagesc1_SimulationPlantModel_Kalman
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  real_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(real_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static real_T c1_emlrt_marshallIn(SFc1_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c1_d_i_f, const char_T *c1_identifier)
{
  real_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_d_i_f), &c1_thisId);
  sf_mex_destroy(&c1_d_i_f);
  return c1_y;
}

static real_T c1_b_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  real_T c1_y;
  real_T c1_d1;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_d1, 1, 0, 0U, 0, 0U, 0);
  c1_y = c1_d1;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_d_i_f;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y;
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c1_d_i_f = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_d_i_f), &c1_thisId);
  sf_mex_destroy(&c1_d_i_f);
  *(real_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i6;
  real_T c1_b_inData[3];
  int32_T c1_i7;
  real_T c1_u[3];
  const mxArray *c1_y = NULL;
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i6 = 0; c1_i6 < 3; c1_i6++) {
    c1_b_inData[c1_i6] = (*(real_T (*)[3])c1_inData)[c1_i6];
  }

  for (c1_i7 = 0; c1_i7 < 3; c1_i7++) {
    c1_u[c1_i7] = c1_b_inData[c1_i7];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_c_emlrt_marshallIn(SFc1_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId,
  real_T c1_y[3])
{
  real_T c1_dv2[3];
  int32_T c1_i8;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv2, 1, 0, 0U, 1, 0U, 1, 3);
  for (c1_i8 = 0; c1_i8 < 3; c1_i8++) {
    c1_y[c1_i8] = c1_dv2[c1_i8];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_r_f_G;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[3];
  int32_T c1_i9;
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c1_b_r_f_G = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_r_f_G), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_b_r_f_G);
  for (c1_i9 = 0; c1_i9 < 3; c1_i9++) {
    (*(real_T (*)[3])c1_outData)[c1_i9] = c1_y[c1_i9];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

const mxArray *sf_c1_SimulationPlantModel_Kalman_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c1_nameCaptureInfo;
  c1_ResolvedFunctionInfo c1_info[5];
  c1_ResolvedFunctionInfo (*c1_b_info)[5];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i10;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  c1_b_info = (c1_ResolvedFunctionInfo (*)[5])c1_info;
  (*c1_b_info)[0].context = "";
  (*c1_b_info)[0].name = "mrdivide";
  (*c1_b_info)[0].dominantType = "double";
  (*c1_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c1_b_info)[0].fileTimeLo = 1357951548U;
  (*c1_b_info)[0].fileTimeHi = 0U;
  (*c1_b_info)[0].mFileTimeLo = 1319729966U;
  (*c1_b_info)[0].mFileTimeHi = 0U;
  (*c1_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c1_b_info)[1].name = "rdivide";
  (*c1_b_info)[1].dominantType = "double";
  (*c1_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c1_b_info)[1].fileTimeLo = 1346510388U;
  (*c1_b_info)[1].fileTimeHi = 0U;
  (*c1_b_info)[1].mFileTimeLo = 0U;
  (*c1_b_info)[1].mFileTimeHi = 0U;
  (*c1_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c1_b_info)[2].name = "eml_scalexp_compatible";
  (*c1_b_info)[2].dominantType = "double";
  (*c1_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  (*c1_b_info)[2].fileTimeLo = 1286818796U;
  (*c1_b_info)[2].fileTimeHi = 0U;
  (*c1_b_info)[2].mFileTimeLo = 0U;
  (*c1_b_info)[2].mFileTimeHi = 0U;
  (*c1_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c1_b_info)[3].name = "eml_div";
  (*c1_b_info)[3].dominantType = "double";
  (*c1_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c1_b_info)[3].fileTimeLo = 1313347810U;
  (*c1_b_info)[3].fileTimeHi = 0U;
  (*c1_b_info)[3].mFileTimeLo = 0U;
  (*c1_b_info)[3].mFileTimeHi = 0U;
  (*c1_b_info)[4].context = "";
  (*c1_b_info)[4].name = "mtimes";
  (*c1_b_info)[4].dominantType = "double";
  (*c1_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c1_b_info)[4].fileTimeLo = 1289519692U;
  (*c1_b_info)[4].fileTimeHi = 0U;
  (*c1_b_info)[4].mFileTimeLo = 0U;
  (*c1_b_info)[4].mFileTimeHi = 0U;
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 5), FALSE);
  for (c1_i10 = 0; c1_i10 < 5; c1_i10++) {
    c1_r0 = &c1_info[c1_i10];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context", "nameCaptureInfo",
                    c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name", "nameCaptureInfo", c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved", "nameCaptureInfo",
                    c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c1_i10);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c1_i10);
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c1_nameCaptureInfo);
  return c1_nameCaptureInfo;
}

static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(int32_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static int32_T c1_d_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  int32_T c1_y;
  int32_T c1_i11;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_i11, 1, 6, 0U, 0, 0U, 0);
  c1_y = c1_i11;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_sfEvent;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  int32_T c1_y;
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c1_b_sfEvent = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_sfEvent),
    &c1_thisId);
  sf_mex_destroy(&c1_b_sfEvent);
  *(int32_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static uint8_T c1_e_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_b_is_active_c1_SimulationPlantModel_Kalman, const char_T *c1_identifier)
{
  uint8_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c1_b_is_active_c1_SimulationPlantModel_Kalman), &c1_thisId);
  sf_mex_destroy(&c1_b_is_active_c1_SimulationPlantModel_Kalman);
  return c1_y;
}

static uint8_T c1_f_emlrt_marshallIn
  (SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_u0, 1, 3, 0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void init_dsm_address_info(SFc1_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c1_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2308821368U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3834048456U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(541997041U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1201102454U);
}

mxArray *sf_c1_SimulationPlantModel_Kalman_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("UVL9z5Gt3tJqFgkz0MPoKB");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c1_SimulationPlantModel_Kalman_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c1_SimulationPlantModel_Kalman(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"d_i_f\",},{M[8],M[0],T\"is_active_c1_SimulationPlantModel_Kalman\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_SimulationPlantModel_Kalman_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
    chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_KalmanMachineNumber_,
           1,
           1,
           1,
           6,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_KalmanMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_f");
          _SFD_SET_DATA_PROPS(1,1,1,0,"i_f");
          _SFD_SET_DATA_PROPS(2,2,0,1,"d_i_f");
          _SFD_SET_DATA_PROPS(3,10,0,0,"tau_f_G");
          _SFD_SET_DATA_PROPS(4,10,0,0,"r_f_G");
          _SFD_SET_DATA_PROPS(5,10,0,0,"GeneratorNumber");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,201);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_b_sf_marshallOut,(MexInFcnForType)
            c1_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_b_sf_marshallOut,(MexInFcnForType)
            c1_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);

        {
          real_T *c1_v_f;
          real_T *c1_i_f;
          real_T *c1_d_i_f;
          c1_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c1_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c1_v_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_v_f);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_i_f);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_d_i_f);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c1_tau_f_G);
          _SFD_SET_DATA_VALUE_PTR(4U, chartInstance->c1_r_f_G);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c1_GeneratorNumber);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_KalmanMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "S0QbnXuLDvv1atNht9gUWB";
}

static void sf_opaque_initialize_c1_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc1_SimulationPlantModel_KalmanInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
  initialize_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c1_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  enable_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c1_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  disable_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c1_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  sf_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c1_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c1_SimulationPlantModel_Kalman(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c1_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c1_SimulationPlantModel_Kalman(S);
}

static void sf_opaque_set_sim_state_c1_SimulationPlantModel_Kalman(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c1_SimulationPlantModel_Kalman(S, st);
}

static void sf_opaque_terminate_c1_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc1_SimulationPlantModel_KalmanInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Kalman_optimization_info();
    }

    finalize_c1_SimulationPlantModel_Kalman
      ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc1_SimulationPlantModel_Kalman
    ((SFc1_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_SimulationPlantModel_Kalman(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_SimulationPlantModel_Kalman
      ((SFc1_SimulationPlantModel_KalmanInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c1_SimulationPlantModel_Kalman(SimStruct *S)
{
  /* Actual parameters from chart:
     GeneratorNumber r_f_G tau_f_G
   */
  const char_T *rtParamNames[] = { "GeneratorNumber", "r_f_G", "tau_f_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for r_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for tau_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Kalman_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,1,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,1);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,1,2);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,1,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 2; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3432124798U));
  ssSetChecksum1(S,(3779589596U));
  ssSetChecksum2(S,(2386720955U));
  ssSetChecksum3(S,(1807110209U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c1_SimulationPlantModel_Kalman(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_SimulationPlantModel_Kalman(SimStruct *S)
{
  SFc1_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc1_SimulationPlantModel_KalmanInstanceStruct *)utMalloc
    (sizeof(SFc1_SimulationPlantModel_KalmanInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc1_SimulationPlantModel_KalmanInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlStart = mdlStart_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c1_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c1_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_SimulationPlantModel_Kalman(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_SimulationPlantModel_Kalman_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
