/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Kalman_sfun.h"
#include "c2_SimulationPlantModel_Kalman.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Kalman_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c2_debug_family_names[21] = { "N_G", "nargin", "nargout",
  "abs_e_a1", "omega_1", "abs_e_a2", "omega_2", "abs_e_a3", "omega_3", "delta_1",
  "delta_2", "delta_3", "omega_b", "e_aG", "omega_0", "d_delta_1", "d_delta_2",
  "d_delta_3", "CB1", "CB2", "CB3" };

/* Function Declarations */
static void initialize_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initialize_params_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void enable_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void disable_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void set_sim_state_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_st);
static void finalize_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void sf_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initSimStructsc2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void registerMessagesc2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData);
static real_T c2_emlrt_marshallIn(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c2_CB3, const char_T *c2_identifier);
static real_T c2_b_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_c_emlrt_marshallIn(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c2_e_aG, const char_T *c2_identifier, creal_T
  c2_y[3]);
static void c2_d_emlrt_marshallIn(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  creal_T c2_y[3]);
static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static int32_T c2_e_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static uint8_T c2_f_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_b_is_active_c2_SimulationPlantModel_Kalman, const char_T *c2_identifier);
static uint8_T c2_g_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId);
static real_T c2_get_CB1(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b);
static void c2_set_CB1(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b, real_T c2_c);
static real_T *c2_access_CB1(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b);
static real_T c2_get_CB2(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b);
static void c2_set_CB2(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b, real_T c2_c);
static real_T *c2_access_CB2(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b);
static real_T c2_get_CB3(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b);
static void c2_set_CB3(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b, real_T c2_c);
static real_T *c2_access_CB3(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b);
static void init_dsm_address_info(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  chartInstance->c2_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_is_active_c2_SimulationPlantModel_Kalman = 0U;
}

static void initialize_params_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c2_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'omega_b' in the parent workspace.\n");
  sf_mex_import_named("omega_b", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      &c2_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c2_omega_b = c2_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  const mxArray *c2_st;
  const mxArray *c2_y = NULL;
  real_T c2_hoistedGlobal;
  real_T c2_u;
  const mxArray *c2_b_y = NULL;
  real_T c2_b_hoistedGlobal;
  real_T c2_b_u;
  const mxArray *c2_c_y = NULL;
  real_T c2_c_hoistedGlobal;
  real_T c2_c_u;
  const mxArray *c2_d_y = NULL;
  int32_T c2_i0;
  creal_T c2_d_u[3];
  const mxArray *c2_e_y = NULL;
  real_T c2_d_hoistedGlobal;
  real_T c2_e_u;
  const mxArray *c2_f_y = NULL;
  uint8_T c2_e_hoistedGlobal;
  uint8_T c2_f_u;
  const mxArray *c2_g_y = NULL;
  real_T *c2_d_delta_1;
  real_T *c2_d_delta_2;
  real_T *c2_d_delta_3;
  real_T *c2_omega_0;
  creal_T (*c2_e_aG)[3];
  c2_d_delta_3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_d_delta_2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_d_delta_1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_omega_0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_e_aG = (creal_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(6), FALSE);
  c2_hoistedGlobal = *c2_d_delta_1;
  c2_u = c2_hoistedGlobal;
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 0, c2_b_y);
  c2_b_hoistedGlobal = *c2_d_delta_2;
  c2_b_u = c2_b_hoistedGlobal;
  c2_c_y = NULL;
  sf_mex_assign(&c2_c_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 1, c2_c_y);
  c2_c_hoistedGlobal = *c2_d_delta_3;
  c2_c_u = c2_c_hoistedGlobal;
  c2_d_y = NULL;
  sf_mex_assign(&c2_d_y, sf_mex_create("y", &c2_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 2, c2_d_y);
  for (c2_i0 = 0; c2_i0 < 3; c2_i0++) {
    c2_d_u[c2_i0] = (*c2_e_aG)[c2_i0];
  }

  c2_e_y = NULL;
  sf_mex_assign(&c2_e_y, sf_mex_create("y", c2_d_u, 0, 1U, 1U, 0U, 2, 3, 1),
                FALSE);
  sf_mex_setcell(c2_y, 3, c2_e_y);
  c2_d_hoistedGlobal = *c2_omega_0;
  c2_e_u = c2_d_hoistedGlobal;
  c2_f_y = NULL;
  sf_mex_assign(&c2_f_y, sf_mex_create("y", &c2_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 4, c2_f_y);
  c2_e_hoistedGlobal =
    chartInstance->c2_is_active_c2_SimulationPlantModel_Kalman;
  c2_f_u = c2_e_hoistedGlobal;
  c2_g_y = NULL;
  sf_mex_assign(&c2_g_y, sf_mex_create("y", &c2_f_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 5, c2_g_y);
  sf_mex_assign(&c2_st, c2_y, FALSE);
  return c2_st;
}

static void set_sim_state_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_st)
{
  const mxArray *c2_u;
  creal_T c2_dcv0[3];
  int32_T c2_i1;
  real_T *c2_d_delta_1;
  real_T *c2_d_delta_2;
  real_T *c2_d_delta_3;
  real_T *c2_omega_0;
  creal_T (*c2_e_aG)[3];
  c2_d_delta_3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_d_delta_2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_d_delta_1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_omega_0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_e_aG = (creal_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  *c2_d_delta_1 = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c2_u, 0)), "d_delta_1");
  *c2_d_delta_2 = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c2_u, 1)), "d_delta_2");
  *c2_d_delta_3 = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c2_u, 2)), "d_delta_3");
  c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 3)),
                        "e_aG", c2_dcv0);
  for (c2_i1 = 0; c2_i1 < 3; c2_i1++) {
    (*c2_e_aG)[c2_i1] = c2_dcv0[c2_i1];
  }

  *c2_omega_0 = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c2_u, 4)), "omega_0");
  chartInstance->c2_is_active_c2_SimulationPlantModel_Kalman =
    c2_f_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 5)),
    "is_active_c2_SimulationPlantModel_Kalman");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_SimulationPlantModel_Kalman(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void sf_c2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c2_hoistedGlobal;
  real_T c2_b_hoistedGlobal;
  real_T c2_c_hoistedGlobal;
  real_T c2_d_hoistedGlobal;
  real_T c2_e_hoistedGlobal;
  real_T c2_f_hoistedGlobal;
  real_T c2_g_hoistedGlobal;
  real_T c2_h_hoistedGlobal;
  real_T c2_i_hoistedGlobal;
  real_T c2_j_hoistedGlobal;
  real_T c2_abs_e_a1;
  real_T c2_omega_1;
  real_T c2_abs_e_a2;
  real_T c2_omega_2;
  real_T c2_abs_e_a3;
  real_T c2_omega_3;
  real_T c2_delta_1;
  real_T c2_delta_2;
  real_T c2_delta_3;
  real_T c2_b_omega_b;
  uint32_T c2_debug_family_var_map[21];
  real_T c2_N_G;
  real_T c2_nargin = 10.0;
  real_T c2_nargout = 5.0;
  creal_T c2_e_aG[3];
  real_T c2_omega_0;
  real_T c2_d_delta_1;
  real_T c2_d_delta_2;
  real_T c2_d_delta_3;
  real_T c2_B;
  real_T c2_y;
  real_T c2_b_y;
  real_T c2_c_y;
  real_T c2_k_hoistedGlobal;
  real_T c2_a;
  real_T c2_b;
  real_T c2_d_y;
  real_T c2_l_hoistedGlobal;
  real_T c2_b_a;
  real_T c2_b_b;
  real_T c2_e_y;
  real_T c2_m_hoistedGlobal;
  real_T c2_c_a;
  real_T c2_c_b;
  real_T c2_f_y;
  real_T c2_d_a;
  real_T c2_d_b;
  real_T c2_e_a;
  real_T c2_e_b;
  real_T c2_f_a;
  real_T c2_f_b;
  real_T c2_g_a;
  real_T c2_g_b;
  real_T c2_h_b;
  static creal_T c2_dc0 = { 0.0, 1.0 };

  creal_T c2_g_y;
  real_T c2_A;
  real_T c2_x;
  real_T c2_b_x;
  real_T c2_h_y;
  real_T c2_r;
  creal_T c2_i_y;
  creal_T c2_j_y;
  real_T c2_h_a;
  real_T c2_i_b;
  creal_T c2_k_y;
  real_T c2_b_A;
  real_T c2_c_x;
  real_T c2_d_x;
  real_T c2_l_y;
  real_T c2_b_r;
  creal_T c2_m_y;
  creal_T c2_n_y;
  real_T c2_i_a;
  real_T c2_j_b;
  creal_T c2_o_y;
  real_T c2_c_A;
  real_T c2_e_x;
  real_T c2_f_x;
  real_T c2_p_y;
  real_T c2_c_r;
  creal_T c2_q_y;
  creal_T c2_r_y;
  real_T c2_j_a;
  int32_T c2_i2;
  real_T *c2_b_d_delta_3;
  real_T *c2_b_d_delta_2;
  real_T *c2_b_d_delta_1;
  real_T *c2_b_omega_0;
  real_T *c2_b_delta_3;
  real_T *c2_b_delta_2;
  real_T *c2_b_delta_1;
  real_T *c2_b_omega_3;
  real_T *c2_b_abs_e_a3;
  real_T *c2_b_omega_2;
  real_T *c2_b_abs_e_a2;
  real_T *c2_b_omega_1;
  real_T *c2_b_abs_e_a1;
  creal_T (*c2_b_e_aG)[3];
  c2_b_d_delta_3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_b_d_delta_2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_b_d_delta_1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_b_delta_3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c2_b_delta_2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c2_b_omega_0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_b_e_aG = (creal_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_b_delta_1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c2_b_omega_3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c2_b_abs_e_a3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c2_b_omega_2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c2_b_abs_e_a2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c2_b_omega_1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c2_b_abs_e_a1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c2_b_abs_e_a1, 0U);
  _SFD_DATA_RANGE_CHECK(*c2_b_omega_1, 1U);
  _SFD_DATA_RANGE_CHECK(*c2_b_abs_e_a2, 2U);
  _SFD_DATA_RANGE_CHECK(*c2_b_omega_2, 3U);
  _SFD_DATA_RANGE_CHECK(*c2_b_abs_e_a3, 4U);
  _SFD_DATA_RANGE_CHECK(*c2_b_omega_3, 5U);
  _SFD_DATA_RANGE_CHECK(*c2_b_delta_1, 6U);
  _SFD_DATA_RANGE_CHECK(*c2_b_omega_0, 8U);
  _SFD_DATA_RANGE_CHECK(*c2_b_delta_2, 9U);
  _SFD_DATA_RANGE_CHECK(*c2_b_delta_3, 10U);
  _SFD_DATA_RANGE_CHECK(*c2_b_d_delta_1, 12U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c2_omega_b, 13U);
  _SFD_DATA_RANGE_CHECK(*c2_b_d_delta_2, 14U);
  _SFD_DATA_RANGE_CHECK(*c2_b_d_delta_3, 15U);
  chartInstance->c2_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  c2_hoistedGlobal = *c2_b_abs_e_a1;
  c2_b_hoistedGlobal = *c2_b_omega_1;
  c2_c_hoistedGlobal = *c2_b_abs_e_a2;
  c2_d_hoistedGlobal = *c2_b_omega_2;
  c2_e_hoistedGlobal = *c2_b_abs_e_a3;
  c2_f_hoistedGlobal = *c2_b_omega_3;
  c2_g_hoistedGlobal = *c2_b_delta_1;
  c2_h_hoistedGlobal = *c2_b_delta_2;
  c2_i_hoistedGlobal = *c2_b_delta_3;
  c2_j_hoistedGlobal = chartInstance->c2_omega_b;
  c2_abs_e_a1 = c2_hoistedGlobal;
  c2_omega_1 = c2_b_hoistedGlobal;
  c2_abs_e_a2 = c2_c_hoistedGlobal;
  c2_omega_2 = c2_d_hoistedGlobal;
  c2_abs_e_a3 = c2_e_hoistedGlobal;
  c2_omega_3 = c2_f_hoistedGlobal;
  c2_delta_1 = c2_g_hoistedGlobal;
  c2_delta_2 = c2_h_hoistedGlobal;
  c2_delta_3 = c2_i_hoistedGlobal;
  c2_b_omega_b = c2_j_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 21U, 21U, c2_debug_family_names,
    c2_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_N_G, 0U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargin, 1U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargout, 2U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_abs_e_a1, 3U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_omega_1, 4U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_abs_e_a2, 5U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_omega_2, 6U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_abs_e_a3, 7U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_omega_3, 8U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_delta_1, 9U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_delta_2, 10U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_delta_3, 11U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_b_omega_b, 12U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_e_aG, 13U, c2_b_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_omega_0, 14U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_d_delta_1, 15U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_d_delta_2, 16U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_d_delta_3, 17U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c2_CB1_address, 18U,
    c2_sf_marshallOut, c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c2_CB2_address, 19U,
    c2_sf_marshallOut, c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c2_CB3_address, 20U,
    c2_sf_marshallOut, c2_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 3);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 5);
  c2_N_G = (c2_get_CB1(chartInstance, 0) + c2_get_CB2(chartInstance, 0)) +
    c2_get_CB3(chartInstance, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 6);
  c2_B = c2_N_G;
  c2_y = c2_B;
  c2_b_y = c2_y;
  c2_c_y = 1.0 / c2_b_y;
  c2_k_hoistedGlobal = c2_get_CB1(chartInstance, 0);
  c2_a = c2_k_hoistedGlobal;
  c2_b = c2_omega_1;
  c2_d_y = c2_a * c2_b;
  c2_l_hoistedGlobal = c2_get_CB2(chartInstance, 0);
  c2_b_a = c2_l_hoistedGlobal;
  c2_b_b = c2_omega_2;
  c2_e_y = c2_b_a * c2_b_b;
  c2_m_hoistedGlobal = c2_get_CB3(chartInstance, 0);
  c2_c_a = c2_m_hoistedGlobal;
  c2_c_b = c2_omega_3;
  c2_f_y = c2_c_a * c2_c_b;
  c2_d_a = c2_c_y;
  c2_d_b = (c2_d_y + c2_e_y) + c2_f_y;
  c2_omega_0 = c2_d_a * c2_d_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 8);
  c2_e_a = c2_b_omega_b;
  c2_e_b = c2_omega_1 - c2_omega_0;
  c2_d_delta_1 = c2_e_a * c2_e_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 9);
  c2_f_a = c2_b_omega_b;
  c2_f_b = c2_omega_2 - c2_omega_0;
  c2_d_delta_2 = c2_f_a * c2_f_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 10);
  c2_g_a = c2_b_omega_b;
  c2_g_b = c2_omega_3 - c2_omega_0;
  c2_d_delta_3 = c2_g_a * c2_g_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 12);
  c2_h_b = c2_delta_1;
  c2_g_y.re = c2_h_b * c2_dc0.re;
  c2_g_y.im = c2_h_b * c2_dc0.im;
  c2_A = c2_g_y.re;
  c2_x = c2_A;
  c2_b_x = c2_x;
  c2_h_y = c2_b_x / 2.0;
  c2_r = muDoubleScalarExp(c2_h_y);
  c2_i_y = c2_g_y;
  c2_j_y = c2_g_y;
  c2_g_y.re = c2_r * (c2_r * muDoubleScalarCos(c2_i_y.im));
  c2_g_y.im = c2_r * (c2_r * muDoubleScalarSin(c2_j_y.im));
  c2_h_a = c2_abs_e_a1;
  c2_g_y.re *= c2_h_a;
  c2_g_y.im *= c2_h_a;
  c2_i_b = c2_delta_2;
  c2_k_y.re = c2_i_b * c2_dc0.re;
  c2_k_y.im = c2_i_b * c2_dc0.im;
  c2_b_A = c2_k_y.re;
  c2_c_x = c2_b_A;
  c2_d_x = c2_c_x;
  c2_l_y = c2_d_x / 2.0;
  c2_b_r = muDoubleScalarExp(c2_l_y);
  c2_m_y = c2_k_y;
  c2_n_y = c2_k_y;
  c2_k_y.re = c2_b_r * (c2_b_r * muDoubleScalarCos(c2_m_y.im));
  c2_k_y.im = c2_b_r * (c2_b_r * muDoubleScalarSin(c2_n_y.im));
  c2_i_a = c2_abs_e_a2;
  c2_k_y.re *= c2_i_a;
  c2_k_y.im *= c2_i_a;
  c2_j_b = c2_delta_3;
  c2_o_y.re = c2_j_b * c2_dc0.re;
  c2_o_y.im = c2_j_b * c2_dc0.im;
  c2_c_A = c2_o_y.re;
  c2_e_x = c2_c_A;
  c2_f_x = c2_e_x;
  c2_p_y = c2_f_x / 2.0;
  c2_c_r = muDoubleScalarExp(c2_p_y);
  c2_q_y = c2_o_y;
  c2_r_y = c2_o_y;
  c2_o_y.re = c2_c_r * (c2_c_r * muDoubleScalarCos(c2_q_y.im));
  c2_o_y.im = c2_c_r * (c2_c_r * muDoubleScalarSin(c2_r_y.im));
  c2_j_a = c2_abs_e_a3;
  c2_o_y.re *= c2_j_a;
  c2_o_y.im *= c2_j_a;
  c2_e_aG[0] = c2_g_y;
  c2_e_aG[1] = c2_k_y;
  c2_e_aG[2] = c2_o_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, -12);
  _SFD_SYMBOL_SCOPE_POP();
  for (c2_i2 = 0; c2_i2 < 3; c2_i2++) {
    (*c2_b_e_aG)[c2_i2] = c2_e_aG[c2_i2];
  }

  *c2_b_omega_0 = c2_omega_0;
  *c2_b_d_delta_1 = c2_d_delta_1;
  *c2_b_d_delta_2 = c2_d_delta_2;
  *c2_b_d_delta_3 = c2_d_delta_3;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_SimulationPlantModel_KalmanMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void registerMessagesc2_SimulationPlantModel_Kalman
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_emlrt_marshallIn(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c2_CB3, const char_T *c2_identifier)
{
  real_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_CB3), &c2_thisId);
  sf_mex_destroy(&c2_CB3);
  return c2_y;
}

static real_T c2_b_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d1;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d1, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d1;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_CB3;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c2_CB3 = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_CB3), &c2_thisId);
  sf_mex_destroy(&c2_CB3);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i3;
  creal_T c2_b_inData[3];
  int32_T c2_i4;
  creal_T c2_u[3];
  const mxArray *c2_y = NULL;
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i3 = 0; c2_i3 < 3; c2_i3++) {
    c2_b_inData[c2_i3] = (*(creal_T (*)[3])c2_inData)[c2_i3];
  }

  for (c2_i4 = 0; c2_i4 < 3; c2_i4++) {
    c2_u[c2_i4] = c2_b_inData[c2_i4];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 1U, 1U, 0U, 2, 3, 1), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_c_emlrt_marshallIn(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c2_e_aG, const char_T *c2_identifier, creal_T
  c2_y[3])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_e_aG), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_e_aG);
}

static void c2_d_emlrt_marshallIn(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  creal_T c2_y[3])
{
  creal_T c2_dcv1[3];
  int32_T c2_i5;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dcv1, 1, 0, 1U, 1, 0U, 2, 3, 1);
  for (c2_i5 = 0; c2_i5 < 3; c2_i5++) {
    c2_y[c2_i5] = c2_dcv1[c2_i5];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_e_aG;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  creal_T c2_y[3];
  int32_T c2_i6;
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c2_e_aG = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_e_aG), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_e_aG);
  for (c2_i6 = 0; c2_i6 < 3; c2_i6++) {
    (*(creal_T (*)[3])c2_outData)[c2_i6] = c2_y[c2_i6];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

const mxArray *sf_c2_SimulationPlantModel_Kalman_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c2_nameCaptureInfo;
  c2_ResolvedFunctionInfo c2_info[8];
  c2_ResolvedFunctionInfo (*c2_b_info)[8];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i7;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_nameCaptureInfo = NULL;
  c2_b_info = (c2_ResolvedFunctionInfo (*)[8])c2_info;
  (*c2_b_info)[0].context = "";
  (*c2_b_info)[0].name = "mrdivide";
  (*c2_b_info)[0].dominantType = "double";
  (*c2_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c2_b_info)[0].fileTimeLo = 1357951548U;
  (*c2_b_info)[0].fileTimeHi = 0U;
  (*c2_b_info)[0].mFileTimeLo = 1319729966U;
  (*c2_b_info)[0].mFileTimeHi = 0U;
  (*c2_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c2_b_info)[1].name = "rdivide";
  (*c2_b_info)[1].dominantType = "double";
  (*c2_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c2_b_info)[1].fileTimeLo = 1346510388U;
  (*c2_b_info)[1].fileTimeHi = 0U;
  (*c2_b_info)[1].mFileTimeLo = 0U;
  (*c2_b_info)[1].mFileTimeHi = 0U;
  (*c2_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c2_b_info)[2].name = "eml_scalexp_compatible";
  (*c2_b_info)[2].dominantType = "double";
  (*c2_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  (*c2_b_info)[2].fileTimeLo = 1286818796U;
  (*c2_b_info)[2].fileTimeHi = 0U;
  (*c2_b_info)[2].mFileTimeLo = 0U;
  (*c2_b_info)[2].mFileTimeHi = 0U;
  (*c2_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c2_b_info)[3].name = "eml_div";
  (*c2_b_info)[3].dominantType = "double";
  (*c2_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c2_b_info)[3].fileTimeLo = 1313347810U;
  (*c2_b_info)[3].fileTimeHi = 0U;
  (*c2_b_info)[3].mFileTimeLo = 0U;
  (*c2_b_info)[3].mFileTimeHi = 0U;
  (*c2_b_info)[4].context = "";
  (*c2_b_info)[4].name = "mtimes";
  (*c2_b_info)[4].dominantType = "double";
  (*c2_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c2_b_info)[4].fileTimeLo = 1289519692U;
  (*c2_b_info)[4].fileTimeHi = 0U;
  (*c2_b_info)[4].mFileTimeLo = 0U;
  (*c2_b_info)[4].mFileTimeHi = 0U;
  (*c2_b_info)[5].context = "";
  (*c2_b_info)[5].name = "exp";
  (*c2_b_info)[5].dominantType = "double";
  (*c2_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  (*c2_b_info)[5].fileTimeLo = 1343830380U;
  (*c2_b_info)[5].fileTimeHi = 0U;
  (*c2_b_info)[5].mFileTimeLo = 0U;
  (*c2_b_info)[5].mFileTimeHi = 0U;
  (*c2_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  (*c2_b_info)[6].name = "eml_scalar_exp";
  (*c2_b_info)[6].dominantType = "double";
  (*c2_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  (*c2_b_info)[6].fileTimeLo = 1301328464U;
  (*c2_b_info)[6].fileTimeHi = 0U;
  (*c2_b_info)[6].mFileTimeLo = 0U;
  (*c2_b_info)[6].mFileTimeHi = 0U;
  (*c2_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  (*c2_b_info)[7].name = "mrdivide";
  (*c2_b_info)[7].dominantType = "double";
  (*c2_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c2_b_info)[7].fileTimeLo = 1357951548U;
  (*c2_b_info)[7].fileTimeHi = 0U;
  (*c2_b_info)[7].mFileTimeLo = 1319729966U;
  (*c2_b_info)[7].mFileTimeHi = 0U;
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 8), FALSE);
  for (c2_i7 = 0; c2_i7 < 8; c2_i7++) {
    c2_r0 = &c2_info[c2_i7];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context", "nameCaptureInfo",
                    c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name", "nameCaptureInfo", c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved", "nameCaptureInfo",
                    c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c2_i7);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c2_i7);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c2_nameCaptureInfo);
  return c2_nameCaptureInfo;
}

static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(int32_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static int32_T c2_e_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  int32_T c2_y;
  int32_T c2_i8;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_i8, 1, 6, 0U, 0, 0U, 0);
  c2_y = c2_i8;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_sfEvent;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  int32_T c2_y;
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c2_b_sfEvent = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_sfEvent),
    &c2_thisId);
  sf_mex_destroy(&c2_b_sfEvent);
  *(int32_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static uint8_T c2_f_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_b_is_active_c2_SimulationPlantModel_Kalman, const char_T *c2_identifier)
{
  uint8_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c2_b_is_active_c2_SimulationPlantModel_Kalman), &c2_thisId);
  sf_mex_destroy(&c2_b_is_active_c2_SimulationPlantModel_Kalman);
  return c2_y;
}

static uint8_T c2_g_emlrt_marshallIn
  (SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_u0, 1, 3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static real_T c2_get_CB1(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 0, NULL, c2_b);
  if (chartInstance->c2_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#46) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c2_CB1_address;
}

static void c2_set_CB1(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b, real_T c2_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 0, NULL, c2_b);
  if (chartInstance->c2_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#46) in the initialization routine of the chart.\n");
  }

  *chartInstance->c2_CB1_address = c2_c;
}

static real_T *c2_access_CB1(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b)
{
  real_T *c2_c;
  ssReadFromDataStore(chartInstance->S, 0, NULL);
  if (chartInstance->c2_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#46) in the initialization routine of the chart.\n");
  }

  c2_c = chartInstance->c2_CB1_address;
  if (c2_b == 0) {
    ssWriteToDataStore(chartInstance->S, 0, NULL);
  }

  return c2_c;
}

static real_T c2_get_CB2(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 1, NULL, c2_b);
  if (chartInstance->c2_CB2_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB2\' (#51) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c2_CB2_address;
}

static void c2_set_CB2(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b, real_T c2_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 1, NULL, c2_b);
  if (chartInstance->c2_CB2_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB2\' (#51) in the initialization routine of the chart.\n");
  }

  *chartInstance->c2_CB2_address = c2_c;
}

static real_T *c2_access_CB2(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b)
{
  real_T *c2_c;
  ssReadFromDataStore(chartInstance->S, 1, NULL);
  if (chartInstance->c2_CB2_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB2\' (#51) in the initialization routine of the chart.\n");
  }

  c2_c = chartInstance->c2_CB2_address;
  if (c2_b == 0) {
    ssWriteToDataStore(chartInstance->S, 1, NULL);
  }

  return c2_c;
}

static real_T c2_get_CB3(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 2, NULL, c2_b);
  if (chartInstance->c2_CB3_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB3\' (#52) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c2_CB3_address;
}

static void c2_set_CB3(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b, real_T c2_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 2, NULL, c2_b);
  if (chartInstance->c2_CB3_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB3\' (#52) in the initialization routine of the chart.\n");
  }

  *chartInstance->c2_CB3_address = c2_c;
}

static real_T *c2_access_CB3(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, uint32_T c2_b)
{
  real_T *c2_c;
  ssReadFromDataStore(chartInstance->S, 2, NULL);
  if (chartInstance->c2_CB3_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB3\' (#52) in the initialization routine of the chart.\n");
  }

  c2_c = chartInstance->c2_CB3_address;
  if (c2_b == 0) {
    ssWriteToDataStore(chartInstance->S, 2, NULL);
  }

  return c2_c;
}

static void init_dsm_address_info(SFc2_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance)
{
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB1", (void **)
    &chartInstance->c2_CB1_address, &chartInstance->c2_CB1_index);
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB2", (void **)
    &chartInstance->c2_CB2_address, &chartInstance->c2_CB2_index);
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB3", (void **)
    &chartInstance->c2_CB3_address, &chartInstance->c2_CB3_index);
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c2_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1672433277U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2726575492U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(888553920U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3411732493U);
}

mxArray *sf_c2_SimulationPlantModel_Kalman_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("0CK8TxScko9rfEn2wfLMiH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,9,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(1));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c2_SimulationPlantModel_Kalman_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c2_SimulationPlantModel_Kalman(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x6'type','srcId','name','auxInfo'{{M[1],M[19],T\"d_delta_1\",},{M[1],M[21],T\"d_delta_2\",},{M[1],M[22],T\"d_delta_3\",},{M[1],M[5],T\"e_aG\",},{M[1],M[25],T\"omega_0\",},{M[8],M[0],T\"is_active_c2_SimulationPlantModel_Kalman\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 6, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_SimulationPlantModel_Kalman_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
    chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_KalmanMachineNumber_,
           2,
           1,
           1,
           18,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_KalmanMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"abs_e_a1");
          _SFD_SET_DATA_PROPS(1,1,1,0,"omega_1");
          _SFD_SET_DATA_PROPS(2,1,1,0,"abs_e_a2");
          _SFD_SET_DATA_PROPS(3,1,1,0,"omega_2");
          _SFD_SET_DATA_PROPS(4,1,1,0,"abs_e_a3");
          _SFD_SET_DATA_PROPS(5,1,1,0,"omega_3");
          _SFD_SET_DATA_PROPS(6,1,1,0,"delta_1");
          _SFD_SET_DATA_PROPS(7,2,0,1,"e_aG");
          _SFD_SET_DATA_PROPS(8,2,0,1,"omega_0");
          _SFD_SET_DATA_PROPS(9,1,1,0,"delta_2");
          _SFD_SET_DATA_PROPS(10,1,1,0,"delta_3");
          _SFD_SET_DATA_PROPS(11,11,0,0,"CB1");
          _SFD_SET_DATA_PROPS(12,2,0,1,"d_delta_1");
          _SFD_SET_DATA_PROPS(13,10,0,0,"omega_b");
          _SFD_SET_DATA_PROPS(14,2,0,1,"d_delta_2");
          _SFD_SET_DATA_PROPS(15,2,0,1,"d_delta_3");
          _SFD_SET_DATA_PROPS(16,11,0,0,"CB2");
          _SFD_SET_DATA_PROPS(17,11,0,0,"CB3");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,471);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 1;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,1,(MexFcnForType)c2_b_sf_marshallOut,(MexInFcnForType)
            c2_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);

        {
          real_T *c2_abs_e_a1;
          real_T *c2_omega_1;
          real_T *c2_abs_e_a2;
          real_T *c2_omega_2;
          real_T *c2_abs_e_a3;
          real_T *c2_omega_3;
          real_T *c2_delta_1;
          real_T *c2_omega_0;
          real_T *c2_delta_2;
          real_T *c2_delta_3;
          real_T *c2_d_delta_1;
          real_T *c2_d_delta_2;
          real_T *c2_d_delta_3;
          creal_T (*c2_e_aG)[3];
          c2_d_delta_3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c2_d_delta_2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c2_d_delta_1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c2_delta_3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
          c2_delta_2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
          c2_omega_0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c2_e_aG = (creal_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c2_delta_1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
          c2_omega_3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c2_abs_e_a3 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c2_omega_2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c2_abs_e_a2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c2_omega_1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c2_abs_e_a1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c2_abs_e_a1);
          _SFD_SET_DATA_VALUE_PTR(1U, c2_omega_1);
          _SFD_SET_DATA_VALUE_PTR(2U, c2_abs_e_a2);
          _SFD_SET_DATA_VALUE_PTR(3U, c2_omega_2);
          _SFD_SET_DATA_VALUE_PTR(4U, c2_abs_e_a3);
          _SFD_SET_DATA_VALUE_PTR(5U, c2_omega_3);
          _SFD_SET_DATA_VALUE_PTR(6U, c2_delta_1);
          _SFD_SET_DATA_VALUE_PTR(7U, *c2_e_aG);
          _SFD_SET_DATA_VALUE_PTR(8U, c2_omega_0);
          _SFD_SET_DATA_VALUE_PTR(9U, c2_delta_2);
          _SFD_SET_DATA_VALUE_PTR(10U, c2_delta_3);
          _SFD_SET_DATA_VALUE_PTR(11U, chartInstance->c2_CB1_address);
          _SFD_SET_DATA_VALUE_PTR(12U, c2_d_delta_1);
          _SFD_SET_DATA_VALUE_PTR(13U, &chartInstance->c2_omega_b);
          _SFD_SET_DATA_VALUE_PTR(14U, c2_d_delta_2);
          _SFD_SET_DATA_VALUE_PTR(15U, c2_d_delta_3);
          _SFD_SET_DATA_VALUE_PTR(16U, chartInstance->c2_CB2_address);
          _SFD_SET_DATA_VALUE_PTR(17U, chartInstance->c2_CB3_address);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_KalmanMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "kLta4e8FAssaQVbeL5YrNC";
}

static void sf_opaque_initialize_c2_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc2_SimulationPlantModel_KalmanInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
  initialize_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c2_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  enable_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c2_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  disable_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c2_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  sf_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c2_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c2_SimulationPlantModel_Kalman(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c2_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c2_SimulationPlantModel_Kalman(S);
}

static void sf_opaque_set_sim_state_c2_SimulationPlantModel_Kalman(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c2_SimulationPlantModel_Kalman(S, st);
}

static void sf_opaque_terminate_c2_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_SimulationPlantModel_KalmanInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Kalman_optimization_info();
    }

    finalize_c2_SimulationPlantModel_Kalman
      ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc2_SimulationPlantModel_Kalman
    ((SFc2_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_SimulationPlantModel_Kalman(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_SimulationPlantModel_Kalman
      ((SFc2_SimulationPlantModel_KalmanInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_SimulationPlantModel_Kalman(SimStruct *S)
{
  /* Actual parameters from chart:
     omega_b
   */
  const char_T *rtParamNames[] = { "omega_b" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for omega_b*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Kalman_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,2,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,2);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,2,9);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,2,5);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=5; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 9; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(245979818U));
  ssSetChecksum1(S,(1362957563U));
  ssSetChecksum2(S,(1967066123U));
  ssSetChecksum3(S,(1446356705U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,0);
}

static void mdlRTW_c2_SimulationPlantModel_Kalman(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_SimulationPlantModel_Kalman(SimStruct *S)
{
  SFc2_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc2_SimulationPlantModel_KalmanInstanceStruct *)utMalloc
    (sizeof(SFc2_SimulationPlantModel_KalmanInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc2_SimulationPlantModel_KalmanInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlStart = mdlStart_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c2_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c2_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_SimulationPlantModel_Kalman(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_SimulationPlantModel_Kalman_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
