#ifndef __c36_SimulationPlantModel_Kalman_h__
#define __c36_SimulationPlantModel_Kalman_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_SFc36_SimulationPlantModel_KalmanInstanceStruct
#define typedef_SFc36_SimulationPlantModel_KalmanInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c36_sfEvent;
  boolean_T c36_isStable;
  boolean_T c36_doneDoubleBufferReInit;
  uint8_T c36_is_active_c36_SimulationPlantModel_Kalman;
  real_T c36_diff_y[6];
  real_T c36_DisconnectWhenFaultDetected;
} SFc36_SimulationPlantModel_KalmanInstanceStruct;

#endif                                 /*typedef_SFc36_SimulationPlantModel_KalmanInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c36_SimulationPlantModel_Kalman_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c36_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[]);
extern void c36_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
