/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c43_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c43_debug_family_names[10] = { "nargin", "nargout",
  "tilde_omega", "tilde_p", "tilde_q", "time", "saveTime", "save_tomega",
  "save_tp", "save_tq" };

/* Function Declarations */
static void initialize_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c43_update_debugger_state_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_st);
static void finalize_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c43_machineNumber, uint32_T
  c43_chartNumber);
static const mxArray *c43_sf_marshallOut(void *chartInstanceVoid, void
  *c43_inData);
static real_T c43_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_save_tq, const char_T *c43_identifier);
static real_T c43_b_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_u, const emlrtMsgIdentifier *c43_parentId);
static void c43_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c43_mxArrayInData, const char_T *c43_varName, void *c43_outData);
static const mxArray *c43_b_sf_marshallOut(void *chartInstanceVoid, void
  *c43_inData);
static int32_T c43_c_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_u, const emlrtMsgIdentifier *c43_parentId);
static void c43_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c43_mxArrayInData, const char_T *c43_varName, void *c43_outData);
static uint8_T c43_d_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_b_is_active_c43_SimulationPlantModel_Luenberg, const char_T
   *c43_identifier);
static uint8_T c43_e_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_u, const emlrtMsgIdentifier *c43_parentId);
static void init_dsm_address_info
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c43_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c43_is_active_c43_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void enable_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c43_update_debugger_state_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c43_st;
  const mxArray *c43_y = NULL;
  real_T c43_hoistedGlobal;
  real_T c43_u;
  const mxArray *c43_b_y = NULL;
  real_T c43_b_hoistedGlobal;
  real_T c43_b_u;
  const mxArray *c43_c_y = NULL;
  real_T c43_c_hoistedGlobal;
  real_T c43_c_u;
  const mxArray *c43_d_y = NULL;
  real_T c43_d_hoistedGlobal;
  real_T c43_d_u;
  const mxArray *c43_e_y = NULL;
  uint8_T c43_e_hoistedGlobal;
  uint8_T c43_e_u;
  const mxArray *c43_f_y = NULL;
  real_T *c43_saveTime;
  real_T *c43_save_tomega;
  real_T *c43_save_tp;
  real_T *c43_save_tq;
  c43_save_tq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c43_save_tp = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c43_save_tomega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c43_saveTime = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c43_st = NULL;
  c43_st = NULL;
  c43_y = NULL;
  sf_mex_assign(&c43_y, sf_mex_createcellarray(5), FALSE);
  c43_hoistedGlobal = *c43_saveTime;
  c43_u = c43_hoistedGlobal;
  c43_b_y = NULL;
  sf_mex_assign(&c43_b_y, sf_mex_create("y", &c43_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c43_y, 0, c43_b_y);
  c43_b_hoistedGlobal = *c43_save_tomega;
  c43_b_u = c43_b_hoistedGlobal;
  c43_c_y = NULL;
  sf_mex_assign(&c43_c_y, sf_mex_create("y", &c43_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c43_y, 1, c43_c_y);
  c43_c_hoistedGlobal = *c43_save_tp;
  c43_c_u = c43_c_hoistedGlobal;
  c43_d_y = NULL;
  sf_mex_assign(&c43_d_y, sf_mex_create("y", &c43_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c43_y, 2, c43_d_y);
  c43_d_hoistedGlobal = *c43_save_tq;
  c43_d_u = c43_d_hoistedGlobal;
  c43_e_y = NULL;
  sf_mex_assign(&c43_e_y, sf_mex_create("y", &c43_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c43_y, 3, c43_e_y);
  c43_e_hoistedGlobal =
    chartInstance->c43_is_active_c43_SimulationPlantModel_Luenberg;
  c43_e_u = c43_e_hoistedGlobal;
  c43_f_y = NULL;
  sf_mex_assign(&c43_f_y, sf_mex_create("y", &c43_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c43_y, 4, c43_f_y);
  sf_mex_assign(&c43_st, c43_y, FALSE);
  return c43_st;
}

static void set_sim_state_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_st)
{
  const mxArray *c43_u;
  real_T *c43_saveTime;
  real_T *c43_save_tomega;
  real_T *c43_save_tp;
  real_T *c43_save_tq;
  c43_save_tq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c43_save_tp = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c43_save_tomega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c43_saveTime = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c43_doneDoubleBufferReInit = TRUE;
  c43_u = sf_mex_dup(c43_st);
  *c43_saveTime = c43_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c43_u, 0)), "saveTime");
  *c43_save_tomega = c43_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c43_u, 1)), "save_tomega");
  *c43_save_tp = c43_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c43_u, 2)), "save_tp");
  *c43_save_tq = c43_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c43_u, 3)), "save_tq");
  chartInstance->c43_is_active_c43_SimulationPlantModel_Luenberg =
    c43_d_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c43_u, 4)),
    "is_active_c43_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c43_u);
  c43_update_debugger_state_c43_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c43_st);
}

static void finalize_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  real_T c43_hoistedGlobal;
  real_T c43_b_hoistedGlobal;
  real_T c43_c_hoistedGlobal;
  real_T c43_d_hoistedGlobal;
  real_T c43_tilde_omega;
  real_T c43_tilde_p;
  real_T c43_tilde_q;
  real_T c43_time;
  uint32_T c43_debug_family_var_map[10];
  real_T c43_nargin = 4.0;
  real_T c43_nargout = 4.0;
  real_T c43_saveTime;
  real_T c43_save_tomega;
  real_T c43_save_tp;
  real_T c43_save_tq;
  real_T *c43_b_tilde_omega;
  real_T *c43_b_tilde_p;
  real_T *c43_b_tilde_q;
  real_T *c43_b_saveTime;
  real_T *c43_b_time;
  real_T *c43_b_save_tomega;
  real_T *c43_b_save_tp;
  real_T *c43_b_save_tq;
  c43_b_save_tq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c43_b_save_tp = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c43_b_save_tomega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c43_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c43_b_saveTime = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c43_b_tilde_q = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c43_b_tilde_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c43_b_tilde_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 42U, chartInstance->c43_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c43_b_tilde_omega, 0U);
  _SFD_DATA_RANGE_CHECK(*c43_b_tilde_p, 1U);
  _SFD_DATA_RANGE_CHECK(*c43_b_tilde_q, 2U);
  _SFD_DATA_RANGE_CHECK(*c43_b_saveTime, 3U);
  _SFD_DATA_RANGE_CHECK(*c43_b_time, 4U);
  _SFD_DATA_RANGE_CHECK(*c43_b_save_tomega, 5U);
  _SFD_DATA_RANGE_CHECK(*c43_b_save_tp, 6U);
  _SFD_DATA_RANGE_CHECK(*c43_b_save_tq, 7U);
  chartInstance->c43_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 42U, chartInstance->c43_sfEvent);
  c43_hoistedGlobal = *c43_b_tilde_omega;
  c43_b_hoistedGlobal = *c43_b_tilde_p;
  c43_c_hoistedGlobal = *c43_b_tilde_q;
  c43_d_hoistedGlobal = *c43_b_time;
  c43_tilde_omega = c43_hoistedGlobal;
  c43_tilde_p = c43_b_hoistedGlobal;
  c43_tilde_q = c43_c_hoistedGlobal;
  c43_time = c43_d_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 10U, 10U, c43_debug_family_names,
    c43_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c43_nargin, 0U, c43_sf_marshallOut,
    c43_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c43_nargout, 1U, c43_sf_marshallOut,
    c43_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c43_tilde_omega, 2U, c43_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c43_tilde_p, 3U, c43_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c43_tilde_q, 4U, c43_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c43_time, 5U, c43_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c43_saveTime, 6U, c43_sf_marshallOut,
    c43_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c43_save_tomega, 7U, c43_sf_marshallOut,
    c43_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c43_save_tp, 8U, c43_sf_marshallOut,
    c43_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c43_save_tq, 9U, c43_sf_marshallOut,
    c43_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 3);
  if (CV_EML_IF(0, 1, 0, c43_time >= 5.0)) {
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 4);
    c43_saveTime = c43_time;
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 5);
    c43_save_tomega = c43_tilde_omega;
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 6);
    c43_save_tp = c43_tilde_p;
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 7);
    c43_save_tq = c43_tilde_q;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 9);
    c43_saveTime = rtNaN;
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 10);
    c43_save_tomega = rtNaN;
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 11);
    c43_save_tp = rtNaN;
    _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, 12);
    c43_save_tq = rtNaN;
  }

  _SFD_EML_CALL(0U, chartInstance->c43_sfEvent, -12);
  _SFD_SYMBOL_SCOPE_POP();
  *c43_b_saveTime = c43_saveTime;
  *c43_b_save_tomega = c43_save_tomega;
  *c43_b_save_tp = c43_save_tp;
  *c43_b_save_tq = c43_save_tq;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 42U, chartInstance->c43_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc43_SimulationPlantModel_Luenberg
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c43_machineNumber, uint32_T
  c43_chartNumber)
{
}

static const mxArray *c43_sf_marshallOut(void *chartInstanceVoid, void
  *c43_inData)
{
  const mxArray *c43_mxArrayOutData = NULL;
  real_T c43_u;
  const mxArray *c43_y = NULL;
  SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc43_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c43_mxArrayOutData = NULL;
  c43_u = *(real_T *)c43_inData;
  c43_y = NULL;
  sf_mex_assign(&c43_y, sf_mex_create("y", &c43_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c43_mxArrayOutData, c43_y, FALSE);
  return c43_mxArrayOutData;
}

static real_T c43_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_save_tq, const char_T *c43_identifier)
{
  real_T c43_y;
  emlrtMsgIdentifier c43_thisId;
  c43_thisId.fIdentifier = c43_identifier;
  c43_thisId.fParent = NULL;
  c43_y = c43_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c43_save_tq),
    &c43_thisId);
  sf_mex_destroy(&c43_save_tq);
  return c43_y;
}

static real_T c43_b_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_u, const emlrtMsgIdentifier *c43_parentId)
{
  real_T c43_y;
  real_T c43_d0;
  sf_mex_import(c43_parentId, sf_mex_dup(c43_u), &c43_d0, 1, 0, 0U, 0, 0U, 0);
  c43_y = c43_d0;
  sf_mex_destroy(&c43_u);
  return c43_y;
}

static void c43_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c43_mxArrayInData, const char_T *c43_varName, void *c43_outData)
{
  const mxArray *c43_save_tq;
  const char_T *c43_identifier;
  emlrtMsgIdentifier c43_thisId;
  real_T c43_y;
  SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc43_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c43_save_tq = sf_mex_dup(c43_mxArrayInData);
  c43_identifier = c43_varName;
  c43_thisId.fIdentifier = c43_identifier;
  c43_thisId.fParent = NULL;
  c43_y = c43_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c43_save_tq),
    &c43_thisId);
  sf_mex_destroy(&c43_save_tq);
  *(real_T *)c43_outData = c43_y;
  sf_mex_destroy(&c43_mxArrayInData);
}

const mxArray
  *sf_c43_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c43_nameCaptureInfo = NULL;
  c43_nameCaptureInfo = NULL;
  sf_mex_assign(&c43_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c43_nameCaptureInfo;
}

static const mxArray *c43_b_sf_marshallOut(void *chartInstanceVoid, void
  *c43_inData)
{
  const mxArray *c43_mxArrayOutData = NULL;
  int32_T c43_u;
  const mxArray *c43_y = NULL;
  SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc43_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c43_mxArrayOutData = NULL;
  c43_u = *(int32_T *)c43_inData;
  c43_y = NULL;
  sf_mex_assign(&c43_y, sf_mex_create("y", &c43_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c43_mxArrayOutData, c43_y, FALSE);
  return c43_mxArrayOutData;
}

static int32_T c43_c_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_u, const emlrtMsgIdentifier *c43_parentId)
{
  int32_T c43_y;
  int32_T c43_i0;
  sf_mex_import(c43_parentId, sf_mex_dup(c43_u), &c43_i0, 1, 6, 0U, 0, 0U, 0);
  c43_y = c43_i0;
  sf_mex_destroy(&c43_u);
  return c43_y;
}

static void c43_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c43_mxArrayInData, const char_T *c43_varName, void *c43_outData)
{
  const mxArray *c43_b_sfEvent;
  const char_T *c43_identifier;
  emlrtMsgIdentifier c43_thisId;
  int32_T c43_y;
  SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc43_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c43_b_sfEvent = sf_mex_dup(c43_mxArrayInData);
  c43_identifier = c43_varName;
  c43_thisId.fIdentifier = c43_identifier;
  c43_thisId.fParent = NULL;
  c43_y = c43_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c43_b_sfEvent),
    &c43_thisId);
  sf_mex_destroy(&c43_b_sfEvent);
  *(int32_T *)c43_outData = c43_y;
  sf_mex_destroy(&c43_mxArrayInData);
}

static uint8_T c43_d_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_b_is_active_c43_SimulationPlantModel_Luenberg, const char_T
   *c43_identifier)
{
  uint8_T c43_y;
  emlrtMsgIdentifier c43_thisId;
  c43_thisId.fIdentifier = c43_identifier;
  c43_thisId.fParent = NULL;
  c43_y = c43_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c43_b_is_active_c43_SimulationPlantModel_Luenberg), &c43_thisId);
  sf_mex_destroy(&c43_b_is_active_c43_SimulationPlantModel_Luenberg);
  return c43_y;
}

static uint8_T c43_e_emlrt_marshallIn
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c43_u, const emlrtMsgIdentifier *c43_parentId)
{
  uint8_T c43_y;
  uint8_T c43_u0;
  sf_mex_import(c43_parentId, sf_mex_dup(c43_u), &c43_u0, 1, 3, 0U, 0, 0U, 0);
  c43_y = c43_u0;
  sf_mex_destroy(&c43_u);
  return c43_y;
}

static void init_dsm_address_info
  (SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c43_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2729244626U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2487729636U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(369244915U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2043269342U);
}

mxArray *sf_c43_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("W9AhuA7vuPVbm4WAq7JEfG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c43_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c43_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[4],T\"saveTime\",},{M[1],M[15],T\"save_tomega\",},{M[1],M[16],T\"save_tp\",},{M[1],M[17],T\"save_tq\",},{M[8],M[0],T\"is_active_c43_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c43_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc43_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           43,
           1,
           1,
           8,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"tilde_omega");
          _SFD_SET_DATA_PROPS(1,1,1,0,"tilde_p");
          _SFD_SET_DATA_PROPS(2,1,1,0,"tilde_q");
          _SFD_SET_DATA_PROPS(3,2,0,1,"saveTime");
          _SFD_SET_DATA_PROPS(4,1,1,0,"time");
          _SFD_SET_DATA_PROPS(5,2,0,1,"save_tomega");
          _SFD_SET_DATA_PROPS(6,2,0,1,"save_tp");
          _SFD_SET_DATA_PROPS(7,2,0,1,"save_tq");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,297);
        _SFD_CV_INIT_EML_IF(0,1,0,93,105,204,293);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)c43_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)c43_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)c43_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c43_sf_marshallOut,(MexInFcnForType)c43_sf_marshallIn);

        {
          real_T *c43_tilde_omega;
          real_T *c43_tilde_p;
          real_T *c43_tilde_q;
          real_T *c43_saveTime;
          real_T *c43_time;
          real_T *c43_save_tomega;
          real_T *c43_save_tp;
          real_T *c43_save_tq;
          c43_save_tq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c43_save_tp = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c43_save_tomega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c43_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c43_saveTime = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c43_tilde_q = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c43_tilde_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c43_tilde_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c43_tilde_omega);
          _SFD_SET_DATA_VALUE_PTR(1U, c43_tilde_p);
          _SFD_SET_DATA_VALUE_PTR(2U, c43_tilde_q);
          _SFD_SET_DATA_VALUE_PTR(3U, c43_saveTime);
          _SFD_SET_DATA_VALUE_PTR(4U, c43_time);
          _SFD_SET_DATA_VALUE_PTR(5U, c43_save_tomega);
          _SFD_SET_DATA_VALUE_PTR(6U, c43_save_tp);
          _SFD_SET_DATA_VALUE_PTR(7U, c43_save_tq);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "pqdejabN6btjAkvbkPjn2B";
}

static void sf_opaque_initialize_c43_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc43_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c43_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c43_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c43_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c43_SimulationPlantModel_Luenberg(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c43_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c43_SimulationPlantModel_Luenberg
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c43_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c43_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c43_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c43_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c43_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c43_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c43_SimulationPlantModel_Luenberg
      ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc43_SimulationPlantModel_Luenberg
    ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c43_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c43_SimulationPlantModel_Luenberg
      ((SFc43_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c43_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      43);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,43,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,43,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,43);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,43,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,43,4);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=4; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 4; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,43);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1509962832U));
  ssSetChecksum1(S,(2607118738U));
  ssSetChecksum2(S,(2401440894U));
  ssSetChecksum3(S,(3964872906U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c43_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c43_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc43_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc43_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc43_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc43_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c43_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c43_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c43_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c43_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c43_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c43_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
