#ifndef __c45_SimulationPlantModel_Luenberg_h__
#define __c45_SimulationPlantModel_Luenberg_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_SFc45_SimulationPlantModel_LuenbergInstanceStruct
#define typedef_SFc45_SimulationPlantModel_LuenbergInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c45_sfEvent;
  boolean_T c45_isStable;
  boolean_T c45_doneDoubleBufferReInit;
  uint8_T c45_is_active_c45_SimulationPlantModel_Luenberg;
  real_T *c45_CB1_address;
  int32_T c45_CB1_index;
  real_T *c45_CB2_address;
  int32_T c45_CB2_index;
  real_T *c45_CB3_address;
  int32_T c45_CB3_index;
} SFc45_SimulationPlantModel_LuenbergInstanceStruct;

#endif                                 /*typedef_SFc45_SimulationPlantModel_LuenbergInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c45_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c45_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[]);
extern void c45_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
