/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c8_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c8_debug_family_names[21] = { "r_s", "p", "q", "D_fw", "H",
  "abs_v_ll", "p_loss", "t_e", "t_D", "t_result", "nargin", "nargout", "t_m",
  "s", "abs_v_an", "z_G", "omega", "GeneratorNumber", "D_fw_G", "H_G", "d_omega"
};

/* Function Declarations */
static void initialize_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c8_update_debugger_state_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_st);
static void finalize_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber);
static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData);
static real_T c8_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_d_omega, const char_T *c8_identifier);
static real_T c8_b_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_c_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3]);
static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_d_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[6]);
static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[16]);
static real_T c8_mpower(SFc8_SimulationPlantModel_LuenbergInstanceStruct
  *chartInstance, real_T c8_a);
static void c8_eml_scalar_eg(SFc8_SimulationPlantModel_LuenbergInstanceStruct
  *chartInstance);
static const mxArray *c8_e_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static int32_T c8_e_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static uint8_T c8_f_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_b_is_active_c8_SimulationPlantModel_Luenberg, const char_T
   *c8_identifier);
static uint8_T c8_g_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void init_dsm_address_info
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c8_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c8_is_active_c8_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  real_T c8_dv0[6];
  int32_T c8_i0;
  real_T c8_d0;
  real_T c8_dv1[3];
  int32_T c8_i1;
  real_T c8_dv2[3];
  int32_T c8_i2;
  sf_set_error_prefix_string(
    "Error evaluating data 'z_G' in the parent workspace.\n");
  sf_mex_import_named("z_G", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      c8_dv0, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c8_i0 = 0; c8_i0 < 6; c8_i0++) {
    chartInstance->c8_z_G[c8_i0] = c8_dv0[c8_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), &c8_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c8_GeneratorNumber = c8_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_fw_G' in the parent workspace.\n");
  sf_mex_import_named("D_fw_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c8_dv1, 0, 0, 0U, 1, 0U, 1, 3);
  for (c8_i1 = 0; c8_i1 < 3; c8_i1++) {
    chartInstance->c8_D_fw_G[c8_i1] = c8_dv1[c8_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'H_G' in the parent workspace.\n");
  sf_mex_import_named("H_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c8_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c8_i2 = 0; c8_i2 < 3; c8_i2++) {
    chartInstance->c8_H_G[c8_i2] = c8_dv2[c8_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c8_update_debugger_state_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c8_st;
  const mxArray *c8_y = NULL;
  real_T c8_hoistedGlobal;
  real_T c8_u;
  const mxArray *c8_b_y = NULL;
  uint8_T c8_b_hoistedGlobal;
  uint8_T c8_b_u;
  const mxArray *c8_c_y = NULL;
  real_T *c8_d_omega;
  c8_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c8_st = NULL;
  c8_st = NULL;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_createcellarray(2), FALSE);
  c8_hoistedGlobal = *c8_d_omega;
  c8_u = c8_hoistedGlobal;
  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c8_y, 0, c8_b_y);
  c8_b_hoistedGlobal =
    chartInstance->c8_is_active_c8_SimulationPlantModel_Luenberg;
  c8_b_u = c8_b_hoistedGlobal;
  c8_c_y = NULL;
  sf_mex_assign(&c8_c_y, sf_mex_create("y", &c8_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c8_y, 1, c8_c_y);
  sf_mex_assign(&c8_st, c8_y, FALSE);
  return c8_st;
}

static void set_sim_state_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_st)
{
  const mxArray *c8_u;
  real_T *c8_d_omega;
  c8_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c8_doneDoubleBufferReInit = TRUE;
  c8_u = sf_mex_dup(c8_st);
  *c8_d_omega = c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c8_u, 0)), "d_omega");
  chartInstance->c8_is_active_c8_SimulationPlantModel_Luenberg =
    c8_f_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 1)),
    "is_active_c8_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c8_u);
  c8_update_debugger_state_c8_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c8_st);
}

static void finalize_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  int32_T c8_i3;
  int32_T c8_i4;
  int32_T c8_i5;
  int32_T c8_i6;
  real_T c8_hoistedGlobal;
  real_T c8_b_hoistedGlobal;
  real_T c8_c_hoistedGlobal;
  real_T c8_d_hoistedGlobal;
  real_T c8_t_m;
  int32_T c8_i7;
  real_T c8_s[2];
  real_T c8_abs_v_an;
  int32_T c8_i8;
  real_T c8_b_z_G[6];
  real_T c8_omega;
  real_T c8_b_GeneratorNumber;
  int32_T c8_i9;
  real_T c8_b_D_fw_G[3];
  int32_T c8_i10;
  real_T c8_b_H_G[3];
  uint32_T c8_debug_family_var_map[21];
  real_T c8_r_s;
  real_T c8_p;
  real_T c8_q;
  real_T c8_D_fw;
  real_T c8_H;
  real_T c8_abs_v_ll;
  real_T c8_p_loss;
  real_T c8_t_e;
  real_T c8_t_D;
  real_T c8_t_result;
  real_T c8_nargin = 8.0;
  real_T c8_nargout = 1.0;
  real_T c8_d_omega;
  real_T c8_b;
  real_T c8_a;
  real_T c8_b_b;
  real_T c8_y;
  real_T c8_A;
  real_T c8_B;
  real_T c8_x;
  real_T c8_b_y;
  real_T c8_b_x;
  real_T c8_c_y;
  real_T c8_b_B;
  real_T c8_d_y;
  real_T c8_e_y;
  real_T c8_f_y;
  real_T c8_b_a;
  real_T c8_c_b;
  real_T c8_c_a;
  real_T c8_d_b;
  real_T c8_e_b;
  real_T c8_g_y;
  real_T c8_b_A;
  real_T c8_c_B;
  real_T c8_c_x;
  real_T c8_h_y;
  real_T c8_d_x;
  real_T c8_i_y;
  real_T *c8_b_omega;
  real_T *c8_b_abs_v_an;
  real_T *c8_b_t_m;
  real_T *c8_b_d_omega;
  real_T (*c8_b_s)[2];
  c8_b_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c8_b_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c8_b_abs_v_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c8_b_s = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
  c8_b_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c8_b_t_m, 0U);
  for (c8_i3 = 0; c8_i3 < 2; c8_i3++) {
    _SFD_DATA_RANGE_CHECK((*c8_b_s)[c8_i3], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c8_b_abs_v_an, 2U);
  for (c8_i4 = 0; c8_i4 < 6; c8_i4++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c8_z_G[c8_i4], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c8_b_omega, 4U);
  _SFD_DATA_RANGE_CHECK(*c8_b_d_omega, 5U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c8_GeneratorNumber, 6U);
  for (c8_i5 = 0; c8_i5 < 3; c8_i5++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c8_D_fw_G[c8_i5], 7U);
  }

  for (c8_i6 = 0; c8_i6 < 3; c8_i6++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c8_H_G[c8_i6], 8U);
  }

  chartInstance->c8_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  c8_hoistedGlobal = *c8_b_t_m;
  c8_b_hoistedGlobal = *c8_b_abs_v_an;
  c8_c_hoistedGlobal = *c8_b_omega;
  c8_d_hoistedGlobal = chartInstance->c8_GeneratorNumber;
  c8_t_m = c8_hoistedGlobal;
  for (c8_i7 = 0; c8_i7 < 2; c8_i7++) {
    c8_s[c8_i7] = (*c8_b_s)[c8_i7];
  }

  c8_abs_v_an = c8_b_hoistedGlobal;
  for (c8_i8 = 0; c8_i8 < 6; c8_i8++) {
    c8_b_z_G[c8_i8] = chartInstance->c8_z_G[c8_i8];
  }

  c8_omega = c8_c_hoistedGlobal;
  c8_b_GeneratorNumber = c8_d_hoistedGlobal;
  for (c8_i9 = 0; c8_i9 < 3; c8_i9++) {
    c8_b_D_fw_G[c8_i9] = chartInstance->c8_D_fw_G[c8_i9];
  }

  for (c8_i10 = 0; c8_i10 < 3; c8_i10++) {
    c8_b_H_G[c8_i10] = chartInstance->c8_H_G[c8_i10];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 21U, 21U, c8_debug_family_names,
    c8_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_r_s, 0U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_p, 1U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_q, 2U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_D_fw, 3U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_H, 4U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_abs_v_ll, 5U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_p_loss, 6U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_t_e, 7U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_t_D, 8U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_t_result, 9U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_nargin, 10U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_nargout, 11U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c8_t_m, 12U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_s, 13U, c8_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c8_abs_v_an, 14U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_b_z_G, 15U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c8_omega, 16U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_GeneratorNumber, 17U,
    c8_sf_marshallOut, c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_b_D_fw_G, 18U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_b_H_G, 19U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_d_omega, 20U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 4);
  c8_r_s = c8_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c8_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 5);
  c8_p = c8_s[0];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 6);
  c8_q = c8_s[1];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 7);
  c8_D_fw = c8_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c8_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 8);
  c8_H = c8_b_H_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("H_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c8_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 9);
  c8_b = c8_abs_v_an;
  c8_abs_v_ll = 1.7320508075688772 * c8_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 11);
  if (CV_EML_IF(0, 1, 0, c8_abs_v_ll <= 0.01)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 12);
    c8_p_loss = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 14);
    c8_a = c8_r_s;
    c8_b_b = c8_mpower(chartInstance, c8_p) + c8_mpower(chartInstance, c8_q);
    c8_y = c8_a * c8_b_b;
    c8_A = c8_y;
    c8_B = c8_mpower(chartInstance, c8_abs_v_ll);
    c8_x = c8_A;
    c8_b_y = c8_B;
    c8_b_x = c8_x;
    c8_c_y = c8_b_y;
    c8_p_loss = c8_b_x / c8_c_y;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 16);
  c8_b_B = c8_omega;
  c8_d_y = c8_b_B;
  c8_e_y = c8_d_y;
  c8_f_y = 1.0 / c8_e_y;
  c8_b_a = c8_f_y;
  c8_c_b = c8_p + c8_p_loss;
  c8_t_e = c8_b_a * c8_c_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 19);
  c8_c_a = c8_D_fw;
  c8_d_b = c8_omega;
  c8_t_D = c8_c_a * c8_d_b;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 22);
  c8_t_result = (c8_t_m - c8_t_D) - c8_t_e;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 23);
  c8_e_b = c8_H;
  c8_g_y = 2.0 * c8_e_b;
  c8_b_A = c8_t_result;
  c8_c_B = c8_g_y;
  c8_c_x = c8_b_A;
  c8_h_y = c8_c_B;
  c8_d_x = c8_c_x;
  c8_i_y = c8_h_y;
  c8_d_omega = c8_d_x / c8_i_y;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, -23);
  _SFD_SYMBOL_SCOPE_POP();
  *c8_b_d_omega = c8_d_omega;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc8_SimulationPlantModel_Luenberg
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber)
{
}

static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(real_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static real_T c8_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_d_omega, const char_T *c8_identifier)
{
  real_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_d_omega), &c8_thisId);
  sf_mex_destroy(&c8_d_omega);
  return c8_y;
}

static real_T c8_b_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  real_T c8_y;
  real_T c8_d1;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_d1, 1, 0, 0U, 0, 0U, 0);
  c8_y = c8_d1;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_d_omega;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_d_omega = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_d_omega), &c8_thisId);
  sf_mex_destroy(&c8_d_omega);
  *(real_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i11;
  real_T c8_b_inData[3];
  int32_T c8_i12;
  real_T c8_u[3];
  const mxArray *c8_y = NULL;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i11 = 0; c8_i11 < 3; c8_i11++) {
    c8_b_inData[c8_i11] = (*(real_T (*)[3])c8_inData)[c8_i11];
  }

  for (c8_i12 = 0; c8_i12 < 3; c8_i12++) {
    c8_u[c8_i12] = c8_b_inData[c8_i12];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_c_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3])
{
  real_T c8_dv3[3];
  int32_T c8_i13;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv3, 1, 0, 0U, 1, 0U, 1, 3);
  for (c8_i13 = 0; c8_i13 < 3; c8_i13++) {
    c8_y[c8_i13] = c8_dv3[c8_i13];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_H_G;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[3];
  int32_T c8_i14;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_b_H_G = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_H_G), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_b_H_G);
  for (c8_i14 = 0; c8_i14 < 3; c8_i14++) {
    (*(real_T (*)[3])c8_outData)[c8_i14] = c8_y[c8_i14];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i15;
  int32_T c8_i16;
  int32_T c8_i17;
  real_T c8_b_inData[6];
  int32_T c8_i18;
  int32_T c8_i19;
  int32_T c8_i20;
  real_T c8_u[6];
  const mxArray *c8_y = NULL;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i15 = 0;
  for (c8_i16 = 0; c8_i16 < 2; c8_i16++) {
    for (c8_i17 = 0; c8_i17 < 3; c8_i17++) {
      c8_b_inData[c8_i17 + c8_i15] = (*(real_T (*)[6])c8_inData)[c8_i17 + c8_i15];
    }

    c8_i15 += 3;
  }

  c8_i18 = 0;
  for (c8_i19 = 0; c8_i19 < 2; c8_i19++) {
    for (c8_i20 = 0; c8_i20 < 3; c8_i20++) {
      c8_u[c8_i20 + c8_i18] = c8_b_inData[c8_i20 + c8_i18];
    }

    c8_i18 += 3;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_d_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[6])
{
  real_T c8_dv4[6];
  int32_T c8_i21;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv4, 1, 0, 0U, 1, 0U, 2, 3, 2);
  for (c8_i21 = 0; c8_i21 < 6; c8_i21++) {
    c8_y[c8_i21] = c8_dv4[c8_i21];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_z_G;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[6];
  int32_T c8_i22;
  int32_T c8_i23;
  int32_T c8_i24;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_b_z_G = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_z_G), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_b_z_G);
  c8_i22 = 0;
  for (c8_i23 = 0; c8_i23 < 2; c8_i23++) {
    for (c8_i24 = 0; c8_i24 < 3; c8_i24++) {
      (*(real_T (*)[6])c8_outData)[c8_i24 + c8_i22] = c8_y[c8_i24 + c8_i22];
    }

    c8_i22 += 3;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i25;
  real_T c8_b_inData[2];
  int32_T c8_i26;
  real_T c8_u[2];
  const mxArray *c8_y = NULL;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i25 = 0; c8_i25 < 2; c8_i25++) {
    c8_b_inData[c8_i25] = (*(real_T (*)[2])c8_inData)[c8_i25];
  }

  for (c8_i26 = 0; c8_i26 < 2; c8_i26++) {
    c8_u[c8_i26] = c8_b_inData[c8_i26];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

const mxArray
  *sf_c8_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c8_nameCaptureInfo;
  c8_ResolvedFunctionInfo c8_info[16];
  const mxArray *c8_m0 = NULL;
  int32_T c8_i27;
  c8_ResolvedFunctionInfo *c8_r0;
  c8_nameCaptureInfo = NULL;
  c8_nameCaptureInfo = NULL;
  c8_info_helper(c8_info);
  sf_mex_assign(&c8_m0, sf_mex_createstruct("nameCaptureInfo", 1, 16), FALSE);
  for (c8_i27 = 0; c8_i27 < 16; c8_i27++) {
    c8_r0 = &c8_info[c8_i27];
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->context)), "context", "nameCaptureInfo",
                    c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c8_r0->name)), "name", "nameCaptureInfo", c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c8_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->resolved)), "resolved", "nameCaptureInfo",
                    c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c8_i27);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c8_i27);
  }

  sf_mex_assign(&c8_nameCaptureInfo, c8_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c8_nameCaptureInfo);
  return c8_nameCaptureInfo;
}

static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[16])
{
  c8_info[0].context = "";
  c8_info[0].name = "sqrt";
  c8_info[0].dominantType = "double";
  c8_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c8_info[0].fileTimeLo = 1343830386U;
  c8_info[0].fileTimeHi = 0U;
  c8_info[0].mFileTimeLo = 0U;
  c8_info[0].mFileTimeHi = 0U;
  c8_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c8_info[1].name = "eml_error";
  c8_info[1].dominantType = "char";
  c8_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c8_info[1].fileTimeLo = 1343830358U;
  c8_info[1].fileTimeHi = 0U;
  c8_info[1].mFileTimeLo = 0U;
  c8_info[1].mFileTimeHi = 0U;
  c8_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c8_info[2].name = "eml_scalar_sqrt";
  c8_info[2].dominantType = "double";
  c8_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c8_info[2].fileTimeLo = 1286818738U;
  c8_info[2].fileTimeHi = 0U;
  c8_info[2].mFileTimeLo = 0U;
  c8_info[2].mFileTimeHi = 0U;
  c8_info[3].context = "";
  c8_info[3].name = "mtimes";
  c8_info[3].dominantType = "double";
  c8_info[3].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[3].fileTimeLo = 1289519692U;
  c8_info[3].fileTimeHi = 0U;
  c8_info[3].mFileTimeLo = 0U;
  c8_info[3].mFileTimeHi = 0U;
  c8_info[4].context = "";
  c8_info[4].name = "mpower";
  c8_info[4].dominantType = "double";
  c8_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c8_info[4].fileTimeLo = 1286818842U;
  c8_info[4].fileTimeHi = 0U;
  c8_info[4].mFileTimeLo = 0U;
  c8_info[4].mFileTimeHi = 0U;
  c8_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c8_info[5].name = "power";
  c8_info[5].dominantType = "double";
  c8_info[5].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c8_info[5].fileTimeLo = 1348191930U;
  c8_info[5].fileTimeHi = 0U;
  c8_info[5].mFileTimeLo = 0U;
  c8_info[5].mFileTimeHi = 0U;
  c8_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c8_info[6].name = "eml_scalar_eg";
  c8_info[6].dominantType = "double";
  c8_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[6].fileTimeLo = 1286818796U;
  c8_info[6].fileTimeHi = 0U;
  c8_info[6].mFileTimeLo = 0U;
  c8_info[6].mFileTimeHi = 0U;
  c8_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c8_info[7].name = "eml_scalexp_alloc";
  c8_info[7].dominantType = "double";
  c8_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c8_info[7].fileTimeLo = 1352424860U;
  c8_info[7].fileTimeHi = 0U;
  c8_info[7].mFileTimeLo = 0U;
  c8_info[7].mFileTimeHi = 0U;
  c8_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c8_info[8].name = "floor";
  c8_info[8].dominantType = "double";
  c8_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c8_info[8].fileTimeLo = 1343830380U;
  c8_info[8].fileTimeHi = 0U;
  c8_info[8].mFileTimeLo = 0U;
  c8_info[8].mFileTimeHi = 0U;
  c8_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c8_info[9].name = "eml_scalar_floor";
  c8_info[9].dominantType = "double";
  c8_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c8_info[9].fileTimeLo = 1286818726U;
  c8_info[9].fileTimeHi = 0U;
  c8_info[9].mFileTimeLo = 0U;
  c8_info[9].mFileTimeHi = 0U;
  c8_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c8_info[10].name = "eml_scalar_eg";
  c8_info[10].dominantType = "double";
  c8_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[10].fileTimeLo = 1286818796U;
  c8_info[10].fileTimeHi = 0U;
  c8_info[10].mFileTimeLo = 0U;
  c8_info[10].mFileTimeHi = 0U;
  c8_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c8_info[11].name = "mtimes";
  c8_info[11].dominantType = "double";
  c8_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[11].fileTimeLo = 1289519692U;
  c8_info[11].fileTimeHi = 0U;
  c8_info[11].mFileTimeLo = 0U;
  c8_info[11].mFileTimeHi = 0U;
  c8_info[12].context = "";
  c8_info[12].name = "mrdivide";
  c8_info[12].dominantType = "double";
  c8_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[12].fileTimeLo = 1357951548U;
  c8_info[12].fileTimeHi = 0U;
  c8_info[12].mFileTimeLo = 1319729966U;
  c8_info[12].mFileTimeHi = 0U;
  c8_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[13].name = "rdivide";
  c8_info[13].dominantType = "double";
  c8_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[13].fileTimeLo = 1346510388U;
  c8_info[13].fileTimeHi = 0U;
  c8_info[13].mFileTimeLo = 0U;
  c8_info[13].mFileTimeHi = 0U;
  c8_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[14].name = "eml_scalexp_compatible";
  c8_info[14].dominantType = "double";
  c8_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c8_info[14].fileTimeLo = 1286818796U;
  c8_info[14].fileTimeHi = 0U;
  c8_info[14].mFileTimeLo = 0U;
  c8_info[14].mFileTimeHi = 0U;
  c8_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[15].name = "eml_div";
  c8_info[15].dominantType = "double";
  c8_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c8_info[15].fileTimeLo = 1313347810U;
  c8_info[15].fileTimeHi = 0U;
  c8_info[15].mFileTimeLo = 0U;
  c8_info[15].mFileTimeHi = 0U;
}

static real_T c8_mpower(SFc8_SimulationPlantModel_LuenbergInstanceStruct
  *chartInstance, real_T c8_a)
{
  real_T c8_b_a;
  real_T c8_c_a;
  real_T c8_ak;
  real_T c8_d_a;
  real_T c8_e_a;
  real_T c8_b;
  c8_b_a = c8_a;
  c8_c_a = c8_b_a;
  c8_eml_scalar_eg(chartInstance);
  c8_ak = c8_c_a;
  c8_d_a = c8_ak;
  c8_eml_scalar_eg(chartInstance);
  c8_e_a = c8_d_a;
  c8_b = c8_d_a;
  return c8_e_a * c8_b;
}

static void c8_eml_scalar_eg(SFc8_SimulationPlantModel_LuenbergInstanceStruct
  *chartInstance)
{
}

static const mxArray *c8_e_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(int32_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static int32_T c8_e_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  int32_T c8_y;
  int32_T c8_i28;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_i28, 1, 6, 0U, 0, 0U, 0);
  c8_y = c8_i28;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_sfEvent;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  int32_T c8_y;
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c8_b_sfEvent = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_sfEvent),
    &c8_thisId);
  sf_mex_destroy(&c8_b_sfEvent);
  *(int32_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static uint8_T c8_f_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_b_is_active_c8_SimulationPlantModel_Luenberg, const char_T
   *c8_identifier)
{
  uint8_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c8_b_is_active_c8_SimulationPlantModel_Luenberg), &c8_thisId);
  sf_mex_destroy(&c8_b_is_active_c8_SimulationPlantModel_Luenberg);
  return c8_y;
}

static uint8_T c8_g_emlrt_marshallIn
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  uint8_T c8_y;
  uint8_T c8_u0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_u0, 1, 3, 0U, 0, 0U, 0);
  c8_y = c8_u0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void init_dsm_address_info
  (SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c8_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1700265200U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3212504997U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4028897047U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3112517185U);
}

mxArray *sf_c8_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("amEP2K24yMj7kncKQZZkoF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c8_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c8_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[9],T\"d_omega\",},{M[8],M[0],T\"is_active_c8_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c8_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           8,
           1,
           1,
           9,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"t_m");
          _SFD_SET_DATA_PROPS(1,1,1,0,"s");
          _SFD_SET_DATA_PROPS(2,1,1,0,"abs_v_an");
          _SFD_SET_DATA_PROPS(3,10,0,0,"z_G");
          _SFD_SET_DATA_PROPS(4,1,1,0,"omega");
          _SFD_SET_DATA_PROPS(5,2,0,1,"d_omega");
          _SFD_SET_DATA_PROPS(6,10,0,0,"GeneratorNumber");
          _SFD_SET_DATA_PROPS(7,10,0,0,"D_fw_G");
          _SFD_SET_DATA_PROPS(8,10,0,0,"H_G");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,579);
        _SFD_CV_INIT_EML_IF(0,1,0,285,304,321,370);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_c_sf_marshallOut,(MexInFcnForType)
            c8_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)c8_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)c8_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)
            c8_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)
            c8_b_sf_marshallIn);
        }

        {
          real_T *c8_t_m;
          real_T *c8_abs_v_an;
          real_T *c8_omega;
          real_T *c8_d_omega;
          real_T (*c8_s)[2];
          c8_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c8_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c8_abs_v_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c8_s = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
          c8_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c8_t_m);
          _SFD_SET_DATA_VALUE_PTR(1U, *c8_s);
          _SFD_SET_DATA_VALUE_PTR(2U, c8_abs_v_an);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c8_z_G);
          _SFD_SET_DATA_VALUE_PTR(4U, c8_omega);
          _SFD_SET_DATA_VALUE_PTR(5U, c8_d_omega);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance->c8_GeneratorNumber);
          _SFD_SET_DATA_VALUE_PTR(7U, chartInstance->c8_D_fw_G);
          _SFD_SET_DATA_VALUE_PTR(8U, chartInstance->c8_H_G);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "CQ31XNii3Yr8HyciH7N34D";
}

static void sf_opaque_initialize_c8_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc8_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c8_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c8_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c8_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c8_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c8_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c8_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c8_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c8_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c8_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c8_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c8_SimulationPlantModel_Luenberg
      ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc8_SimulationPlantModel_Luenberg
    ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c8_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c8_SimulationPlantModel_Luenberg
      ((SFc8_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c8_SimulationPlantModel_Luenberg(SimStruct *S)
{
  /* Actual parameters from chart:
     D_fw_G GeneratorNumber H_G z_G
   */
  const char_T *rtParamNames[] = { "D_fw_G", "GeneratorNumber", "H_G", "z_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for D_fw_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for H_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for z_G*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      8);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,8,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,8,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,8);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,8,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,8,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 4; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,8);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2577042925U));
  ssSetChecksum1(S,(3197147290U));
  ssSetChecksum2(S,(2570570851U));
  ssSetChecksum3(S,(3770030211U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c8_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c8_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc8_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc8_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc8_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc8_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c8_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c8_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c8_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c8_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c8_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c8_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
