GeneratorNumber = 1;
omega_b = omega_b;
H = H_G(GeneratorNumber);
D_fw = D_fw_G(GeneratorNumber);
T_e = tau_e_G(GeneratorNumber);
T_f = tau_f_G(GeneratorNumber);
r_f = r_f_G(GeneratorNumber);
r_s = z_G(GeneratorNumber,1);
x_s = z_G(GeneratorNumber,2);
omega0 = x_0(2);
i_f0 = x_0(4);    

A = [0 omega_b 0 0;
    0 -(1/(2*H))*D_fw 1/(2*H) 0;
    0 0 -1/T_e 0;
    0 0 0 -1/T_f]

B = [-omega_b 0 0 0;
    0 0 0 0;
    0 0 (D_fw+1)/T_e 0;
    0 0 0 1/(T_f*r_f)];

%f_uy = [0; (1/(2*H))*(-p/omega - r_s*(p^2+q^2)/(omega*abs_v_ll^2)); 0; 0];

C = [0 1 0 0;
    1/x_s 0 0 0;
    0 (1/x_s)*r_f*i_f0 0 (1/x_s)*r_f*omega0]

D = [0 0 0 0;
    0 0 0 0;
    0 -1/x_s 0 0];


%L = sym('L', [4 3])
%L = zeros(4,3);
L = zeros(4,3);
L(1,2) = 50;
L(2,2) = 100;
L(4,3) = 0;
% 
% L = [L11 0 L13;
%     L21 0 L23;
%     0 0 0;
%     0 0 L43]

temp_LC = L*C
temp = A-L*C
eigenvalues = eig(temp)

% L =
%  
% [ L1_1, L1_2, L1_3]
% [ L2_1, L2_2, L2_3]
% [ L3_1, L3_2, L3_3]
% [ L4_1, L4_2, L4_3]
%  
%  
% temp_LC =
%  
% [ (5*L1_2)/9, L1_1 + (5*L1_3)/9, 0, (17*L1_3)/18]
% [ (5*L2_2)/9, L2_1 + (5*L2_3)/9, 0, (17*L2_3)/18]
% [ (5*L3_2)/9, L3_1 + (5*L3_3)/9, 0, (17*L3_3)/18]
% [ (5*L4_2)/9, L4_1 + (5*L4_3)/9, 0, (17*L4_3)/18]
%  
%  
% temp =
%  
% [ -(5*L1_2)/9,      377 - (5*L1_3)/9 - L1_1,       0,           -(17*L1_3)/18]
% [ -(5*L2_2)/9, - L2_1 - (5*L2_3)/9 - 3/1120,    5/56,           -(17*L2_3)/18]
% [ -(5*L3_2)/9,          - L3_1 - (5*L3_3)/9, -3770/9,           -(17*L3_3)/18]
% [ -(5*L4_2)/9,          - L4_1 - (5*L4_3)/9,       0, - (17*L4_3)/18 - 3770/9]


