#ifndef __c27_SimulationPlantModel_h__
#define __c27_SimulationPlantModel_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_SFc27_SimulationPlantModelInstanceStruct
#define typedef_SFc27_SimulationPlantModelInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c27_sfEvent;
  boolean_T c27_isStable;
  boolean_T c27_doneDoubleBufferReInit;
  uint8_T c27_is_active_c27_SimulationPlantModel;
  real_T c27_f_u_matrix[12];
  real_T c27_f_u_magnitudes[9];
  real_T c27_GeneratorNumber;
} SFc27_SimulationPlantModelInstanceStruct;

#endif                                 /*typedef_SFc27_SimulationPlantModelInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c27_SimulationPlantModel_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c27_SimulationPlantModel_get_check_sum(mxArray *plhs[]);
extern void c27_SimulationPlantModel_method_dispatcher(SimStruct *S, int_T
  method, void *data);

#endif
