/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Kalman_sfun.h"
#include "c25_SimulationPlantModel_Kalman.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Kalman_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c25_debug_family_names[11] = { "N_faults", "vf_0", "vf_min",
  "vf_max", "nargin", "nargout", "v_f", "f_vf_matrix", "f_vf_magnitudes",
  "GeneratorNumber", "f_vf" };

/* Function Declarations */
static void initialize_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initialize_params_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void enable_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void disable_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c25_update_debugger_state_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void set_sim_state_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_st);
static void finalize_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void sf_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initSimStructsc25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void registerMessagesc25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c25_machineNumber, uint32_T
  c25_chartNumber);
static const mxArray *c25_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData);
static real_T c25_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_f_vf, const char_T *c25_identifier);
static real_T c25_b_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId);
static void c25_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData);
static const mxArray *c25_b_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData);
static void c25_c_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId, real_T c25_y[9]);
static void c25_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData);
static const mxArray *c25_c_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData);
static void c25_d_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId, real_T c25_y[12]);
static void c25_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData);
static const mxArray *c25_d_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData);
static int32_T c25_e_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId);
static void c25_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData);
static uint8_T c25_f_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_b_is_active_c25_SimulationPlantModel_Kalman, const char_T
   *c25_identifier);
static uint8_T c25_g_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId);
static void init_dsm_address_info
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  chartInstance->c25_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c25_is_active_c25_SimulationPlantModel_Kalman = 0U;
}

static void initialize_params_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c25_dv0[12];
  int32_T c25_i0;
  real_T c25_dv1[9];
  int32_T c25_i1;
  real_T c25_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'f_vf_matrix' in the parent workspace.\n");
  sf_mex_import_named("f_vf_matrix", sf_mex_get_sfun_param(chartInstance->S, 2,
    0), c25_dv0, 0, 0, 0U, 1, 0U, 2, 3, 4);
  for (c25_i0 = 0; c25_i0 < 12; c25_i0++) {
    chartInstance->c25_f_vf_matrix[c25_i0] = c25_dv0[c25_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'f_vf_magnitudes' in the parent workspace.\n");
  sf_mex_import_named("f_vf_magnitudes", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), c25_dv1, 0, 0, 0U, 1, 0U, 2, 3, 3);
  for (c25_i1 = 0; c25_i1 < 9; c25_i1++) {
    chartInstance->c25_f_vf_magnitudes[c25_i1] = c25_dv1[c25_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    0, 0), &c25_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c25_GeneratorNumber = c25_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c25_update_debugger_state_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  const mxArray *c25_st;
  const mxArray *c25_y = NULL;
  real_T c25_hoistedGlobal;
  real_T c25_u;
  const mxArray *c25_b_y = NULL;
  uint8_T c25_b_hoistedGlobal;
  uint8_T c25_b_u;
  const mxArray *c25_c_y = NULL;
  real_T *c25_f_vf;
  c25_f_vf = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c25_st = NULL;
  c25_st = NULL;
  c25_y = NULL;
  sf_mex_assign(&c25_y, sf_mex_createcellarray(2), FALSE);
  c25_hoistedGlobal = *c25_f_vf;
  c25_u = c25_hoistedGlobal;
  c25_b_y = NULL;
  sf_mex_assign(&c25_b_y, sf_mex_create("y", &c25_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c25_y, 0, c25_b_y);
  c25_b_hoistedGlobal =
    chartInstance->c25_is_active_c25_SimulationPlantModel_Kalman;
  c25_b_u = c25_b_hoistedGlobal;
  c25_c_y = NULL;
  sf_mex_assign(&c25_c_y, sf_mex_create("y", &c25_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c25_y, 1, c25_c_y);
  sf_mex_assign(&c25_st, c25_y, FALSE);
  return c25_st;
}

static void set_sim_state_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_st)
{
  const mxArray *c25_u;
  real_T *c25_f_vf;
  c25_f_vf = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c25_doneDoubleBufferReInit = TRUE;
  c25_u = sf_mex_dup(c25_st);
  *c25_f_vf = c25_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c25_u, 0)), "f_vf");
  chartInstance->c25_is_active_c25_SimulationPlantModel_Kalman =
    c25_f_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c25_u, 1)),
    "is_active_c25_SimulationPlantModel_Kalman");
  sf_mex_destroy(&c25_u);
  c25_update_debugger_state_c25_SimulationPlantModel_Kalman(chartInstance);
  sf_mex_destroy(&c25_st);
}

static void finalize_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void sf_c25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  int32_T c25_i2;
  int32_T c25_i3;
  real_T c25_hoistedGlobal;
  real_T c25_b_hoistedGlobal;
  real_T c25_v_f;
  int32_T c25_i4;
  real_T c25_b_f_vf_matrix[12];
  int32_T c25_i5;
  real_T c25_b_f_vf_magnitudes[9];
  real_T c25_b_GeneratorNumber;
  uint32_T c25_debug_family_var_map[11];
  real_T c25_N_faults;
  real_T c25_vf_0;
  real_T c25_vf_min;
  real_T c25_vf_max;
  real_T c25_nargin = 4.0;
  real_T c25_nargout = 1.0;
  real_T c25_f_vf;
  real_T *c25_b_v_f;
  real_T *c25_b_f_vf;
  c25_b_f_vf = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c25_b_v_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 24U, chartInstance->c25_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c25_b_v_f, 0U);
  for (c25_i2 = 0; c25_i2 < 12; c25_i2++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c25_f_vf_matrix[c25_i2], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c25_b_f_vf, 2U);
  for (c25_i3 = 0; c25_i3 < 9; c25_i3++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c25_f_vf_magnitudes[c25_i3], 3U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c25_GeneratorNumber, 4U);
  chartInstance->c25_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 24U, chartInstance->c25_sfEvent);
  c25_hoistedGlobal = *c25_b_v_f;
  c25_b_hoistedGlobal = chartInstance->c25_GeneratorNumber;
  c25_v_f = c25_hoistedGlobal;
  for (c25_i4 = 0; c25_i4 < 12; c25_i4++) {
    c25_b_f_vf_matrix[c25_i4] = chartInstance->c25_f_vf_matrix[c25_i4];
  }

  for (c25_i5 = 0; c25_i5 < 9; c25_i5++) {
    c25_b_f_vf_magnitudes[c25_i5] = chartInstance->c25_f_vf_magnitudes[c25_i5];
  }

  c25_b_GeneratorNumber = c25_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c25_debug_family_names,
    c25_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_N_faults, 0U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_vf_0, 1U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_vf_min, 2U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_vf_max, 3U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_nargin, 4U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_nargout, 5U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c25_v_f, 6U, c25_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c25_b_f_vf_matrix, 7U,
    c25_c_sf_marshallOut, c25_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c25_b_f_vf_magnitudes, 8U,
    c25_b_sf_marshallOut, c25_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_b_GeneratorNumber, 9U,
    c25_sf_marshallOut, c25_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c25_f_vf, 10U, c25_sf_marshallOut,
    c25_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 5);
  c25_N_faults = ((c25_b_f_vf_matrix[(int32_T)(real_T)
                   _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1, 0) -
                   1] + c25_b_f_vf_matrix[(int32_T)(real_T)
                   _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1, 0) +
                   2]) + c25_b_f_vf_matrix[(int32_T)(real_T)
                  _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1, 0) +
                  5]) + c25_b_f_vf_matrix[(int32_T)(real_T)
    _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)_SFD_INTEGER_CHECK(
    "GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1, 0) + 8];
  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 6);
  c25_vf_0 = c25_b_f_vf_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_vf_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c25_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 7);
  c25_vf_min = c25_b_f_vf_magnitudes[(int32_T)(real_T)
    _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_magnitudes", (int32_T)_SFD_INTEGER_CHECK(
    "GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1, 0) + 2];
  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 8);
  c25_vf_max = c25_b_f_vf_magnitudes[(int32_T)(real_T)
    _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_magnitudes", (int32_T)_SFD_INTEGER_CHECK(
    "GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1, 0) + 5];
  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 11);
  c25_f_vf = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 12);
  if (CV_EML_IF(0, 1, 0, c25_N_faults >= 2.0)) {
    _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 13);
    c25_f_vf = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 14);
    if (CV_EML_IF(0, 1, 1, c25_b_f_vf_matrix[(int32_T)(real_T)
                  _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
          _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1, 3, 1,
          0) - 1] == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 15);
      c25_f_vf = 0.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 16);
      if (CV_EML_IF(0, 1, 2, c25_b_f_vf_matrix[(int32_T)(real_T)
                    _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
            _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1, 3,
            1, 0) + 2] == 1.0)) {
        _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 17);
        c25_f_vf = c25_vf_0 - c25_v_f;
      } else {
        _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 18);
        if (CV_EML_IF(0, 1, 3, c25_b_f_vf_matrix[(int32_T)(real_T)
                      _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
              _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1, 3,
              1, 0) + 5] == 1.0)) {
          _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 19);
          c25_f_vf = c25_vf_min - c25_v_f;
        } else {
          _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 20);
          if (CV_EML_IF(0, 1, 4, c25_b_f_vf_matrix[(int32_T)(real_T)
                        _SFD_EML_ARRAY_BOUNDS_CHECK("f_vf_matrix", (int32_T)
                _SFD_INTEGER_CHECK("GeneratorNumber", c25_b_GeneratorNumber), 1,
                3, 1, 0) + 8] == 1.0)) {
            _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, 21);
            c25_f_vf = c25_vf_max - c25_v_f;
          }
        }
      }
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c25_sfEvent, -21);
  _SFD_SYMBOL_SCOPE_POP();
  *c25_b_f_vf = c25_f_vf;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 24U, chartInstance->c25_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_SimulationPlantModel_KalmanMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void registerMessagesc25_SimulationPlantModel_Kalman
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c25_machineNumber, uint32_T
  c25_chartNumber)
{
}

static const mxArray *c25_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData)
{
  const mxArray *c25_mxArrayOutData = NULL;
  real_T c25_u;
  const mxArray *c25_y = NULL;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_mxArrayOutData = NULL;
  c25_u = *(real_T *)c25_inData;
  c25_y = NULL;
  sf_mex_assign(&c25_y, sf_mex_create("y", &c25_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c25_mxArrayOutData, c25_y, FALSE);
  return c25_mxArrayOutData;
}

static real_T c25_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_f_vf, const char_T *c25_identifier)
{
  real_T c25_y;
  emlrtMsgIdentifier c25_thisId;
  c25_thisId.fIdentifier = c25_identifier;
  c25_thisId.fParent = NULL;
  c25_y = c25_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c25_f_vf),
    &c25_thisId);
  sf_mex_destroy(&c25_f_vf);
  return c25_y;
}

static real_T c25_b_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId)
{
  real_T c25_y;
  real_T c25_d1;
  sf_mex_import(c25_parentId, sf_mex_dup(c25_u), &c25_d1, 1, 0, 0U, 0, 0U, 0);
  c25_y = c25_d1;
  sf_mex_destroy(&c25_u);
  return c25_y;
}

static void c25_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData)
{
  const mxArray *c25_f_vf;
  const char_T *c25_identifier;
  emlrtMsgIdentifier c25_thisId;
  real_T c25_y;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_f_vf = sf_mex_dup(c25_mxArrayInData);
  c25_identifier = c25_varName;
  c25_thisId.fIdentifier = c25_identifier;
  c25_thisId.fParent = NULL;
  c25_y = c25_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c25_f_vf),
    &c25_thisId);
  sf_mex_destroy(&c25_f_vf);
  *(real_T *)c25_outData = c25_y;
  sf_mex_destroy(&c25_mxArrayInData);
}

static const mxArray *c25_b_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData)
{
  const mxArray *c25_mxArrayOutData = NULL;
  int32_T c25_i6;
  int32_T c25_i7;
  int32_T c25_i8;
  real_T c25_b_inData[9];
  int32_T c25_i9;
  int32_T c25_i10;
  int32_T c25_i11;
  real_T c25_u[9];
  const mxArray *c25_y = NULL;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_mxArrayOutData = NULL;
  c25_i6 = 0;
  for (c25_i7 = 0; c25_i7 < 3; c25_i7++) {
    for (c25_i8 = 0; c25_i8 < 3; c25_i8++) {
      c25_b_inData[c25_i8 + c25_i6] = (*(real_T (*)[9])c25_inData)[c25_i8 +
        c25_i6];
    }

    c25_i6 += 3;
  }

  c25_i9 = 0;
  for (c25_i10 = 0; c25_i10 < 3; c25_i10++) {
    for (c25_i11 = 0; c25_i11 < 3; c25_i11++) {
      c25_u[c25_i11 + c25_i9] = c25_b_inData[c25_i11 + c25_i9];
    }

    c25_i9 += 3;
  }

  c25_y = NULL;
  sf_mex_assign(&c25_y, sf_mex_create("y", c25_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c25_mxArrayOutData, c25_y, FALSE);
  return c25_mxArrayOutData;
}

static void c25_c_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId, real_T c25_y[9])
{
  real_T c25_dv2[9];
  int32_T c25_i12;
  sf_mex_import(c25_parentId, sf_mex_dup(c25_u), c25_dv2, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c25_i12 = 0; c25_i12 < 9; c25_i12++) {
    c25_y[c25_i12] = c25_dv2[c25_i12];
  }

  sf_mex_destroy(&c25_u);
}

static void c25_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData)
{
  const mxArray *c25_b_f_vf_magnitudes;
  const char_T *c25_identifier;
  emlrtMsgIdentifier c25_thisId;
  real_T c25_y[9];
  int32_T c25_i13;
  int32_T c25_i14;
  int32_T c25_i15;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_b_f_vf_magnitudes = sf_mex_dup(c25_mxArrayInData);
  c25_identifier = c25_varName;
  c25_thisId.fIdentifier = c25_identifier;
  c25_thisId.fParent = NULL;
  c25_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c25_b_f_vf_magnitudes),
    &c25_thisId, c25_y);
  sf_mex_destroy(&c25_b_f_vf_magnitudes);
  c25_i13 = 0;
  for (c25_i14 = 0; c25_i14 < 3; c25_i14++) {
    for (c25_i15 = 0; c25_i15 < 3; c25_i15++) {
      (*(real_T (*)[9])c25_outData)[c25_i15 + c25_i13] = c25_y[c25_i15 + c25_i13];
    }

    c25_i13 += 3;
  }

  sf_mex_destroy(&c25_mxArrayInData);
}

static const mxArray *c25_c_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData)
{
  const mxArray *c25_mxArrayOutData = NULL;
  int32_T c25_i16;
  int32_T c25_i17;
  int32_T c25_i18;
  real_T c25_b_inData[12];
  int32_T c25_i19;
  int32_T c25_i20;
  int32_T c25_i21;
  real_T c25_u[12];
  const mxArray *c25_y = NULL;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_mxArrayOutData = NULL;
  c25_i16 = 0;
  for (c25_i17 = 0; c25_i17 < 4; c25_i17++) {
    for (c25_i18 = 0; c25_i18 < 3; c25_i18++) {
      c25_b_inData[c25_i18 + c25_i16] = (*(real_T (*)[12])c25_inData)[c25_i18 +
        c25_i16];
    }

    c25_i16 += 3;
  }

  c25_i19 = 0;
  for (c25_i20 = 0; c25_i20 < 4; c25_i20++) {
    for (c25_i21 = 0; c25_i21 < 3; c25_i21++) {
      c25_u[c25_i21 + c25_i19] = c25_b_inData[c25_i21 + c25_i19];
    }

    c25_i19 += 3;
  }

  c25_y = NULL;
  sf_mex_assign(&c25_y, sf_mex_create("y", c25_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c25_mxArrayOutData, c25_y, FALSE);
  return c25_mxArrayOutData;
}

static void c25_d_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId, real_T c25_y[12])
{
  real_T c25_dv3[12];
  int32_T c25_i22;
  sf_mex_import(c25_parentId, sf_mex_dup(c25_u), c25_dv3, 1, 0, 0U, 1, 0U, 2, 3,
                4);
  for (c25_i22 = 0; c25_i22 < 12; c25_i22++) {
    c25_y[c25_i22] = c25_dv3[c25_i22];
  }

  sf_mex_destroy(&c25_u);
}

static void c25_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData)
{
  const mxArray *c25_b_f_vf_matrix;
  const char_T *c25_identifier;
  emlrtMsgIdentifier c25_thisId;
  real_T c25_y[12];
  int32_T c25_i23;
  int32_T c25_i24;
  int32_T c25_i25;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_b_f_vf_matrix = sf_mex_dup(c25_mxArrayInData);
  c25_identifier = c25_varName;
  c25_thisId.fIdentifier = c25_identifier;
  c25_thisId.fParent = NULL;
  c25_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c25_b_f_vf_matrix),
    &c25_thisId, c25_y);
  sf_mex_destroy(&c25_b_f_vf_matrix);
  c25_i23 = 0;
  for (c25_i24 = 0; c25_i24 < 4; c25_i24++) {
    for (c25_i25 = 0; c25_i25 < 3; c25_i25++) {
      (*(real_T (*)[12])c25_outData)[c25_i25 + c25_i23] = c25_y[c25_i25 +
        c25_i23];
    }

    c25_i23 += 3;
  }

  sf_mex_destroy(&c25_mxArrayInData);
}

const mxArray
  *sf_c25_SimulationPlantModel_Kalman_get_eml_resolved_functions_info(void)
{
  const mxArray *c25_nameCaptureInfo = NULL;
  c25_nameCaptureInfo = NULL;
  sf_mex_assign(&c25_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c25_nameCaptureInfo;
}

static const mxArray *c25_d_sf_marshallOut(void *chartInstanceVoid, void
  *c25_inData)
{
  const mxArray *c25_mxArrayOutData = NULL;
  int32_T c25_u;
  const mxArray *c25_y = NULL;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_mxArrayOutData = NULL;
  c25_u = *(int32_T *)c25_inData;
  c25_y = NULL;
  sf_mex_assign(&c25_y, sf_mex_create("y", &c25_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c25_mxArrayOutData, c25_y, FALSE);
  return c25_mxArrayOutData;
}

static int32_T c25_e_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId)
{
  int32_T c25_y;
  int32_T c25_i26;
  sf_mex_import(c25_parentId, sf_mex_dup(c25_u), &c25_i26, 1, 6, 0U, 0, 0U, 0);
  c25_y = c25_i26;
  sf_mex_destroy(&c25_u);
  return c25_y;
}

static void c25_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c25_mxArrayInData, const char_T *c25_varName, void *c25_outData)
{
  const mxArray *c25_b_sfEvent;
  const char_T *c25_identifier;
  emlrtMsgIdentifier c25_thisId;
  int32_T c25_y;
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c25_b_sfEvent = sf_mex_dup(c25_mxArrayInData);
  c25_identifier = c25_varName;
  c25_thisId.fIdentifier = c25_identifier;
  c25_thisId.fParent = NULL;
  c25_y = c25_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c25_b_sfEvent),
    &c25_thisId);
  sf_mex_destroy(&c25_b_sfEvent);
  *(int32_T *)c25_outData = c25_y;
  sf_mex_destroy(&c25_mxArrayInData);
}

static uint8_T c25_f_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_b_is_active_c25_SimulationPlantModel_Kalman, const char_T
   *c25_identifier)
{
  uint8_T c25_y;
  emlrtMsgIdentifier c25_thisId;
  c25_thisId.fIdentifier = c25_identifier;
  c25_thisId.fParent = NULL;
  c25_y = c25_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c25_b_is_active_c25_SimulationPlantModel_Kalman), &c25_thisId);
  sf_mex_destroy(&c25_b_is_active_c25_SimulationPlantModel_Kalman);
  return c25_y;
}

static uint8_T c25_g_emlrt_marshallIn
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c25_u, const emlrtMsgIdentifier *c25_parentId)
{
  uint8_T c25_y;
  uint8_T c25_u0;
  sf_mex_import(c25_parentId, sf_mex_dup(c25_u), &c25_u0, 1, 3, 0U, 0, 0U, 0);
  c25_y = c25_u0;
  sf_mex_destroy(&c25_u);
  return c25_y;
}

static void init_dsm_address_info
  (SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c25_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3906241395U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2013421308U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1860707424U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3217011910U);
}

mxArray *sf_c25_SimulationPlantModel_Kalman_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("xHuVBpCKk93YyCp8LpgIIH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(4);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c25_SimulationPlantModel_Kalman_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c25_SimulationPlantModel_Kalman(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"f_vf\",},{M[8],M[0],T\"is_active_c25_SimulationPlantModel_Kalman\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c25_SimulationPlantModel_Kalman_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
    chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_KalmanMachineNumber_,
           25,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_KalmanMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v_f");
          _SFD_SET_DATA_PROPS(1,10,0,0,"f_vf_matrix");
          _SFD_SET_DATA_PROPS(2,2,0,1,"f_vf");
          _SFD_SET_DATA_PROPS(3,10,0,0,"f_vf_magnitudes");
          _SFD_SET_DATA_PROPS(4,10,0,0,"GeneratorNumber");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,5,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,772);
        _SFD_CV_INIT_EML_IF(0,1,0,478,494,509,551);
        _SFD_CV_INIT_EML_IF(0,1,1,509,551,566,771);
        _SFD_CV_INIT_EML_IF(0,1,2,566,608,632,771);
        _SFD_CV_INIT_EML_IF(0,1,3,632,674,700,771);
        _SFD_CV_INIT_EML_IF(0,1,4,700,742,-1,742);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c25_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c25_c_sf_marshallOut,(MexInFcnForType)
            c25_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c25_sf_marshallOut,(MexInFcnForType)c25_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c25_b_sf_marshallOut,(MexInFcnForType)
            c25_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c25_sf_marshallOut,(MexInFcnForType)c25_sf_marshallIn);

        {
          real_T *c25_v_f;
          real_T *c25_f_vf;
          c25_f_vf = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c25_v_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c25_v_f);
          _SFD_SET_DATA_VALUE_PTR(1U, chartInstance->c25_f_vf_matrix);
          _SFD_SET_DATA_VALUE_PTR(2U, c25_f_vf);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c25_f_vf_magnitudes);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c25_GeneratorNumber);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_KalmanMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "OeB273J16CIjNr3j9IdgsG";
}

static void sf_opaque_initialize_c25_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc25_SimulationPlantModel_KalmanInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
  initialize_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c25_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  enable_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c25_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  disable_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c25_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  sf_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c25_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c25_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c25_SimulationPlantModel_Kalman(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c25_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c25_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c25_SimulationPlantModel_Kalman(S);
}

static void sf_opaque_set_sim_state_c25_SimulationPlantModel_Kalman(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c25_SimulationPlantModel_Kalman(S, st);
}

static void sf_opaque_terminate_c25_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc25_SimulationPlantModel_KalmanInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Kalman_optimization_info();
    }

    finalize_c25_SimulationPlantModel_Kalman
      ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc25_SimulationPlantModel_Kalman
    ((SFc25_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c25_SimulationPlantModel_Kalman(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c25_SimulationPlantModel_Kalman
      ((SFc25_SimulationPlantModel_KalmanInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c25_SimulationPlantModel_Kalman(SimStruct *S)
{
  /* Actual parameters from chart:
     GeneratorNumber f_vf_magnitudes f_vf_matrix
   */
  const char_T *rtParamNames[] = { "GeneratorNumber", "f_vf_magnitudes",
    "f_vf_matrix" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for f_vf_magnitudes*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for f_vf_matrix*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Kalman_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      25);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,25,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,25,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,25);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,25,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,25,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 1; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,25);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2809422973U));
  ssSetChecksum1(S,(1885527561U));
  ssSetChecksum2(S,(1971061686U));
  ssSetChecksum3(S,(3257303678U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c25_SimulationPlantModel_Kalman(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c25_SimulationPlantModel_Kalman(SimStruct *S)
{
  SFc25_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc25_SimulationPlantModel_KalmanInstanceStruct *)utMalloc
    (sizeof(SFc25_SimulationPlantModel_KalmanInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc25_SimulationPlantModel_KalmanInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlStart = mdlStart_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c25_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c25_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c25_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c25_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c25_SimulationPlantModel_Kalman(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c25_SimulationPlantModel_Kalman_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
