/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c30_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c30_debug_family_names[17] = { "abs_v_ll", "u1", "v_f1",
  "u2", "v_f2", "u3", "v_f3", "nargin", "nargout", "u_VG1", "u_VG2", "u_VG3",
  "omega_0", "abs_v_an", "u1_vec", "u2_vec", "u3_vec" };

/* Function Declarations */
static void initialize_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c30_update_debugger_state_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_st);
static void finalize_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c30_machineNumber, uint32_T
  c30_chartNumber);
static const mxArray *c30_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData);
static void c30_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u3_vec, const char_T *c30_identifier, real_T c30_y[4]);
static void c30_b_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId, real_T c30_y[4]);
static void c30_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c30_mxArrayInData, const char_T *c30_varName, void *c30_outData);
static const mxArray *c30_b_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData);
static const mxArray *c30_c_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData);
static real_T c30_c_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId);
static void c30_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c30_mxArrayInData, const char_T *c30_varName, void *c30_outData);
static const mxArray *c30_d_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData);
static int32_T c30_d_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId);
static void c30_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c30_mxArrayInData, const char_T *c30_varName, void *c30_outData);
static uint8_T c30_e_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_b_is_active_c30_SimulationPlantModel_Luenberg, const char_T
   *c30_identifier);
static uint8_T c30_f_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId);
static void init_dsm_address_info
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c30_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c30_is_active_c30_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void enable_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c30_update_debugger_state_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c30_st;
  const mxArray *c30_y = NULL;
  int32_T c30_i0;
  real_T c30_u[4];
  const mxArray *c30_b_y = NULL;
  int32_T c30_i1;
  real_T c30_b_u[4];
  const mxArray *c30_c_y = NULL;
  int32_T c30_i2;
  real_T c30_c_u[4];
  const mxArray *c30_d_y = NULL;
  uint8_T c30_hoistedGlobal;
  uint8_T c30_d_u;
  const mxArray *c30_e_y = NULL;
  real_T (*c30_u3_vec)[4];
  real_T (*c30_u2_vec)[4];
  real_T (*c30_u1_vec)[4];
  c30_u3_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 3);
  c30_u2_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c30_u1_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c30_st = NULL;
  c30_st = NULL;
  c30_y = NULL;
  sf_mex_assign(&c30_y, sf_mex_createcellarray(4), FALSE);
  for (c30_i0 = 0; c30_i0 < 4; c30_i0++) {
    c30_u[c30_i0] = (*c30_u1_vec)[c30_i0];
  }

  c30_b_y = NULL;
  sf_mex_assign(&c30_b_y, sf_mex_create("y", c30_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c30_y, 0, c30_b_y);
  for (c30_i1 = 0; c30_i1 < 4; c30_i1++) {
    c30_b_u[c30_i1] = (*c30_u2_vec)[c30_i1];
  }

  c30_c_y = NULL;
  sf_mex_assign(&c30_c_y, sf_mex_create("y", c30_b_u, 0, 0U, 1U, 0U, 1, 4),
                FALSE);
  sf_mex_setcell(c30_y, 1, c30_c_y);
  for (c30_i2 = 0; c30_i2 < 4; c30_i2++) {
    c30_c_u[c30_i2] = (*c30_u3_vec)[c30_i2];
  }

  c30_d_y = NULL;
  sf_mex_assign(&c30_d_y, sf_mex_create("y", c30_c_u, 0, 0U, 1U, 0U, 1, 4),
                FALSE);
  sf_mex_setcell(c30_y, 2, c30_d_y);
  c30_hoistedGlobal =
    chartInstance->c30_is_active_c30_SimulationPlantModel_Luenberg;
  c30_d_u = c30_hoistedGlobal;
  c30_e_y = NULL;
  sf_mex_assign(&c30_e_y, sf_mex_create("y", &c30_d_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c30_y, 3, c30_e_y);
  sf_mex_assign(&c30_st, c30_y, FALSE);
  return c30_st;
}

static void set_sim_state_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_st)
{
  const mxArray *c30_u;
  real_T c30_dv0[4];
  int32_T c30_i3;
  real_T c30_dv1[4];
  int32_T c30_i4;
  real_T c30_dv2[4];
  int32_T c30_i5;
  real_T (*c30_u1_vec)[4];
  real_T (*c30_u2_vec)[4];
  real_T (*c30_u3_vec)[4];
  c30_u3_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 3);
  c30_u2_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c30_u1_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c30_doneDoubleBufferReInit = TRUE;
  c30_u = sf_mex_dup(c30_st);
  c30_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c30_u, 0)),
                       "u1_vec", c30_dv0);
  for (c30_i3 = 0; c30_i3 < 4; c30_i3++) {
    (*c30_u1_vec)[c30_i3] = c30_dv0[c30_i3];
  }

  c30_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c30_u, 1)),
                       "u2_vec", c30_dv1);
  for (c30_i4 = 0; c30_i4 < 4; c30_i4++) {
    (*c30_u2_vec)[c30_i4] = c30_dv1[c30_i4];
  }

  c30_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c30_u, 2)),
                       "u3_vec", c30_dv2);
  for (c30_i5 = 0; c30_i5 < 4; c30_i5++) {
    (*c30_u3_vec)[c30_i5] = c30_dv2[c30_i5];
  }

  chartInstance->c30_is_active_c30_SimulationPlantModel_Luenberg =
    c30_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c30_u, 3)),
    "is_active_c30_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c30_u);
  c30_update_debugger_state_c30_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c30_st);
}

static void finalize_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  int32_T c30_i6;
  int32_T c30_i7;
  int32_T c30_i8;
  int32_T c30_i9;
  int32_T c30_i10;
  int32_T c30_i11;
  real_T c30_hoistedGlobal;
  real_T c30_b_hoistedGlobal;
  int32_T c30_i12;
  real_T c30_u_VG1[2];
  int32_T c30_i13;
  real_T c30_u_VG2[2];
  int32_T c30_i14;
  real_T c30_u_VG3[2];
  real_T c30_omega_0;
  real_T c30_abs_v_an;
  uint32_T c30_debug_family_var_map[17];
  real_T c30_abs_v_ll;
  real_T c30_u1;
  real_T c30_v_f1;
  real_T c30_u2;
  real_T c30_v_f2;
  real_T c30_u3;
  real_T c30_v_f3;
  real_T c30_nargin = 5.0;
  real_T c30_nargout = 3.0;
  real_T c30_u1_vec[4];
  real_T c30_u2_vec[4];
  real_T c30_u3_vec[4];
  real_T c30_b;
  int32_T c30_i15;
  int32_T c30_i16;
  int32_T c30_i17;
  real_T *c30_b_omega_0;
  real_T *c30_b_abs_v_an;
  real_T (*c30_b_u1_vec)[4];
  real_T (*c30_b_u2_vec)[4];
  real_T (*c30_b_u3_vec)[4];
  real_T (*c30_b_u_VG3)[2];
  real_T (*c30_b_u_VG2)[2];
  real_T (*c30_b_u_VG1)[2];
  c30_b_u3_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 3);
  c30_b_u2_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
  c30_b_u1_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
  c30_b_abs_v_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c30_b_omega_0 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c30_b_u_VG3 = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c30_b_u_VG2 = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
  c30_b_u_VG1 = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 29U, chartInstance->c30_sfEvent);
  for (c30_i6 = 0; c30_i6 < 2; c30_i6++) {
    _SFD_DATA_RANGE_CHECK((*c30_b_u_VG1)[c30_i6], 0U);
  }

  for (c30_i7 = 0; c30_i7 < 2; c30_i7++) {
    _SFD_DATA_RANGE_CHECK((*c30_b_u_VG2)[c30_i7], 1U);
  }

  for (c30_i8 = 0; c30_i8 < 2; c30_i8++) {
    _SFD_DATA_RANGE_CHECK((*c30_b_u_VG3)[c30_i8], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c30_b_omega_0, 3U);
  _SFD_DATA_RANGE_CHECK(*c30_b_abs_v_an, 4U);
  for (c30_i9 = 0; c30_i9 < 4; c30_i9++) {
    _SFD_DATA_RANGE_CHECK((*c30_b_u1_vec)[c30_i9], 5U);
  }

  for (c30_i10 = 0; c30_i10 < 4; c30_i10++) {
    _SFD_DATA_RANGE_CHECK((*c30_b_u2_vec)[c30_i10], 6U);
  }

  for (c30_i11 = 0; c30_i11 < 4; c30_i11++) {
    _SFD_DATA_RANGE_CHECK((*c30_b_u3_vec)[c30_i11], 7U);
  }

  chartInstance->c30_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 29U, chartInstance->c30_sfEvent);
  c30_hoistedGlobal = *c30_b_omega_0;
  c30_b_hoistedGlobal = *c30_b_abs_v_an;
  for (c30_i12 = 0; c30_i12 < 2; c30_i12++) {
    c30_u_VG1[c30_i12] = (*c30_b_u_VG1)[c30_i12];
  }

  for (c30_i13 = 0; c30_i13 < 2; c30_i13++) {
    c30_u_VG2[c30_i13] = (*c30_b_u_VG2)[c30_i13];
  }

  for (c30_i14 = 0; c30_i14 < 2; c30_i14++) {
    c30_u_VG3[c30_i14] = (*c30_b_u_VG3)[c30_i14];
  }

  c30_omega_0 = c30_hoistedGlobal;
  c30_abs_v_an = c30_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 17U, 17U, c30_debug_family_names,
    c30_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_abs_v_ll, 0U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_u1, 1U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_v_f1, 2U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_u2, 3U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_v_f2, 4U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_u3, 5U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_v_f3, 6U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_nargin, 7U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c30_nargout, 8U, c30_b_sf_marshallOut,
    c30_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c30_u_VG1, 9U, c30_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c30_u_VG2, 10U, c30_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c30_u_VG3, 11U, c30_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c30_omega_0, 12U, c30_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c30_abs_v_an, 13U, c30_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c30_u1_vec, 14U, c30_sf_marshallOut,
    c30_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c30_u2_vec, 15U, c30_sf_marshallOut,
    c30_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c30_u3_vec, 16U, c30_sf_marshallOut,
    c30_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 3);
  c30_b = c30_abs_v_an;
  c30_abs_v_ll = 1.7320508075688772 * c30_b;
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 4);
  c30_u1 = c30_u_VG1[0];
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 5);
  c30_v_f1 = c30_u_VG1[1];
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 6);
  c30_u2 = c30_u_VG2[0];
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 7);
  c30_v_f2 = c30_u_VG2[1];
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 8);
  c30_u3 = c30_u_VG3[0];
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 9);
  c30_v_f3 = c30_u_VG3[1];
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 12);
  c30_u1_vec[0] = c30_omega_0;
  c30_u1_vec[1] = c30_abs_v_ll;
  c30_u1_vec[2] = c30_u1;
  c30_u1_vec[3] = c30_v_f1;
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 13);
  c30_u2_vec[0] = c30_omega_0;
  c30_u2_vec[1] = c30_abs_v_ll;
  c30_u2_vec[2] = c30_u2;
  c30_u2_vec[3] = c30_v_f2;
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, 14);
  c30_u3_vec[0] = c30_omega_0;
  c30_u3_vec[1] = c30_abs_v_ll;
  c30_u3_vec[2] = c30_u3;
  c30_u3_vec[3] = c30_v_f3;
  _SFD_EML_CALL(0U, chartInstance->c30_sfEvent, -14);
  _SFD_SYMBOL_SCOPE_POP();
  for (c30_i15 = 0; c30_i15 < 4; c30_i15++) {
    (*c30_b_u1_vec)[c30_i15] = c30_u1_vec[c30_i15];
  }

  for (c30_i16 = 0; c30_i16 < 4; c30_i16++) {
    (*c30_b_u2_vec)[c30_i16] = c30_u2_vec[c30_i16];
  }

  for (c30_i17 = 0; c30_i17 < 4; c30_i17++) {
    (*c30_b_u3_vec)[c30_i17] = c30_u3_vec[c30_i17];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 29U, chartInstance->c30_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc30_SimulationPlantModel_Luenberg
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c30_machineNumber, uint32_T
  c30_chartNumber)
{
}

static const mxArray *c30_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData)
{
  const mxArray *c30_mxArrayOutData = NULL;
  int32_T c30_i18;
  real_T c30_b_inData[4];
  int32_T c30_i19;
  real_T c30_u[4];
  const mxArray *c30_y = NULL;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_mxArrayOutData = NULL;
  for (c30_i18 = 0; c30_i18 < 4; c30_i18++) {
    c30_b_inData[c30_i18] = (*(real_T (*)[4])c30_inData)[c30_i18];
  }

  for (c30_i19 = 0; c30_i19 < 4; c30_i19++) {
    c30_u[c30_i19] = c30_b_inData[c30_i19];
  }

  c30_y = NULL;
  sf_mex_assign(&c30_y, sf_mex_create("y", c30_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c30_mxArrayOutData, c30_y, FALSE);
  return c30_mxArrayOutData;
}

static void c30_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u3_vec, const char_T *c30_identifier, real_T c30_y[4])
{
  emlrtMsgIdentifier c30_thisId;
  c30_thisId.fIdentifier = c30_identifier;
  c30_thisId.fParent = NULL;
  c30_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c30_u3_vec), &c30_thisId,
    c30_y);
  sf_mex_destroy(&c30_u3_vec);
}

static void c30_b_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId, real_T c30_y[4])
{
  real_T c30_dv3[4];
  int32_T c30_i20;
  sf_mex_import(c30_parentId, sf_mex_dup(c30_u), c30_dv3, 1, 0, 0U, 1, 0U, 1, 4);
  for (c30_i20 = 0; c30_i20 < 4; c30_i20++) {
    c30_y[c30_i20] = c30_dv3[c30_i20];
  }

  sf_mex_destroy(&c30_u);
}

static void c30_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c30_mxArrayInData, const char_T *c30_varName, void *c30_outData)
{
  const mxArray *c30_u3_vec;
  const char_T *c30_identifier;
  emlrtMsgIdentifier c30_thisId;
  real_T c30_y[4];
  int32_T c30_i21;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_u3_vec = sf_mex_dup(c30_mxArrayInData);
  c30_identifier = c30_varName;
  c30_thisId.fIdentifier = c30_identifier;
  c30_thisId.fParent = NULL;
  c30_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c30_u3_vec), &c30_thisId,
    c30_y);
  sf_mex_destroy(&c30_u3_vec);
  for (c30_i21 = 0; c30_i21 < 4; c30_i21++) {
    (*(real_T (*)[4])c30_outData)[c30_i21] = c30_y[c30_i21];
  }

  sf_mex_destroy(&c30_mxArrayInData);
}

static const mxArray *c30_b_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData)
{
  const mxArray *c30_mxArrayOutData = NULL;
  real_T c30_u;
  const mxArray *c30_y = NULL;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_mxArrayOutData = NULL;
  c30_u = *(real_T *)c30_inData;
  c30_y = NULL;
  sf_mex_assign(&c30_y, sf_mex_create("y", &c30_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c30_mxArrayOutData, c30_y, FALSE);
  return c30_mxArrayOutData;
}

static const mxArray *c30_c_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData)
{
  const mxArray *c30_mxArrayOutData = NULL;
  int32_T c30_i22;
  real_T c30_b_inData[2];
  int32_T c30_i23;
  real_T c30_u[2];
  const mxArray *c30_y = NULL;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_mxArrayOutData = NULL;
  for (c30_i22 = 0; c30_i22 < 2; c30_i22++) {
    c30_b_inData[c30_i22] = (*(real_T (*)[2])c30_inData)[c30_i22];
  }

  for (c30_i23 = 0; c30_i23 < 2; c30_i23++) {
    c30_u[c30_i23] = c30_b_inData[c30_i23];
  }

  c30_y = NULL;
  sf_mex_assign(&c30_y, sf_mex_create("y", c30_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c30_mxArrayOutData, c30_y, FALSE);
  return c30_mxArrayOutData;
}

static real_T c30_c_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId)
{
  real_T c30_y;
  real_T c30_d0;
  sf_mex_import(c30_parentId, sf_mex_dup(c30_u), &c30_d0, 1, 0, 0U, 0, 0U, 0);
  c30_y = c30_d0;
  sf_mex_destroy(&c30_u);
  return c30_y;
}

static void c30_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c30_mxArrayInData, const char_T *c30_varName, void *c30_outData)
{
  const mxArray *c30_nargout;
  const char_T *c30_identifier;
  emlrtMsgIdentifier c30_thisId;
  real_T c30_y;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_nargout = sf_mex_dup(c30_mxArrayInData);
  c30_identifier = c30_varName;
  c30_thisId.fIdentifier = c30_identifier;
  c30_thisId.fParent = NULL;
  c30_y = c30_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c30_nargout),
    &c30_thisId);
  sf_mex_destroy(&c30_nargout);
  *(real_T *)c30_outData = c30_y;
  sf_mex_destroy(&c30_mxArrayInData);
}

const mxArray
  *sf_c30_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c30_nameCaptureInfo;
  c30_ResolvedFunctionInfo c30_info[4];
  c30_ResolvedFunctionInfo (*c30_b_info)[4];
  const mxArray *c30_m0 = NULL;
  int32_T c30_i24;
  c30_ResolvedFunctionInfo *c30_r0;
  c30_nameCaptureInfo = NULL;
  c30_nameCaptureInfo = NULL;
  c30_b_info = (c30_ResolvedFunctionInfo (*)[4])c30_info;
  (*c30_b_info)[0].context = "";
  (*c30_b_info)[0].name = "sqrt";
  (*c30_b_info)[0].dominantType = "double";
  (*c30_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  (*c30_b_info)[0].fileTimeLo = 1343830386U;
  (*c30_b_info)[0].fileTimeHi = 0U;
  (*c30_b_info)[0].mFileTimeLo = 0U;
  (*c30_b_info)[0].mFileTimeHi = 0U;
  (*c30_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  (*c30_b_info)[1].name = "eml_error";
  (*c30_b_info)[1].dominantType = "char";
  (*c30_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  (*c30_b_info)[1].fileTimeLo = 1343830358U;
  (*c30_b_info)[1].fileTimeHi = 0U;
  (*c30_b_info)[1].mFileTimeLo = 0U;
  (*c30_b_info)[1].mFileTimeHi = 0U;
  (*c30_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  (*c30_b_info)[2].name = "eml_scalar_sqrt";
  (*c30_b_info)[2].dominantType = "double";
  (*c30_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  (*c30_b_info)[2].fileTimeLo = 1286818738U;
  (*c30_b_info)[2].fileTimeHi = 0U;
  (*c30_b_info)[2].mFileTimeLo = 0U;
  (*c30_b_info)[2].mFileTimeHi = 0U;
  (*c30_b_info)[3].context = "";
  (*c30_b_info)[3].name = "mtimes";
  (*c30_b_info)[3].dominantType = "double";
  (*c30_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c30_b_info)[3].fileTimeLo = 1289519692U;
  (*c30_b_info)[3].fileTimeHi = 0U;
  (*c30_b_info)[3].mFileTimeLo = 0U;
  (*c30_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c30_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4), FALSE);
  for (c30_i24 = 0; c30_i24 < 4; c30_i24++) {
    c30_r0 = &c30_info[c30_i24];
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo", c30_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c30_r0->context)), "context", "nameCaptureInfo",
                    c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo", c30_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c30_r0->name)), "name", "nameCaptureInfo",
                    c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo",
      c30_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c30_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo", c30_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c30_r0->resolved)), "resolved",
                    "nameCaptureInfo", c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo", &c30_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo", &c30_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo",
      &c30_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c30_i24);
    sf_mex_addfield(c30_m0, sf_mex_create("nameCaptureInfo",
      &c30_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c30_i24);
  }

  sf_mex_assign(&c30_nameCaptureInfo, c30_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c30_nameCaptureInfo);
  return c30_nameCaptureInfo;
}

static const mxArray *c30_d_sf_marshallOut(void *chartInstanceVoid, void
  *c30_inData)
{
  const mxArray *c30_mxArrayOutData = NULL;
  int32_T c30_u;
  const mxArray *c30_y = NULL;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_mxArrayOutData = NULL;
  c30_u = *(int32_T *)c30_inData;
  c30_y = NULL;
  sf_mex_assign(&c30_y, sf_mex_create("y", &c30_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c30_mxArrayOutData, c30_y, FALSE);
  return c30_mxArrayOutData;
}

static int32_T c30_d_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId)
{
  int32_T c30_y;
  int32_T c30_i25;
  sf_mex_import(c30_parentId, sf_mex_dup(c30_u), &c30_i25, 1, 6, 0U, 0, 0U, 0);
  c30_y = c30_i25;
  sf_mex_destroy(&c30_u);
  return c30_y;
}

static void c30_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c30_mxArrayInData, const char_T *c30_varName, void *c30_outData)
{
  const mxArray *c30_b_sfEvent;
  const char_T *c30_identifier;
  emlrtMsgIdentifier c30_thisId;
  int32_T c30_y;
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c30_b_sfEvent = sf_mex_dup(c30_mxArrayInData);
  c30_identifier = c30_varName;
  c30_thisId.fIdentifier = c30_identifier;
  c30_thisId.fParent = NULL;
  c30_y = c30_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c30_b_sfEvent),
    &c30_thisId);
  sf_mex_destroy(&c30_b_sfEvent);
  *(int32_T *)c30_outData = c30_y;
  sf_mex_destroy(&c30_mxArrayInData);
}

static uint8_T c30_e_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_b_is_active_c30_SimulationPlantModel_Luenberg, const char_T
   *c30_identifier)
{
  uint8_T c30_y;
  emlrtMsgIdentifier c30_thisId;
  c30_thisId.fIdentifier = c30_identifier;
  c30_thisId.fParent = NULL;
  c30_y = c30_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c30_b_is_active_c30_SimulationPlantModel_Luenberg), &c30_thisId);
  sf_mex_destroy(&c30_b_is_active_c30_SimulationPlantModel_Luenberg);
  return c30_y;
}

static uint8_T c30_f_emlrt_marshallIn
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c30_u, const emlrtMsgIdentifier *c30_parentId)
{
  uint8_T c30_y;
  uint8_T c30_u0;
  sf_mex_import(c30_parentId, sf_mex_dup(c30_u), &c30_u0, 1, 3, 0U, 0, 0U, 0);
  c30_y = c30_u0;
  sf_mex_destroy(&c30_u);
  return c30_y;
}

static void init_dsm_address_info
  (SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c30_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2539454369U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(364206007U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2186654145U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2057838044U);
}

mxArray *sf_c30_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("EU4FcNkaSl7QCfULYBVhHH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c30_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c30_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[4],T\"u1_vec\",},{M[1],M[16],T\"u2_vec\",},{M[1],M[17],T\"u3_vec\",},{M[8],M[0],T\"is_active_c30_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c30_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           30,
           1,
           1,
           8,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"u_VG1");
          _SFD_SET_DATA_PROPS(1,1,1,0,"u_VG2");
          _SFD_SET_DATA_PROPS(2,1,1,0,"u_VG3");
          _SFD_SET_DATA_PROPS(3,1,1,0,"omega_0");
          _SFD_SET_DATA_PROPS(4,1,1,0,"abs_v_an");
          _SFD_SET_DATA_PROPS(5,2,0,1,"u1_vec");
          _SFD_SET_DATA_PROPS(6,2,0,1,"u2_vec");
          _SFD_SET_DATA_PROPS(7,2,0,1,"u3_vec");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,321);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c30_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c30_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c30_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c30_b_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c30_b_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c30_sf_marshallOut,(MexInFcnForType)
            c30_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c30_sf_marshallOut,(MexInFcnForType)
            c30_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c30_sf_marshallOut,(MexInFcnForType)
            c30_sf_marshallIn);
        }

        {
          real_T *c30_omega_0;
          real_T *c30_abs_v_an;
          real_T (*c30_u_VG1)[2];
          real_T (*c30_u_VG2)[2];
          real_T (*c30_u_VG3)[2];
          real_T (*c30_u1_vec)[4];
          real_T (*c30_u2_vec)[4];
          real_T (*c30_u3_vec)[4];
          c30_u3_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 3);
          c30_u2_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 2);
          c30_u1_vec = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 1);
          c30_abs_v_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c30_omega_0 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c30_u_VG3 = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
          c30_u_VG2 = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
          c30_u_VG1 = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c30_u_VG1);
          _SFD_SET_DATA_VALUE_PTR(1U, *c30_u_VG2);
          _SFD_SET_DATA_VALUE_PTR(2U, *c30_u_VG3);
          _SFD_SET_DATA_VALUE_PTR(3U, c30_omega_0);
          _SFD_SET_DATA_VALUE_PTR(4U, c30_abs_v_an);
          _SFD_SET_DATA_VALUE_PTR(5U, *c30_u1_vec);
          _SFD_SET_DATA_VALUE_PTR(6U, *c30_u2_vec);
          _SFD_SET_DATA_VALUE_PTR(7U, *c30_u3_vec);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "Pb2melnblr2KOvpES75KxG";
}

static void sf_opaque_initialize_c30_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc30_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c30_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c30_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c30_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c30_SimulationPlantModel_Luenberg(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c30_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c30_SimulationPlantModel_Luenberg
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c30_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c30_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c30_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c30_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c30_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c30_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c30_SimulationPlantModel_Luenberg
      ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc30_SimulationPlantModel_Luenberg
    ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c30_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c30_SimulationPlantModel_Luenberg
      ((SFc30_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c30_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      30);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,30,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,30,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,30);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,30,5);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,30,3);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=3; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 5; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,30);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2612942203U));
  ssSetChecksum1(S,(3858303492U));
  ssSetChecksum2(S,(4259089584U));
  ssSetChecksum3(S,(3015200490U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c30_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c30_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc30_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc30_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc30_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc30_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c30_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c30_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c30_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c30_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c30_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c30_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
