/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c37_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c37_debug_family_names[15] = { "diff_omega_max",
  "diff_omega_min", "diff_p_max", "diff_p_min", "diff_q_max", "diff_q_min",
  "nargin", "nargout", "time", "tilde_omega", "tilde_p", "tilde_q", "diff_y",
  "DisconnectWhenFaultDetected", "StayConnectedG" };

/* Function Declarations */
static void initialize_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c37_update_debugger_state_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_st);
static void finalize_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c37_machineNumber, uint32_T
  c37_chartNumber);
static const mxArray *c37_sf_marshallOut(void *chartInstanceVoid, void
  *c37_inData);
static real_T c37_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_StayConnectedG, const char_T *c37_identifier);
static real_T c37_b_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId);
static void c37_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c37_mxArrayInData, const char_T *c37_varName, void *c37_outData);
static const mxArray *c37_b_sf_marshallOut(void *chartInstanceVoid, void
  *c37_inData);
static void c37_c_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId, real_T c37_y[6]);
static void c37_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c37_mxArrayInData, const char_T *c37_varName, void *c37_outData);
static const mxArray *c37_c_sf_marshallOut(void *chartInstanceVoid, void
  *c37_inData);
static int32_T c37_d_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId);
static void c37_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c37_mxArrayInData, const char_T *c37_varName, void *c37_outData);
static uint8_T c37_e_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_b_is_active_c37_SimulationPlantModel_Luenberg, const char_T
   *c37_identifier);
static uint8_T c37_f_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId);
static void init_dsm_address_info
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c37_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c37_is_active_c37_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  real_T c37_dv0[6];
  int32_T c37_i0;
  real_T c37_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'diff_y' in the parent workspace.\n");
  sf_mex_import_named("diff_y", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c37_dv0, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c37_i0 = 0; c37_i0 < 6; c37_i0++) {
    chartInstance->c37_diff_y[c37_i0] = c37_dv0[c37_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'DisconnectWhenFaultDetected' in the parent workspace.\n");
  sf_mex_import_named("DisconnectWhenFaultDetected", sf_mex_get_sfun_param
                      (chartInstance->S, 0, 0), &c37_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c37_DisconnectWhenFaultDetected = c37_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c37_update_debugger_state_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c37_st;
  const mxArray *c37_y = NULL;
  real_T c37_hoistedGlobal;
  real_T c37_u;
  const mxArray *c37_b_y = NULL;
  uint8_T c37_b_hoistedGlobal;
  uint8_T c37_b_u;
  const mxArray *c37_c_y = NULL;
  real_T *c37_StayConnectedG;
  c37_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c37_st = NULL;
  c37_st = NULL;
  c37_y = NULL;
  sf_mex_assign(&c37_y, sf_mex_createcellarray(2), FALSE);
  c37_hoistedGlobal = *c37_StayConnectedG;
  c37_u = c37_hoistedGlobal;
  c37_b_y = NULL;
  sf_mex_assign(&c37_b_y, sf_mex_create("y", &c37_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c37_y, 0, c37_b_y);
  c37_b_hoistedGlobal =
    chartInstance->c37_is_active_c37_SimulationPlantModel_Luenberg;
  c37_b_u = c37_b_hoistedGlobal;
  c37_c_y = NULL;
  sf_mex_assign(&c37_c_y, sf_mex_create("y", &c37_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c37_y, 1, c37_c_y);
  sf_mex_assign(&c37_st, c37_y, FALSE);
  return c37_st;
}

static void set_sim_state_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_st)
{
  const mxArray *c37_u;
  real_T *c37_StayConnectedG;
  c37_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c37_doneDoubleBufferReInit = TRUE;
  c37_u = sf_mex_dup(c37_st);
  *c37_StayConnectedG = c37_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c37_u, 0)), "StayConnectedG");
  chartInstance->c37_is_active_c37_SimulationPlantModel_Luenberg =
    c37_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c37_u, 1)),
    "is_active_c37_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c37_u);
  c37_update_debugger_state_c37_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c37_st);
}

static void finalize_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  int32_T c37_i1;
  real_T c37_hoistedGlobal;
  real_T c37_b_hoistedGlobal;
  real_T c37_c_hoistedGlobal;
  real_T c37_d_hoistedGlobal;
  real_T c37_e_hoistedGlobal;
  real_T c37_time;
  real_T c37_tilde_omega;
  real_T c37_tilde_p;
  real_T c37_tilde_q;
  int32_T c37_i2;
  real_T c37_b_diff_y[6];
  real_T c37_b_DisconnectWhenFaultDetected;
  uint32_T c37_debug_family_var_map[15];
  real_T c37_diff_omega_max;
  real_T c37_diff_omega_min;
  real_T c37_diff_p_max;
  real_T c37_diff_p_min;
  real_T c37_diff_q_max;
  real_T c37_diff_q_min;
  real_T c37_nargin = 6.0;
  real_T c37_nargout = 1.0;
  real_T c37_StayConnectedG;
  real_T *c37_b_time;
  real_T *c37_b_tilde_omega;
  real_T *c37_b_StayConnectedG;
  real_T *c37_b_tilde_p;
  real_T *c37_b_tilde_q;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  c37_b_tilde_q = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c37_b_tilde_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c37_b_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c37_b_tilde_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c37_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 36U, chartInstance->c37_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c37_b_time, 0U);
  _SFD_DATA_RANGE_CHECK(*c37_b_tilde_omega, 1U);
  _SFD_DATA_RANGE_CHECK(*c37_b_StayConnectedG, 2U);
  _SFD_DATA_RANGE_CHECK(*c37_b_tilde_p, 3U);
  _SFD_DATA_RANGE_CHECK(*c37_b_tilde_q, 4U);
  for (c37_i1 = 0; c37_i1 < 6; c37_i1++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c37_diff_y[c37_i1], 5U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c37_DisconnectWhenFaultDetected, 6U);
  chartInstance->c37_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 36U, chartInstance->c37_sfEvent);
  c37_hoistedGlobal = *c37_b_time;
  c37_b_hoistedGlobal = *c37_b_tilde_omega;
  c37_c_hoistedGlobal = *c37_b_tilde_p;
  c37_d_hoistedGlobal = *c37_b_tilde_q;
  c37_e_hoistedGlobal = chartInstance->c37_DisconnectWhenFaultDetected;
  c37_time = c37_hoistedGlobal;
  c37_tilde_omega = c37_b_hoistedGlobal;
  c37_tilde_p = c37_c_hoistedGlobal;
  c37_tilde_q = c37_d_hoistedGlobal;
  for (c37_i2 = 0; c37_i2 < 6; c37_i2++) {
    c37_b_diff_y[c37_i2] = chartInstance->c37_diff_y[c37_i2];
  }

  c37_b_DisconnectWhenFaultDetected = c37_e_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 15U, 15U, c37_debug_family_names,
    c37_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_diff_omega_max, 0U,
    c37_sf_marshallOut, c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_diff_omega_min, 1U,
    c37_sf_marshallOut, c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_diff_p_max, 2U, c37_sf_marshallOut,
    c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_diff_p_min, 3U, c37_sf_marshallOut,
    c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_diff_q_max, 4U, c37_sf_marshallOut,
    c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_diff_q_min, 5U, c37_sf_marshallOut,
    c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_nargin, 6U, c37_sf_marshallOut,
    c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_nargout, 7U, c37_sf_marshallOut,
    c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c37_time, 8U, c37_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c37_tilde_omega, 9U, c37_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c37_tilde_p, 10U, c37_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c37_tilde_q, 11U, c37_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c37_b_diff_y, 12U, c37_b_sf_marshallOut,
    c37_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_b_DisconnectWhenFaultDetected, 13U,
    c37_sf_marshallOut, c37_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c37_StayConnectedG, 14U,
    c37_sf_marshallOut, c37_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 3);
  c37_diff_omega_max = c37_b_diff_y[3];
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 4);
  c37_diff_omega_min = c37_b_diff_y[0];
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 5);
  c37_diff_p_max = c37_b_diff_y[4];
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 6);
  c37_diff_p_min = c37_b_diff_y[1];
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 7);
  c37_diff_q_max = c37_b_diff_y[5];
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 8);
  c37_diff_q_min = c37_b_diff_y[2];
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 10);
  c37_StayConnectedG = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 11);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 0, c37_b_DisconnectWhenFaultDetected == 1.0)) {
    if (CV_EML_COND(0, 1, 1, c37_time >= 5.0)) {
      CV_EML_MCDC(0, 1, 0, TRUE);
      CV_EML_IF(0, 1, 0, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 12);
      guard2 = FALSE;
      if (CV_EML_COND(0, 1, 2, c37_tilde_omega >= c37_diff_omega_max)) {
        guard2 = TRUE;
      } else if (CV_EML_COND(0, 1, 3, c37_tilde_omega <= c37_diff_omega_min)) {
        guard2 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 1, FALSE);
        CV_EML_IF(0, 1, 1, FALSE);
        _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 14);
        guard3 = FALSE;
        if (CV_EML_COND(0, 1, 4, c37_tilde_p >= c37_diff_p_max)) {
          guard3 = TRUE;
        } else if (CV_EML_COND(0, 1, 5, c37_tilde_p <= c37_diff_p_min)) {
          guard3 = TRUE;
        } else {
          CV_EML_MCDC(0, 1, 2, FALSE);
          CV_EML_IF(0, 1, 2, FALSE);
          _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 16);
          guard4 = FALSE;
          if (CV_EML_COND(0, 1, 6, c37_tilde_q >= c37_diff_q_max)) {
            guard4 = TRUE;
          } else if (CV_EML_COND(0, 1, 7, c37_tilde_q <= c37_diff_q_min)) {
            guard4 = TRUE;
          } else {
            CV_EML_MCDC(0, 1, 3, FALSE);
            CV_EML_IF(0, 1, 3, FALSE);
          }

          if (guard4 == TRUE) {
            CV_EML_MCDC(0, 1, 3, TRUE);
            CV_EML_IF(0, 1, 3, TRUE);
            _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 17);
            c37_StayConnectedG = 0.0;
          }
        }

        if (guard3 == TRUE) {
          CV_EML_MCDC(0, 1, 2, TRUE);
          CV_EML_IF(0, 1, 2, TRUE);
          _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 15);
          c37_StayConnectedG = 0.0;
        }
      }

      if (guard2 == TRUE) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 1, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, 13);
        c37_StayConnectedG = 0.0;
      }
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c37_sfEvent, -17);
  _SFD_SYMBOL_SCOPE_POP();
  *c37_b_StayConnectedG = c37_StayConnectedG;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 36U, chartInstance->c37_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc37_SimulationPlantModel_Luenberg
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c37_machineNumber, uint32_T
  c37_chartNumber)
{
}

static const mxArray *c37_sf_marshallOut(void *chartInstanceVoid, void
  *c37_inData)
{
  const mxArray *c37_mxArrayOutData = NULL;
  real_T c37_u;
  const mxArray *c37_y = NULL;
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c37_mxArrayOutData = NULL;
  c37_u = *(real_T *)c37_inData;
  c37_y = NULL;
  sf_mex_assign(&c37_y, sf_mex_create("y", &c37_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c37_mxArrayOutData, c37_y, FALSE);
  return c37_mxArrayOutData;
}

static real_T c37_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_StayConnectedG, const char_T *c37_identifier)
{
  real_T c37_y;
  emlrtMsgIdentifier c37_thisId;
  c37_thisId.fIdentifier = c37_identifier;
  c37_thisId.fParent = NULL;
  c37_y = c37_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c37_StayConnectedG),
    &c37_thisId);
  sf_mex_destroy(&c37_StayConnectedG);
  return c37_y;
}

static real_T c37_b_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId)
{
  real_T c37_y;
  real_T c37_d1;
  sf_mex_import(c37_parentId, sf_mex_dup(c37_u), &c37_d1, 1, 0, 0U, 0, 0U, 0);
  c37_y = c37_d1;
  sf_mex_destroy(&c37_u);
  return c37_y;
}

static void c37_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c37_mxArrayInData, const char_T *c37_varName, void *c37_outData)
{
  const mxArray *c37_StayConnectedG;
  const char_T *c37_identifier;
  emlrtMsgIdentifier c37_thisId;
  real_T c37_y;
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c37_StayConnectedG = sf_mex_dup(c37_mxArrayInData);
  c37_identifier = c37_varName;
  c37_thisId.fIdentifier = c37_identifier;
  c37_thisId.fParent = NULL;
  c37_y = c37_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c37_StayConnectedG),
    &c37_thisId);
  sf_mex_destroy(&c37_StayConnectedG);
  *(real_T *)c37_outData = c37_y;
  sf_mex_destroy(&c37_mxArrayInData);
}

static const mxArray *c37_b_sf_marshallOut(void *chartInstanceVoid, void
  *c37_inData)
{
  const mxArray *c37_mxArrayOutData = NULL;
  int32_T c37_i3;
  int32_T c37_i4;
  int32_T c37_i5;
  real_T c37_b_inData[6];
  int32_T c37_i6;
  int32_T c37_i7;
  int32_T c37_i8;
  real_T c37_u[6];
  const mxArray *c37_y = NULL;
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c37_mxArrayOutData = NULL;
  c37_i3 = 0;
  for (c37_i4 = 0; c37_i4 < 2; c37_i4++) {
    for (c37_i5 = 0; c37_i5 < 3; c37_i5++) {
      c37_b_inData[c37_i5 + c37_i3] = (*(real_T (*)[6])c37_inData)[c37_i5 +
        c37_i3];
    }

    c37_i3 += 3;
  }

  c37_i6 = 0;
  for (c37_i7 = 0; c37_i7 < 2; c37_i7++) {
    for (c37_i8 = 0; c37_i8 < 3; c37_i8++) {
      c37_u[c37_i8 + c37_i6] = c37_b_inData[c37_i8 + c37_i6];
    }

    c37_i6 += 3;
  }

  c37_y = NULL;
  sf_mex_assign(&c37_y, sf_mex_create("y", c37_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c37_mxArrayOutData, c37_y, FALSE);
  return c37_mxArrayOutData;
}

static void c37_c_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId, real_T c37_y[6])
{
  real_T c37_dv1[6];
  int32_T c37_i9;
  sf_mex_import(c37_parentId, sf_mex_dup(c37_u), c37_dv1, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c37_i9 = 0; c37_i9 < 6; c37_i9++) {
    c37_y[c37_i9] = c37_dv1[c37_i9];
  }

  sf_mex_destroy(&c37_u);
}

static void c37_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c37_mxArrayInData, const char_T *c37_varName, void *c37_outData)
{
  const mxArray *c37_b_diff_y;
  const char_T *c37_identifier;
  emlrtMsgIdentifier c37_thisId;
  real_T c37_y[6];
  int32_T c37_i10;
  int32_T c37_i11;
  int32_T c37_i12;
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c37_b_diff_y = sf_mex_dup(c37_mxArrayInData);
  c37_identifier = c37_varName;
  c37_thisId.fIdentifier = c37_identifier;
  c37_thisId.fParent = NULL;
  c37_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c37_b_diff_y), &c37_thisId,
    c37_y);
  sf_mex_destroy(&c37_b_diff_y);
  c37_i10 = 0;
  for (c37_i11 = 0; c37_i11 < 2; c37_i11++) {
    for (c37_i12 = 0; c37_i12 < 3; c37_i12++) {
      (*(real_T (*)[6])c37_outData)[c37_i12 + c37_i10] = c37_y[c37_i12 + c37_i10];
    }

    c37_i10 += 3;
  }

  sf_mex_destroy(&c37_mxArrayInData);
}

const mxArray
  *sf_c37_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c37_nameCaptureInfo = NULL;
  c37_nameCaptureInfo = NULL;
  sf_mex_assign(&c37_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c37_nameCaptureInfo;
}

static const mxArray *c37_c_sf_marshallOut(void *chartInstanceVoid, void
  *c37_inData)
{
  const mxArray *c37_mxArrayOutData = NULL;
  int32_T c37_u;
  const mxArray *c37_y = NULL;
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c37_mxArrayOutData = NULL;
  c37_u = *(int32_T *)c37_inData;
  c37_y = NULL;
  sf_mex_assign(&c37_y, sf_mex_create("y", &c37_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c37_mxArrayOutData, c37_y, FALSE);
  return c37_mxArrayOutData;
}

static int32_T c37_d_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId)
{
  int32_T c37_y;
  int32_T c37_i13;
  sf_mex_import(c37_parentId, sf_mex_dup(c37_u), &c37_i13, 1, 6, 0U, 0, 0U, 0);
  c37_y = c37_i13;
  sf_mex_destroy(&c37_u);
  return c37_y;
}

static void c37_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c37_mxArrayInData, const char_T *c37_varName, void *c37_outData)
{
  const mxArray *c37_b_sfEvent;
  const char_T *c37_identifier;
  emlrtMsgIdentifier c37_thisId;
  int32_T c37_y;
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c37_b_sfEvent = sf_mex_dup(c37_mxArrayInData);
  c37_identifier = c37_varName;
  c37_thisId.fIdentifier = c37_identifier;
  c37_thisId.fParent = NULL;
  c37_y = c37_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c37_b_sfEvent),
    &c37_thisId);
  sf_mex_destroy(&c37_b_sfEvent);
  *(int32_T *)c37_outData = c37_y;
  sf_mex_destroy(&c37_mxArrayInData);
}

static uint8_T c37_e_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_b_is_active_c37_SimulationPlantModel_Luenberg, const char_T
   *c37_identifier)
{
  uint8_T c37_y;
  emlrtMsgIdentifier c37_thisId;
  c37_thisId.fIdentifier = c37_identifier;
  c37_thisId.fParent = NULL;
  c37_y = c37_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c37_b_is_active_c37_SimulationPlantModel_Luenberg), &c37_thisId);
  sf_mex_destroy(&c37_b_is_active_c37_SimulationPlantModel_Luenberg);
  return c37_y;
}

static uint8_T c37_f_emlrt_marshallIn
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c37_u, const emlrtMsgIdentifier *c37_parentId)
{
  uint8_T c37_y;
  uint8_T c37_u0;
  sf_mex_import(c37_parentId, sf_mex_dup(c37_u), &c37_u0, 1, 3, 0U, 0, 0U, 0);
  c37_y = c37_u0;
  sf_mex_destroy(&c37_u);
  return c37_y;
}

static void init_dsm_address_info
  (SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c37_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2603422224U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1596075760U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3926953297U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2654641494U);
}

mxArray *sf_c37_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("dPWrZdVV1M1h7dSSSbpf6");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c37_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c37_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"StayConnectedG\",},{M[8],M[0],T\"is_active_c37_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c37_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           37,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"time");
          _SFD_SET_DATA_PROPS(1,1,1,0,"tilde_omega");
          _SFD_SET_DATA_PROPS(2,2,0,1,"StayConnectedG");
          _SFD_SET_DATA_PROPS(3,1,1,0,"tilde_p");
          _SFD_SET_DATA_PROPS(4,1,1,0,"tilde_q");
          _SFD_SET_DATA_PROPS(5,10,0,0,"diff_y");
          _SFD_SET_DATA_PROPS(6,10,0,0,"DisconnectWhenFaultDetected");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,0,8,4);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,619);
        _SFD_CV_INIT_EML_IF(0,1,0,285,333,-1,615);
        _SFD_CV_INIT_EML_IF(0,1,1,338,403,436,489);
        _SFD_CV_INIT_EML_IF(0,1,2,436,489,522,611);
        _SFD_CV_INIT_EML_IF(0,1,3,522,575,-1,575);

        {
          static int condStart[] = { 288, 324 };

          static int condEnd[] = { 320, 333 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,288,333,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 341, 374 };

          static int condEnd[] = { 370, 403 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,341,403,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 443, 468 };

          static int condEnd[] = { 464, 489 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,443,489,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 529, 554 };

          static int condEnd[] = { 550, 575 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,3,529,575,2,6,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c37_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c37_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c37_sf_marshallOut,(MexInFcnForType)c37_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c37_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c37_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c37_b_sf_marshallOut,(MexInFcnForType)
            c37_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c37_sf_marshallOut,(MexInFcnForType)c37_sf_marshallIn);

        {
          real_T *c37_time;
          real_T *c37_tilde_omega;
          real_T *c37_StayConnectedG;
          real_T *c37_tilde_p;
          real_T *c37_tilde_q;
          c37_tilde_q = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c37_tilde_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c37_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S,
            1);
          c37_tilde_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c37_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c37_time);
          _SFD_SET_DATA_VALUE_PTR(1U, c37_tilde_omega);
          _SFD_SET_DATA_VALUE_PTR(2U, c37_StayConnectedG);
          _SFD_SET_DATA_VALUE_PTR(3U, c37_tilde_p);
          _SFD_SET_DATA_VALUE_PTR(4U, c37_tilde_q);
          _SFD_SET_DATA_VALUE_PTR(5U, chartInstance->c37_diff_y);
          _SFD_SET_DATA_VALUE_PTR(6U,
            &chartInstance->c37_DisconnectWhenFaultDetected);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "A6JbT5aMV3X5mDjCdrhRUB";
}

static void sf_opaque_initialize_c37_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc37_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c37_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c37_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c37_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c37_SimulationPlantModel_Luenberg(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c37_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c37_SimulationPlantModel_Luenberg
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c37_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c37_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c37_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c37_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c37_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c37_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c37_SimulationPlantModel_Luenberg
      ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc37_SimulationPlantModel_Luenberg
    ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c37_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c37_SimulationPlantModel_Luenberg
      ((SFc37_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c37_SimulationPlantModel_Luenberg(SimStruct *S)
{
  /* Actual parameters from chart:
     DisconnectWhenFaultDetected diff_y
   */
  const char_T *rtParamNames[] = { "DisconnectWhenFaultDetected", "diff_y" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for DisconnectWhenFaultDetected*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for diff_y*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      37);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,37,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,37,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,37);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,37,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,37,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 4; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,37);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1043317577U));
  ssSetChecksum1(S,(3079215313U));
  ssSetChecksum2(S,(3081891912U));
  ssSetChecksum3(S,(2155963491U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c37_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c37_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc37_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc37_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc37_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc37_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c37_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c37_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c37_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c37_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c37_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c37_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
