/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_NonlinRR_sfun.h"
#include "c36_SimulationPlantModel_NonlinRR.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_NonlinRR_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c36_debug_family_names[17] = { "diff_rdq_max",
  "diff_rdq_min", "diff_rddw_max", "diff_rddw_min", "diff_rddq_max",
  "diff_rddq_min", "nargin", "nargout", "time", "r_dq", "r_ddw", "r_ddq",
  "diff_r", "DisconnectWhenFaultDetected", "FaultDetectionInitTime",
  "StayConnectedG", "CB1" };

/* Function Declarations */
static void initialize_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void initialize_params_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void enable_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void disable_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void c36_update_debugger_state_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void set_sim_state_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_st);
static void finalize_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void sf_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void initSimStructsc36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void registerMessagesc36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c36_machineNumber, uint32_T
  c36_chartNumber);
static const mxArray *c36_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static real_T c36_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_CB1, const char_T *c36_identifier);
static real_T c36_b_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void c36_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static const mxArray *c36_b_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static void c36_c_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId, real_T c36_y[6]);
static void c36_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static const mxArray *c36_c_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static int32_T c36_d_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void c36_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static uint8_T c36_e_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_b_is_active_c36_SimulationPlantModel_NonlinRR, const char_T
   *c36_identifier);
static uint8_T c36_f_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId);
static real_T c36_get_CB1(SFc36_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c36_b);
static void c36_set_CB1(SFc36_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c36_b, real_T c36_c);
static real_T *c36_access_CB1(SFc36_SimulationPlantModel_NonlinRRInstanceStruct *
  chartInstance, uint32_T c36_b);
static void init_dsm_address_info
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  chartInstance->c36_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c36_is_active_c36_SimulationPlantModel_NonlinRR = 0U;
}

static void initialize_params_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  real_T c36_dv0[6];
  int32_T c36_i0;
  real_T c36_d0;
  real_T c36_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'diff_r' in the parent workspace.\n");
  sf_mex_import_named("diff_r", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c36_dv0, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c36_i0 = 0; c36_i0 < 6; c36_i0++) {
    chartInstance->c36_diff_r[c36_i0] = c36_dv0[c36_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'DisconnectWhenFaultDetected' in the parent workspace.\n");
  sf_mex_import_named("DisconnectWhenFaultDetected", sf_mex_get_sfun_param
                      (chartInstance->S, 0, 0), &c36_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_DisconnectWhenFaultDetected = c36_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'FaultDetectionInitTime' in the parent workspace.\n");
  sf_mex_import_named("FaultDetectionInitTime", sf_mex_get_sfun_param
                      (chartInstance->S, 1, 0), &c36_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_FaultDetectionInitTime = c36_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c36_update_debugger_state_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  const mxArray *c36_st;
  const mxArray *c36_y = NULL;
  real_T c36_hoistedGlobal;
  real_T c36_u;
  const mxArray *c36_b_y = NULL;
  uint8_T c36_b_hoistedGlobal;
  uint8_T c36_b_u;
  const mxArray *c36_c_y = NULL;
  real_T *c36_StayConnectedG;
  c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c36_st = NULL;
  c36_st = NULL;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_createcellarray(2), FALSE);
  c36_hoistedGlobal = *c36_StayConnectedG;
  c36_u = c36_hoistedGlobal;
  c36_b_y = NULL;
  sf_mex_assign(&c36_b_y, sf_mex_create("y", &c36_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 0, c36_b_y);
  c36_b_hoistedGlobal =
    chartInstance->c36_is_active_c36_SimulationPlantModel_NonlinRR;
  c36_b_u = c36_b_hoistedGlobal;
  c36_c_y = NULL;
  sf_mex_assign(&c36_c_y, sf_mex_create("y", &c36_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 1, c36_c_y);
  sf_mex_assign(&c36_st, c36_y, FALSE);
  return c36_st;
}

static void set_sim_state_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_st)
{
  const mxArray *c36_u;
  real_T *c36_StayConnectedG;
  c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c36_doneDoubleBufferReInit = TRUE;
  c36_u = sf_mex_dup(c36_st);
  *c36_StayConnectedG = c36_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c36_u, 0)), "StayConnectedG");
  chartInstance->c36_is_active_c36_SimulationPlantModel_NonlinRR =
    c36_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c36_u, 1)),
    "is_active_c36_SimulationPlantModel_NonlinRR");
  sf_mex_destroy(&c36_u);
  c36_update_debugger_state_c36_SimulationPlantModel_NonlinRR(chartInstance);
  sf_mex_destroy(&c36_st);
}

static void finalize_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void sf_c36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  int32_T c36_i1;
  real_T c36_hoistedGlobal;
  real_T c36_b_hoistedGlobal;
  real_T c36_c_hoistedGlobal;
  real_T c36_d_hoistedGlobal;
  real_T c36_e_hoistedGlobal;
  real_T c36_f_hoistedGlobal;
  real_T c36_time;
  real_T c36_r_dq;
  real_T c36_r_ddw;
  real_T c36_r_ddq;
  int32_T c36_i2;
  real_T c36_b_diff_r[6];
  real_T c36_b_DisconnectWhenFaultDetected;
  real_T c36_b_FaultDetectionInitTime;
  uint32_T c36_debug_family_var_map[17];
  real_T c36_diff_rdq_max;
  real_T c36_diff_rdq_min;
  real_T c36_diff_rddw_max;
  real_T c36_diff_rddw_min;
  real_T c36_diff_rddq_max;
  real_T c36_diff_rddq_min;
  real_T c36_nargin = 7.0;
  real_T c36_nargout = 1.0;
  real_T c36_StayConnectedG;
  real_T *c36_b_time;
  real_T *c36_b_r_dq;
  real_T *c36_b_StayConnectedG;
  real_T *c36_b_r_ddw;
  real_T *c36_b_r_ddq;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  c36_b_r_ddq = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c36_b_r_ddw = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c36_b_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c36_b_r_dq = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c36_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c36_b_time, 0U);
  _SFD_DATA_RANGE_CHECK(*c36_b_r_dq, 1U);
  _SFD_DATA_RANGE_CHECK(*c36_b_StayConnectedG, 2U);
  _SFD_DATA_RANGE_CHECK(*c36_b_r_ddw, 3U);
  _SFD_DATA_RANGE_CHECK(*c36_b_r_ddq, 4U);
  for (c36_i1 = 0; c36_i1 < 6; c36_i1++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c36_diff_r[c36_i1], 5U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c36_DisconnectWhenFaultDetected, 6U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c36_FaultDetectionInitTime, 7U);
  chartInstance->c36_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  c36_hoistedGlobal = *c36_b_time;
  c36_b_hoistedGlobal = *c36_b_r_dq;
  c36_c_hoistedGlobal = *c36_b_r_ddw;
  c36_d_hoistedGlobal = *c36_b_r_ddq;
  c36_e_hoistedGlobal = chartInstance->c36_DisconnectWhenFaultDetected;
  c36_f_hoistedGlobal = chartInstance->c36_FaultDetectionInitTime;
  c36_time = c36_hoistedGlobal;
  c36_r_dq = c36_b_hoistedGlobal;
  c36_r_ddw = c36_c_hoistedGlobal;
  c36_r_ddq = c36_d_hoistedGlobal;
  for (c36_i2 = 0; c36_i2 < 6; c36_i2++) {
    c36_b_diff_r[c36_i2] = chartInstance->c36_diff_r[c36_i2];
  }

  c36_b_DisconnectWhenFaultDetected = c36_e_hoistedGlobal;
  c36_b_FaultDetectionInitTime = c36_f_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 17U, 17U, c36_debug_family_names,
    c36_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_rdq_max, 0U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_rdq_min, 1U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_rddw_max, 2U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_rddw_min, 3U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_rddq_max, 4U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_rddq_min, 5U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_nargin, 6U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_nargout, 7U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_time, 8U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_r_dq, 9U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_r_ddw, 10U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_r_ddq, 11U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c36_b_diff_r, 12U, c36_b_sf_marshallOut,
    c36_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_DisconnectWhenFaultDetected, 13U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_FaultDetectionInitTime, 14U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_StayConnectedG, 15U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c36_CB1_address, 16U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 4);
  c36_diff_rdq_max = c36_b_diff_r[3];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 5);
  c36_diff_rdq_min = c36_b_diff_r[0];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 6);
  c36_diff_rddw_max = c36_b_diff_r[4];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 7);
  c36_diff_rddw_min = c36_b_diff_r[1];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 8);
  c36_diff_rddq_max = c36_b_diff_r[5];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 9);
  c36_diff_rddq_min = c36_b_diff_r[2];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 11);
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 12);
  c36_StayConnectedG = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 13);
  if (CV_EML_IF(0, 1, 0, c36_get_CB1(chartInstance, 0) == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 14);
    c36_StayConnectedG = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 17);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 0, c36_b_DisconnectWhenFaultDetected == 1.0)) {
    if (CV_EML_COND(0, 1, 1, c36_time >= c36_b_FaultDetectionInitTime)) {
      CV_EML_MCDC(0, 1, 0, TRUE);
      CV_EML_IF(0, 1, 1, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 18);
      guard2 = FALSE;
      if (CV_EML_COND(0, 1, 2, c36_r_dq >= c36_diff_rdq_max)) {
        guard2 = TRUE;
      } else if (CV_EML_COND(0, 1, 3, c36_r_dq <= c36_diff_rdq_min)) {
        guard2 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 1, FALSE);
        CV_EML_IF(0, 1, 2, FALSE);
        _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 20);
        guard3 = FALSE;
        if (CV_EML_COND(0, 1, 4, c36_r_ddw >= c36_diff_rddw_max)) {
          guard3 = TRUE;
        } else if (CV_EML_COND(0, 1, 5, c36_r_ddw <= c36_diff_rddw_min)) {
          guard3 = TRUE;
        } else {
          CV_EML_MCDC(0, 1, 2, FALSE);
          CV_EML_IF(0, 1, 3, FALSE);
          _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 22);
          guard4 = FALSE;
          if (CV_EML_COND(0, 1, 6, c36_r_ddq >= c36_diff_rddq_max)) {
            guard4 = TRUE;
          } else if (CV_EML_COND(0, 1, 7, c36_r_ddq <= c36_diff_rddq_min)) {
            guard4 = TRUE;
          } else {
            CV_EML_MCDC(0, 1, 3, FALSE);
            CV_EML_IF(0, 1, 4, FALSE);
          }

          if (guard4 == TRUE) {
            CV_EML_MCDC(0, 1, 3, TRUE);
            CV_EML_IF(0, 1, 4, TRUE);
            _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 23);
            c36_StayConnectedG = 0.0;
          }
        }

        if (guard3 == TRUE) {
          CV_EML_MCDC(0, 1, 2, TRUE);
          CV_EML_IF(0, 1, 3, TRUE);
          _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 21);
          c36_StayConnectedG = 0.0;
        }
      }

      if (guard2 == TRUE) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 2, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 19);
        c36_StayConnectedG = 0.0;
      }
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, -23);
  _SFD_SYMBOL_SCOPE_POP();
  *c36_b_StayConnectedG = c36_StayConnectedG;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_NonlinRRMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void registerMessagesc36_SimulationPlantModel_NonlinRR
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c36_machineNumber, uint32_T
  c36_chartNumber)
{
}

static const mxArray *c36_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  real_T c36_u;
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_u = *(real_T *)c36_inData;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", &c36_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static real_T c36_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_CB1, const char_T *c36_identifier)
{
  real_T c36_y;
  emlrtMsgIdentifier c36_thisId;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_CB1), &c36_thisId);
  sf_mex_destroy(&c36_CB1);
  return c36_y;
}

static real_T c36_b_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  real_T c36_y;
  real_T c36_d2;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_d2, 1, 0, 0U, 0, 0U, 0);
  c36_y = c36_d2;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void c36_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_CB1;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  real_T c36_y;
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c36_CB1 = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_CB1), &c36_thisId);
  sf_mex_destroy(&c36_CB1);
  *(real_T *)c36_outData = c36_y;
  sf_mex_destroy(&c36_mxArrayInData);
}

static const mxArray *c36_b_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_i3;
  int32_T c36_i4;
  int32_T c36_i5;
  real_T c36_b_inData[6];
  int32_T c36_i6;
  int32_T c36_i7;
  int32_T c36_i8;
  real_T c36_u[6];
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_i3 = 0;
  for (c36_i4 = 0; c36_i4 < 2; c36_i4++) {
    for (c36_i5 = 0; c36_i5 < 3; c36_i5++) {
      c36_b_inData[c36_i5 + c36_i3] = (*(real_T (*)[6])c36_inData)[c36_i5 +
        c36_i3];
    }

    c36_i3 += 3;
  }

  c36_i6 = 0;
  for (c36_i7 = 0; c36_i7 < 2; c36_i7++) {
    for (c36_i8 = 0; c36_i8 < 3; c36_i8++) {
      c36_u[c36_i8 + c36_i6] = c36_b_inData[c36_i8 + c36_i6];
    }

    c36_i6 += 3;
  }

  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", c36_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static void c36_c_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId, real_T c36_y[6])
{
  real_T c36_dv1[6];
  int32_T c36_i9;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), c36_dv1, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c36_i9 = 0; c36_i9 < 6; c36_i9++) {
    c36_y[c36_i9] = c36_dv1[c36_i9];
  }

  sf_mex_destroy(&c36_u);
}

static void c36_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_b_diff_r;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  real_T c36_y[6];
  int32_T c36_i10;
  int32_T c36_i11;
  int32_T c36_i12;
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c36_b_diff_r = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_b_diff_r), &c36_thisId,
    c36_y);
  sf_mex_destroy(&c36_b_diff_r);
  c36_i10 = 0;
  for (c36_i11 = 0; c36_i11 < 2; c36_i11++) {
    for (c36_i12 = 0; c36_i12 < 3; c36_i12++) {
      (*(real_T (*)[6])c36_outData)[c36_i12 + c36_i10] = c36_y[c36_i12 + c36_i10];
    }

    c36_i10 += 3;
  }

  sf_mex_destroy(&c36_mxArrayInData);
}

const mxArray
  *sf_c36_SimulationPlantModel_NonlinRR_get_eml_resolved_functions_info(void)
{
  const mxArray *c36_nameCaptureInfo = NULL;
  c36_nameCaptureInfo = NULL;
  sf_mex_assign(&c36_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c36_nameCaptureInfo;
}

static const mxArray *c36_c_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_u;
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_u = *(int32_T *)c36_inData;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", &c36_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static int32_T c36_d_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  int32_T c36_y;
  int32_T c36_i13;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_i13, 1, 6, 0U, 0, 0U, 0);
  c36_y = c36_i13;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void c36_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_b_sfEvent;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  int32_T c36_y;
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c36_b_sfEvent = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_b_sfEvent),
    &c36_thisId);
  sf_mex_destroy(&c36_b_sfEvent);
  *(int32_T *)c36_outData = c36_y;
  sf_mex_destroy(&c36_mxArrayInData);
}

static uint8_T c36_e_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_b_is_active_c36_SimulationPlantModel_NonlinRR, const char_T
   *c36_identifier)
{
  uint8_T c36_y;
  emlrtMsgIdentifier c36_thisId;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c36_b_is_active_c36_SimulationPlantModel_NonlinRR), &c36_thisId);
  sf_mex_destroy(&c36_b_is_active_c36_SimulationPlantModel_NonlinRR);
  return c36_y;
}

static uint8_T c36_f_emlrt_marshallIn
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  uint8_T c36_y;
  uint8_T c36_u0;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_u0, 1, 3, 0U, 0, 0U, 0);
  c36_y = c36_u0;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static real_T c36_get_CB1(SFc36_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c36_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 0, NULL, c36_b);
  if (chartInstance->c36_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#947) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c36_CB1_address;
}

static void c36_set_CB1(SFc36_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c36_b, real_T c36_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 0, NULL, c36_b);
  if (chartInstance->c36_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#947) in the initialization routine of the chart.\n");
  }

  *chartInstance->c36_CB1_address = c36_c;
}

static real_T *c36_access_CB1(SFc36_SimulationPlantModel_NonlinRRInstanceStruct *
  chartInstance, uint32_T c36_b)
{
  real_T *c36_c;
  ssReadFromDataStore(chartInstance->S, 0, NULL);
  if (chartInstance->c36_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#947) in the initialization routine of the chart.\n");
  }

  c36_c = chartInstance->c36_CB1_address;
  if (c36_b == 0) {
    ssWriteToDataStore(chartInstance->S, 0, NULL);
  }

  return c36_c;
}

static void init_dsm_address_info
  (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB1", (void **)
    &chartInstance->c36_CB1_address, &chartInstance->c36_CB1_index);
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c36_SimulationPlantModel_NonlinRR_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1028138794U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1709831353U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3468715354U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1007770303U);
}

mxArray *sf_c36_SimulationPlantModel_NonlinRR_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("OtcSrehYhVAuid3fTpKAt");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c36_SimulationPlantModel_NonlinRR_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c36_SimulationPlantModel_NonlinRR
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"StayConnectedG\",},{M[8],M[0],T\"is_active_c36_SimulationPlantModel_NonlinRR\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c36_SimulationPlantModel_NonlinRR_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
    chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_NonlinRRMachineNumber_,
           36,
           1,
           1,
           9,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_NonlinRRMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_NonlinRRMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_NonlinRRMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"time");
          _SFD_SET_DATA_PROPS(1,1,1,0,"r_dq");
          _SFD_SET_DATA_PROPS(2,2,0,1,"StayConnectedG");
          _SFD_SET_DATA_PROPS(3,1,1,0,"r_ddw");
          _SFD_SET_DATA_PROPS(4,1,1,0,"r_ddq");
          _SFD_SET_DATA_PROPS(5,10,0,0,"diff_r");
          _SFD_SET_DATA_PROPS(6,10,0,0,"DisconnectWhenFaultDetected");
          _SFD_SET_DATA_PROPS(7,10,0,0,"FaultDetectionInitTime");
          _SFD_SET_DATA_PROPS(8,11,0,0,"CB1");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,5,0,0,0,0,0,8,4);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,701);
        _SFD_CV_INIT_EML_IF(0,1,0,319,330,-1,358);
        _SFD_CV_INIT_EML_IF(0,1,1,360,429,-1,697);
        _SFD_CV_INIT_EML_IF(0,1,2,434,481,514,569);
        _SFD_CV_INIT_EML_IF(0,1,3,514,569,602,693);
        _SFD_CV_INIT_EML_IF(0,1,4,602,657,-1,657);

        {
          static int condStart[] = { 363, 399 };

          static int condEnd[] = { 395, 429 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,363,429,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 437, 461 };

          static int condEnd[] = { 457, 481 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,437,481,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 521, 547 };

          static int condEnd[] = { 543, 569 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,521,569,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 609, 635 };

          static int condEnd[] = { 631, 657 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,3,609,657,2,6,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)
            c36_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);

        {
          real_T *c36_time;
          real_T *c36_r_dq;
          real_T *c36_StayConnectedG;
          real_T *c36_r_ddw;
          real_T *c36_r_ddq;
          c36_r_ddq = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c36_r_ddw = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S,
            1);
          c36_r_dq = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c36_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c36_time);
          _SFD_SET_DATA_VALUE_PTR(1U, c36_r_dq);
          _SFD_SET_DATA_VALUE_PTR(2U, c36_StayConnectedG);
          _SFD_SET_DATA_VALUE_PTR(3U, c36_r_ddw);
          _SFD_SET_DATA_VALUE_PTR(4U, c36_r_ddq);
          _SFD_SET_DATA_VALUE_PTR(5U, chartInstance->c36_diff_r);
          _SFD_SET_DATA_VALUE_PTR(6U,
            &chartInstance->c36_DisconnectWhenFaultDetected);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance->c36_FaultDetectionInitTime);
          _SFD_SET_DATA_VALUE_PTR(8U, chartInstance->c36_CB1_address);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_NonlinRRMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "81nz7y2aeMT3iSNujbqnPH";
}

static void sf_opaque_initialize_c36_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
  initialize_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c36_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  enable_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c36_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  disable_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c36_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  sf_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c36_SimulationPlantModel_NonlinRR(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c36_SimulationPlantModel_NonlinRR();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c36_SimulationPlantModel_NonlinRR
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c36_SimulationPlantModel_NonlinRR();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c36_SimulationPlantModel_NonlinRR
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c36_SimulationPlantModel_NonlinRR(S);
}

static void sf_opaque_set_sim_state_c36_SimulationPlantModel_NonlinRR(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c36_SimulationPlantModel_NonlinRR(S, st);
}

static void sf_opaque_terminate_c36_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_NonlinRR_optimization_info();
    }

    finalize_c36_SimulationPlantModel_NonlinRR
      ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc36_SimulationPlantModel_NonlinRR
    ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c36_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c36_SimulationPlantModel_NonlinRR
      ((SFc36_SimulationPlantModel_NonlinRRInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c36_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  /* Actual parameters from chart:
     DisconnectWhenFaultDetected FaultDetectionInitTime diff_r
   */
  const char_T *rtParamNames[] = { "DisconnectWhenFaultDetected",
    "FaultDetectionInitTime", "diff_r" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for DisconnectWhenFaultDetected*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for FaultDetectionInitTime*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for diff_r*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_NonlinRR_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      36);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,36,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,36,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,36);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,36,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,36,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 4; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,36);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1044073966U));
  ssSetChecksum1(S,(1303591277U));
  ssSetChecksum2(S,(1037757255U));
  ssSetChecksum3(S,(946823961U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,0);
}

static void mdlRTW_c36_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c36_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  SFc36_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_NonlinRRInstanceStruct *)utMalloc
    (sizeof(SFc36_SimulationPlantModel_NonlinRRInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc36_SimulationPlantModel_NonlinRRInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.mdlStart = mdlStart_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c36_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c36_SimulationPlantModel_NonlinRR_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c36_SimulationPlantModel_NonlinRR(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c36_SimulationPlantModel_NonlinRR(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c36_SimulationPlantModel_NonlinRR(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c36_SimulationPlantModel_NonlinRR_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
