#ifndef __c49_SimulationPlantModel_NonlinRR_h__
#define __c49_SimulationPlantModel_NonlinRR_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c49_ResolvedFunctionInfo
#define typedef_c49_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c49_ResolvedFunctionInfo;

#endif                                 /*typedef_c49_ResolvedFunctionInfo*/

#ifndef typedef_SFc49_SimulationPlantModel_NonlinRRInstanceStruct
#define typedef_SFc49_SimulationPlantModel_NonlinRRInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c49_sfEvent;
  boolean_T c49_isStable;
  boolean_T c49_doneDoubleBufferReInit;
  uint8_T c49_is_active_c49_SimulationPlantModel_NonlinRR;
  real_T c49_omega_b;
  real_T c49_tau_f_G[3];
  real_T c49_r_f_G[3];
  real_T c49_H_G[3];
  real_T c49_D_fw_G[3];
  real_T c49_z_G[6];
  real_T c49_tau_e_G[3];
  real_T c49_GeneratorNumber;
} SFc49_SimulationPlantModel_NonlinRRInstanceStruct;

#endif                                 /*typedef_SFc49_SimulationPlantModel_NonlinRRInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c49_SimulationPlantModel_NonlinRR_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c49_SimulationPlantModel_NonlinRR_get_check_sum(mxArray *plhs[]);
extern void c49_SimulationPlantModel_NonlinRR_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
