#ifndef __c56_SimulationPlantModel_NonlinRR_h__
#define __c56_SimulationPlantModel_NonlinRR_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c56_ResolvedFunctionInfo
#define typedef_c56_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c56_ResolvedFunctionInfo;

#endif                                 /*typedef_c56_ResolvedFunctionInfo*/

#ifndef typedef_SFc56_SimulationPlantModel_NonlinRRInstanceStruct
#define typedef_SFc56_SimulationPlantModel_NonlinRRInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c56_sfEvent;
  boolean_T c56_isStable;
  boolean_T c56_doneDoubleBufferReInit;
  uint8_T c56_is_active_c56_SimulationPlantModel_NonlinRR;
  real_T c56_omega_b;
  real_T c56_tau_f_G[3];
  real_T c56_r_f_G[3];
  real_T c56_H_G[3];
  real_T c56_D_fw_G[3];
  real_T c56_z_G[6];
  real_T c56_tau_e_G[3];
  real_T c56_GeneratorNumber;
} SFc56_SimulationPlantModel_NonlinRRInstanceStruct;

#endif                                 /*typedef_SFc56_SimulationPlantModel_NonlinRRInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c56_SimulationPlantModel_NonlinRR_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c56_SimulationPlantModel_NonlinRR_get_check_sum(mxArray *plhs[]);
extern void c56_SimulationPlantModel_NonlinRR_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
