/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_NonlinRR_sfun.h"
#include "c5_SimulationPlantModel_NonlinRR.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_NonlinRR_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c5_debug_family_names[27] = { "CB_G", "P_load", "Q_load",
  "z", "Z", "dividend_v_T", "divisor_v_T", "divisor_Z_T", "i", "v_T", "Z_T",
  "Z_L", "v_an", "temp", "nargin", "nargout", "e_aG", "S_load", "abs_V_an",
  "S_b_G", "z_G", "Z_G", "s_G", "abs_v_an", "CB1", "CB2", "CB3" };

/* Function Declarations */
static void initialize_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void initialize_params_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void enable_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void disable_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void c5_update_debugger_state_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void set_sim_state_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_st);
static void finalize_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void sf_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void c5_chartstep_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void initSimStructsc5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void registerMessagesc5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber);
static const mxArray *c5_sf_marshallOut(void *chartInstanceVoid, void *c5_inData);
static real_T c5_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_CB3, const char_T *c5_identifier);
static real_T c5_b_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_b_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static void c5_c_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_s_G, const char_T *c5_identifier, real_T c5_y[6]);
static void c5_d_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, real_T c5_y[6]);
static void c5_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_c_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static void c5_e_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, real_T c5_y[3]);
static void c5_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_d_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static const mxArray *c5_e_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static const mxArray *c5_f_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static creal_T c5_f_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_g_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static void c5_g_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, creal_T c5_y[3]);
static void c5_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static void c5_info_helper(c5_ResolvedFunctionInfo c5_info[20]);
static real_T c5_mpower(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, real_T c5_a);
static void c5_eml_scalar_eg(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance);
static const mxArray *c5_h_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static int32_T c5_h_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static uint8_T c5_i_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_b_is_active_c5_SimulationPlantModel_NonlinRR, const char_T
   *c5_identifier);
static uint8_T c5_j_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static real_T c5_get_CB1(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b);
static void c5_set_CB1(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b, real_T c5_c);
static real_T *c5_access_CB1(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b);
static real_T c5_get_CB2(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b);
static void c5_set_CB2(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b, real_T c5_c);
static real_T *c5_access_CB2(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b);
static real_T c5_get_CB3(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b);
static void c5_set_CB3(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b, real_T c5_c);
static real_T *c5_access_CB3(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b);
static void init_dsm_address_info
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  chartInstance->c5_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c5_is_active_c5_SimulationPlantModel_NonlinRR = 0U;
}

static void initialize_params_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  real_T c5_dv0[3];
  int32_T c5_i0;
  real_T c5_dv1[6];
  int32_T c5_i1;
  real_T c5_dv2[6];
  int32_T c5_i2;
  sf_set_error_prefix_string(
    "Error evaluating data 'S_b_G' in the parent workspace.\n");
  sf_mex_import_named("S_b_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c5_dv0, 0, 0, 0U, 1, 0U, 1, 3);
  for (c5_i0 = 0; c5_i0 < 3; c5_i0++) {
    chartInstance->c5_S_b_G[c5_i0] = c5_dv0[c5_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'z_G' in the parent workspace.\n");
  sf_mex_import_named("z_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c5_dv1, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c5_i1 = 0; c5_i1 < 6; c5_i1++) {
    chartInstance->c5_z_G[c5_i1] = c5_dv1[c5_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'Z_G' in the parent workspace.\n");
  sf_mex_import_named("Z_G", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c5_dv2, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c5_i2 = 0; c5_i2 < 6; c5_i2++) {
    chartInstance->c5_Z_G[c5_i2] = c5_dv2[c5_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c5_update_debugger_state_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  const mxArray *c5_st;
  const mxArray *c5_y = NULL;
  real_T c5_hoistedGlobal;
  real_T c5_u;
  const mxArray *c5_b_y = NULL;
  int32_T c5_i3;
  real_T c5_b_u[6];
  const mxArray *c5_c_y = NULL;
  uint8_T c5_b_hoistedGlobal;
  uint8_T c5_c_u;
  const mxArray *c5_d_y = NULL;
  real_T *c5_abs_v_an;
  real_T (*c5_s_G)[6];
  c5_abs_v_an = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c5_s_G = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c5_st = NULL;
  c5_st = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createcellarray(3), FALSE);
  c5_hoistedGlobal = *c5_abs_v_an;
  c5_u = c5_hoistedGlobal;
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c5_y, 0, c5_b_y);
  for (c5_i3 = 0; c5_i3 < 6; c5_i3++) {
    c5_b_u[c5_i3] = (*c5_s_G)[c5_i3];
  }

  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create("y", c5_b_u, 0, 0U, 1U, 0U, 2, 3, 2),
                FALSE);
  sf_mex_setcell(c5_y, 1, c5_c_y);
  c5_b_hoistedGlobal =
    chartInstance->c5_is_active_c5_SimulationPlantModel_NonlinRR;
  c5_c_u = c5_b_hoistedGlobal;
  c5_d_y = NULL;
  sf_mex_assign(&c5_d_y, sf_mex_create("y", &c5_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c5_y, 2, c5_d_y);
  sf_mex_assign(&c5_st, c5_y, FALSE);
  return c5_st;
}

static void set_sim_state_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_st)
{
  const mxArray *c5_u;
  real_T c5_dv3[6];
  int32_T c5_i4;
  real_T *c5_abs_v_an;
  real_T (*c5_s_G)[6];
  c5_abs_v_an = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c5_s_G = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c5_doneDoubleBufferReInit = TRUE;
  c5_u = sf_mex_dup(c5_st);
  *c5_abs_v_an = c5_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c5_u, 0)), "abs_v_an");
  c5_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 1)),
                        "s_G", c5_dv3);
  for (c5_i4 = 0; c5_i4 < 6; c5_i4++) {
    (*c5_s_G)[c5_i4] = c5_dv3[c5_i4];
  }

  chartInstance->c5_is_active_c5_SimulationPlantModel_NonlinRR =
    c5_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 2)),
    "is_active_c5_SimulationPlantModel_NonlinRR");
  sf_mex_destroy(&c5_u);
  c5_update_debugger_state_c5_SimulationPlantModel_NonlinRR(chartInstance);
  sf_mex_destroy(&c5_st);
}

static void finalize_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void sf_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  int32_T c5_i5;
  int32_T c5_i6;
  int32_T c5_i7;
  int32_T c5_i8;
  int32_T c5_i9;
  real_T *c5_abs_v_an;
  real_T *c5_abs_V_an;
  real_T (*c5_S_load)[2];
  real_T (*c5_s_G)[6];
  c5_abs_V_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c5_S_load = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
  c5_abs_v_an = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c5_s_G = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 4U, chartInstance->c5_sfEvent);
  for (c5_i5 = 0; c5_i5 < 6; c5_i5++) {
    _SFD_DATA_RANGE_CHECK((*c5_s_G)[c5_i5], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c5_abs_v_an, 1U);
  for (c5_i6 = 0; c5_i6 < 2; c5_i6++) {
    _SFD_DATA_RANGE_CHECK((*c5_S_load)[c5_i6], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c5_abs_V_an, 4U);
  for (c5_i7 = 0; c5_i7 < 3; c5_i7++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c5_S_b_G[c5_i7], 5U);
  }

  for (c5_i8 = 0; c5_i8 < 6; c5_i8++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c5_z_G[c5_i8], 6U);
  }

  for (c5_i9 = 0; c5_i9 < 6; c5_i9++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c5_Z_G[c5_i9], 7U);
  }

  chartInstance->c5_sfEvent = CALL_EVENT;
  c5_chartstep_c5_SimulationPlantModel_NonlinRR(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_NonlinRRMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void c5_chartstep_c5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  real_T c5_hoistedGlobal;
  int32_T c5_i10;
  creal_T c5_e_aG[3];
  int32_T c5_i11;
  real_T c5_S_load[2];
  real_T c5_abs_V_an;
  int32_T c5_i12;
  real_T c5_b_S_b_G[3];
  int32_T c5_i13;
  real_T c5_b_z_G[6];
  int32_T c5_i14;
  real_T c5_b_Z_G[6];
  uint32_T c5_debug_family_var_map[27];
  real_T c5_CB_G[3];
  real_T c5_P_load;
  real_T c5_Q_load;
  creal_T c5_z[3];
  creal_T c5_Z[3];
  creal_T c5_dividend_v_T;
  creal_T c5_divisor_v_T;
  creal_T c5_divisor_Z_T;
  real_T c5_i;
  creal_T c5_v_T;
  creal_T c5_Z_T;
  creal_T c5_Z_L;
  creal_T c5_v_an;
  creal_T c5_temp;
  real_T c5_nargin = 6.0;
  real_T c5_nargout = 2.0;
  real_T c5_s_G[6];
  real_T c5_abs_v_an;
  real_T c5_b;
  static creal_T c5_dc0 = { 0.0, 1.0 };

  creal_T c5_y;
  real_T c5_b_b;
  creal_T c5_b_y;
  real_T c5_c_b;
  creal_T c5_c_y;
  real_T c5_d_b;
  real_T c5_e_b;
  real_T c5_f_b;
  static creal_T c5_dc1 = { 0.0, 0.0 };

  int32_T c5_b_i;
  real_T c5_a;
  real_T c5_g_b;
  real_T c5_d_y;
  real_T c5_b_a;
  creal_T c5_e_y;
  real_T c5_ar;
  real_T c5_ai;
  real_T c5_br;
  real_T c5_bi;
  real_T c5_brm;
  real_T c5_bim;
  real_T c5_s;
  real_T c5_d;
  real_T c5_nr;
  real_T c5_ni;
  real_T c5_sgnbr;
  real_T c5_sgnbi;
  real_T c5_c_a;
  real_T c5_h_b;
  real_T c5_f_y;
  real_T c5_A;
  real_T c5_x;
  real_T c5_b_x;
  real_T c5_b_ar;
  real_T c5_b_ai;
  real_T c5_b_br;
  real_T c5_b_bi;
  real_T c5_b_brm;
  real_T c5_b_bim;
  real_T c5_b_s;
  real_T c5_b_d;
  real_T c5_b_nr;
  real_T c5_b_ni;
  real_T c5_b_sgnbr;
  real_T c5_b_sgnbi;
  real_T c5_b_A;
  real_T c5_c_x;
  real_T c5_d_x;
  real_T c5_c_ar;
  real_T c5_c_ai;
  real_T c5_c_br;
  real_T c5_c_bi;
  real_T c5_c_brm;
  real_T c5_c_bim;
  real_T c5_c_s;
  real_T c5_c_d;
  real_T c5_c_nr;
  real_T c5_c_ni;
  real_T c5_c_sgnbr;
  real_T c5_c_sgnbi;
  real_T c5_d_ar;
  real_T c5_d_ai;
  real_T c5_d_br;
  real_T c5_d_bi;
  real_T c5_d_brm;
  real_T c5_d_bim;
  real_T c5_d_s;
  real_T c5_d_d;
  real_T c5_d_nr;
  real_T c5_d_ni;
  real_T c5_d_sgnbr;
  real_T c5_d_sgnbi;
  static creal_T c5_dc2 = { 1.0, 0.0 };

  real_T c5_e_ar;
  real_T c5_e_ai;
  real_T c5_e_br;
  real_T c5_e_bi;
  real_T c5_e_brm;
  real_T c5_e_bim;
  real_T c5_e_s;
  real_T c5_e_d;
  real_T c5_e_nr;
  real_T c5_e_ni;
  real_T c5_e_sgnbr;
  real_T c5_e_sgnbi;
  real_T c5_i_b;
  real_T c5_g_y;
  real_T c5_j_b;
  real_T c5_c_A;
  real_T c5_e_x;
  real_T c5_f_x;
  real_T c5_f_ar;
  real_T c5_f_ai;
  real_T c5_f_br;
  real_T c5_f_bi;
  real_T c5_f_brm;
  real_T c5_f_bim;
  real_T c5_f_s;
  real_T c5_f_d;
  real_T c5_f_nr;
  real_T c5_f_ni;
  real_T c5_f_sgnbr;
  real_T c5_f_sgnbi;
  real_T c5_g_ar;
  real_T c5_g_ai;
  real_T c5_g_br;
  real_T c5_g_bi;
  real_T c5_g_brm;
  real_T c5_g_bim;
  real_T c5_g_s;
  real_T c5_g_d;
  real_T c5_g_nr;
  real_T c5_g_ni;
  real_T c5_g_sgnbr;
  real_T c5_g_sgnbi;
  real_T c5_x1;
  real_T c5_x2;
  real_T c5_d_a;
  real_T c5_k_b;
  int32_T c5_i15;
  int32_T c5_c_i;
  real_T c5_e_a;
  real_T c5_h_y;
  real_T c5_f_a;
  creal_T c5_i_y;
  real_T c5_h_ar;
  real_T c5_h_ai;
  real_T c5_h_br;
  real_T c5_h_bi;
  real_T c5_h_brm;
  real_T c5_h_bim;
  real_T c5_h_s;
  real_T c5_h_d;
  real_T c5_h_nr;
  real_T c5_h_ni;
  real_T c5_h_sgnbr;
  real_T c5_h_sgnbi;
  int32_T c5_d_i;
  int32_T c5_i16;
  real_T *c5_b_abs_v_an;
  real_T *c5_b_abs_V_an;
  real_T (*c5_b_s_G)[6];
  real_T (*c5_b_S_load)[2];
  creal_T (*c5_b_e_aG)[3];
  c5_b_abs_V_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c5_b_S_load = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
  c5_b_e_aG = (creal_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c5_b_abs_v_an = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c5_b_s_G = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 4U, chartInstance->c5_sfEvent);
  c5_hoistedGlobal = *c5_b_abs_V_an;
  for (c5_i10 = 0; c5_i10 < 3; c5_i10++) {
    c5_e_aG[c5_i10] = (*c5_b_e_aG)[c5_i10];
  }

  for (c5_i11 = 0; c5_i11 < 2; c5_i11++) {
    c5_S_load[c5_i11] = (*c5_b_S_load)[c5_i11];
  }

  c5_abs_V_an = c5_hoistedGlobal;
  for (c5_i12 = 0; c5_i12 < 3; c5_i12++) {
    c5_b_S_b_G[c5_i12] = chartInstance->c5_S_b_G[c5_i12];
  }

  for (c5_i13 = 0; c5_i13 < 6; c5_i13++) {
    c5_b_z_G[c5_i13] = chartInstance->c5_z_G[c5_i13];
  }

  for (c5_i14 = 0; c5_i14 < 6; c5_i14++) {
    c5_b_Z_G[c5_i14] = chartInstance->c5_Z_G[c5_i14];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 27U, 27U, c5_debug_family_names,
    c5_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_CB_G, 0U, c5_c_sf_marshallOut,
    c5_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_P_load, 1U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_Q_load, 2U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_z, 3U, c5_g_sf_marshallOut,
    c5_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_Z, 4U, c5_g_sf_marshallOut,
    c5_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_dividend_v_T, 5U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_divisor_v_T, 6U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_divisor_Z_T, 7U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_i, 8U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_v_T, 9U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_Z_T, 10U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_Z_L, 11U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_v_an, 12U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_temp, 13U, c5_f_sf_marshallOut,
    c5_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_nargin, 14U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_nargout, 15U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c5_e_aG, 16U, c5_e_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c5_S_load, 17U, c5_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c5_abs_V_an, 18U, c5_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_b_S_b_G, 19U, c5_c_sf_marshallOut,
    c5_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_b_z_G, 20U, c5_b_sf_marshallOut,
    c5_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_b_Z_G, 21U, c5_b_sf_marshallOut,
    c5_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c5_s_G, 22U, c5_b_sf_marshallOut,
    c5_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c5_abs_v_an, 23U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c5_CB1_address, 24U,
    c5_sf_marshallOut, c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c5_CB2_address, 25U,
    c5_sf_marshallOut, c5_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c5_CB3_address, 26U,
    c5_sf_marshallOut, c5_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 5);
  c5_CB_G[0] = c5_get_CB1(chartInstance, 0);
  c5_CB_G[1] = c5_get_CB2(chartInstance, 0);
  c5_CB_G[2] = c5_get_CB3(chartInstance, 0);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 6);
  c5_P_load = c5_S_load[0];
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 7);
  c5_Q_load = c5_S_load[1];
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 8);
  c5_b = c5_b_z_G[3];
  c5_y.re = c5_b * c5_dc0.re;
  c5_y.im = c5_b * c5_dc0.im;
  c5_b_b = c5_b_z_G[4];
  c5_b_y.re = c5_b_b * c5_dc0.re;
  c5_b_y.im = c5_b_b * c5_dc0.im;
  c5_c_b = c5_b_z_G[5];
  c5_c_y.re = c5_c_b * c5_dc0.re;
  c5_c_y.im = c5_c_b * c5_dc0.im;
  c5_z[0].re = c5_b_z_G[0] + c5_y.re;
  c5_z[0].im = c5_y.im;
  c5_z[1].re = c5_b_z_G[1] + c5_b_y.re;
  c5_z[1].im = c5_b_y.im;
  c5_z[2].re = c5_b_z_G[2] + c5_c_y.re;
  c5_z[2].im = c5_c_y.im;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 11);
  c5_d_b = c5_b_Z_G[3];
  c5_y.re = c5_d_b * c5_dc0.re;
  c5_y.im = c5_d_b * c5_dc0.im;
  c5_e_b = c5_b_Z_G[4];
  c5_b_y.re = c5_e_b * c5_dc0.re;
  c5_b_y.im = c5_e_b * c5_dc0.im;
  c5_f_b = c5_b_Z_G[5];
  c5_c_y.re = c5_f_b * c5_dc0.re;
  c5_c_y.im = c5_f_b * c5_dc0.im;
  c5_Z[0].re = c5_b_Z_G[0] + c5_y.re;
  c5_Z[0].im = c5_y.im;
  c5_Z[1].re = c5_b_Z_G[1] + c5_b_y.re;
  c5_Z[1].im = c5_b_y.im;
  c5_Z[2].re = c5_b_Z_G[2] + c5_c_y.re;
  c5_Z[2].im = c5_c_y.im;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 16);
  c5_dividend_v_T = c5_dc1;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 17);
  c5_divisor_v_T = c5_dc1;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 18);
  c5_divisor_Z_T = c5_dc1;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 19);
  c5_i = 1.0;
  c5_b_i = 0;
  while (c5_b_i < 3) {
    c5_i = 1.0 + (real_T)c5_b_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 20);
    c5_a = c5_CB_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("CB_G", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_g_b = c5_b_S_b_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("S_b_G",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_d_y = c5_a * c5_g_b;
    c5_b_a = c5_d_y;
    c5_c_y = c5_e_aG[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("e_aG",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_y.re = c5_b_a * c5_c_y.re;
    c5_y.im = c5_b_a * c5_c_y.im;
    c5_c_y = c5_z[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_e_y = c5_y;
    c5_ar = c5_e_y.re;
    c5_ai = c5_e_y.im;
    c5_br = c5_c_y.re;
    c5_bi = c5_c_y.im;
    if (c5_bi == 0.0) {
      if (c5_ai == 0.0) {
        c5_y.re = c5_ar / c5_br;
        c5_y.im = 0.0;
      } else if (c5_ar == 0.0) {
        c5_y.re = 0.0;
        c5_y.im = c5_ai / c5_br;
      } else {
        c5_y.re = c5_ar / c5_br;
        c5_y.im = c5_ai / c5_br;
      }
    } else if (c5_br == 0.0) {
      if (c5_ar == 0.0) {
        c5_y.re = c5_ai / c5_bi;
        c5_y.im = 0.0;
      } else if (c5_ai == 0.0) {
        c5_y.re = 0.0;
        c5_y.im = -(c5_ar / c5_bi);
      } else {
        c5_y.re = c5_ai / c5_bi;
        c5_y.im = -(c5_ar / c5_bi);
      }
    } else {
      c5_brm = muDoubleScalarAbs(c5_br);
      c5_bim = muDoubleScalarAbs(c5_bi);
      if (c5_brm > c5_bim) {
        c5_s = c5_bi / c5_br;
        c5_d = c5_br + c5_s * c5_bi;
        c5_nr = c5_ar + c5_s * c5_ai;
        c5_ni = c5_ai - c5_s * c5_ar;
        c5_y.re = c5_nr / c5_d;
        c5_y.im = c5_ni / c5_d;
      } else if (c5_bim == c5_brm) {
        if (c5_br > 0.0) {
          c5_sgnbr = 0.5;
        } else {
          c5_sgnbr = -0.5;
        }

        if (c5_bi > 0.0) {
          c5_sgnbi = 0.5;
        } else {
          c5_sgnbi = -0.5;
        }

        c5_nr = c5_ar * c5_sgnbr + c5_ai * c5_sgnbi;
        c5_ni = c5_ai * c5_sgnbr - c5_ar * c5_sgnbi;
        c5_y.re = c5_nr / c5_brm;
        c5_y.im = c5_ni / c5_brm;
      } else {
        c5_s = c5_br / c5_bi;
        c5_d = c5_bi + c5_s * c5_br;
        c5_nr = c5_s * c5_ar + c5_ai;
        c5_ni = c5_s * c5_ai - c5_ar;
        c5_y.re = c5_nr / c5_d;
        c5_y.im = c5_ni / c5_d;
      }
    }

    c5_dividend_v_T.re += c5_y.re;
    c5_dividend_v_T.im += c5_y.im;
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 21);
    c5_c_a = c5_CB_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("CB_G",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_h_b = c5_b_S_b_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("S_b_G",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_f_y = c5_c_a * c5_h_b;
    c5_A = c5_f_y;
    c5_c_y = c5_z[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_x = c5_A;
    c5_b_x = c5_x;
    c5_b_ar = c5_b_x;
    c5_b_ai = 0.0;
    c5_b_br = c5_c_y.re;
    c5_b_bi = c5_c_y.im;
    if (c5_b_bi == 0.0) {
      if (c5_b_ai == 0.0) {
        c5_y.re = c5_b_ar / c5_b_br;
        c5_y.im = 0.0;
      } else if (c5_b_ar == 0.0) {
        c5_y.re = 0.0;
        c5_y.im = c5_b_ai / c5_b_br;
      } else {
        c5_y.re = c5_b_ar / c5_b_br;
        c5_y.im = c5_b_ai / c5_b_br;
      }
    } else if (c5_b_br == 0.0) {
      if (c5_b_ar == 0.0) {
        c5_y.re = c5_b_ai / c5_b_bi;
        c5_y.im = 0.0;
      } else if (c5_b_ai == 0.0) {
        c5_y.re = 0.0;
        c5_y.im = -(c5_b_ar / c5_b_bi);
      } else {
        c5_y.re = c5_b_ai / c5_b_bi;
        c5_y.im = -(c5_b_ar / c5_b_bi);
      }
    } else {
      c5_b_brm = muDoubleScalarAbs(c5_b_br);
      c5_b_bim = muDoubleScalarAbs(c5_b_bi);
      if (c5_b_brm > c5_b_bim) {
        c5_b_s = c5_b_bi / c5_b_br;
        c5_b_d = c5_b_br + c5_b_s * c5_b_bi;
        c5_b_nr = c5_b_ar + c5_b_s * c5_b_ai;
        c5_b_ni = c5_b_ai - c5_b_s * c5_b_ar;
        c5_y.re = c5_b_nr / c5_b_d;
        c5_y.im = c5_b_ni / c5_b_d;
      } else if (c5_b_bim == c5_b_brm) {
        if (c5_b_br > 0.0) {
          c5_b_sgnbr = 0.5;
        } else {
          c5_b_sgnbr = -0.5;
        }

        if (c5_b_bi > 0.0) {
          c5_b_sgnbi = 0.5;
        } else {
          c5_b_sgnbi = -0.5;
        }

        c5_b_nr = c5_b_ar * c5_b_sgnbr + c5_b_ai * c5_b_sgnbi;
        c5_b_ni = c5_b_ai * c5_b_sgnbr - c5_b_ar * c5_b_sgnbi;
        c5_y.re = c5_b_nr / c5_b_brm;
        c5_y.im = c5_b_ni / c5_b_brm;
      } else {
        c5_b_s = c5_b_br / c5_b_bi;
        c5_b_d = c5_b_bi + c5_b_s * c5_b_br;
        c5_b_nr = c5_b_s * c5_b_ar + c5_b_ai;
        c5_b_ni = c5_b_s * c5_b_ai - c5_b_ar;
        c5_y.re = c5_b_nr / c5_b_d;
        c5_y.im = c5_b_ni / c5_b_d;
      }
    }

    c5_divisor_v_T.re += c5_y.re;
    c5_divisor_v_T.im += c5_y.im;
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 22);
    c5_b_A = c5_CB_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("CB_G",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_c_y = c5_Z[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("Z", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_c_x = c5_b_A;
    c5_d_x = c5_c_x;
    c5_c_ar = c5_d_x;
    c5_c_ai = 0.0;
    c5_c_br = c5_c_y.re;
    c5_c_bi = c5_c_y.im;
    if (c5_c_bi == 0.0) {
      if (c5_c_ai == 0.0) {
        c5_y.re = c5_c_ar / c5_c_br;
        c5_y.im = 0.0;
      } else if (c5_c_ar == 0.0) {
        c5_y.re = 0.0;
        c5_y.im = c5_c_ai / c5_c_br;
      } else {
        c5_y.re = c5_c_ar / c5_c_br;
        c5_y.im = c5_c_ai / c5_c_br;
      }
    } else if (c5_c_br == 0.0) {
      if (c5_c_ar == 0.0) {
        c5_y.re = c5_c_ai / c5_c_bi;
        c5_y.im = 0.0;
      } else if (c5_c_ai == 0.0) {
        c5_y.re = 0.0;
        c5_y.im = -(c5_c_ar / c5_c_bi);
      } else {
        c5_y.re = c5_c_ai / c5_c_bi;
        c5_y.im = -(c5_c_ar / c5_c_bi);
      }
    } else {
      c5_c_brm = muDoubleScalarAbs(c5_c_br);
      c5_c_bim = muDoubleScalarAbs(c5_c_bi);
      if (c5_c_brm > c5_c_bim) {
        c5_c_s = c5_c_bi / c5_c_br;
        c5_c_d = c5_c_br + c5_c_s * c5_c_bi;
        c5_c_nr = c5_c_ar + c5_c_s * c5_c_ai;
        c5_c_ni = c5_c_ai - c5_c_s * c5_c_ar;
        c5_y.re = c5_c_nr / c5_c_d;
        c5_y.im = c5_c_ni / c5_c_d;
      } else if (c5_c_bim == c5_c_brm) {
        if (c5_c_br > 0.0) {
          c5_c_sgnbr = 0.5;
        } else {
          c5_c_sgnbr = -0.5;
        }

        if (c5_c_bi > 0.0) {
          c5_c_sgnbi = 0.5;
        } else {
          c5_c_sgnbi = -0.5;
        }

        c5_c_nr = c5_c_ar * c5_c_sgnbr + c5_c_ai * c5_c_sgnbi;
        c5_c_ni = c5_c_ai * c5_c_sgnbr - c5_c_ar * c5_c_sgnbi;
        c5_y.re = c5_c_nr / c5_c_brm;
        c5_y.im = c5_c_ni / c5_c_brm;
      } else {
        c5_c_s = c5_c_br / c5_c_bi;
        c5_c_d = c5_c_bi + c5_c_s * c5_c_br;
        c5_c_nr = c5_c_s * c5_c_ar + c5_c_ai;
        c5_c_ni = c5_c_s * c5_c_ai - c5_c_ar;
        c5_y.re = c5_c_nr / c5_c_d;
        c5_y.im = c5_c_ni / c5_c_d;
      }
    }

    c5_divisor_Z_T.re += c5_y.re;
    c5_divisor_Z_T.im += c5_y.im;
    c5_b_i++;
    _SF_MEX_LISTEN_FOR_CTRL_C(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 24);
  c5_b_y = c5_dividend_v_T;
  c5_c_y = c5_divisor_v_T;
  c5_d_ar = c5_b_y.re;
  c5_d_ai = c5_b_y.im;
  c5_d_br = c5_c_y.re;
  c5_d_bi = c5_c_y.im;
  if (c5_d_bi == 0.0) {
    if (c5_d_ai == 0.0) {
      c5_v_T.re = c5_d_ar / c5_d_br;
      c5_v_T.im = 0.0;
    } else if (c5_d_ar == 0.0) {
      c5_v_T.re = 0.0;
      c5_v_T.im = c5_d_ai / c5_d_br;
    } else {
      c5_v_T.re = c5_d_ar / c5_d_br;
      c5_v_T.im = c5_d_ai / c5_d_br;
    }
  } else if (c5_d_br == 0.0) {
    if (c5_d_ar == 0.0) {
      c5_v_T.re = c5_d_ai / c5_d_bi;
      c5_v_T.im = 0.0;
    } else if (c5_d_ai == 0.0) {
      c5_v_T.re = 0.0;
      c5_v_T.im = -(c5_d_ar / c5_d_bi);
    } else {
      c5_v_T.re = c5_d_ai / c5_d_bi;
      c5_v_T.im = -(c5_d_ar / c5_d_bi);
    }
  } else {
    c5_d_brm = muDoubleScalarAbs(c5_d_br);
    c5_d_bim = muDoubleScalarAbs(c5_d_bi);
    if (c5_d_brm > c5_d_bim) {
      c5_d_s = c5_d_bi / c5_d_br;
      c5_d_d = c5_d_br + c5_d_s * c5_d_bi;
      c5_d_nr = c5_d_ar + c5_d_s * c5_d_ai;
      c5_d_ni = c5_d_ai - c5_d_s * c5_d_ar;
      c5_v_T.re = c5_d_nr / c5_d_d;
      c5_v_T.im = c5_d_ni / c5_d_d;
    } else if (c5_d_bim == c5_d_brm) {
      if (c5_d_br > 0.0) {
        c5_d_sgnbr = 0.5;
      } else {
        c5_d_sgnbr = -0.5;
      }

      if (c5_d_bi > 0.0) {
        c5_d_sgnbi = 0.5;
      } else {
        c5_d_sgnbi = -0.5;
      }

      c5_d_nr = c5_d_ar * c5_d_sgnbr + c5_d_ai * c5_d_sgnbi;
      c5_d_ni = c5_d_ai * c5_d_sgnbr - c5_d_ar * c5_d_sgnbi;
      c5_v_T.re = c5_d_nr / c5_d_brm;
      c5_v_T.im = c5_d_ni / c5_d_brm;
    } else {
      c5_d_s = c5_d_br / c5_d_bi;
      c5_d_d = c5_d_bi + c5_d_s * c5_d_br;
      c5_d_nr = c5_d_s * c5_d_ar + c5_d_ai;
      c5_d_ni = c5_d_s * c5_d_ai - c5_d_ar;
      c5_v_T.re = c5_d_nr / c5_d_d;
      c5_v_T.im = c5_d_ni / c5_d_d;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 25);
  c5_c_y = c5_divisor_Z_T;
  c5_e_ar = c5_dc2.re;
  c5_e_ai = c5_dc2.im;
  c5_e_br = c5_c_y.re;
  c5_e_bi = c5_c_y.im;
  if (c5_e_bi == 0.0) {
    if (c5_e_ai == 0.0) {
      c5_Z_T.re = c5_e_ar / c5_e_br;
      c5_Z_T.im = 0.0;
    } else if (c5_e_ar == 0.0) {
      c5_Z_T.re = 0.0;
      c5_Z_T.im = c5_e_ai / c5_e_br;
    } else {
      c5_Z_T.re = c5_e_ar / c5_e_br;
      c5_Z_T.im = c5_e_ai / c5_e_br;
    }
  } else if (c5_e_br == 0.0) {
    if (c5_e_ar == 0.0) {
      c5_Z_T.re = c5_e_ai / c5_e_bi;
      c5_Z_T.im = 0.0;
    } else if (c5_e_ai == 0.0) {
      c5_Z_T.re = 0.0;
      c5_Z_T.im = -(c5_e_ar / c5_e_bi);
    } else {
      c5_Z_T.re = c5_e_ai / c5_e_bi;
      c5_Z_T.im = -(c5_e_ar / c5_e_bi);
    }
  } else {
    c5_e_brm = muDoubleScalarAbs(c5_e_br);
    c5_e_bim = muDoubleScalarAbs(c5_e_bi);
    if (c5_e_brm > c5_e_bim) {
      c5_e_s = c5_e_bi / c5_e_br;
      c5_e_d = c5_e_br + c5_e_s * c5_e_bi;
      c5_e_nr = c5_e_ar + c5_e_s * c5_e_ai;
      c5_e_ni = c5_e_ai - c5_e_s * c5_e_ar;
      c5_Z_T.re = c5_e_nr / c5_e_d;
      c5_Z_T.im = c5_e_ni / c5_e_d;
    } else if (c5_e_bim == c5_e_brm) {
      if (c5_e_br > 0.0) {
        c5_e_sgnbr = 0.5;
      } else {
        c5_e_sgnbr = -0.5;
      }

      if (c5_e_bi > 0.0) {
        c5_e_sgnbi = 0.5;
      } else {
        c5_e_sgnbi = -0.5;
      }

      c5_e_nr = c5_e_ar * c5_e_sgnbr + c5_e_ai * c5_e_sgnbi;
      c5_e_ni = c5_e_ai * c5_e_sgnbr - c5_e_ar * c5_e_sgnbi;
      c5_Z_T.re = c5_e_nr / c5_e_brm;
      c5_Z_T.im = c5_e_ni / c5_e_brm;
    } else {
      c5_e_s = c5_e_br / c5_e_bi;
      c5_e_d = c5_e_bi + c5_e_s * c5_e_br;
      c5_e_nr = c5_e_s * c5_e_ar + c5_e_ai;
      c5_e_ni = c5_e_s * c5_e_ai - c5_e_ar;
      c5_Z_T.re = c5_e_nr / c5_e_d;
      c5_Z_T.im = c5_e_ni / c5_e_d;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 28);
  c5_i_b = c5_mpower(chartInstance, c5_abs_V_an);
  c5_g_y = 3.0 * c5_i_b;
  c5_j_b = c5_Q_load;
  c5_y.re = c5_j_b * c5_dc0.re;
  c5_y.im = c5_j_b * c5_dc0.im;
  c5_c_A = c5_g_y;
  c5_c_y.re = c5_P_load - c5_y.re;
  c5_c_y.im = 0.0 - c5_y.im;
  c5_e_x = c5_c_A;
  c5_f_x = c5_e_x;
  c5_f_ar = c5_f_x;
  c5_f_ai = 0.0;
  c5_f_br = c5_c_y.re;
  c5_f_bi = c5_c_y.im;
  if (c5_f_bi == 0.0) {
    if (c5_f_ai == 0.0) {
      c5_Z_L.re = c5_f_ar / c5_f_br;
      c5_Z_L.im = 0.0;
    } else if (c5_f_ar == 0.0) {
      c5_Z_L.re = 0.0;
      c5_Z_L.im = c5_f_ai / c5_f_br;
    } else {
      c5_Z_L.re = c5_f_ar / c5_f_br;
      c5_Z_L.im = c5_f_ai / c5_f_br;
    }
  } else if (c5_f_br == 0.0) {
    if (c5_f_ar == 0.0) {
      c5_Z_L.re = c5_f_ai / c5_f_bi;
      c5_Z_L.im = 0.0;
    } else if (c5_f_ai == 0.0) {
      c5_Z_L.re = 0.0;
      c5_Z_L.im = -(c5_f_ar / c5_f_bi);
    } else {
      c5_Z_L.re = c5_f_ai / c5_f_bi;
      c5_Z_L.im = -(c5_f_ar / c5_f_bi);
    }
  } else {
    c5_f_brm = muDoubleScalarAbs(c5_f_br);
    c5_f_bim = muDoubleScalarAbs(c5_f_bi);
    if (c5_f_brm > c5_f_bim) {
      c5_f_s = c5_f_bi / c5_f_br;
      c5_f_d = c5_f_br + c5_f_s * c5_f_bi;
      c5_f_nr = c5_f_ar + c5_f_s * c5_f_ai;
      c5_f_ni = c5_f_ai - c5_f_s * c5_f_ar;
      c5_Z_L.re = c5_f_nr / c5_f_d;
      c5_Z_L.im = c5_f_ni / c5_f_d;
    } else if (c5_f_bim == c5_f_brm) {
      if (c5_f_br > 0.0) {
        c5_f_sgnbr = 0.5;
      } else {
        c5_f_sgnbr = -0.5;
      }

      if (c5_f_bi > 0.0) {
        c5_f_sgnbi = 0.5;
      } else {
        c5_f_sgnbi = -0.5;
      }

      c5_f_nr = c5_f_ar * c5_f_sgnbr + c5_f_ai * c5_f_sgnbi;
      c5_f_ni = c5_f_ai * c5_f_sgnbr - c5_f_ar * c5_f_sgnbi;
      c5_Z_L.re = c5_f_nr / c5_f_brm;
      c5_Z_L.im = c5_f_ni / c5_f_brm;
    } else {
      c5_f_s = c5_f_br / c5_f_bi;
      c5_f_d = c5_f_bi + c5_f_s * c5_f_br;
      c5_f_nr = c5_f_s * c5_f_ar + c5_f_ai;
      c5_f_ni = c5_f_s * c5_f_ai - c5_f_ar;
      c5_Z_L.re = c5_f_nr / c5_f_d;
      c5_Z_L.im = c5_f_ni / c5_f_d;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 31);
  c5_b_y = c5_v_T;
  c5_c_y = c5_Z_L;
  c5_y.re = c5_b_y.re * c5_c_y.re - c5_b_y.im * c5_c_y.im;
  c5_y.im = c5_b_y.re * c5_c_y.im + c5_b_y.im * c5_c_y.re;
  c5_c_y.re = c5_Z_T.re + c5_Z_L.re;
  c5_c_y.im = c5_Z_T.im + c5_Z_L.im;
  c5_g_ar = c5_y.re;
  c5_g_ai = c5_y.im;
  c5_g_br = c5_c_y.re;
  c5_g_bi = c5_c_y.im;
  if (c5_g_bi == 0.0) {
    if (c5_g_ai == 0.0) {
      c5_v_an.re = c5_g_ar / c5_g_br;
      c5_v_an.im = 0.0;
    } else if (c5_g_ar == 0.0) {
      c5_v_an.re = 0.0;
      c5_v_an.im = c5_g_ai / c5_g_br;
    } else {
      c5_v_an.re = c5_g_ar / c5_g_br;
      c5_v_an.im = c5_g_ai / c5_g_br;
    }
  } else if (c5_g_br == 0.0) {
    if (c5_g_ar == 0.0) {
      c5_v_an.re = c5_g_ai / c5_g_bi;
      c5_v_an.im = 0.0;
    } else if (c5_g_ai == 0.0) {
      c5_v_an.re = 0.0;
      c5_v_an.im = -(c5_g_ar / c5_g_bi);
    } else {
      c5_v_an.re = c5_g_ai / c5_g_bi;
      c5_v_an.im = -(c5_g_ar / c5_g_bi);
    }
  } else {
    c5_g_brm = muDoubleScalarAbs(c5_g_br);
    c5_g_bim = muDoubleScalarAbs(c5_g_bi);
    if (c5_g_brm > c5_g_bim) {
      c5_g_s = c5_g_bi / c5_g_br;
      c5_g_d = c5_g_br + c5_g_s * c5_g_bi;
      c5_g_nr = c5_g_ar + c5_g_s * c5_g_ai;
      c5_g_ni = c5_g_ai - c5_g_s * c5_g_ar;
      c5_v_an.re = c5_g_nr / c5_g_d;
      c5_v_an.im = c5_g_ni / c5_g_d;
    } else if (c5_g_bim == c5_g_brm) {
      if (c5_g_br > 0.0) {
        c5_g_sgnbr = 0.5;
      } else {
        c5_g_sgnbr = -0.5;
      }

      if (c5_g_bi > 0.0) {
        c5_g_sgnbi = 0.5;
      } else {
        c5_g_sgnbi = -0.5;
      }

      c5_g_nr = c5_g_ar * c5_g_sgnbr + c5_g_ai * c5_g_sgnbi;
      c5_g_ni = c5_g_ai * c5_g_sgnbr - c5_g_ar * c5_g_sgnbi;
      c5_v_an.re = c5_g_nr / c5_g_brm;
      c5_v_an.im = c5_g_ni / c5_g_brm;
    } else {
      c5_g_s = c5_g_br / c5_g_bi;
      c5_g_d = c5_g_bi + c5_g_s * c5_g_br;
      c5_g_nr = c5_g_s * c5_g_ar + c5_g_ai;
      c5_g_ni = c5_g_s * c5_g_ai - c5_g_ar;
      c5_v_an.re = c5_g_nr / c5_g_d;
      c5_v_an.im = c5_g_ni / c5_g_d;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 32);
  c5_b_y = c5_v_an;
  c5_x1 = c5_b_y.re;
  c5_x2 = c5_b_y.im;
  c5_d_a = c5_x1;
  c5_k_b = c5_x2;
  c5_abs_v_an = muDoubleScalarHypot(c5_d_a, c5_k_b);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 34);
  for (c5_i15 = 0; c5_i15 < 6; c5_i15++) {
    c5_s_G[c5_i15] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 35);
  c5_i = 1.0;
  c5_c_i = 0;
  while (c5_c_i < 3) {
    c5_i = 1.0 + (real_T)c5_c_i;
    CV_EML_FOR(0, 1, 1, 1);
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 36);
    c5_e_a = c5_CB_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("CB_G",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_h_y = c5_e_a * 3.0;
    c5_f_a = c5_h_y;
    c5_c_y = c5_v_an;
    c5_y.re = c5_f_a * c5_c_y.re;
    c5_y.im = c5_f_a * c5_c_y.im;
    c5_b_y.re = c5_e_aG[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("e_aG",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1].re - c5_v_an.re;
    c5_b_y.im = c5_e_aG[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("e_aG",
      (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1].im - c5_v_an.im;
    c5_c_y = c5_z[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1];
    c5_i_y = c5_b_y;
    c5_h_ar = c5_i_y.re;
    c5_h_ai = c5_i_y.im;
    c5_h_br = c5_c_y.re;
    c5_h_bi = c5_c_y.im;
    if (c5_h_bi == 0.0) {
      if (c5_h_ai == 0.0) {
        c5_b_y.re = c5_h_ar / c5_h_br;
        c5_b_y.im = 0.0;
      } else if (c5_h_ar == 0.0) {
        c5_b_y.re = 0.0;
        c5_b_y.im = c5_h_ai / c5_h_br;
      } else {
        c5_b_y.re = c5_h_ar / c5_h_br;
        c5_b_y.im = c5_h_ai / c5_h_br;
      }
    } else if (c5_h_br == 0.0) {
      if (c5_h_ar == 0.0) {
        c5_b_y.re = c5_h_ai / c5_h_bi;
        c5_b_y.im = 0.0;
      } else if (c5_h_ai == 0.0) {
        c5_b_y.re = 0.0;
        c5_b_y.im = -(c5_h_ar / c5_h_bi);
      } else {
        c5_b_y.re = c5_h_ai / c5_h_bi;
        c5_b_y.im = -(c5_h_ar / c5_h_bi);
      }
    } else {
      c5_h_brm = muDoubleScalarAbs(c5_h_br);
      c5_h_bim = muDoubleScalarAbs(c5_h_bi);
      if (c5_h_brm > c5_h_bim) {
        c5_h_s = c5_h_bi / c5_h_br;
        c5_h_d = c5_h_br + c5_h_s * c5_h_bi;
        c5_h_nr = c5_h_ar + c5_h_s * c5_h_ai;
        c5_h_ni = c5_h_ai - c5_h_s * c5_h_ar;
        c5_b_y.re = c5_h_nr / c5_h_d;
        c5_b_y.im = c5_h_ni / c5_h_d;
      } else if (c5_h_bim == c5_h_brm) {
        if (c5_h_br > 0.0) {
          c5_h_sgnbr = 0.5;
        } else {
          c5_h_sgnbr = -0.5;
        }

        if (c5_h_bi > 0.0) {
          c5_h_sgnbi = 0.5;
        } else {
          c5_h_sgnbi = -0.5;
        }

        c5_h_nr = c5_h_ar * c5_h_sgnbr + c5_h_ai * c5_h_sgnbi;
        c5_h_ni = c5_h_ai * c5_h_sgnbr - c5_h_ar * c5_h_sgnbi;
        c5_b_y.re = c5_h_nr / c5_h_brm;
        c5_b_y.im = c5_h_ni / c5_h_brm;
      } else {
        c5_h_s = c5_h_br / c5_h_bi;
        c5_h_d = c5_h_bi + c5_h_s * c5_h_br;
        c5_h_nr = c5_h_s * c5_h_ar + c5_h_ai;
        c5_h_ni = c5_h_s * c5_h_ai - c5_h_ar;
        c5_b_y.re = c5_h_nr / c5_h_d;
        c5_b_y.im = c5_h_ni / c5_h_d;
      }
    }

    c5_c_y.re = c5_b_y.re;
    c5_c_y.im = -c5_b_y.im;
    c5_temp.re = c5_y.re * c5_c_y.re - c5_y.im * c5_c_y.im;
    c5_temp.im = c5_y.re * c5_c_y.im + c5_y.im * c5_c_y.re;
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 37);
    c5_d_i = (int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("s_G", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 3, 1, 0) - 1;
    c5_s_G[c5_d_i] = c5_temp.re;
    c5_s_G[3 + c5_d_i] = c5_temp.im;
    c5_c_i++;
    _SF_MEX_LISTEN_FOR_CTRL_C(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 1, 0);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, -37);
  _SFD_SYMBOL_SCOPE_POP();
  for (c5_i16 = 0; c5_i16 < 6; c5_i16++) {
    (*c5_b_s_G)[c5_i16] = c5_s_G[c5_i16];
  }

  *c5_b_abs_v_an = c5_abs_v_an;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 4U, chartInstance->c5_sfEvent);
}

static void initSimStructsc5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void registerMessagesc5_SimulationPlantModel_NonlinRR
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber)
{
}

static const mxArray *c5_sf_marshallOut(void *chartInstanceVoid, void *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  real_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(real_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static real_T c5_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_CB3, const char_T *c5_identifier)
{
  real_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_CB3), &c5_thisId);
  sf_mex_destroy(&c5_CB3);
  return c5_y;
}

static real_T c5_b_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  real_T c5_y;
  real_T c5_d0;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_d0, 1, 0, 0U, 0, 0U, 0);
  c5_y = c5_d0;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_CB3;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_CB3 = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_CB3), &c5_thisId);
  sf_mex_destroy(&c5_CB3);
  *(real_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_b_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i17;
  int32_T c5_i18;
  int32_T c5_i19;
  real_T c5_b_inData[6];
  int32_T c5_i20;
  int32_T c5_i21;
  int32_T c5_i22;
  real_T c5_u[6];
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_i17 = 0;
  for (c5_i18 = 0; c5_i18 < 2; c5_i18++) {
    for (c5_i19 = 0; c5_i19 < 3; c5_i19++) {
      c5_b_inData[c5_i19 + c5_i17] = (*(real_T (*)[6])c5_inData)[c5_i19 + c5_i17];
    }

    c5_i17 += 3;
  }

  c5_i20 = 0;
  for (c5_i21 = 0; c5_i21 < 2; c5_i21++) {
    for (c5_i22 = 0; c5_i22 < 3; c5_i22++) {
      c5_u[c5_i22 + c5_i20] = c5_b_inData[c5_i22 + c5_i20];
    }

    c5_i20 += 3;
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static void c5_c_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_s_G, const char_T *c5_identifier, real_T c5_y[6])
{
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_s_G), &c5_thisId, c5_y);
  sf_mex_destroy(&c5_s_G);
}

static void c5_d_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, real_T c5_y[6])
{
  real_T c5_dv4[6];
  int32_T c5_i23;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), c5_dv4, 1, 0, 0U, 1, 0U, 2, 3, 2);
  for (c5_i23 = 0; c5_i23 < 6; c5_i23++) {
    c5_y[c5_i23] = c5_dv4[c5_i23];
  }

  sf_mex_destroy(&c5_u);
}

static void c5_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_s_G;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y[6];
  int32_T c5_i24;
  int32_T c5_i25;
  int32_T c5_i26;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_s_G = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_s_G), &c5_thisId, c5_y);
  sf_mex_destroy(&c5_s_G);
  c5_i24 = 0;
  for (c5_i25 = 0; c5_i25 < 2; c5_i25++) {
    for (c5_i26 = 0; c5_i26 < 3; c5_i26++) {
      (*(real_T (*)[6])c5_outData)[c5_i26 + c5_i24] = c5_y[c5_i26 + c5_i24];
    }

    c5_i24 += 3;
  }

  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_c_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i27;
  real_T c5_b_inData[3];
  int32_T c5_i28;
  real_T c5_u[3];
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  for (c5_i27 = 0; c5_i27 < 3; c5_i27++) {
    c5_b_inData[c5_i27] = (*(real_T (*)[3])c5_inData)[c5_i27];
  }

  for (c5_i28 = 0; c5_i28 < 3; c5_i28++) {
    c5_u[c5_i28] = c5_b_inData[c5_i28];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static void c5_e_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, real_T c5_y[3])
{
  real_T c5_dv5[3];
  int32_T c5_i29;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), c5_dv5, 1, 0, 0U, 1, 0U, 1, 3);
  for (c5_i29 = 0; c5_i29 < 3; c5_i29++) {
    c5_y[c5_i29] = c5_dv5[c5_i29];
  }

  sf_mex_destroy(&c5_u);
}

static void c5_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_S_b_G;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y[3];
  int32_T c5_i30;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_b_S_b_G = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_S_b_G), &c5_thisId, c5_y);
  sf_mex_destroy(&c5_b_S_b_G);
  for (c5_i30 = 0; c5_i30 < 3; c5_i30++) {
    (*(real_T (*)[3])c5_outData)[c5_i30] = c5_y[c5_i30];
  }

  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_d_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i31;
  real_T c5_b_inData[2];
  int32_T c5_i32;
  real_T c5_u[2];
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  for (c5_i31 = 0; c5_i31 < 2; c5_i31++) {
    c5_b_inData[c5_i31] = (*(real_T (*)[2])c5_inData)[c5_i31];
  }

  for (c5_i32 = 0; c5_i32 < 2; c5_i32++) {
    c5_u[c5_i32] = c5_b_inData[c5_i32];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static const mxArray *c5_e_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i33;
  creal_T c5_b_inData[3];
  int32_T c5_i34;
  creal_T c5_u[3];
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  for (c5_i33 = 0; c5_i33 < 3; c5_i33++) {
    c5_b_inData[c5_i33] = (*(creal_T (*)[3])c5_inData)[c5_i33];
  }

  for (c5_i34 = 0; c5_i34 < 3; c5_i34++) {
    c5_u[c5_i34] = c5_b_inData[c5_i34];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 1U, 1U, 0U, 2, 3, 1), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static const mxArray *c5_f_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  creal_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(creal_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 1U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static creal_T c5_f_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  creal_T c5_y;
  creal_T c5_dc3;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_dc3, 1, 0, 1U, 0, 0U, 0);
  c5_y = c5_dc3;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_temp;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  creal_T c5_y;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_temp = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_temp), &c5_thisId);
  sf_mex_destroy(&c5_temp);
  *(creal_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_g_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i35;
  creal_T c5_b_inData[3];
  int32_T c5_i36;
  creal_T c5_u[3];
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  for (c5_i35 = 0; c5_i35 < 3; c5_i35++) {
    c5_b_inData[c5_i35] = (*(creal_T (*)[3])c5_inData)[c5_i35];
  }

  for (c5_i36 = 0; c5_i36 < 3; c5_i36++) {
    c5_u[c5_i36] = c5_b_inData[c5_i36];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 1U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static void c5_g_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, creal_T c5_y[3])
{
  creal_T c5_dcv0[3];
  int32_T c5_i37;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), c5_dcv0, 1, 0, 1U, 1, 0U, 1, 3);
  for (c5_i37 = 0; c5_i37 < 3; c5_i37++) {
    c5_y[c5_i37] = c5_dcv0[c5_i37];
  }

  sf_mex_destroy(&c5_u);
}

static void c5_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_Z;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  creal_T c5_y[3];
  int32_T c5_i38;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_Z = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_Z), &c5_thisId, c5_y);
  sf_mex_destroy(&c5_Z);
  for (c5_i38 = 0; c5_i38 < 3; c5_i38++) {
    (*(creal_T (*)[3])c5_outData)[c5_i38] = c5_y[c5_i38];
  }

  sf_mex_destroy(&c5_mxArrayInData);
}

const mxArray
  *sf_c5_SimulationPlantModel_NonlinRR_get_eml_resolved_functions_info(void)
{
  const mxArray *c5_nameCaptureInfo;
  c5_ResolvedFunctionInfo c5_info[20];
  const mxArray *c5_m0 = NULL;
  int32_T c5_i39;
  c5_ResolvedFunctionInfo *c5_r0;
  c5_nameCaptureInfo = NULL;
  c5_nameCaptureInfo = NULL;
  c5_info_helper(c5_info);
  sf_mex_assign(&c5_m0, sf_mex_createstruct("nameCaptureInfo", 1, 20), FALSE);
  for (c5_i39 = 0; c5_i39 < 20; c5_i39++) {
    c5_r0 = &c5_info[c5_i39];
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->context)), "context", "nameCaptureInfo",
                    c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c5_r0->name)), "name", "nameCaptureInfo", c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c5_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->resolved)), "resolved", "nameCaptureInfo",
                    c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c5_i39);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c5_i39);
  }

  sf_mex_assign(&c5_nameCaptureInfo, c5_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c5_nameCaptureInfo);
  return c5_nameCaptureInfo;
}

static void c5_info_helper(c5_ResolvedFunctionInfo c5_info[20])
{
  c5_info[0].context = "";
  c5_info[0].name = "mtimes";
  c5_info[0].dominantType = "double";
  c5_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[0].fileTimeLo = 1289519692U;
  c5_info[0].fileTimeHi = 0U;
  c5_info[0].mFileTimeLo = 0U;
  c5_info[0].mFileTimeHi = 0U;
  c5_info[1].context = "";
  c5_info[1].name = "mrdivide";
  c5_info[1].dominantType = "double";
  c5_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c5_info[1].fileTimeLo = 1357951548U;
  c5_info[1].fileTimeHi = 0U;
  c5_info[1].mFileTimeLo = 1319729966U;
  c5_info[1].mFileTimeHi = 0U;
  c5_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c5_info[2].name = "rdivide";
  c5_info[2].dominantType = "double";
  c5_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[2].fileTimeLo = 1346510388U;
  c5_info[2].fileTimeHi = 0U;
  c5_info[2].mFileTimeLo = 0U;
  c5_info[2].mFileTimeHi = 0U;
  c5_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[3].name = "eml_scalexp_compatible";
  c5_info[3].dominantType = "double";
  c5_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c5_info[3].fileTimeLo = 1286818796U;
  c5_info[3].fileTimeHi = 0U;
  c5_info[3].mFileTimeLo = 0U;
  c5_info[3].mFileTimeHi = 0U;
  c5_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[4].name = "eml_div";
  c5_info[4].dominantType = "double";
  c5_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c5_info[4].fileTimeLo = 1313347810U;
  c5_info[4].fileTimeHi = 0U;
  c5_info[4].mFileTimeLo = 0U;
  c5_info[4].mFileTimeHi = 0U;
  c5_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m!eml_fldiv";
  c5_info[5].name = "eml_scalar_eg";
  c5_info[5].dominantType = "double";
  c5_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c5_info[5].fileTimeLo = 1286818796U;
  c5_info[5].fileTimeHi = 0U;
  c5_info[5].mFileTimeLo = 0U;
  c5_info[5].mFileTimeHi = 0U;
  c5_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m!eml_fldiv";
  c5_info[6].name = "eml_scalexp_alloc";
  c5_info[6].dominantType = "double";
  c5_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c5_info[6].fileTimeLo = 1352424860U;
  c5_info[6].fileTimeHi = 0U;
  c5_info[6].mFileTimeLo = 0U;
  c5_info[6].mFileTimeHi = 0U;
  c5_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m!eml_fldiv";
  c5_info[7].name = "abs";
  c5_info[7].dominantType = "double";
  c5_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[7].fileTimeLo = 1343830366U;
  c5_info[7].fileTimeHi = 0U;
  c5_info[7].mFileTimeLo = 0U;
  c5_info[7].mFileTimeHi = 0U;
  c5_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[8].name = "eml_scalar_abs";
  c5_info[8].dominantType = "double";
  c5_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c5_info[8].fileTimeLo = 1286818712U;
  c5_info[8].fileTimeHi = 0U;
  c5_info[8].mFileTimeLo = 0U;
  c5_info[8].mFileTimeHi = 0U;
  c5_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m!eml_fldiv";
  c5_info[9].name = "mtimes";
  c5_info[9].dominantType = "double";
  c5_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[9].fileTimeLo = 1289519692U;
  c5_info[9].fileTimeHi = 0U;
  c5_info[9].mFileTimeLo = 0U;
  c5_info[9].mFileTimeHi = 0U;
  c5_info[10].context = "";
  c5_info[10].name = "mpower";
  c5_info[10].dominantType = "double";
  c5_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c5_info[10].fileTimeLo = 1286818842U;
  c5_info[10].fileTimeHi = 0U;
  c5_info[10].mFileTimeLo = 0U;
  c5_info[10].mFileTimeHi = 0U;
  c5_info[11].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c5_info[11].name = "power";
  c5_info[11].dominantType = "double";
  c5_info[11].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c5_info[11].fileTimeLo = 1348191930U;
  c5_info[11].fileTimeHi = 0U;
  c5_info[11].mFileTimeLo = 0U;
  c5_info[11].mFileTimeHi = 0U;
  c5_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c5_info[12].name = "eml_scalar_eg";
  c5_info[12].dominantType = "double";
  c5_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c5_info[12].fileTimeLo = 1286818796U;
  c5_info[12].fileTimeHi = 0U;
  c5_info[12].mFileTimeLo = 0U;
  c5_info[12].mFileTimeHi = 0U;
  c5_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c5_info[13].name = "eml_scalexp_alloc";
  c5_info[13].dominantType = "double";
  c5_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c5_info[13].fileTimeLo = 1352424860U;
  c5_info[13].fileTimeHi = 0U;
  c5_info[13].mFileTimeLo = 0U;
  c5_info[13].mFileTimeHi = 0U;
  c5_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c5_info[14].name = "floor";
  c5_info[14].dominantType = "double";
  c5_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c5_info[14].fileTimeLo = 1343830380U;
  c5_info[14].fileTimeHi = 0U;
  c5_info[14].mFileTimeLo = 0U;
  c5_info[14].mFileTimeHi = 0U;
  c5_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c5_info[15].name = "eml_scalar_floor";
  c5_info[15].dominantType = "double";
  c5_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c5_info[15].fileTimeLo = 1286818726U;
  c5_info[15].fileTimeHi = 0U;
  c5_info[15].mFileTimeLo = 0U;
  c5_info[15].mFileTimeHi = 0U;
  c5_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c5_info[16].name = "eml_scalar_eg";
  c5_info[16].dominantType = "double";
  c5_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c5_info[16].fileTimeLo = 1286818796U;
  c5_info[16].fileTimeHi = 0U;
  c5_info[16].mFileTimeLo = 0U;
  c5_info[16].mFileTimeHi = 0U;
  c5_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c5_info[17].name = "mtimes";
  c5_info[17].dominantType = "double";
  c5_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[17].fileTimeLo = 1289519692U;
  c5_info[17].fileTimeHi = 0U;
  c5_info[17].mFileTimeLo = 0U;
  c5_info[17].mFileTimeHi = 0U;
  c5_info[18].context = "";
  c5_info[18].name = "abs";
  c5_info[18].dominantType = "double";
  c5_info[18].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[18].fileTimeLo = 1343830366U;
  c5_info[18].fileTimeHi = 0U;
  c5_info[18].mFileTimeLo = 0U;
  c5_info[18].mFileTimeHi = 0U;
  c5_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c5_info[19].name = "eml_dlapy2";
  c5_info[19].dominantType = "double";
  c5_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_dlapy2.m";
  c5_info[19].fileTimeLo = 1350410654U;
  c5_info[19].fileTimeHi = 0U;
  c5_info[19].mFileTimeLo = 0U;
  c5_info[19].mFileTimeHi = 0U;
}

static real_T c5_mpower(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, real_T c5_a)
{
  real_T c5_b_a;
  real_T c5_c_a;
  real_T c5_ak;
  real_T c5_d_a;
  real_T c5_e_a;
  real_T c5_b;
  c5_b_a = c5_a;
  c5_c_a = c5_b_a;
  c5_eml_scalar_eg(chartInstance);
  c5_ak = c5_c_a;
  c5_d_a = c5_ak;
  c5_eml_scalar_eg(chartInstance);
  c5_e_a = c5_d_a;
  c5_b = c5_d_a;
  return c5_e_a * c5_b;
}

static void c5_eml_scalar_eg(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance)
{
}

static const mxArray *c5_h_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(int32_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static int32_T c5_h_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  int32_T c5_y;
  int32_T c5_i40;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_i40, 1, 6, 0U, 0, 0U, 0);
  c5_y = c5_i40;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_sfEvent;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  int32_T c5_y;
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c5_b_sfEvent = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_sfEvent),
    &c5_thisId);
  sf_mex_destroy(&c5_b_sfEvent);
  *(int32_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static uint8_T c5_i_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_b_is_active_c5_SimulationPlantModel_NonlinRR, const char_T
   *c5_identifier)
{
  uint8_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c5_b_is_active_c5_SimulationPlantModel_NonlinRR), &c5_thisId);
  sf_mex_destroy(&c5_b_is_active_c5_SimulationPlantModel_NonlinRR);
  return c5_y;
}

static uint8_T c5_j_emlrt_marshallIn
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  uint8_T c5_y;
  uint8_T c5_u0;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_u0, 1, 3, 0U, 0, 0U, 0);
  c5_y = c5_u0;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static real_T c5_get_CB1(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 0, NULL, c5_b);
  if (chartInstance->c5_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#387) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c5_CB1_address;
}

static void c5_set_CB1(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b, real_T c5_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 0, NULL, c5_b);
  if (chartInstance->c5_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#387) in the initialization routine of the chart.\n");
  }

  *chartInstance->c5_CB1_address = c5_c;
}

static real_T *c5_access_CB1(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b)
{
  real_T *c5_c;
  ssReadFromDataStore(chartInstance->S, 0, NULL);
  if (chartInstance->c5_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#387) in the initialization routine of the chart.\n");
  }

  c5_c = chartInstance->c5_CB1_address;
  if (c5_b == 0) {
    ssWriteToDataStore(chartInstance->S, 0, NULL);
  }

  return c5_c;
}

static real_T c5_get_CB2(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 1, NULL, c5_b);
  if (chartInstance->c5_CB2_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB2\' (#388) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c5_CB2_address;
}

static void c5_set_CB2(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b, real_T c5_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 1, NULL, c5_b);
  if (chartInstance->c5_CB2_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB2\' (#388) in the initialization routine of the chart.\n");
  }

  *chartInstance->c5_CB2_address = c5_c;
}

static real_T *c5_access_CB2(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b)
{
  real_T *c5_c;
  ssReadFromDataStore(chartInstance->S, 1, NULL);
  if (chartInstance->c5_CB2_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB2\' (#388) in the initialization routine of the chart.\n");
  }

  c5_c = chartInstance->c5_CB2_address;
  if (c5_b == 0) {
    ssWriteToDataStore(chartInstance->S, 1, NULL);
  }

  return c5_c;
}

static real_T c5_get_CB3(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 2, NULL, c5_b);
  if (chartInstance->c5_CB3_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB3\' (#389) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c5_CB3_address;
}

static void c5_set_CB3(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b, real_T c5_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 2, NULL, c5_b);
  if (chartInstance->c5_CB3_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB3\' (#389) in the initialization routine of the chart.\n");
  }

  *chartInstance->c5_CB3_address = c5_c;
}

static real_T *c5_access_CB3(SFc5_SimulationPlantModel_NonlinRRInstanceStruct
  *chartInstance, uint32_T c5_b)
{
  real_T *c5_c;
  ssReadFromDataStore(chartInstance->S, 2, NULL);
  if (chartInstance->c5_CB3_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB3\' (#389) in the initialization routine of the chart.\n");
  }

  c5_c = chartInstance->c5_CB3_address;
  if (c5_b == 0) {
    ssWriteToDataStore(chartInstance->S, 2, NULL);
  }

  return c5_c;
}

static void init_dsm_address_info
  (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB1", (void **)
    &chartInstance->c5_CB1_address, &chartInstance->c5_CB1_index);
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB2", (void **)
    &chartInstance->c5_CB2_address, &chartInstance->c5_CB2_index);
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB3", (void **)
    &chartInstance->c5_CB3_address, &chartInstance->c5_CB3_index);
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c5_SimulationPlantModel_NonlinRR_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1269085116U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1741579189U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(499649768U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4226373574U);
}

mxArray *sf_c5_SimulationPlantModel_NonlinRR_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("9GViUUgp0r8W0fMdavji0");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(1));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c5_SimulationPlantModel_NonlinRR_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c5_SimulationPlantModel_NonlinRR
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[19],T\"abs_v_an\",},{M[1],M[16],T\"s_G\",},{M[8],M[0],T\"is_active_c5_SimulationPlantModel_NonlinRR\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c5_SimulationPlantModel_NonlinRR_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
    chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_NonlinRRMachineNumber_,
           5,
           1,
           1,
           11,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_NonlinRRMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_NonlinRRMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_NonlinRRMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"s_G");
          _SFD_SET_DATA_PROPS(1,2,0,1,"abs_v_an");
          _SFD_SET_DATA_PROPS(2,1,1,0,"e_aG");
          _SFD_SET_DATA_PROPS(3,1,1,0,"S_load");
          _SFD_SET_DATA_PROPS(4,1,1,0,"abs_V_an");
          _SFD_SET_DATA_PROPS(5,10,0,0,"S_b_G");
          _SFD_SET_DATA_PROPS(6,10,0,0,"z_G");
          _SFD_SET_DATA_PROPS(7,10,0,0,"Z_G");
          _SFD_SET_DATA_PROPS(8,11,0,0,"CB1");
          _SFD_SET_DATA_PROPS(9,11,0,0,"CB2");
          _SFD_SET_DATA_PROPS(10,11,0,0,"CB3");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,2,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1117);
        _SFD_CV_INIT_EML_FOR(0,1,0,479,491,660);
        _SFD_CV_INIT_EML_FOR(0,1,1,1004,1016,1112);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_b_sf_marshallOut,(MexInFcnForType)
            c5_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)c5_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 1;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,1,(MexFcnForType)c5_e_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_c_sf_marshallOut,(MexInFcnForType)
            c5_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_b_sf_marshallOut,(MexInFcnForType)
            c5_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_b_sf_marshallOut,(MexInFcnForType)
            c5_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)c5_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)c5_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)c5_sf_marshallIn);

        {
          real_T *c5_abs_v_an;
          real_T *c5_abs_V_an;
          real_T (*c5_s_G)[6];
          creal_T (*c5_e_aG)[3];
          real_T (*c5_S_load)[2];
          c5_abs_V_an = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c5_S_load = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 1);
          c5_e_aG = (creal_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          c5_abs_v_an = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c5_s_G = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, *c5_s_G);
          _SFD_SET_DATA_VALUE_PTR(1U, c5_abs_v_an);
          _SFD_SET_DATA_VALUE_PTR(2U, *c5_e_aG);
          _SFD_SET_DATA_VALUE_PTR(3U, *c5_S_load);
          _SFD_SET_DATA_VALUE_PTR(4U, c5_abs_V_an);
          _SFD_SET_DATA_VALUE_PTR(5U, chartInstance->c5_S_b_G);
          _SFD_SET_DATA_VALUE_PTR(6U, chartInstance->c5_z_G);
          _SFD_SET_DATA_VALUE_PTR(7U, chartInstance->c5_Z_G);
          _SFD_SET_DATA_VALUE_PTR(8U, chartInstance->c5_CB1_address);
          _SFD_SET_DATA_VALUE_PTR(9U, chartInstance->c5_CB2_address);
          _SFD_SET_DATA_VALUE_PTR(10U, chartInstance->c5_CB3_address);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_NonlinRRMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "xHiDRvIPRmR7ekKMUVl8yG";
}

static void sf_opaque_initialize_c5_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
  initialize_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c5_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  enable_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c5_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  disable_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c5_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  sf_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c5_SimulationPlantModel_NonlinRR
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_SimulationPlantModel_NonlinRR();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c5_SimulationPlantModel_NonlinRR(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_SimulationPlantModel_NonlinRR();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c5_SimulationPlantModel_NonlinRR
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c5_SimulationPlantModel_NonlinRR(S);
}

static void sf_opaque_set_sim_state_c5_SimulationPlantModel_NonlinRR(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c5_SimulationPlantModel_NonlinRR(S, st);
}

static void sf_opaque_terminate_c5_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_NonlinRR_optimization_info();
    }

    finalize_c5_SimulationPlantModel_NonlinRR
      ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc5_SimulationPlantModel_NonlinRR
    ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c5_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c5_SimulationPlantModel_NonlinRR
      ((SFc5_SimulationPlantModel_NonlinRRInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c5_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  /* Actual parameters from chart:
     S_b_G Z_G z_G
   */
  const char_T *rtParamNames[] = { "S_b_G", "Z_G", "z_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for S_b_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for Z_G*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for z_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_NonlinRR_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      5);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,5,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,5,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,5);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,5,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,5,2);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=2; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,5);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(23344227U));
  ssSetChecksum1(S,(1984442776U));
  ssSetChecksum2(S,(2124920125U));
  ssSetChecksum3(S,(1329283105U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,0);
}

static void mdlRTW_c5_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c5_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  SFc5_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc5_SimulationPlantModel_NonlinRRInstanceStruct *)utMalloc
    (sizeof(SFc5_SimulationPlantModel_NonlinRRInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc5_SimulationPlantModel_NonlinRRInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.mdlStart = mdlStart_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c5_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c5_SimulationPlantModel_NonlinRR_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c5_SimulationPlantModel_NonlinRR(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c5_SimulationPlantModel_NonlinRR(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c5_SimulationPlantModel_NonlinRR(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c5_SimulationPlantModel_NonlinRR_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
