/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_NonlinRR_sfun.h"
#include "c60_SimulationPlantModel_NonlinRR.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_NonlinRR_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c60_debug_family_names[9] = { "nargin", "nargout", "r_dq",
  "r_ddw", "r_ddq", "time", "save_r_dq", "save_r_ddw", "save_r_ddq" };

/* Function Declarations */
static void initialize_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void initialize_params_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void enable_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void disable_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void c60_update_debugger_state_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void set_sim_state_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_st);
static void finalize_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void sf_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void initSimStructsc60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void registerMessagesc60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c60_machineNumber, uint32_T
  c60_chartNumber);
static const mxArray *c60_sf_marshallOut(void *chartInstanceVoid, void
  *c60_inData);
static real_T c60_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_save_r_ddq, const char_T *c60_identifier);
static real_T c60_b_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_u, const emlrtMsgIdentifier *c60_parentId);
static void c60_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c60_mxArrayInData, const char_T *c60_varName, void *c60_outData);
static const mxArray *c60_b_sf_marshallOut(void *chartInstanceVoid, void
  *c60_inData);
static int32_T c60_c_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_u, const emlrtMsgIdentifier *c60_parentId);
static void c60_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c60_mxArrayInData, const char_T *c60_varName, void *c60_outData);
static uint8_T c60_d_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_b_is_active_c60_SimulationPlantModel_NonlinRR, const char_T
   *c60_identifier);
static uint8_T c60_e_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_u, const emlrtMsgIdentifier *c60_parentId);
static void init_dsm_address_info
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  chartInstance->c60_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c60_is_active_c60_SimulationPlantModel_NonlinRR = 0U;
}

static void initialize_params_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void enable_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c60_update_debugger_state_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  const mxArray *c60_st;
  const mxArray *c60_y = NULL;
  real_T c60_hoistedGlobal;
  real_T c60_u;
  const mxArray *c60_b_y = NULL;
  real_T c60_b_hoistedGlobal;
  real_T c60_b_u;
  const mxArray *c60_c_y = NULL;
  real_T c60_c_hoistedGlobal;
  real_T c60_c_u;
  const mxArray *c60_d_y = NULL;
  uint8_T c60_d_hoistedGlobal;
  uint8_T c60_d_u;
  const mxArray *c60_e_y = NULL;
  real_T *c60_save_r_ddq;
  real_T *c60_save_r_ddw;
  real_T *c60_save_r_dq;
  c60_save_r_ddq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c60_save_r_ddw = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c60_save_r_dq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c60_st = NULL;
  c60_st = NULL;
  c60_y = NULL;
  sf_mex_assign(&c60_y, sf_mex_createcellarray(4), FALSE);
  c60_hoistedGlobal = *c60_save_r_ddq;
  c60_u = c60_hoistedGlobal;
  c60_b_y = NULL;
  sf_mex_assign(&c60_b_y, sf_mex_create("y", &c60_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c60_y, 0, c60_b_y);
  c60_b_hoistedGlobal = *c60_save_r_ddw;
  c60_b_u = c60_b_hoistedGlobal;
  c60_c_y = NULL;
  sf_mex_assign(&c60_c_y, sf_mex_create("y", &c60_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c60_y, 1, c60_c_y);
  c60_c_hoistedGlobal = *c60_save_r_dq;
  c60_c_u = c60_c_hoistedGlobal;
  c60_d_y = NULL;
  sf_mex_assign(&c60_d_y, sf_mex_create("y", &c60_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c60_y, 2, c60_d_y);
  c60_d_hoistedGlobal =
    chartInstance->c60_is_active_c60_SimulationPlantModel_NonlinRR;
  c60_d_u = c60_d_hoistedGlobal;
  c60_e_y = NULL;
  sf_mex_assign(&c60_e_y, sf_mex_create("y", &c60_d_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c60_y, 3, c60_e_y);
  sf_mex_assign(&c60_st, c60_y, FALSE);
  return c60_st;
}

static void set_sim_state_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_st)
{
  const mxArray *c60_u;
  real_T *c60_save_r_ddq;
  real_T *c60_save_r_ddw;
  real_T *c60_save_r_dq;
  c60_save_r_ddq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c60_save_r_ddw = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c60_save_r_dq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c60_doneDoubleBufferReInit = TRUE;
  c60_u = sf_mex_dup(c60_st);
  *c60_save_r_ddq = c60_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c60_u, 0)), "save_r_ddq");
  *c60_save_r_ddw = c60_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c60_u, 1)), "save_r_ddw");
  *c60_save_r_dq = c60_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c60_u, 2)), "save_r_dq");
  chartInstance->c60_is_active_c60_SimulationPlantModel_NonlinRR =
    c60_d_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c60_u, 3)),
    "is_active_c60_SimulationPlantModel_NonlinRR");
  sf_mex_destroy(&c60_u);
  c60_update_debugger_state_c60_SimulationPlantModel_NonlinRR(chartInstance);
  sf_mex_destroy(&c60_st);
}

static void finalize_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void sf_c60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
  real_T c60_hoistedGlobal;
  real_T c60_b_hoistedGlobal;
  real_T c60_c_hoistedGlobal;
  real_T c60_d_hoistedGlobal;
  real_T c60_r_dq;
  real_T c60_r_ddw;
  real_T c60_r_ddq;
  real_T c60_time;
  uint32_T c60_debug_family_var_map[9];
  real_T c60_nargin = 4.0;
  real_T c60_nargout = 3.0;
  real_T c60_save_r_dq;
  real_T c60_save_r_ddw;
  real_T c60_save_r_ddq;
  real_T *c60_b_r_dq;
  real_T *c60_b_r_ddw;
  real_T *c60_b_r_ddq;
  real_T *c60_b_time;
  real_T *c60_b_save_r_dq;
  real_T *c60_b_save_r_ddw;
  real_T *c60_b_save_r_ddq;
  c60_b_save_r_ddq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c60_b_save_r_ddw = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c60_b_save_r_dq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c60_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c60_b_r_ddq = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c60_b_r_ddw = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c60_b_r_dq = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 59U, chartInstance->c60_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c60_b_r_dq, 0U);
  _SFD_DATA_RANGE_CHECK(*c60_b_r_ddw, 1U);
  _SFD_DATA_RANGE_CHECK(*c60_b_r_ddq, 2U);
  _SFD_DATA_RANGE_CHECK(*c60_b_time, 3U);
  _SFD_DATA_RANGE_CHECK(*c60_b_save_r_dq, 4U);
  _SFD_DATA_RANGE_CHECK(*c60_b_save_r_ddw, 5U);
  _SFD_DATA_RANGE_CHECK(*c60_b_save_r_ddq, 6U);
  chartInstance->c60_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 59U, chartInstance->c60_sfEvent);
  c60_hoistedGlobal = *c60_b_r_dq;
  c60_b_hoistedGlobal = *c60_b_r_ddw;
  c60_c_hoistedGlobal = *c60_b_r_ddq;
  c60_d_hoistedGlobal = *c60_b_time;
  c60_r_dq = c60_hoistedGlobal;
  c60_r_ddw = c60_b_hoistedGlobal;
  c60_r_ddq = c60_c_hoistedGlobal;
  c60_time = c60_d_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 9U, 9U, c60_debug_family_names,
    c60_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c60_nargin, 0U, c60_sf_marshallOut,
    c60_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c60_nargout, 1U, c60_sf_marshallOut,
    c60_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c60_r_dq, 2U, c60_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c60_r_ddw, 3U, c60_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c60_r_ddq, 4U, c60_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c60_time, 5U, c60_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c60_save_r_dq, 6U, c60_sf_marshallOut,
    c60_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c60_save_r_ddw, 7U, c60_sf_marshallOut,
    c60_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c60_save_r_ddq, 8U, c60_sf_marshallOut,
    c60_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 3);
  if (CV_EML_IF(0, 1, 0, c60_time >= 15.0)) {
    _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 4);
    c60_save_r_dq = c60_r_dq;
    _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 5);
    c60_save_r_ddw = c60_r_ddw;
    _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 6);
    c60_save_r_ddq = c60_r_ddq;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 8);
    c60_save_r_dq = rtNaN;
    _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 9);
    c60_save_r_ddw = rtNaN;
    _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, 10);
    c60_save_r_ddq = rtNaN;
  }

  _SFD_EML_CALL(0U, chartInstance->c60_sfEvent, -10);
  _SFD_SYMBOL_SCOPE_POP();
  *c60_b_save_r_dq = c60_save_r_dq;
  *c60_b_save_r_ddw = c60_save_r_ddw;
  *c60_b_save_r_ddq = c60_save_r_ddq;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 59U, chartInstance->c60_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_NonlinRRMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void registerMessagesc60_SimulationPlantModel_NonlinRR
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c60_machineNumber, uint32_T
  c60_chartNumber)
{
}

static const mxArray *c60_sf_marshallOut(void *chartInstanceVoid, void
  *c60_inData)
{
  const mxArray *c60_mxArrayOutData = NULL;
  real_T c60_u;
  const mxArray *c60_y = NULL;
  SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c60_mxArrayOutData = NULL;
  c60_u = *(real_T *)c60_inData;
  c60_y = NULL;
  sf_mex_assign(&c60_y, sf_mex_create("y", &c60_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c60_mxArrayOutData, c60_y, FALSE);
  return c60_mxArrayOutData;
}

static real_T c60_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_save_r_ddq, const char_T *c60_identifier)
{
  real_T c60_y;
  emlrtMsgIdentifier c60_thisId;
  c60_thisId.fIdentifier = c60_identifier;
  c60_thisId.fParent = NULL;
  c60_y = c60_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c60_save_r_ddq),
    &c60_thisId);
  sf_mex_destroy(&c60_save_r_ddq);
  return c60_y;
}

static real_T c60_b_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_u, const emlrtMsgIdentifier *c60_parentId)
{
  real_T c60_y;
  real_T c60_d0;
  sf_mex_import(c60_parentId, sf_mex_dup(c60_u), &c60_d0, 1, 0, 0U, 0, 0U, 0);
  c60_y = c60_d0;
  sf_mex_destroy(&c60_u);
  return c60_y;
}

static void c60_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c60_mxArrayInData, const char_T *c60_varName, void *c60_outData)
{
  const mxArray *c60_save_r_ddq;
  const char_T *c60_identifier;
  emlrtMsgIdentifier c60_thisId;
  real_T c60_y;
  SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c60_save_r_ddq = sf_mex_dup(c60_mxArrayInData);
  c60_identifier = c60_varName;
  c60_thisId.fIdentifier = c60_identifier;
  c60_thisId.fParent = NULL;
  c60_y = c60_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c60_save_r_ddq),
    &c60_thisId);
  sf_mex_destroy(&c60_save_r_ddq);
  *(real_T *)c60_outData = c60_y;
  sf_mex_destroy(&c60_mxArrayInData);
}

const mxArray
  *sf_c60_SimulationPlantModel_NonlinRR_get_eml_resolved_functions_info(void)
{
  const mxArray *c60_nameCaptureInfo = NULL;
  c60_nameCaptureInfo = NULL;
  sf_mex_assign(&c60_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c60_nameCaptureInfo;
}

static const mxArray *c60_b_sf_marshallOut(void *chartInstanceVoid, void
  *c60_inData)
{
  const mxArray *c60_mxArrayOutData = NULL;
  int32_T c60_u;
  const mxArray *c60_y = NULL;
  SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c60_mxArrayOutData = NULL;
  c60_u = *(int32_T *)c60_inData;
  c60_y = NULL;
  sf_mex_assign(&c60_y, sf_mex_create("y", &c60_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c60_mxArrayOutData, c60_y, FALSE);
  return c60_mxArrayOutData;
}

static int32_T c60_c_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_u, const emlrtMsgIdentifier *c60_parentId)
{
  int32_T c60_y;
  int32_T c60_i0;
  sf_mex_import(c60_parentId, sf_mex_dup(c60_u), &c60_i0, 1, 6, 0U, 0, 0U, 0);
  c60_y = c60_i0;
  sf_mex_destroy(&c60_u);
  return c60_y;
}

static void c60_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c60_mxArrayInData, const char_T *c60_varName, void *c60_outData)
{
  const mxArray *c60_b_sfEvent;
  const char_T *c60_identifier;
  emlrtMsgIdentifier c60_thisId;
  int32_T c60_y;
  SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *)
    chartInstanceVoid;
  c60_b_sfEvent = sf_mex_dup(c60_mxArrayInData);
  c60_identifier = c60_varName;
  c60_thisId.fIdentifier = c60_identifier;
  c60_thisId.fParent = NULL;
  c60_y = c60_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c60_b_sfEvent),
    &c60_thisId);
  sf_mex_destroy(&c60_b_sfEvent);
  *(int32_T *)c60_outData = c60_y;
  sf_mex_destroy(&c60_mxArrayInData);
}

static uint8_T c60_d_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_b_is_active_c60_SimulationPlantModel_NonlinRR, const char_T
   *c60_identifier)
{
  uint8_T c60_y;
  emlrtMsgIdentifier c60_thisId;
  c60_thisId.fIdentifier = c60_identifier;
  c60_thisId.fParent = NULL;
  c60_y = c60_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c60_b_is_active_c60_SimulationPlantModel_NonlinRR), &c60_thisId);
  sf_mex_destroy(&c60_b_is_active_c60_SimulationPlantModel_NonlinRR);
  return c60_y;
}

static uint8_T c60_e_emlrt_marshallIn
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance, const
   mxArray *c60_u, const emlrtMsgIdentifier *c60_parentId)
{
  uint8_T c60_y;
  uint8_T c60_u0;
  sf_mex_import(c60_parentId, sf_mex_dup(c60_u), &c60_u0, 1, 3, 0U, 0, 0U, 0);
  c60_y = c60_u0;
  sf_mex_destroy(&c60_u);
  return c60_y;
}

static void init_dsm_address_info
  (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c60_SimulationPlantModel_NonlinRR_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2973441431U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1851640922U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(730407654U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2758654441U);
}

mxArray *sf_c60_SimulationPlantModel_NonlinRR_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("D790jTUvR7uA7NNFUPMwxB");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c60_SimulationPlantModel_NonlinRR_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c60_SimulationPlantModel_NonlinRR
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[17],T\"save_r_ddq\",},{M[1],M[16],T\"save_r_ddw\",},{M[1],M[15],T\"save_r_dq\",},{M[8],M[0],T\"is_active_c60_SimulationPlantModel_NonlinRR\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c60_SimulationPlantModel_NonlinRR_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
    chartInstance = (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_NonlinRRMachineNumber_,
           60,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_NonlinRRMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_NonlinRRMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_NonlinRRMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"r_dq");
          _SFD_SET_DATA_PROPS(1,1,1,0,"r_ddw");
          _SFD_SET_DATA_PROPS(2,1,1,0,"r_ddq");
          _SFD_SET_DATA_PROPS(3,1,1,0,"time");
          _SFD_SET_DATA_PROPS(4,2,0,1,"save_r_dq");
          _SFD_SET_DATA_PROPS(5,2,0,1,"save_r_ddw");
          _SFD_SET_DATA_PROPS(6,2,0,1,"save_r_ddq");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,237);
        _SFD_CV_INIT_EML_IF(0,1,0,76,89,160,233);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)c60_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)c60_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c60_sf_marshallOut,(MexInFcnForType)c60_sf_marshallIn);

        {
          real_T *c60_r_dq;
          real_T *c60_r_ddw;
          real_T *c60_r_ddq;
          real_T *c60_time;
          real_T *c60_save_r_dq;
          real_T *c60_save_r_ddw;
          real_T *c60_save_r_ddq;
          c60_save_r_ddq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c60_save_r_ddw = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c60_save_r_dq = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c60_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c60_r_ddq = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c60_r_ddw = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c60_r_dq = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c60_r_dq);
          _SFD_SET_DATA_VALUE_PTR(1U, c60_r_ddw);
          _SFD_SET_DATA_VALUE_PTR(2U, c60_r_ddq);
          _SFD_SET_DATA_VALUE_PTR(3U, c60_time);
          _SFD_SET_DATA_VALUE_PTR(4U, c60_save_r_dq);
          _SFD_SET_DATA_VALUE_PTR(5U, c60_save_r_ddw);
          _SFD_SET_DATA_VALUE_PTR(6U, c60_save_r_ddq);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_NonlinRRMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "EZAoUoLgW6JbZYzPgbIKnB";
}

static void sf_opaque_initialize_c60_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
  initialize_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c60_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  enable_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c60_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  disable_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c60_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  sf_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c60_SimulationPlantModel_NonlinRR(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c60_SimulationPlantModel_NonlinRR();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c60_SimulationPlantModel_NonlinRR
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c60_SimulationPlantModel_NonlinRR();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c60_SimulationPlantModel_NonlinRR
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c60_SimulationPlantModel_NonlinRR(S);
}

static void sf_opaque_set_sim_state_c60_SimulationPlantModel_NonlinRR(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c60_SimulationPlantModel_NonlinRR(S, st);
}

static void sf_opaque_terminate_c60_SimulationPlantModel_NonlinRR(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_NonlinRR_optimization_info();
    }

    finalize_c60_SimulationPlantModel_NonlinRR
      ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc60_SimulationPlantModel_NonlinRR
    ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c60_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c60_SimulationPlantModel_NonlinRR
      ((SFc60_SimulationPlantModel_NonlinRRInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c60_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_NonlinRR_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      60);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,60,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,60,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,60);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,60,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,60,3);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=3; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 4; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,60);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1607803483U));
  ssSetChecksum1(S,(2644107350U));
  ssSetChecksum2(S,(4077163270U));
  ssSetChecksum3(S,(1455485727U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c60_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c60_SimulationPlantModel_NonlinRR(SimStruct *S)
{
  SFc60_SimulationPlantModel_NonlinRRInstanceStruct *chartInstance;
  chartInstance = (SFc60_SimulationPlantModel_NonlinRRInstanceStruct *)utMalloc
    (sizeof(SFc60_SimulationPlantModel_NonlinRRInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc60_SimulationPlantModel_NonlinRRInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.mdlStart = mdlStart_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c60_SimulationPlantModel_NonlinRR;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c60_SimulationPlantModel_NonlinRR_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c60_SimulationPlantModel_NonlinRR(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c60_SimulationPlantModel_NonlinRR(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c60_SimulationPlantModel_NonlinRR(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c60_SimulationPlantModel_NonlinRR_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
