/* Include files */

#include <stddef.h>
#include "blas.h"
#include "test_turbo_sfun.h"
#include "c4_test_turbo.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "test_turbo_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c4_debug_family_names[17] = { "AF_n", "AF_low", "AF_high",
  "m_a0", "nargin", "nargout", "omega_t", "u", "omega", "AF_n_G", "AF_low_G",
  "AF_high_G", "m_a0_G", "t_m", "t_m_simplified", "AF", "eta_c" };

/* Function Declarations */
static void initialize_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance);
static void initialize_params_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance);
static void enable_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance);
static void disable_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance);
static void c4_update_debugger_state_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c4_test_turbo(SFc4_test_turboInstanceStruct *
  chartInstance);
static void set_sim_state_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_st);
static void finalize_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance);
static void sf_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance);
static void initSimStructsc4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance);
static void registerMessagesc4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData);
static real_T c4_emlrt_marshallIn(SFc4_test_turboInstanceStruct *chartInstance,
  const mxArray *c4_eta_c, const char_T *c4_identifier);
static real_T c4_b_emlrt_marshallIn(SFc4_test_turboInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static void c4_c_emlrt_marshallIn(SFc4_test_turboInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[3]);
static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static int32_T c4_d_emlrt_marshallIn(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static uint8_T c4_e_emlrt_marshallIn(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_b_is_active_c4_test_turbo, const char_T
  *c4_identifier);
static uint8_T c4_f_emlrt_marshallIn(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void init_dsm_address_info(SFc4_test_turboInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance)
{
  chartInstance->c4_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c4_is_active_c4_test_turbo = 0U;
}

static void initialize_params_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance)
{
  real_T c4_dv0[3];
  int32_T c4_i0;
  real_T c4_dv1[3];
  int32_T c4_i1;
  real_T c4_dv2[3];
  int32_T c4_i2;
  real_T c4_dv3[3];
  int32_T c4_i3;
  sf_set_error_prefix_string(
    "Error evaluating data 'AF_n_G' in the parent workspace.\n");
  sf_mex_import_named("AF_n_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c4_dv0, 0, 0, 0U, 1, 0U, 1, 3);
  for (c4_i0 = 0; c4_i0 < 3; c4_i0++) {
    chartInstance->c4_AF_n_G[c4_i0] = c4_dv0[c4_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'AF_low_G' in the parent workspace.\n");
  sf_mex_import_named("AF_low_G", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c4_dv1, 0, 0, 0U, 1, 0U, 1, 3);
  for (c4_i1 = 0; c4_i1 < 3; c4_i1++) {
    chartInstance->c4_AF_low_G[c4_i1] = c4_dv1[c4_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'AF_high_G' in the parent workspace.\n");
  sf_mex_import_named("AF_high_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c4_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c4_i2 = 0; c4_i2 < 3; c4_i2++) {
    chartInstance->c4_AF_high_G[c4_i2] = c4_dv2[c4_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'm_a0_G' in the parent workspace.\n");
  sf_mex_import_named("m_a0_G", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      c4_dv3, 0, 0, 0U, 1, 0U, 1, 3);
  for (c4_i3 = 0; c4_i3 < 3; c4_i3++) {
    chartInstance->c4_m_a0_G[c4_i3] = c4_dv3[c4_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c4_update_debugger_state_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c4_test_turbo(SFc4_test_turboInstanceStruct *
  chartInstance)
{
  const mxArray *c4_st;
  const mxArray *c4_y = NULL;
  real_T c4_hoistedGlobal;
  real_T c4_u;
  const mxArray *c4_b_y = NULL;
  real_T c4_b_hoistedGlobal;
  real_T c4_b_u;
  const mxArray *c4_c_y = NULL;
  real_T c4_c_hoistedGlobal;
  real_T c4_c_u;
  const mxArray *c4_d_y = NULL;
  real_T c4_d_hoistedGlobal;
  real_T c4_d_u;
  const mxArray *c4_e_y = NULL;
  uint8_T c4_e_hoistedGlobal;
  uint8_T c4_e_u;
  const mxArray *c4_f_y = NULL;
  real_T *c4_AF;
  real_T *c4_eta_c;
  real_T *c4_t_m;
  real_T *c4_t_m_simplified;
  c4_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c4_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_t_m_simplified = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c4_st = NULL;
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(5), FALSE);
  c4_hoistedGlobal = *c4_AF;
  c4_u = c4_hoistedGlobal;
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 0, c4_b_y);
  c4_b_hoistedGlobal = *c4_eta_c;
  c4_b_u = c4_b_hoistedGlobal;
  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", &c4_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 1, c4_c_y);
  c4_c_hoistedGlobal = *c4_t_m;
  c4_c_u = c4_c_hoistedGlobal;
  c4_d_y = NULL;
  sf_mex_assign(&c4_d_y, sf_mex_create("y", &c4_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 2, c4_d_y);
  c4_d_hoistedGlobal = *c4_t_m_simplified;
  c4_d_u = c4_d_hoistedGlobal;
  c4_e_y = NULL;
  sf_mex_assign(&c4_e_y, sf_mex_create("y", &c4_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 3, c4_e_y);
  c4_e_hoistedGlobal = chartInstance->c4_is_active_c4_test_turbo;
  c4_e_u = c4_e_hoistedGlobal;
  c4_f_y = NULL;
  sf_mex_assign(&c4_f_y, sf_mex_create("y", &c4_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 4, c4_f_y);
  sf_mex_assign(&c4_st, c4_y, FALSE);
  return c4_st;
}

static void set_sim_state_c4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T *c4_AF;
  real_T *c4_eta_c;
  real_T *c4_t_m;
  real_T *c4_t_m_simplified;
  c4_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c4_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_t_m_simplified = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c4_doneDoubleBufferReInit = TRUE;
  c4_u = sf_mex_dup(c4_st);
  *c4_AF = c4_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 0)),
    "AF");
  *c4_eta_c = c4_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u,
    1)), "eta_c");
  *c4_t_m = c4_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 2)),
    "t_m");
  *c4_t_m_simplified = c4_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c4_u, 3)), "t_m_simplified");
  chartInstance->c4_is_active_c4_test_turbo = c4_e_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 4)),
     "is_active_c4_test_turbo");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_test_turbo(chartInstance);
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance)
{
}

static void sf_c4_test_turbo(SFc4_test_turboInstanceStruct *chartInstance)
{
  int32_T c4_i4;
  int32_T c4_i5;
  int32_T c4_i6;
  int32_T c4_i7;
  real_T c4_hoistedGlobal;
  real_T c4_b_hoistedGlobal;
  real_T c4_c_hoistedGlobal;
  real_T c4_omega_t;
  real_T c4_u;
  real_T c4_omega;
  int32_T c4_i8;
  real_T c4_b_AF_n_G[3];
  int32_T c4_i9;
  real_T c4_b_AF_low_G[3];
  int32_T c4_i10;
  real_T c4_b_AF_high_G[3];
  int32_T c4_i11;
  real_T c4_b_m_a0_G[3];
  uint32_T c4_debug_family_var_map[17];
  real_T c4_AF_n;
  real_T c4_AF_low;
  real_T c4_AF_high;
  real_T c4_m_a0;
  real_T c4_nargin = 7.0;
  real_T c4_nargout = 4.0;
  real_T c4_t_m;
  real_T c4_t_m_simplified;
  real_T c4_AF;
  real_T c4_eta_c;
  real_T c4_a;
  real_T c4_b;
  real_T c4_y;
  real_T c4_b_a;
  real_T c4_b_b;
  real_T c4_b_y;
  real_T c4_A;
  real_T c4_B;
  real_T c4_x;
  real_T c4_c_y;
  real_T c4_b_x;
  real_T c4_d_y;
  real_T c4_b_A;
  real_T c4_b_B;
  real_T c4_c_x;
  real_T c4_e_y;
  real_T c4_d_x;
  real_T c4_f_y;
  real_T c4_c_a;
  real_T c4_c_b;
  real_T c4_g_y;
  real_T c4_c_A;
  real_T c4_c_B;
  real_T c4_e_x;
  real_T c4_h_y;
  real_T c4_f_x;
  real_T c4_i_y;
  real_T c4_d_b;
  real_T c4_j_y;
  real_T c4_d_A;
  real_T c4_d_B;
  real_T c4_g_x;
  real_T c4_k_y;
  real_T c4_h_x;
  real_T c4_l_y;
  real_T *c4_b_eta_c;
  real_T *c4_b_AF;
  real_T *c4_b_t_m_simplified;
  real_T *c4_b_t_m;
  real_T *c4_b_omega;
  real_T *c4_b_u;
  real_T *c4_b_omega_t;
  c4_b_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c4_b_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c4_b_t_m_simplified = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c4_b_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c4_b_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c4_b_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c4_b_omega_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c4_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c4_b_omega_t, 0U);
  _SFD_DATA_RANGE_CHECK(*c4_b_u, 1U);
  _SFD_DATA_RANGE_CHECK(*c4_b_omega, 2U);
  for (c4_i4 = 0; c4_i4 < 3; c4_i4++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_AF_n_G[c4_i4], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c4_b_t_m, 4U);
  for (c4_i5 = 0; c4_i5 < 3; c4_i5++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_AF_low_G[c4_i5], 5U);
  }

  for (c4_i6 = 0; c4_i6 < 3; c4_i6++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_AF_high_G[c4_i6], 6U);
  }

  for (c4_i7 = 0; c4_i7 < 3; c4_i7++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_m_a0_G[c4_i7], 7U);
  }

  _SFD_DATA_RANGE_CHECK(*c4_b_t_m_simplified, 8U);
  _SFD_DATA_RANGE_CHECK(*c4_b_AF, 9U);
  _SFD_DATA_RANGE_CHECK(*c4_b_eta_c, 10U);
  chartInstance->c4_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c4_sfEvent);
  c4_hoistedGlobal = *c4_b_omega_t;
  c4_b_hoistedGlobal = *c4_b_u;
  c4_c_hoistedGlobal = *c4_b_omega;
  c4_omega_t = c4_hoistedGlobal;
  c4_u = c4_b_hoistedGlobal;
  c4_omega = c4_c_hoistedGlobal;
  for (c4_i8 = 0; c4_i8 < 3; c4_i8++) {
    c4_b_AF_n_G[c4_i8] = chartInstance->c4_AF_n_G[c4_i8];
  }

  for (c4_i9 = 0; c4_i9 < 3; c4_i9++) {
    c4_b_AF_low_G[c4_i9] = chartInstance->c4_AF_low_G[c4_i9];
  }

  for (c4_i10 = 0; c4_i10 < 3; c4_i10++) {
    c4_b_AF_high_G[c4_i10] = chartInstance->c4_AF_high_G[c4_i10];
  }

  for (c4_i11 = 0; c4_i11 < 3; c4_i11++) {
    c4_b_m_a0_G[c4_i11] = chartInstance->c4_m_a0_G[c4_i11];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 17U, 17U, c4_debug_family_names,
    c4_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_AF_n, 0U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_AF_low, 1U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_AF_high, 2U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_m_a0, 3U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_nargin, 4U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_nargout, 5U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c4_omega_t, 6U, c4_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c4_u, 7U, c4_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c4_omega, 8U, c4_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c4_b_AF_n_G, 9U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c4_b_AF_low_G, 10U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c4_b_AF_high_G, 11U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c4_b_m_a0_G, 12U, c4_b_sf_marshallOut,
    c4_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_t_m, 13U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_t_m_simplified, 14U,
    c4_sf_marshallOut, c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_AF, 15U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c4_eta_c, 16U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 5);
  c4_AF_n = c4_b_AF_n_G[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 6);
  c4_AF_low = c4_b_AF_low_G[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 7);
  c4_AF_high = c4_b_AF_high_G[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 8);
  c4_m_a0 = c4_b_m_a0_G[0];
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 11);
  if (CV_EML_IF(0, 1, 0, c4_u <= 0.0001)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 12);
    c4_AF = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 14);
    c4_a = 1.0 - c4_m_a0;
    c4_b = c4_omega_t;
    c4_y = c4_a * c4_b;
    c4_b_a = c4_AF_n;
    c4_b_b = c4_m_a0 + c4_y;
    c4_b_y = c4_b_a * c4_b_b;
    c4_A = c4_b_y;
    c4_B = c4_u;
    c4_x = c4_A;
    c4_c_y = c4_B;
    c4_b_x = c4_x;
    c4_d_y = c4_c_y;
    c4_AF = c4_b_x / c4_d_y;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 17);
  if (CV_EML_IF(0, 1, 1, c4_AF >= c4_AF_high)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 18);
    c4_eta_c = 1.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 19);
    if (CV_EML_IF(0, 1, 2, c4_AF <= c4_AF_low)) {
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 20);
      c4_eta_c = 0.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 22);
      c4_b_A = c4_AF - c4_AF_low;
      c4_b_B = c4_AF_high - c4_AF_low;
      c4_c_x = c4_b_A;
      c4_e_y = c4_b_B;
      c4_d_x = c4_c_x;
      c4_f_y = c4_e_y;
      c4_eta_c = c4_d_x / c4_f_y;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 25);
  c4_c_a = c4_eta_c;
  c4_c_b = c4_u;
  c4_g_y = c4_c_a * c4_c_b;
  c4_c_A = c4_g_y;
  c4_c_B = c4_omega;
  c4_e_x = c4_c_A;
  c4_h_y = c4_c_B;
  c4_f_x = c4_e_x;
  c4_i_y = c4_h_y;
  c4_t_m = c4_f_x / c4_i_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 26);
  c4_d_b = c4_u;
  c4_j_y = c4_d_b;
  c4_d_A = c4_j_y;
  c4_d_B = c4_omega;
  c4_g_x = c4_d_A;
  c4_k_y = c4_d_B;
  c4_h_x = c4_g_x;
  c4_l_y = c4_k_y;
  c4_t_m_simplified = c4_h_x / c4_l_y;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -26);
  _SFD_SYMBOL_SCOPE_POP();
  *c4_b_t_m = c4_t_m;
  *c4_b_t_m_simplified = c4_t_m_simplified;
  *c4_b_AF = c4_AF;
  *c4_b_eta_c = c4_eta_c;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c4_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_test_turboMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance)
{
}

static void registerMessagesc4_test_turbo(SFc4_test_turboInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_emlrt_marshallIn(SFc4_test_turboInstanceStruct *chartInstance,
  const mxArray *c4_eta_c, const char_T *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_eta_c), &c4_thisId);
  sf_mex_destroy(&c4_eta_c);
  return c4_y;
}

static real_T c4_b_emlrt_marshallIn(SFc4_test_turboInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d0, 1, 0, 0U, 0, 0U, 0);
  c4_y = c4_d0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_eta_c;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)chartInstanceVoid;
  c4_eta_c = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_eta_c), &c4_thisId);
  sf_mex_destroy(&c4_eta_c);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_i12;
  real_T c4_b_inData[3];
  int32_T c4_i13;
  real_T c4_u[3];
  const mxArray *c4_y = NULL;
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  for (c4_i12 = 0; c4_i12 < 3; c4_i12++) {
    c4_b_inData[c4_i12] = (*(real_T (*)[3])c4_inData)[c4_i12];
  }

  for (c4_i13 = 0; c4_i13 < 3; c4_i13++) {
    c4_u[c4_i13] = c4_b_inData[c4_i13];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static void c4_c_emlrt_marshallIn(SFc4_test_turboInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId, real_T c4_y[3])
{
  real_T c4_dv4[3];
  int32_T c4_i14;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), c4_dv4, 1, 0, 0U, 1, 0U, 1, 3);
  for (c4_i14 = 0; c4_i14 < 3; c4_i14++) {
    c4_y[c4_i14] = c4_dv4[c4_i14];
  }

  sf_mex_destroy(&c4_u);
}

static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_m_a0_G;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y[3];
  int32_T c4_i15;
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)chartInstanceVoid;
  c4_b_m_a0_G = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_m_a0_G), &c4_thisId, c4_y);
  sf_mex_destroy(&c4_b_m_a0_G);
  for (c4_i15 = 0; c4_i15 < 3; c4_i15++) {
    (*(real_T (*)[3])c4_outData)[c4_i15] = c4_y[c4_i15];
  }

  sf_mex_destroy(&c4_mxArrayInData);
}

const mxArray *sf_c4_test_turbo_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo;
  c4_ResolvedFunctionInfo c4_info[5];
  c4_ResolvedFunctionInfo (*c4_b_info)[5];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i16;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_nameCaptureInfo = NULL;
  c4_b_info = (c4_ResolvedFunctionInfo (*)[5])c4_info;
  (*c4_b_info)[0].context = "";
  (*c4_b_info)[0].name = "mtimes";
  (*c4_b_info)[0].dominantType = "double";
  (*c4_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c4_b_info)[0].fileTimeLo = 1289519692U;
  (*c4_b_info)[0].fileTimeHi = 0U;
  (*c4_b_info)[0].mFileTimeLo = 0U;
  (*c4_b_info)[0].mFileTimeHi = 0U;
  (*c4_b_info)[1].context = "";
  (*c4_b_info)[1].name = "mrdivide";
  (*c4_b_info)[1].dominantType = "double";
  (*c4_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c4_b_info)[1].fileTimeLo = 1357951548U;
  (*c4_b_info)[1].fileTimeHi = 0U;
  (*c4_b_info)[1].mFileTimeLo = 1319729966U;
  (*c4_b_info)[1].mFileTimeHi = 0U;
  (*c4_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c4_b_info)[2].name = "rdivide";
  (*c4_b_info)[2].dominantType = "double";
  (*c4_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c4_b_info)[2].fileTimeLo = 1346510388U;
  (*c4_b_info)[2].fileTimeHi = 0U;
  (*c4_b_info)[2].mFileTimeLo = 0U;
  (*c4_b_info)[2].mFileTimeHi = 0U;
  (*c4_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c4_b_info)[3].name = "eml_scalexp_compatible";
  (*c4_b_info)[3].dominantType = "double";
  (*c4_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  (*c4_b_info)[3].fileTimeLo = 1286818796U;
  (*c4_b_info)[3].fileTimeHi = 0U;
  (*c4_b_info)[3].mFileTimeLo = 0U;
  (*c4_b_info)[3].mFileTimeHi = 0U;
  (*c4_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c4_b_info)[4].name = "eml_div";
  (*c4_b_info)[4].dominantType = "double";
  (*c4_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c4_b_info)[4].fileTimeLo = 1313347810U;
  (*c4_b_info)[4].fileTimeHi = 0U;
  (*c4_b_info)[4].mFileTimeLo = 0U;
  (*c4_b_info)[4].mFileTimeHi = 0U;
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 5), FALSE);
  for (c4_i16 = 0; c4_i16 < 5; c4_i16++) {
    c4_r0 = &c4_info[c4_i16];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context", "nameCaptureInfo",
                    c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name", "nameCaptureInfo", c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved", "nameCaptureInfo",
                    c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c4_i16);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c4_i16);
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c4_nameCaptureInfo);
  return c4_nameCaptureInfo;
}

static const mxArray *c4_c_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(int32_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static int32_T c4_d_emlrt_marshallIn(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  int32_T c4_y;
  int32_T c4_i17;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_i17, 1, 6, 0U, 0, 0U, 0);
  c4_y = c4_i17;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_sfEvent;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  int32_T c4_y;
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)chartInstanceVoid;
  c4_b_sfEvent = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_sfEvent),
    &c4_thisId);
  sf_mex_destroy(&c4_b_sfEvent);
  *(int32_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static uint8_T c4_e_emlrt_marshallIn(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_b_is_active_c4_test_turbo, const char_T
  *c4_identifier)
{
  uint8_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c4_b_is_active_c4_test_turbo), &c4_thisId);
  sf_mex_destroy(&c4_b_is_active_c4_test_turbo);
  return c4_y;
}

static uint8_T c4_f_emlrt_marshallIn(SFc4_test_turboInstanceStruct
  *chartInstance, const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_u0, 1, 3, 0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void init_dsm_address_info(SFc4_test_turboInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c4_test_turbo_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1232445477U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3187300573U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2213332520U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(362753086U);
}

mxArray *sf_c4_test_turbo_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("kTv5PcoHaUGONB0oWElJm");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c4_test_turbo_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c4_test_turbo(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[25],T\"AF\",},{M[1],M[26],T\"eta_c\",},{M[1],M[5],T\"t_m\",},{M[1],M[24],T\"t_m_simplified\",},{M[8],M[0],T\"is_active_c4_test_turbo\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_test_turbo_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc4_test_turboInstanceStruct *chartInstance;
    chartInstance = (SFc4_test_turboInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _test_turboMachineNumber_,
           4,
           1,
           1,
           11,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_test_turboMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,_test_turboMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _test_turboMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"omega_t");
          _SFD_SET_DATA_PROPS(1,1,1,0,"u");
          _SFD_SET_DATA_PROPS(2,1,1,0,"omega");
          _SFD_SET_DATA_PROPS(3,10,0,0,"AF_n_G");
          _SFD_SET_DATA_PROPS(4,2,0,1,"t_m");
          _SFD_SET_DATA_PROPS(5,10,0,0,"AF_low_G");
          _SFD_SET_DATA_PROPS(6,10,0,0,"AF_high_G");
          _SFD_SET_DATA_PROPS(7,10,0,0,"m_a0_G");
          _SFD_SET_DATA_PROPS(8,2,0,1,"t_m_simplified");
          _SFD_SET_DATA_PROPS(9,2,0,1,"AF");
          _SFD_SET_DATA_PROPS(10,2,0,1,"eta_c");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,535);
        _SFD_CV_INIT_EML_IF(0,1,0,279,293,306,357);
        _SFD_CV_INIT_EML_IF(0,1,1,359,375,391,480);
        _SFD_CV_INIT_EML_IF(0,1,2,391,410,426,480);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)
            c4_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)c4_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)
            c4_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)
            c4_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c4_b_sf_marshallOut,(MexInFcnForType)
            c4_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)c4_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)c4_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)c4_sf_marshallIn);

        {
          real_T *c4_omega_t;
          real_T *c4_u;
          real_T *c4_omega;
          real_T *c4_t_m;
          real_T *c4_t_m_simplified;
          real_T *c4_AF;
          real_T *c4_eta_c;
          c4_eta_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c4_AF = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c4_t_m_simplified = (real_T *)ssGetOutputPortSignal(chartInstance->S,
            2);
          c4_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c4_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c4_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c4_omega_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c4_omega_t);
          _SFD_SET_DATA_VALUE_PTR(1U, c4_u);
          _SFD_SET_DATA_VALUE_PTR(2U, c4_omega);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c4_AF_n_G);
          _SFD_SET_DATA_VALUE_PTR(4U, c4_t_m);
          _SFD_SET_DATA_VALUE_PTR(5U, chartInstance->c4_AF_low_G);
          _SFD_SET_DATA_VALUE_PTR(6U, chartInstance->c4_AF_high_G);
          _SFD_SET_DATA_VALUE_PTR(7U, chartInstance->c4_m_a0_G);
          _SFD_SET_DATA_VALUE_PTR(8U, c4_t_m_simplified);
          _SFD_SET_DATA_VALUE_PTR(9U, c4_AF);
          _SFD_SET_DATA_VALUE_PTR(10U, c4_eta_c);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _test_turboMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "XN7BFnaC6StgDa2WjpsEiE";
}

static void sf_opaque_initialize_c4_test_turbo(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc4_test_turboInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c4_test_turbo((SFc4_test_turboInstanceStruct*)
    chartInstanceVar);
  initialize_c4_test_turbo((SFc4_test_turboInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c4_test_turbo(void *chartInstanceVar)
{
  enable_c4_test_turbo((SFc4_test_turboInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c4_test_turbo(void *chartInstanceVar)
{
  disable_c4_test_turbo((SFc4_test_turboInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c4_test_turbo(void *chartInstanceVar)
{
  sf_c4_test_turbo((SFc4_test_turboInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c4_test_turbo(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c4_test_turbo
    ((SFc4_test_turboInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_test_turbo();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c4_test_turbo(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_test_turbo();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c4_test_turbo((SFc4_test_turboInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c4_test_turbo(SimStruct* S)
{
  return sf_internal_get_sim_state_c4_test_turbo(S);
}

static void sf_opaque_set_sim_state_c4_test_turbo(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c4_test_turbo(S, st);
}

static void sf_opaque_terminate_c4_test_turbo(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc4_test_turboInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_test_turbo_optimization_info();
    }

    finalize_c4_test_turbo((SFc4_test_turboInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc4_test_turbo((SFc4_test_turboInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_test_turbo(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_test_turbo((SFc4_test_turboInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c4_test_turbo(SimStruct *S)
{
  /* Actual parameters from chart:
     AF_high_G AF_low_G AF_n_G m_a0_G
   */
  const char_T *rtParamNames[] = { "AF_high_G", "AF_low_G", "AF_n_G", "m_a0_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for AF_high_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for AF_low_G*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for AF_n_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for m_a0_G*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_test_turbo_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,4,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,4);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,4,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,4,4);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=4; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2684464693U));
  ssSetChecksum1(S,(2246428215U));
  ssSetChecksum2(S,(2628487133U));
  ssSetChecksum3(S,(2754521507U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c4_test_turbo(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_test_turbo(SimStruct *S)
{
  SFc4_test_turboInstanceStruct *chartInstance;
  chartInstance = (SFc4_test_turboInstanceStruct *)utMalloc(sizeof
    (SFc4_test_turboInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc4_test_turboInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c4_test_turbo;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c4_test_turbo;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c4_test_turbo;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c4_test_turbo;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c4_test_turbo;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c4_test_turbo;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c4_test_turbo;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c4_test_turbo;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c4_test_turbo;
  chartInstance->chartInfo.mdlStart = mdlStart_c4_test_turbo;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c4_test_turbo;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c4_test_turbo_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_test_turbo(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_test_turbo(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_test_turbo(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_test_turbo_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
