#ifndef __c1_CPModel_1Genset_h__
#define __c1_CPModel_1Genset_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c1_ResolvedFunctionInfo
#define typedef_c1_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c1_ResolvedFunctionInfo;

#endif                                 /*typedef_c1_ResolvedFunctionInfo*/

#ifndef typedef_SFc1_CPModel_1GensetInstanceStruct
#define typedef_SFc1_CPModel_1GensetInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c1_sfEvent;
  boolean_T c1_isStable;
  boolean_T c1_doneDoubleBufferReInit;
  uint8_T c1_is_active_c1_CPModel_1Genset;
  real_T c1_r_f_G[3];
  real_T c1_z_G[6];
  real_T c1_S_b_G[3];
  real_T c1_Q_load1;
  real_T c1_P_load1;
  real_T c1_omega_b;
  real_T c1_GeneratorNumber;
} SFc1_CPModel_1GensetInstanceStruct;

#endif                                 /*typedef_SFc1_CPModel_1GensetInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c1_CPModel_1Genset_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c1_CPModel_1Genset_get_check_sum(mxArray *plhs[]);
extern void c1_CPModel_1Genset_method_dispatcher(SimStruct *S, int_T method,
  void *data);

#endif
