#ifndef __c34_SimulationPlantModel_CommercialSystem_h__
#define __c34_SimulationPlantModel_CommercialSystem_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c34_ResolvedFunctionInfo
#define typedef_c34_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c34_ResolvedFunctionInfo;

#endif                                 /*typedef_c34_ResolvedFunctionInfo*/

#ifndef typedef_SFc34_SimulationPlantModel_CommercialSystemInstanceStruct
#define typedef_SFc34_SimulationPlantModel_CommercialSystemInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c34_sfEvent;
  boolean_T c34_isStable;
  boolean_T c34_doneDoubleBufferReInit;
  uint8_T c34_is_active_c34_SimulationPlantModel_CommercialSystem;
  real_T c34_DisconnectWhenFaultDetected;
  real_T c34_omega_noload[3];
  real_T c34_droop_speed[3];
  real_T c34_D_omega_max;
  real_T c34_D_omega_min;
  real_T c34_v_noload[3];
  real_T c34_droop_voltage[3];
  real_T c34_D_v_max;
  real_T c34_D_v_min;
  real_T c34_FaultDetectionInitTime;
  real_T *c34_CB1_address;
  int32_T c34_CB1_index;
  real_T *c34_CB3_address;
  int32_T c34_CB3_index;
} SFc34_SimulationPlantModel_CommercialSystemInstanceStruct;

#endif                                 /*typedef_SFc34_SimulationPlantModel_CommercialSystemInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c34_SimulationPlantModel_CommercialSystem_get_eml_resolved_functions_info
  (void);

/* Function Definitions */
extern void sf_c34_SimulationPlantModel_CommercialSystem_get_check_sum(mxArray
  *plhs[]);
extern void c34_SimulationPlantModel_CommercialSystem_method_dispatcher
  (SimStruct *S, int_T method, void *data);

#endif
