/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_CommercialSystem_sfun.h"
#include "c36_SimulationPlantModel_CommercialSystem.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_CommercialSystem_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c36_debug_family_names[26] = { "GeneratorNumber", "abs_v_an",
  "omega", "p", "q", "nargin", "nargout", "y", "u", "time",
  "DisconnectWhenFaultDetected", "omega_noload", "droop_speed", "D_omega_max",
  "D_omega_min", "v_noload", "droop_voltage", "D_v_max", "D_v_min",
  "FaultDetectionInitTime", "StayConnectedG", "w_min", "w_max", "v_min", "v_max",
  "CB1" };

/* Function Declarations */
static void initialize_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void initialize_params_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void enable_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void disable_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void c36_update_debugger_state_c36_SimulationPlantModel_CommercialSys
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void set_sim_state_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_st);
static void finalize_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void sf_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void initSimStructsc36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void registerMessagesc36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c36_machineNumber, uint32_T
  c36_chartNumber);
static const mxArray *c36_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static real_T c36_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_CB1, const char_T *c36_identifier);
static real_T c36_b_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void c36_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static const mxArray *c36_b_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static void c36_c_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId, real_T c36_y[3]);
static void c36_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static const mxArray *c36_c_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static const mxArray *c36_d_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static int32_T c36_d_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void c36_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static uint8_T c36_e_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_b_is_active_c36_SimulationPlantModel_CommercialSystem,
   const char_T *c36_identifier);
static uint8_T c36_f_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId);
static real_T c36_get_CB1
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   uint32_T c36_b);
static void c36_set_CB1
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   uint32_T c36_b, real_T c36_c);
static real_T *c36_access_CB1
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   uint32_T c36_b);
static void init_dsm_address_info
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  chartInstance->c36_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c36_is_active_c36_SimulationPlantModel_CommercialSystem = 0U;
}

static void initialize_params_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  real_T c36_d0;
  real_T c36_dv0[3];
  int32_T c36_i0;
  real_T c36_dv1[3];
  int32_T c36_i1;
  real_T c36_d1;
  real_T c36_d2;
  real_T c36_dv2[3];
  int32_T c36_i2;
  real_T c36_dv3[3];
  int32_T c36_i3;
  real_T c36_d3;
  real_T c36_d4;
  real_T c36_d5;
  sf_set_error_prefix_string(
    "Error evaluating data 'DisconnectWhenFaultDetected' in the parent workspace.\n");
  sf_mex_import_named("DisconnectWhenFaultDetected", sf_mex_get_sfun_param
                      (chartInstance->S, 4, 0), &c36_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_DisconnectWhenFaultDetected = c36_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'omega_noload' in the parent workspace.\n");
  sf_mex_import_named("omega_noload", sf_mex_get_sfun_param(chartInstance->S, 8,
    0), c36_dv0, 0, 0, 0U, 1, 0U, 1, 3);
  for (c36_i0 = 0; c36_i0 < 3; c36_i0++) {
    chartInstance->c36_omega_noload[c36_i0] = c36_dv0[c36_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'droop_speed' in the parent workspace.\n");
  sf_mex_import_named("droop_speed", sf_mex_get_sfun_param(chartInstance->S, 6,
    0), c36_dv1, 0, 0, 0U, 1, 0U, 1, 3);
  for (c36_i1 = 0; c36_i1 < 3; c36_i1++) {
    chartInstance->c36_droop_speed[c36_i1] = c36_dv1[c36_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_omega_max' in the parent workspace.\n");
  sf_mex_import_named("D_omega_max", sf_mex_get_sfun_param(chartInstance->S, 0,
    0), &c36_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_D_omega_max = c36_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_omega_min' in the parent workspace.\n");
  sf_mex_import_named("D_omega_min", sf_mex_get_sfun_param(chartInstance->S, 1,
    0), &c36_d2, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_D_omega_min = c36_d2;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'v_noload' in the parent workspace.\n");
  sf_mex_import_named("v_noload", sf_mex_get_sfun_param(chartInstance->S, 9, 0),
                      c36_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c36_i2 = 0; c36_i2 < 3; c36_i2++) {
    chartInstance->c36_v_noload[c36_i2] = c36_dv2[c36_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'droop_voltage' in the parent workspace.\n");
  sf_mex_import_named("droop_voltage", sf_mex_get_sfun_param(chartInstance->S, 7,
    0), c36_dv3, 0, 0, 0U, 1, 0U, 1, 3);
  for (c36_i3 = 0; c36_i3 < 3; c36_i3++) {
    chartInstance->c36_droop_voltage[c36_i3] = c36_dv3[c36_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_v_max' in the parent workspace.\n");
  sf_mex_import_named("D_v_max", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      &c36_d3, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_D_v_max = c36_d3;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_v_min' in the parent workspace.\n");
  sf_mex_import_named("D_v_min", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c36_d4, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_D_v_min = c36_d4;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'FaultDetectionInitTime' in the parent workspace.\n");
  sf_mex_import_named("FaultDetectionInitTime", sf_mex_get_sfun_param
                      (chartInstance->S, 5, 0), &c36_d5, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_FaultDetectionInitTime = c36_d5;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c36_update_debugger_state_c36_SimulationPlantModel_CommercialSys
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  const mxArray *c36_st;
  const mxArray *c36_y = NULL;
  real_T c36_hoistedGlobal;
  real_T c36_u;
  const mxArray *c36_b_y = NULL;
  real_T c36_b_hoistedGlobal;
  real_T c36_b_u;
  const mxArray *c36_c_y = NULL;
  real_T c36_c_hoistedGlobal;
  real_T c36_c_u;
  const mxArray *c36_d_y = NULL;
  real_T c36_d_hoistedGlobal;
  real_T c36_d_u;
  const mxArray *c36_e_y = NULL;
  real_T c36_e_hoistedGlobal;
  real_T c36_e_u;
  const mxArray *c36_f_y = NULL;
  uint8_T c36_f_hoistedGlobal;
  uint8_T c36_f_u;
  const mxArray *c36_g_y = NULL;
  real_T *c36_StayConnectedG;
  real_T *c36_v_max;
  real_T *c36_v_min;
  real_T *c36_w_max;
  real_T *c36_w_min;
  c36_v_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c36_v_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c36_w_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c36_w_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c36_st = NULL;
  c36_st = NULL;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_createcellarray(6), FALSE);
  c36_hoistedGlobal = *c36_StayConnectedG;
  c36_u = c36_hoistedGlobal;
  c36_b_y = NULL;
  sf_mex_assign(&c36_b_y, sf_mex_create("y", &c36_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 0, c36_b_y);
  c36_b_hoistedGlobal = *c36_v_max;
  c36_b_u = c36_b_hoistedGlobal;
  c36_c_y = NULL;
  sf_mex_assign(&c36_c_y, sf_mex_create("y", &c36_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 1, c36_c_y);
  c36_c_hoistedGlobal = *c36_v_min;
  c36_c_u = c36_c_hoistedGlobal;
  c36_d_y = NULL;
  sf_mex_assign(&c36_d_y, sf_mex_create("y", &c36_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 2, c36_d_y);
  c36_d_hoistedGlobal = *c36_w_max;
  c36_d_u = c36_d_hoistedGlobal;
  c36_e_y = NULL;
  sf_mex_assign(&c36_e_y, sf_mex_create("y", &c36_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 3, c36_e_y);
  c36_e_hoistedGlobal = *c36_w_min;
  c36_e_u = c36_e_hoistedGlobal;
  c36_f_y = NULL;
  sf_mex_assign(&c36_f_y, sf_mex_create("y", &c36_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 4, c36_f_y);
  c36_f_hoistedGlobal =
    chartInstance->c36_is_active_c36_SimulationPlantModel_CommercialSystem;
  c36_f_u = c36_f_hoistedGlobal;
  c36_g_y = NULL;
  sf_mex_assign(&c36_g_y, sf_mex_create("y", &c36_f_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 5, c36_g_y);
  sf_mex_assign(&c36_st, c36_y, FALSE);
  return c36_st;
}

static void set_sim_state_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_st)
{
  const mxArray *c36_u;
  real_T *c36_StayConnectedG;
  real_T *c36_v_max;
  real_T *c36_v_min;
  real_T *c36_w_max;
  real_T *c36_w_min;
  c36_v_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c36_v_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c36_w_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c36_w_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c36_doneDoubleBufferReInit = TRUE;
  c36_u = sf_mex_dup(c36_st);
  *c36_StayConnectedG = c36_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c36_u, 0)), "StayConnectedG");
  *c36_v_max = c36_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c36_u, 1)), "v_max");
  *c36_v_min = c36_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c36_u, 2)), "v_min");
  *c36_w_max = c36_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c36_u, 3)), "w_max");
  *c36_w_min = c36_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c36_u, 4)), "w_min");
  chartInstance->c36_is_active_c36_SimulationPlantModel_CommercialSystem =
    c36_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c36_u, 5)),
    "is_active_c36_SimulationPlantModel_CommercialSystem");
  sf_mex_destroy(&c36_u);
  c36_update_debugger_state_c36_SimulationPlantModel_CommercialSys(chartInstance);
  sf_mex_destroy(&c36_st);
}

static void finalize_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void sf_c36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  int32_T c36_i4;
  int32_T c36_i5;
  int32_T c36_i6;
  int32_T c36_i7;
  int32_T c36_i8;
  int32_T c36_i9;
  real_T c36_hoistedGlobal;
  real_T c36_b_hoistedGlobal;
  real_T c36_c_hoistedGlobal;
  real_T c36_d_hoistedGlobal;
  real_T c36_e_hoistedGlobal;
  real_T c36_f_hoistedGlobal;
  real_T c36_g_hoistedGlobal;
  int32_T c36_i10;
  real_T c36_y[3];
  int32_T c36_i11;
  real_T c36_u[4];
  real_T c36_time;
  real_T c36_b_DisconnectWhenFaultDetected;
  int32_T c36_i12;
  real_T c36_b_omega_noload[3];
  int32_T c36_i13;
  real_T c36_b_droop_speed[3];
  real_T c36_b_D_omega_max;
  real_T c36_b_D_omega_min;
  int32_T c36_i14;
  real_T c36_b_v_noload[3];
  int32_T c36_i15;
  real_T c36_b_droop_voltage[3];
  real_T c36_b_D_v_max;
  real_T c36_b_D_v_min;
  real_T c36_b_FaultDetectionInitTime;
  uint32_T c36_debug_family_var_map[26];
  real_T c36_GeneratorNumber;
  real_T c36_abs_v_an;
  real_T c36_omega;
  real_T c36_p;
  real_T c36_q;
  real_T c36_nargin = 13.0;
  real_T c36_nargout = 5.0;
  real_T c36_StayConnectedG;
  real_T c36_w_min;
  real_T c36_w_max;
  real_T c36_v_min;
  real_T c36_v_max;
  real_T c36_b;
  real_T c36_a;
  real_T c36_b_b;
  real_T c36_b_y;
  real_T c36_b_a;
  real_T c36_c_b;
  real_T c36_c_y;
  real_T c36_c_a;
  real_T c36_d_b;
  real_T c36_d_y;
  real_T c36_d_a;
  real_T c36_e_b;
  real_T c36_e_y;
  real_T *c36_b_StayConnectedG;
  real_T *c36_b_time;
  real_T *c36_b_w_min;
  real_T *c36_b_w_max;
  real_T *c36_b_v_min;
  real_T *c36_b_v_max;
  real_T (*c36_b_u)[4];
  real_T (*c36_f_y)[3];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  c36_b_v_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c36_b_v_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c36_b_w_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c36_b_w_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c36_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c36_b_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c36_b_u = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c36_f_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  for (c36_i4 = 0; c36_i4 < 3; c36_i4++) {
    _SFD_DATA_RANGE_CHECK((*c36_f_y)[c36_i4], 0U);
  }

  for (c36_i5 = 0; c36_i5 < 4; c36_i5++) {
    _SFD_DATA_RANGE_CHECK((*c36_b_u)[c36_i5], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c36_b_StayConnectedG, 2U);
  _SFD_DATA_RANGE_CHECK(*c36_b_time, 3U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c36_DisconnectWhenFaultDetected, 4U);
  for (c36_i6 = 0; c36_i6 < 3; c36_i6++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c36_omega_noload[c36_i6], 5U);
  }

  for (c36_i7 = 0; c36_i7 < 3; c36_i7++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c36_droop_speed[c36_i7], 6U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c36_D_omega_max, 7U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c36_D_omega_min, 8U);
  for (c36_i8 = 0; c36_i8 < 3; c36_i8++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c36_v_noload[c36_i8], 10U);
  }

  for (c36_i9 = 0; c36_i9 < 3; c36_i9++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c36_droop_voltage[c36_i9], 11U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c36_D_v_max, 12U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c36_D_v_min, 13U);
  _SFD_DATA_RANGE_CHECK(*c36_b_w_min, 14U);
  _SFD_DATA_RANGE_CHECK(*c36_b_w_max, 15U);
  _SFD_DATA_RANGE_CHECK(*c36_b_v_min, 16U);
  _SFD_DATA_RANGE_CHECK(*c36_b_v_max, 17U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c36_FaultDetectionInitTime, 18U);
  chartInstance->c36_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  c36_hoistedGlobal = *c36_b_time;
  c36_b_hoistedGlobal = chartInstance->c36_DisconnectWhenFaultDetected;
  c36_c_hoistedGlobal = chartInstance->c36_D_omega_max;
  c36_d_hoistedGlobal = chartInstance->c36_D_omega_min;
  c36_e_hoistedGlobal = chartInstance->c36_D_v_max;
  c36_f_hoistedGlobal = chartInstance->c36_D_v_min;
  c36_g_hoistedGlobal = chartInstance->c36_FaultDetectionInitTime;
  for (c36_i10 = 0; c36_i10 < 3; c36_i10++) {
    c36_y[c36_i10] = (*c36_f_y)[c36_i10];
  }

  for (c36_i11 = 0; c36_i11 < 4; c36_i11++) {
    c36_u[c36_i11] = (*c36_b_u)[c36_i11];
  }

  c36_time = c36_hoistedGlobal;
  c36_b_DisconnectWhenFaultDetected = c36_b_hoistedGlobal;
  for (c36_i12 = 0; c36_i12 < 3; c36_i12++) {
    c36_b_omega_noload[c36_i12] = chartInstance->c36_omega_noload[c36_i12];
  }

  for (c36_i13 = 0; c36_i13 < 3; c36_i13++) {
    c36_b_droop_speed[c36_i13] = chartInstance->c36_droop_speed[c36_i13];
  }

  c36_b_D_omega_max = c36_c_hoistedGlobal;
  c36_b_D_omega_min = c36_d_hoistedGlobal;
  for (c36_i14 = 0; c36_i14 < 3; c36_i14++) {
    c36_b_v_noload[c36_i14] = chartInstance->c36_v_noload[c36_i14];
  }

  for (c36_i15 = 0; c36_i15 < 3; c36_i15++) {
    c36_b_droop_voltage[c36_i15] = chartInstance->c36_droop_voltage[c36_i15];
  }

  c36_b_D_v_max = c36_e_hoistedGlobal;
  c36_b_D_v_min = c36_f_hoistedGlobal;
  c36_b_FaultDetectionInitTime = c36_g_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 26U, 26U, c36_debug_family_names,
    c36_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_GeneratorNumber, 0U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_abs_v_an, 1U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_omega, 2U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_p, 3U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_q, 4U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_nargin, 5U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_nargout, 6U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c36_y, 7U, c36_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c36_u, 8U, c36_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_time, 9U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_DisconnectWhenFaultDetected, 10U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c36_b_omega_noload, 11U,
    c36_b_sf_marshallOut, c36_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c36_b_droop_speed, 12U,
    c36_b_sf_marshallOut, c36_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_D_omega_max, 13U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_D_omega_min, 14U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c36_b_v_noload, 15U, c36_b_sf_marshallOut,
    c36_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c36_b_droop_voltage, 16U,
    c36_b_sf_marshallOut, c36_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_D_v_max, 17U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_D_v_min, 18U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_FaultDetectionInitTime, 19U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_StayConnectedG, 20U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_w_min, 21U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_w_max, 22U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_v_min, 23U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_v_max, 24U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(chartInstance->c36_CB1_address, 25U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 3);
  c36_GeneratorNumber = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 5);
  c36_b = c36_u[1];
  c36_abs_v_an = 0.57735026918962584 * c36_b;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 6);
  c36_omega = c36_y[0];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 7);
  c36_p = c36_y[1];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 8);
  c36_q = c36_y[2];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 10);
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 11);
  c36_StayConnectedG = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 12);
  if (CV_EML_IF(0, 1, 0, c36_get_CB1(chartInstance, 0) == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 13);
    c36_StayConnectedG = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 16);
  c36_a = c36_p;
  c36_b_b = c36_b_droop_speed[0];
  c36_b_y = c36_a * c36_b_b;
  c36_w_max = (c36_b_omega_noload[0] - c36_b_y) + c36_b_D_omega_max;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 17);
  c36_b_a = c36_p;
  c36_c_b = c36_b_droop_speed[0];
  c36_c_y = c36_b_a * c36_c_b;
  c36_w_min = (c36_b_omega_noload[0] - c36_c_y) - c36_b_D_omega_min;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 18);
  c36_c_a = c36_q;
  c36_d_b = c36_b_droop_voltage[0];
  c36_d_y = c36_c_a * c36_d_b;
  c36_v_max = (c36_b_v_noload[0] - c36_d_y) + c36_b_D_v_max;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 19);
  c36_d_a = c36_q;
  c36_e_b = c36_b_droop_voltage[0];
  c36_e_y = c36_d_a * c36_e_b;
  c36_v_min = (c36_b_v_noload[0] - c36_e_y) - c36_b_D_v_min;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 21);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 0, c36_b_DisconnectWhenFaultDetected == 1.0)) {
    if (CV_EML_COND(0, 1, 1, c36_time >= c36_b_FaultDetectionInitTime)) {
      CV_EML_MCDC(0, 1, 0, TRUE);
      CV_EML_IF(0, 1, 1, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 22);
      guard3 = FALSE;
      if (CV_EML_COND(0, 1, 2, c36_omega >= c36_w_max)) {
        guard3 = TRUE;
      } else if (CV_EML_COND(0, 1, 3, c36_omega <= c36_w_min)) {
        guard3 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 1, FALSE);
        CV_EML_IF(0, 1, 2, FALSE);
      }

      if (guard3 == TRUE) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 2, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 23);
        c36_StayConnectedG = 0.0;
      }

      _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 26);
      guard2 = FALSE;
      if (CV_EML_COND(0, 1, 4, c36_abs_v_an >= c36_v_max)) {
        guard2 = TRUE;
      } else if (CV_EML_COND(0, 1, 5, c36_abs_v_an <= c36_v_min)) {
        guard2 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 2, FALSE);
        CV_EML_IF(0, 1, 3, FALSE);
      }

      if (guard2 == TRUE) {
        CV_EML_MCDC(0, 1, 2, TRUE);
        CV_EML_IF(0, 1, 3, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 27);
        c36_StayConnectedG = 0.0;
      }
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, -27);
  _SFD_SYMBOL_SCOPE_POP();
  *c36_b_StayConnectedG = c36_StayConnectedG;
  *c36_b_w_min = c36_w_min;
  *c36_b_w_max = c36_w_max;
  *c36_b_v_min = c36_v_min;
  *c36_b_v_max = c36_v_max;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_CommercialSystemMachineNumber_,
     chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void registerMessagesc36_SimulationPlantModel_CommercialSystem
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c36_machineNumber, uint32_T
  c36_chartNumber)
{
}

static const mxArray *c36_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  real_T c36_u;
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_u = *(real_T *)c36_inData;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", &c36_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static real_T c36_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_CB1, const char_T *c36_identifier)
{
  real_T c36_y;
  emlrtMsgIdentifier c36_thisId;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_CB1), &c36_thisId);
  sf_mex_destroy(&c36_CB1);
  return c36_y;
}

static real_T c36_b_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  real_T c36_y;
  real_T c36_d6;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_d6, 1, 0, 0U, 0, 0U, 0);
  c36_y = c36_d6;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void c36_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_CB1;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  real_T c36_y;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_CB1 = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_CB1), &c36_thisId);
  sf_mex_destroy(&c36_CB1);
  *(real_T *)c36_outData = c36_y;
  sf_mex_destroy(&c36_mxArrayInData);
}

static const mxArray *c36_b_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_i16;
  real_T c36_b_inData[3];
  int32_T c36_i17;
  real_T c36_u[3];
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  for (c36_i16 = 0; c36_i16 < 3; c36_i16++) {
    c36_b_inData[c36_i16] = (*(real_T (*)[3])c36_inData)[c36_i16];
  }

  for (c36_i17 = 0; c36_i17 < 3; c36_i17++) {
    c36_u[c36_i17] = c36_b_inData[c36_i17];
  }

  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", c36_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static void c36_c_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId, real_T c36_y[3])
{
  real_T c36_dv4[3];
  int32_T c36_i18;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), c36_dv4, 1, 0, 0U, 1, 0U, 1, 3);
  for (c36_i18 = 0; c36_i18 < 3; c36_i18++) {
    c36_y[c36_i18] = c36_dv4[c36_i18];
  }

  sf_mex_destroy(&c36_u);
}

static void c36_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_b_droop_voltage;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  real_T c36_y[3];
  int32_T c36_i19;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_b_droop_voltage = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_b_droop_voltage),
    &c36_thisId, c36_y);
  sf_mex_destroy(&c36_b_droop_voltage);
  for (c36_i19 = 0; c36_i19 < 3; c36_i19++) {
    (*(real_T (*)[3])c36_outData)[c36_i19] = c36_y[c36_i19];
  }

  sf_mex_destroy(&c36_mxArrayInData);
}

static const mxArray *c36_c_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_i20;
  real_T c36_b_inData[4];
  int32_T c36_i21;
  real_T c36_u[4];
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  for (c36_i20 = 0; c36_i20 < 4; c36_i20++) {
    c36_b_inData[c36_i20] = (*(real_T (*)[4])c36_inData)[c36_i20];
  }

  for (c36_i21 = 0; c36_i21 < 4; c36_i21++) {
    c36_u[c36_i21] = c36_b_inData[c36_i21];
  }

  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", c36_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

const mxArray
  *sf_c36_SimulationPlantModel_CommercialSystem_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c36_nameCaptureInfo;
  c36_ResolvedFunctionInfo c36_info[8];
  c36_ResolvedFunctionInfo (*c36_b_info)[8];
  const mxArray *c36_m0 = NULL;
  int32_T c36_i22;
  c36_ResolvedFunctionInfo *c36_r0;
  c36_nameCaptureInfo = NULL;
  c36_nameCaptureInfo = NULL;
  c36_b_info = (c36_ResolvedFunctionInfo (*)[8])c36_info;
  (*c36_b_info)[0].context = "";
  (*c36_b_info)[0].name = "sqrt";
  (*c36_b_info)[0].dominantType = "double";
  (*c36_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  (*c36_b_info)[0].fileTimeLo = 1343830386U;
  (*c36_b_info)[0].fileTimeHi = 0U;
  (*c36_b_info)[0].mFileTimeLo = 0U;
  (*c36_b_info)[0].mFileTimeHi = 0U;
  (*c36_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  (*c36_b_info)[1].name = "eml_error";
  (*c36_b_info)[1].dominantType = "char";
  (*c36_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  (*c36_b_info)[1].fileTimeLo = 1343830358U;
  (*c36_b_info)[1].fileTimeHi = 0U;
  (*c36_b_info)[1].mFileTimeLo = 0U;
  (*c36_b_info)[1].mFileTimeHi = 0U;
  (*c36_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  (*c36_b_info)[2].name = "eml_scalar_sqrt";
  (*c36_b_info)[2].dominantType = "double";
  (*c36_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  (*c36_b_info)[2].fileTimeLo = 1286818738U;
  (*c36_b_info)[2].fileTimeHi = 0U;
  (*c36_b_info)[2].mFileTimeLo = 0U;
  (*c36_b_info)[2].mFileTimeHi = 0U;
  (*c36_b_info)[3].context = "";
  (*c36_b_info)[3].name = "mrdivide";
  (*c36_b_info)[3].dominantType = "double";
  (*c36_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c36_b_info)[3].fileTimeLo = 1357951548U;
  (*c36_b_info)[3].fileTimeHi = 0U;
  (*c36_b_info)[3].mFileTimeLo = 1319729966U;
  (*c36_b_info)[3].mFileTimeHi = 0U;
  (*c36_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c36_b_info)[4].name = "rdivide";
  (*c36_b_info)[4].dominantType = "double";
  (*c36_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c36_b_info)[4].fileTimeLo = 1346510388U;
  (*c36_b_info)[4].fileTimeHi = 0U;
  (*c36_b_info)[4].mFileTimeLo = 0U;
  (*c36_b_info)[4].mFileTimeHi = 0U;
  (*c36_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c36_b_info)[5].name = "eml_scalexp_compatible";
  (*c36_b_info)[5].dominantType = "double";
  (*c36_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  (*c36_b_info)[5].fileTimeLo = 1286818796U;
  (*c36_b_info)[5].fileTimeHi = 0U;
  (*c36_b_info)[5].mFileTimeLo = 0U;
  (*c36_b_info)[5].mFileTimeHi = 0U;
  (*c36_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c36_b_info)[6].name = "eml_div";
  (*c36_b_info)[6].dominantType = "double";
  (*c36_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c36_b_info)[6].fileTimeLo = 1313347810U;
  (*c36_b_info)[6].fileTimeHi = 0U;
  (*c36_b_info)[6].mFileTimeLo = 0U;
  (*c36_b_info)[6].mFileTimeHi = 0U;
  (*c36_b_info)[7].context = "";
  (*c36_b_info)[7].name = "mtimes";
  (*c36_b_info)[7].dominantType = "double";
  (*c36_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c36_b_info)[7].fileTimeLo = 1289519692U;
  (*c36_b_info)[7].fileTimeHi = 0U;
  (*c36_b_info)[7].mFileTimeLo = 0U;
  (*c36_b_info)[7].mFileTimeHi = 0U;
  sf_mex_assign(&c36_m0, sf_mex_createstruct("nameCaptureInfo", 1, 8), FALSE);
  for (c36_i22 = 0; c36_i22 < 8; c36_i22++) {
    c36_r0 = &c36_info[c36_i22];
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo", c36_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c36_r0->context)), "context", "nameCaptureInfo",
                    c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo", c36_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c36_r0->name)), "name", "nameCaptureInfo",
                    c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo",
      c36_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c36_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo", c36_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c36_r0->resolved)), "resolved",
                    "nameCaptureInfo", c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo", &c36_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo", &c36_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo",
      &c36_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c36_i22);
    sf_mex_addfield(c36_m0, sf_mex_create("nameCaptureInfo",
      &c36_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c36_i22);
  }

  sf_mex_assign(&c36_nameCaptureInfo, c36_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c36_nameCaptureInfo);
  return c36_nameCaptureInfo;
}

static const mxArray *c36_d_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_u;
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_u = *(int32_T *)c36_inData;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", &c36_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static int32_T c36_d_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  int32_T c36_y;
  int32_T c36_i23;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_i23, 1, 6, 0U, 0, 0U, 0);
  c36_y = c36_i23;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void c36_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_b_sfEvent;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  int32_T c36_y;
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    chartInstanceVoid;
  c36_b_sfEvent = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_b_sfEvent),
    &c36_thisId);
  sf_mex_destroy(&c36_b_sfEvent);
  *(int32_T *)c36_outData = c36_y;
  sf_mex_destroy(&c36_mxArrayInData);
}

static uint8_T c36_e_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_b_is_active_c36_SimulationPlantModel_CommercialSystem,
   const char_T *c36_identifier)
{
  uint8_T c36_y;
  emlrtMsgIdentifier c36_thisId;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c36_b_is_active_c36_SimulationPlantModel_CommercialSystem), &c36_thisId);
  sf_mex_destroy(&c36_b_is_active_c36_SimulationPlantModel_CommercialSystem);
  return c36_y;
}

static uint8_T c36_f_emlrt_marshallIn
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   const mxArray *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  uint8_T c36_y;
  uint8_T c36_u0;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_u0, 1, 3, 0U, 0, 0U, 0);
  c36_y = c36_u0;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static real_T c36_get_CB1
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   uint32_T c36_b)
{
  ssReadFromDataStoreElement(chartInstance->S, 0, NULL, c36_b);
  if (chartInstance->c36_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#593) in the initialization routine of the chart.\n");
  }

  return *chartInstance->c36_CB1_address;
}

static void c36_set_CB1
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   uint32_T c36_b, real_T c36_c)
{
  ssWriteToDataStoreElement(chartInstance->S, 0, NULL, c36_b);
  if (chartInstance->c36_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#593) in the initialization routine of the chart.\n");
  }

  *chartInstance->c36_CB1_address = c36_c;
}

static real_T *c36_access_CB1
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance,
   uint32_T c36_b)
{
  real_T *c36_c;
  ssReadFromDataStore(chartInstance->S, 0, NULL);
  if (chartInstance->c36_CB1_address == 0) {
    sf_mex_error_message("Invalid access to Data Store Memory data \'CB1\' (#593) in the initialization routine of the chart.\n");
  }

  c36_c = chartInstance->c36_CB1_address;
  if (c36_b == 0) {
    ssWriteToDataStore(chartInstance->S, 0, NULL);
  }

  return c36_c;
}

static void init_dsm_address_info
  (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance)
{
  ssGetSFcnDataStoreNameAddrIdx(chartInstance->S, "CB1", (void **)
    &chartInstance->c36_CB1_address, &chartInstance->c36_CB1_index);
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c36_SimulationPlantModel_CommercialSystem_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(996203865U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3501853704U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(28536924U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(980136921U);
}

mxArray *sf_c36_SimulationPlantModel_CommercialSystem_get_autoinheritance_info
  (void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("y8lp57Z4DFYMdCboTSZj8C");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,10,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c36_SimulationPlantModel_CommercialSystem_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray
  *sf_get_sim_state_info_c36_SimulationPlantModel_CommercialSystem(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x6'type','srcId','name','auxInfo'{{M[1],M[5],T\"StayConnectedG\",},{M[1],M[25],T\"v_max\",},{M[1],M[24],T\"v_min\",},{M[1],M[23],T\"w_max\",},{M[1],M[22],T\"w_min\",},{M[8],M[0],T\"is_active_c36_SimulationPlantModel_CommercialSystem\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 6, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c36_SimulationPlantModel_CommercialSystem_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
    chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_CommercialSystemMachineNumber_,
           36,
           1,
           1,
           19,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_CommercialSystemMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_CommercialSystemMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_CommercialSystemMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"y");
          _SFD_SET_DATA_PROPS(1,1,1,0,"u");
          _SFD_SET_DATA_PROPS(2,2,0,1,"StayConnectedG");
          _SFD_SET_DATA_PROPS(3,1,1,0,"time");
          _SFD_SET_DATA_PROPS(4,10,0,0,"DisconnectWhenFaultDetected");
          _SFD_SET_DATA_PROPS(5,10,0,0,"omega_noload");
          _SFD_SET_DATA_PROPS(6,10,0,0,"droop_speed");
          _SFD_SET_DATA_PROPS(7,10,0,0,"D_omega_max");
          _SFD_SET_DATA_PROPS(8,10,0,0,"D_omega_min");
          _SFD_SET_DATA_PROPS(9,11,0,0,"CB1");
          _SFD_SET_DATA_PROPS(10,10,0,0,"v_noload");
          _SFD_SET_DATA_PROPS(11,10,0,0,"droop_voltage");
          _SFD_SET_DATA_PROPS(12,10,0,0,"D_v_max");
          _SFD_SET_DATA_PROPS(13,10,0,0,"D_v_min");
          _SFD_SET_DATA_PROPS(14,2,0,1,"w_min");
          _SFD_SET_DATA_PROPS(15,2,0,1,"w_max");
          _SFD_SET_DATA_PROPS(16,2,0,1,"v_min");
          _SFD_SET_DATA_PROPS(17,2,0,1,"v_max");
          _SFD_SET_DATA_PROPS(18,10,0,0,"FaultDetectionInitTime");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,0,6,3);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,921);
        _SFD_CV_INIT_EML_IF(0,1,0,325,336,-1,364);
        _SFD_CV_INIT_EML_IF(0,1,1,683,752,-1,915);
        _SFD_CV_INIT_EML_IF(0,1,2,757,792,-1,828);
        _SFD_CV_INIT_EML_IF(0,1,3,834,875,-1,911);

        {
          static int condStart[] = { 686, 722 };

          static int condEnd[] = { 718, 752 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,686,752,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 760, 778 };

          static int condEnd[] = { 774, 792 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,760,792,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 837, 858 };

          static int condEnd[] = { 854, 875 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,837,875,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)
            c36_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)
            c36_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)
            c36_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)
            c36_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(18,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);

        {
          real_T *c36_StayConnectedG;
          real_T *c36_time;
          real_T *c36_w_min;
          real_T *c36_w_max;
          real_T *c36_v_min;
          real_T *c36_v_max;
          real_T (*c36_y)[3];
          real_T (*c36_u)[4];
          c36_v_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c36_v_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c36_w_max = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c36_w_min = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c36_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S,
            1);
          c36_u = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c36_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c36_y);
          _SFD_SET_DATA_VALUE_PTR(1U, *c36_u);
          _SFD_SET_DATA_VALUE_PTR(2U, c36_StayConnectedG);
          _SFD_SET_DATA_VALUE_PTR(3U, c36_time);
          _SFD_SET_DATA_VALUE_PTR(4U,
            &chartInstance->c36_DisconnectWhenFaultDetected);
          _SFD_SET_DATA_VALUE_PTR(5U, chartInstance->c36_omega_noload);
          _SFD_SET_DATA_VALUE_PTR(6U, chartInstance->c36_droop_speed);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance->c36_D_omega_max);
          _SFD_SET_DATA_VALUE_PTR(8U, &chartInstance->c36_D_omega_min);
          _SFD_SET_DATA_VALUE_PTR(9U, chartInstance->c36_CB1_address);
          _SFD_SET_DATA_VALUE_PTR(10U, chartInstance->c36_v_noload);
          _SFD_SET_DATA_VALUE_PTR(11U, chartInstance->c36_droop_voltage);
          _SFD_SET_DATA_VALUE_PTR(12U, &chartInstance->c36_D_v_max);
          _SFD_SET_DATA_VALUE_PTR(13U, &chartInstance->c36_D_v_min);
          _SFD_SET_DATA_VALUE_PTR(14U, c36_w_min);
          _SFD_SET_DATA_VALUE_PTR(15U, c36_w_max);
          _SFD_SET_DATA_VALUE_PTR(16U, c36_v_min);
          _SFD_SET_DATA_VALUE_PTR(17U, c36_v_max);
          _SFD_SET_DATA_VALUE_PTR(18U,
            &chartInstance->c36_FaultDetectionInitTime);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_CommercialSystemMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "5XjRdTfyr5EEpW01DsXS8F";
}

static void sf_opaque_initialize_c36_SimulationPlantModel_CommercialSystem(void *
  chartInstanceVar)
{
  chart_debug_initialization
    (((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
      chartInstanceVar)->S,0);
  initialize_params_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
  initialize_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_enable_c36_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  enable_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_disable_c36_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  disable_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_gateway_c36_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  sf_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c36_SimulationPlantModel_CommercialSystem(SimStruct*
  S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c36_SimulationPlantModel_CommercialSystem();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c36_SimulationPlantModel_CommercialSystem
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c36_SimulationPlantModel_CommercialSystem();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray*
  sf_opaque_get_sim_state_c36_SimulationPlantModel_CommercialSystem(SimStruct* S)
{
  return sf_internal_get_sim_state_c36_SimulationPlantModel_CommercialSystem(S);
}

static void sf_opaque_set_sim_state_c36_SimulationPlantModel_CommercialSystem
  (SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c36_SimulationPlantModel_CommercialSystem(S, st);
}

static void sf_opaque_terminate_c36_SimulationPlantModel_CommercialSystem(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_CommercialSystem_optimization_info();
    }

    finalize_c36_SimulationPlantModel_CommercialSystem
      ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
       chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc36_SimulationPlantModel_CommercialSystem
    ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
     chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c36_SimulationPlantModel_CommercialSystem
  (SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c36_SimulationPlantModel_CommercialSystem
      ((SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*)
       (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c36_SimulationPlantModel_CommercialSystem(SimStruct
  *S)
{
  /* Actual parameters from chart:
     D_omega_max D_omega_min D_v_max D_v_min DisconnectWhenFaultDetected FaultDetectionInitTime droop_speed droop_voltage omega_noload v_noload
   */
  const char_T *rtParamNames[] = { "D_omega_max", "D_omega_min", "D_v_max",
    "D_v_min", "DisconnectWhenFaultDetected", "FaultDetectionInitTime",
    "droop_speed", "droop_voltage", "omega_noload", "v_noload" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for D_omega_max*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for D_omega_min*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for D_v_max*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for D_v_min*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for DisconnectWhenFaultDetected*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for FaultDetectionInitTime*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);

  /* registration for droop_speed*/
  ssRegDlgParamAsRunTimeParam(S, 6, 6, rtParamNames[6], SS_DOUBLE);

  /* registration for droop_voltage*/
  ssRegDlgParamAsRunTimeParam(S, 7, 7, rtParamNames[7], SS_DOUBLE);

  /* registration for omega_noload*/
  ssRegDlgParamAsRunTimeParam(S, 8, 8, rtParamNames[8], SS_DOUBLE);

  /* registration for v_noload*/
  ssRegDlgParamAsRunTimeParam(S, 9, 9, rtParamNames[9], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct =
      load_SimulationPlantModel_CommercialSystem_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      36);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,36,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,36,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,36);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,36,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,36,5);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=5; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,36);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(465686470U));
  ssSetChecksum1(S,(3296926540U));
  ssSetChecksum2(S,(1704863645U));
  ssSetChecksum3(S,(2358266461U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,0);
}

static void mdlRTW_c36_SimulationPlantModel_CommercialSystem(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c36_SimulationPlantModel_CommercialSystem(SimStruct *S)
{
  SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct *)
    utMalloc(sizeof(SFc36_SimulationPlantModel_CommercialSystemInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc36_SimulationPlantModel_CommercialSystemInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW =
    mdlRTW_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.mdlStart =
    mdlStart_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c36_SimulationPlantModel_CommercialSystem;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c36_SimulationPlantModel_CommercialSystem_method_dispatcher(SimStruct *S,
  int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c36_SimulationPlantModel_CommercialSystem(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c36_SimulationPlantModel_CommercialSystem(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c36_SimulationPlantModel_CommercialSystem(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c36_SimulationPlantModel_CommercialSystem_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
