#ifndef __c36_SimulationPlantModel_CommercialSystem_h__
#define __c36_SimulationPlantModel_CommercialSystem_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c36_ResolvedFunctionInfo
#define typedef_c36_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c36_ResolvedFunctionInfo;

#endif                                 /*typedef_c36_ResolvedFunctionInfo*/

#ifndef typedef_SFc36_SimulationPlantModel_CommercialSystemInstanceStruct
#define typedef_SFc36_SimulationPlantModel_CommercialSystemInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c36_sfEvent;
  boolean_T c36_isStable;
  boolean_T c36_doneDoubleBufferReInit;
  uint8_T c36_is_active_c36_SimulationPlantModel_CommercialSystem;
  real_T c36_DisconnectWhenFaultDetected;
  real_T c36_omega_noload[3];
  real_T c36_droop_speed[3];
  real_T c36_D_omega_max;
  real_T c36_D_omega_min;
  real_T c36_v_noload[3];
  real_T c36_droop_voltage[3];
  real_T c36_D_v_max;
  real_T c36_D_v_min;
  real_T c36_FaultDetectionInitTime;
  real_T *c36_CB1_address;
  int32_T c36_CB1_index;
} SFc36_SimulationPlantModel_CommercialSystemInstanceStruct;

#endif                                 /*typedef_SFc36_SimulationPlantModel_CommercialSystemInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c36_SimulationPlantModel_CommercialSystem_get_eml_resolved_functions_info
  (void);

/* Function Definitions */
extern void sf_c36_SimulationPlantModel_CommercialSystem_get_check_sum(mxArray
  *plhs[]);
extern void c36_SimulationPlantModel_CommercialSystem_method_dispatcher
  (SimStruct *S, int_T method, void *data);

#endif
