/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Kalman_sfun.h"
#include "c36_SimulationPlantModel_Kalman.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Kalman_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c36_debug_family_names[14] = { "diff_omega_max",
  "diff_omega_min", "diff_p_max", "diff_p_min", "diff_q_max", "diff_q_min",
  "nargin", "nargout", "tilde_omega", "tilde_p", "tilde_q", "diff_y",
  "DisconnectWhenFaultDetected", "StayConnectedG" };

/* Function Declarations */
static void initialize_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initialize_params_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void enable_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void disable_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c36_update_debugger_state_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void set_sim_state_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_st);
static void finalize_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void sf_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initSimStructsc36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void registerMessagesc36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c36_machineNumber, uint32_T
  c36_chartNumber);
static const mxArray *c36_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static real_T c36_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_StayConnectedG, const char_T *c36_identifier);
static real_T c36_b_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void c36_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static const mxArray *c36_b_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static void c36_c_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId, real_T c36_y[6]);
static void c36_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static const mxArray *c36_c_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData);
static int32_T c36_d_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void c36_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData);
static uint8_T c36_e_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_b_is_active_c36_SimulationPlantModel_Kalman, const char_T
   *c36_identifier);
static uint8_T c36_f_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId);
static void init_dsm_address_info
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  chartInstance->c36_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c36_is_active_c36_SimulationPlantModel_Kalman = 0U;
}

static void initialize_params_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c36_dv0[6];
  int32_T c36_i0;
  real_T c36_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'diff_y' in the parent workspace.\n");
  sf_mex_import_named("diff_y", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                      c36_dv0, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c36_i0 = 0; c36_i0 < 6; c36_i0++) {
    chartInstance->c36_diff_y[c36_i0] = c36_dv0[c36_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'DisconnectWhenFaultDetected' in the parent workspace.\n");
  sf_mex_import_named("DisconnectWhenFaultDetected", sf_mex_get_sfun_param
                      (chartInstance->S, 0, 0), &c36_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c36_DisconnectWhenFaultDetected = c36_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c36_update_debugger_state_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  const mxArray *c36_st;
  const mxArray *c36_y = NULL;
  real_T c36_hoistedGlobal;
  real_T c36_u;
  const mxArray *c36_b_y = NULL;
  uint8_T c36_b_hoistedGlobal;
  uint8_T c36_b_u;
  const mxArray *c36_c_y = NULL;
  real_T *c36_StayConnectedG;
  c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c36_st = NULL;
  c36_st = NULL;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_createcellarray(2), FALSE);
  c36_hoistedGlobal = *c36_StayConnectedG;
  c36_u = c36_hoistedGlobal;
  c36_b_y = NULL;
  sf_mex_assign(&c36_b_y, sf_mex_create("y", &c36_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 0, c36_b_y);
  c36_b_hoistedGlobal =
    chartInstance->c36_is_active_c36_SimulationPlantModel_Kalman;
  c36_b_u = c36_b_hoistedGlobal;
  c36_c_y = NULL;
  sf_mex_assign(&c36_c_y, sf_mex_create("y", &c36_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c36_y, 1, c36_c_y);
  sf_mex_assign(&c36_st, c36_y, FALSE);
  return c36_st;
}

static void set_sim_state_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_st)
{
  const mxArray *c36_u;
  real_T *c36_StayConnectedG;
  c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c36_doneDoubleBufferReInit = TRUE;
  c36_u = sf_mex_dup(c36_st);
  *c36_StayConnectedG = c36_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c36_u, 0)), "StayConnectedG");
  chartInstance->c36_is_active_c36_SimulationPlantModel_Kalman =
    c36_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c36_u, 1)),
    "is_active_c36_SimulationPlantModel_Kalman");
  sf_mex_destroy(&c36_u);
  c36_update_debugger_state_c36_SimulationPlantModel_Kalman(chartInstance);
  sf_mex_destroy(&c36_st);
}

static void finalize_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void sf_c36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  int32_T c36_i1;
  real_T c36_hoistedGlobal;
  real_T c36_b_hoistedGlobal;
  real_T c36_c_hoistedGlobal;
  real_T c36_d_hoistedGlobal;
  real_T c36_tilde_omega;
  real_T c36_tilde_p;
  real_T c36_tilde_q;
  int32_T c36_i2;
  real_T c36_b_diff_y[6];
  real_T c36_b_DisconnectWhenFaultDetected;
  uint32_T c36_debug_family_var_map[14];
  real_T c36_diff_omega_max;
  real_T c36_diff_omega_min;
  real_T c36_diff_p_max;
  real_T c36_diff_p_min;
  real_T c36_diff_q_max;
  real_T c36_diff_q_min;
  real_T c36_nargin = 5.0;
  real_T c36_nargout = 1.0;
  real_T c36_StayConnectedG;
  real_T *c36_b_tilde_omega;
  real_T *c36_b_StayConnectedG;
  real_T *c36_b_tilde_p;
  real_T *c36_b_tilde_q;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  c36_b_tilde_q = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c36_b_tilde_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c36_b_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c36_b_tilde_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c36_b_tilde_omega, 0U);
  _SFD_DATA_RANGE_CHECK(*c36_b_StayConnectedG, 1U);
  _SFD_DATA_RANGE_CHECK(*c36_b_tilde_p, 2U);
  _SFD_DATA_RANGE_CHECK(*c36_b_tilde_q, 3U);
  for (c36_i1 = 0; c36_i1 < 6; c36_i1++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c36_diff_y[c36_i1], 4U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c36_DisconnectWhenFaultDetected, 5U);
  chartInstance->c36_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  c36_hoistedGlobal = *c36_b_tilde_omega;
  c36_b_hoistedGlobal = *c36_b_tilde_p;
  c36_c_hoistedGlobal = *c36_b_tilde_q;
  c36_d_hoistedGlobal = chartInstance->c36_DisconnectWhenFaultDetected;
  c36_tilde_omega = c36_hoistedGlobal;
  c36_tilde_p = c36_b_hoistedGlobal;
  c36_tilde_q = c36_c_hoistedGlobal;
  for (c36_i2 = 0; c36_i2 < 6; c36_i2++) {
    c36_b_diff_y[c36_i2] = chartInstance->c36_diff_y[c36_i2];
  }

  c36_b_DisconnectWhenFaultDetected = c36_d_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 14U, 14U, c36_debug_family_names,
    c36_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_omega_max, 0U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_omega_min, 1U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_p_max, 2U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_p_min, 3U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_q_max, 4U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_diff_q_min, 5U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_nargin, 6U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_nargout, 7U, c36_sf_marshallOut,
    c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_tilde_omega, 8U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_tilde_p, 9U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c36_tilde_q, 10U, c36_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c36_b_diff_y, 11U, c36_b_sf_marshallOut,
    c36_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_b_DisconnectWhenFaultDetected, 12U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c36_StayConnectedG, 13U,
    c36_sf_marshallOut, c36_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 3);
  c36_diff_omega_max = c36_b_diff_y[3];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 4);
  c36_diff_omega_min = c36_b_diff_y[0];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 5);
  c36_diff_p_max = c36_b_diff_y[4];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 6);
  c36_diff_p_min = c36_b_diff_y[1];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 7);
  c36_diff_q_max = c36_b_diff_y[5];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 8);
  c36_diff_q_min = c36_b_diff_y[2];
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 10);
  c36_StayConnectedG = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 11);
  if (CV_EML_IF(0, 1, 0, c36_b_DisconnectWhenFaultDetected == 1.0)) {
    _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 12);
    guard1 = FALSE;
    if (CV_EML_COND(0, 1, 0, c36_tilde_omega >= c36_diff_omega_max)) {
      guard1 = TRUE;
    } else if (CV_EML_COND(0, 1, 1, c36_tilde_omega <= c36_diff_omega_min)) {
      guard1 = TRUE;
    } else {
      CV_EML_MCDC(0, 1, 0, FALSE);
      CV_EML_IF(0, 1, 1, FALSE);
      _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 14);
      guard2 = FALSE;
      if (CV_EML_COND(0, 1, 2, c36_tilde_p >= c36_diff_p_max)) {
        guard2 = TRUE;
      } else if (CV_EML_COND(0, 1, 3, c36_tilde_p <= c36_diff_p_min)) {
        guard2 = TRUE;
      } else {
        CV_EML_MCDC(0, 1, 1, FALSE);
        CV_EML_IF(0, 1, 2, FALSE);
        _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 16);
        guard3 = FALSE;
        if (CV_EML_COND(0, 1, 4, c36_tilde_q >= c36_diff_q_max)) {
          guard3 = TRUE;
        } else if (CV_EML_COND(0, 1, 5, c36_tilde_q <= c36_diff_q_min)) {
          guard3 = TRUE;
        } else {
          CV_EML_MCDC(0, 1, 2, FALSE);
          CV_EML_IF(0, 1, 3, FALSE);
        }

        if (guard3 == TRUE) {
          CV_EML_MCDC(0, 1, 2, TRUE);
          CV_EML_IF(0, 1, 3, TRUE);
          _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 17);
          c36_StayConnectedG = 0.0;
        }
      }

      if (guard2 == TRUE) {
        CV_EML_MCDC(0, 1, 1, TRUE);
        CV_EML_IF(0, 1, 2, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 15);
        c36_StayConnectedG = 0.0;
      }
    }

    if (guard1 == TRUE) {
      CV_EML_MCDC(0, 1, 0, TRUE);
      CV_EML_IF(0, 1, 1, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, 13);
      c36_StayConnectedG = 0.0;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c36_sfEvent, -17);
  _SFD_SYMBOL_SCOPE_POP();
  *c36_b_StayConnectedG = c36_StayConnectedG;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 35U, chartInstance->c36_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_SimulationPlantModel_KalmanMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void registerMessagesc36_SimulationPlantModel_Kalman
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c36_machineNumber, uint32_T
  c36_chartNumber)
{
}

static const mxArray *c36_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  real_T c36_u;
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_u = *(real_T *)c36_inData;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", &c36_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static real_T c36_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_StayConnectedG, const char_T *c36_identifier)
{
  real_T c36_y;
  emlrtMsgIdentifier c36_thisId;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_StayConnectedG),
    &c36_thisId);
  sf_mex_destroy(&c36_StayConnectedG);
  return c36_y;
}

static real_T c36_b_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  real_T c36_y;
  real_T c36_d1;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_d1, 1, 0, 0U, 0, 0U, 0);
  c36_y = c36_d1;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void c36_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_StayConnectedG;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  real_T c36_y;
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c36_StayConnectedG = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_StayConnectedG),
    &c36_thisId);
  sf_mex_destroy(&c36_StayConnectedG);
  *(real_T *)c36_outData = c36_y;
  sf_mex_destroy(&c36_mxArrayInData);
}

static const mxArray *c36_b_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_i3;
  int32_T c36_i4;
  int32_T c36_i5;
  real_T c36_b_inData[6];
  int32_T c36_i6;
  int32_T c36_i7;
  int32_T c36_i8;
  real_T c36_u[6];
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_i3 = 0;
  for (c36_i4 = 0; c36_i4 < 2; c36_i4++) {
    for (c36_i5 = 0; c36_i5 < 3; c36_i5++) {
      c36_b_inData[c36_i5 + c36_i3] = (*(real_T (*)[6])c36_inData)[c36_i5 +
        c36_i3];
    }

    c36_i3 += 3;
  }

  c36_i6 = 0;
  for (c36_i7 = 0; c36_i7 < 2; c36_i7++) {
    for (c36_i8 = 0; c36_i8 < 3; c36_i8++) {
      c36_u[c36_i8 + c36_i6] = c36_b_inData[c36_i8 + c36_i6];
    }

    c36_i6 += 3;
  }

  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", c36_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static void c36_c_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId, real_T c36_y[6])
{
  real_T c36_dv1[6];
  int32_T c36_i9;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), c36_dv1, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c36_i9 = 0; c36_i9 < 6; c36_i9++) {
    c36_y[c36_i9] = c36_dv1[c36_i9];
  }

  sf_mex_destroy(&c36_u);
}

static void c36_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_b_diff_y;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  real_T c36_y[6];
  int32_T c36_i10;
  int32_T c36_i11;
  int32_T c36_i12;
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c36_b_diff_y = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_b_diff_y), &c36_thisId,
    c36_y);
  sf_mex_destroy(&c36_b_diff_y);
  c36_i10 = 0;
  for (c36_i11 = 0; c36_i11 < 2; c36_i11++) {
    for (c36_i12 = 0; c36_i12 < 3; c36_i12++) {
      (*(real_T (*)[6])c36_outData)[c36_i12 + c36_i10] = c36_y[c36_i12 + c36_i10];
    }

    c36_i10 += 3;
  }

  sf_mex_destroy(&c36_mxArrayInData);
}

const mxArray
  *sf_c36_SimulationPlantModel_Kalman_get_eml_resolved_functions_info(void)
{
  const mxArray *c36_nameCaptureInfo = NULL;
  c36_nameCaptureInfo = NULL;
  sf_mex_assign(&c36_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c36_nameCaptureInfo;
}

static const mxArray *c36_c_sf_marshallOut(void *chartInstanceVoid, void
  *c36_inData)
{
  const mxArray *c36_mxArrayOutData = NULL;
  int32_T c36_u;
  const mxArray *c36_y = NULL;
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c36_mxArrayOutData = NULL;
  c36_u = *(int32_T *)c36_inData;
  c36_y = NULL;
  sf_mex_assign(&c36_y, sf_mex_create("y", &c36_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c36_mxArrayOutData, c36_y, FALSE);
  return c36_mxArrayOutData;
}

static int32_T c36_d_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  int32_T c36_y;
  int32_T c36_i13;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_i13, 1, 6, 0U, 0, 0U, 0);
  c36_y = c36_i13;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void c36_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c36_mxArrayInData, const char_T *c36_varName, void *c36_outData)
{
  const mxArray *c36_b_sfEvent;
  const char_T *c36_identifier;
  emlrtMsgIdentifier c36_thisId;
  int32_T c36_y;
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c36_b_sfEvent = sf_mex_dup(c36_mxArrayInData);
  c36_identifier = c36_varName;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c36_b_sfEvent),
    &c36_thisId);
  sf_mex_destroy(&c36_b_sfEvent);
  *(int32_T *)c36_outData = c36_y;
  sf_mex_destroy(&c36_mxArrayInData);
}

static uint8_T c36_e_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_b_is_active_c36_SimulationPlantModel_Kalman, const char_T
   *c36_identifier)
{
  uint8_T c36_y;
  emlrtMsgIdentifier c36_thisId;
  c36_thisId.fIdentifier = c36_identifier;
  c36_thisId.fParent = NULL;
  c36_y = c36_f_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c36_b_is_active_c36_SimulationPlantModel_Kalman), &c36_thisId);
  sf_mex_destroy(&c36_b_is_active_c36_SimulationPlantModel_Kalman);
  return c36_y;
}

static uint8_T c36_f_emlrt_marshallIn
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c36_u, const emlrtMsgIdentifier *c36_parentId)
{
  uint8_T c36_y;
  uint8_T c36_u0;
  sf_mex_import(c36_parentId, sf_mex_dup(c36_u), &c36_u0, 1, 3, 0U, 0, 0U, 0);
  c36_y = c36_u0;
  sf_mex_destroy(&c36_u);
  return c36_y;
}

static void init_dsm_address_info
  (SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c36_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1357272412U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2142269936U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1566477838U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1170681469U);
}

mxArray *sf_c36_SimulationPlantModel_Kalman_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("UwFvia5niwP3oqS8QeOflE");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c36_SimulationPlantModel_Kalman_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c36_SimulationPlantModel_Kalman(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"StayConnectedG\",},{M[8],M[0],T\"is_active_c36_SimulationPlantModel_Kalman\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c36_SimulationPlantModel_Kalman_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
    chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_KalmanMachineNumber_,
           36,
           1,
           1,
           6,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_KalmanMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"tilde_omega");
          _SFD_SET_DATA_PROPS(1,2,0,1,"StayConnectedG");
          _SFD_SET_DATA_PROPS(2,1,1,0,"tilde_p");
          _SFD_SET_DATA_PROPS(3,1,1,0,"tilde_q");
          _SFD_SET_DATA_PROPS(4,10,0,0,"diff_y");
          _SFD_SET_DATA_PROPS(5,10,0,0,"DisconnectWhenFaultDetected");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,4,0,0,0,0,0,6,3);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,601);
        _SFD_CV_INIT_EML_IF(0,1,0,280,315,-1,597);
        _SFD_CV_INIT_EML_IF(0,1,1,320,385,418,471);
        _SFD_CV_INIT_EML_IF(0,1,2,418,471,504,593);
        _SFD_CV_INIT_EML_IF(0,1,3,504,557,-1,557);

        {
          static int condStart[] = { 323, 356 };

          static int condEnd[] = { 352, 385 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,323,385,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 425, 450 };

          static int condEnd[] = { 446, 471 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,425,471,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 511, 536 };

          static int condEnd[] = { 532, 557 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,511,557,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c36_b_sf_marshallOut,(MexInFcnForType)
            c36_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c36_sf_marshallOut,(MexInFcnForType)c36_sf_marshallIn);

        {
          real_T *c36_tilde_omega;
          real_T *c36_StayConnectedG;
          real_T *c36_tilde_p;
          real_T *c36_tilde_q;
          c36_tilde_q = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c36_tilde_p = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c36_StayConnectedG = (real_T *)ssGetOutputPortSignal(chartInstance->S,
            1);
          c36_tilde_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c36_tilde_omega);
          _SFD_SET_DATA_VALUE_PTR(1U, c36_StayConnectedG);
          _SFD_SET_DATA_VALUE_PTR(2U, c36_tilde_p);
          _SFD_SET_DATA_VALUE_PTR(3U, c36_tilde_q);
          _SFD_SET_DATA_VALUE_PTR(4U, chartInstance->c36_diff_y);
          _SFD_SET_DATA_VALUE_PTR(5U,
            &chartInstance->c36_DisconnectWhenFaultDetected);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_KalmanMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "jP2hehs3B2a3xr99s1N8PG";
}

static void sf_opaque_initialize_c36_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc36_SimulationPlantModel_KalmanInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
  initialize_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c36_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  enable_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c36_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  disable_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c36_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  sf_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c36_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c36_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c36_SimulationPlantModel_Kalman(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c36_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c36_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c36_SimulationPlantModel_Kalman(S);
}

static void sf_opaque_set_sim_state_c36_SimulationPlantModel_Kalman(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c36_SimulationPlantModel_Kalman(S, st);
}

static void sf_opaque_terminate_c36_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc36_SimulationPlantModel_KalmanInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Kalman_optimization_info();
    }

    finalize_c36_SimulationPlantModel_Kalman
      ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc36_SimulationPlantModel_Kalman
    ((SFc36_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c36_SimulationPlantModel_Kalman(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c36_SimulationPlantModel_Kalman
      ((SFc36_SimulationPlantModel_KalmanInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c36_SimulationPlantModel_Kalman(SimStruct *S)
{
  /* Actual parameters from chart:
     DisconnectWhenFaultDetected diff_y
   */
  const char_T *rtParamNames[] = { "DisconnectWhenFaultDetected", "diff_y" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for DisconnectWhenFaultDetected*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for diff_y*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Kalman_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      36);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,36,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,36,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,36);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,36,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,36,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,36);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2620924715U));
  ssSetChecksum1(S,(3388963037U));
  ssSetChecksum2(S,(2919630829U));
  ssSetChecksum3(S,(2593515218U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c36_SimulationPlantModel_Kalman(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c36_SimulationPlantModel_Kalman(SimStruct *S)
{
  SFc36_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc36_SimulationPlantModel_KalmanInstanceStruct *)utMalloc
    (sizeof(SFc36_SimulationPlantModel_KalmanInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc36_SimulationPlantModel_KalmanInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlStart = mdlStart_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c36_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c36_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c36_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c36_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c36_SimulationPlantModel_Kalman(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c36_SimulationPlantModel_Kalman_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
