/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Kalman_sfun.h"
#include "c34_SimulationPlantModel_Kalman.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Kalman_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c34_debug_family_names[55] = { "a", "b", "c", "d", "e", "g",
  "h", "k", "m", "n", "x_01", "x_02", "x_03", "x_04", "u_01", "u_02", "u_03",
  "u_04", "x1", "x2", "x3", "x4", "x", "A", "B", "C", "D", "K", "d_x", "r",
  "nargin", "nargout", "y", "u_vector", "delta", "omega", "t_m", "i_f", "x_0",
  "u_0", "H_G", "D_fw_G", "z_G", "tau_e_G", "tau_f_G", "r_f_G",
  "GeneratorNumber", "omega_b", "r1", "r2", "r3", "d_delta", "d_omega", "d_t_m",
  "d_i_f" };

/* Function Declarations */
static void initialize_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initialize_params_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void enable_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void disable_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c34_update_debugger_state_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void set_sim_state_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_st);
static void finalize_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void sf_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c34_chartstep_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initSimStructsc34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void registerMessagesc34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c34_machineNumber, uint32_T
  c34_chartNumber);
static const mxArray *c34_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static real_T c34_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_d_i_f, const char_T *c34_identifier);
static real_T c34_b_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId);
static void c34_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static const mxArray *c34_b_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static void c34_c_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[3]);
static void c34_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static const mxArray *c34_c_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static void c34_d_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[6]);
static void c34_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static const mxArray *c34_d_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static void c34_e_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[4]);
static void c34_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static const mxArray *c34_e_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static const mxArray *c34_f_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static void c34_f_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[12]);
static void c34_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static const mxArray *c34_g_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static void c34_g_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[16]);
static void c34_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static void c34_info_helper(c34_ResolvedFunctionInfo c34_info[21]);
static real_T c34_mpower(SFc34_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c34_a);
static void c34_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance);
static real_T c34_b_mpower(SFc34_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c34_a);
static void c34_b_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static void c34_c_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static void c34_d_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static void c34_e_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static const mxArray *c34_h_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData);
static int32_T c34_h_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId);
static void c34_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData);
static uint8_T c34_i_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_b_is_active_c34_SimulationPlantModel_Kalman, const char_T
   *c34_identifier);
static uint8_T c34_j_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId);
static void init_dsm_address_info
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  chartInstance->c34_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c34_is_active_c34_SimulationPlantModel_Kalman = 0U;
}

static void initialize_params_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c34_dv0[4];
  int32_T c34_i0;
  real_T c34_dv1[4];
  int32_T c34_i1;
  real_T c34_dv2[3];
  int32_T c34_i2;
  real_T c34_dv3[3];
  int32_T c34_i3;
  real_T c34_dv4[6];
  int32_T c34_i4;
  real_T c34_dv5[3];
  int32_T c34_i5;
  real_T c34_dv6[3];
  int32_T c34_i6;
  real_T c34_dv7[3];
  int32_T c34_i7;
  real_T c34_d0;
  real_T c34_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'x_0' in the parent workspace.\n");
  sf_mex_import_named("x_0", sf_mex_get_sfun_param(chartInstance->S, 8, 0),
                      c34_dv0, 0, 0, 0U, 1, 0U, 1, 4);
  for (c34_i0 = 0; c34_i0 < 4; c34_i0++) {
    chartInstance->c34_x_0[c34_i0] = c34_dv0[c34_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'u_0' in the parent workspace.\n");
  sf_mex_import_named("u_0", sf_mex_get_sfun_param(chartInstance->S, 7, 0),
                      c34_dv1, 0, 0, 0U, 1, 0U, 1, 4);
  for (c34_i1 = 0; c34_i1 < 4; c34_i1++) {
    chartInstance->c34_u_0[c34_i1] = c34_dv1[c34_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'H_G' in the parent workspace.\n");
  sf_mex_import_named("H_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c34_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c34_i2 = 0; c34_i2 < 3; c34_i2++) {
    chartInstance->c34_H_G[c34_i2] = c34_dv2[c34_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_fw_G' in the parent workspace.\n");
  sf_mex_import_named("D_fw_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c34_dv3, 0, 0, 0U, 1, 0U, 1, 3);
  for (c34_i3 = 0; c34_i3 < 3; c34_i3++) {
    chartInstance->c34_D_fw_G[c34_i3] = c34_dv3[c34_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'z_G' in the parent workspace.\n");
  sf_mex_import_named("z_G", sf_mex_get_sfun_param(chartInstance->S, 9, 0),
                      c34_dv4, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c34_i4 = 0; c34_i4 < 6; c34_i4++) {
    chartInstance->c34_z_G[c34_i4] = c34_dv4[c34_i4];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_e_G' in the parent workspace.\n");
  sf_mex_import_named("tau_e_G", sf_mex_get_sfun_param(chartInstance->S, 5, 0),
                      c34_dv5, 0, 0, 0U, 1, 0U, 1, 3);
  for (c34_i5 = 0; c34_i5 < 3; c34_i5++) {
    chartInstance->c34_tau_e_G[c34_i5] = c34_dv5[c34_i5];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_f_G' in the parent workspace.\n");
  sf_mex_import_named("tau_f_G", sf_mex_get_sfun_param(chartInstance->S, 6, 0),
                      c34_dv6, 0, 0, 0U, 1, 0U, 1, 3);
  for (c34_i6 = 0; c34_i6 < 3; c34_i6++) {
    chartInstance->c34_tau_f_G[c34_i6] = c34_dv6[c34_i6];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'r_f_G' in the parent workspace.\n");
  sf_mex_import_named("r_f_G", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      c34_dv7, 0, 0, 0U, 1, 0U, 1, 3);
  for (c34_i7 = 0; c34_i7 < 3; c34_i7++) {
    chartInstance->c34_r_f_G[c34_i7] = c34_dv7[c34_i7];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), &c34_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c34_GeneratorNumber = c34_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'omega_b' in the parent workspace.\n");
  sf_mex_import_named("omega_b", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c34_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c34_omega_b = c34_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c34_update_debugger_state_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  const mxArray *c34_st;
  const mxArray *c34_y = NULL;
  real_T c34_hoistedGlobal;
  real_T c34_u;
  const mxArray *c34_b_y = NULL;
  real_T c34_b_hoistedGlobal;
  real_T c34_b_u;
  const mxArray *c34_c_y = NULL;
  real_T c34_c_hoistedGlobal;
  real_T c34_c_u;
  const mxArray *c34_d_y = NULL;
  real_T c34_d_hoistedGlobal;
  real_T c34_d_u;
  const mxArray *c34_e_y = NULL;
  real_T c34_e_hoistedGlobal;
  real_T c34_e_u;
  const mxArray *c34_f_y = NULL;
  real_T c34_f_hoistedGlobal;
  real_T c34_f_u;
  const mxArray *c34_g_y = NULL;
  real_T c34_g_hoistedGlobal;
  real_T c34_g_u;
  const mxArray *c34_h_y = NULL;
  uint8_T c34_h_hoistedGlobal;
  uint8_T c34_h_u;
  const mxArray *c34_i_y = NULL;
  real_T *c34_d_delta;
  real_T *c34_d_i_f;
  real_T *c34_d_omega;
  real_T *c34_d_t_m;
  real_T *c34_r1;
  real_T *c34_r2;
  real_T *c34_r3;
  c34_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c34_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c34_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c34_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c34_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c34_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c34_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c34_st = NULL;
  c34_st = NULL;
  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_createcellarray(8), FALSE);
  c34_hoistedGlobal = *c34_d_delta;
  c34_u = c34_hoistedGlobal;
  c34_b_y = NULL;
  sf_mex_assign(&c34_b_y, sf_mex_create("y", &c34_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 0, c34_b_y);
  c34_b_hoistedGlobal = *c34_d_i_f;
  c34_b_u = c34_b_hoistedGlobal;
  c34_c_y = NULL;
  sf_mex_assign(&c34_c_y, sf_mex_create("y", &c34_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 1, c34_c_y);
  c34_c_hoistedGlobal = *c34_d_omega;
  c34_c_u = c34_c_hoistedGlobal;
  c34_d_y = NULL;
  sf_mex_assign(&c34_d_y, sf_mex_create("y", &c34_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 2, c34_d_y);
  c34_d_hoistedGlobal = *c34_d_t_m;
  c34_d_u = c34_d_hoistedGlobal;
  c34_e_y = NULL;
  sf_mex_assign(&c34_e_y, sf_mex_create("y", &c34_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 3, c34_e_y);
  c34_e_hoistedGlobal = *c34_r1;
  c34_e_u = c34_e_hoistedGlobal;
  c34_f_y = NULL;
  sf_mex_assign(&c34_f_y, sf_mex_create("y", &c34_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 4, c34_f_y);
  c34_f_hoistedGlobal = *c34_r2;
  c34_f_u = c34_f_hoistedGlobal;
  c34_g_y = NULL;
  sf_mex_assign(&c34_g_y, sf_mex_create("y", &c34_f_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 5, c34_g_y);
  c34_g_hoistedGlobal = *c34_r3;
  c34_g_u = c34_g_hoistedGlobal;
  c34_h_y = NULL;
  sf_mex_assign(&c34_h_y, sf_mex_create("y", &c34_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 6, c34_h_y);
  c34_h_hoistedGlobal =
    chartInstance->c34_is_active_c34_SimulationPlantModel_Kalman;
  c34_h_u = c34_h_hoistedGlobal;
  c34_i_y = NULL;
  sf_mex_assign(&c34_i_y, sf_mex_create("y", &c34_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c34_y, 7, c34_i_y);
  sf_mex_assign(&c34_st, c34_y, FALSE);
  return c34_st;
}

static void set_sim_state_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_st)
{
  const mxArray *c34_u;
  real_T *c34_d_delta;
  real_T *c34_d_i_f;
  real_T *c34_d_omega;
  real_T *c34_d_t_m;
  real_T *c34_r1;
  real_T *c34_r2;
  real_T *c34_r3;
  c34_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c34_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c34_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c34_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c34_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c34_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c34_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c34_doneDoubleBufferReInit = TRUE;
  c34_u = sf_mex_dup(c34_st);
  *c34_d_delta = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c34_u, 0)), "d_delta");
  *c34_d_i_f = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c34_u, 1)), "d_i_f");
  *c34_d_omega = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c34_u, 2)), "d_omega");
  *c34_d_t_m = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c34_u, 3)), "d_t_m");
  *c34_r1 = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c34_u,
    4)), "r1");
  *c34_r2 = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c34_u,
    5)), "r2");
  *c34_r3 = c34_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c34_u,
    6)), "r3");
  chartInstance->c34_is_active_c34_SimulationPlantModel_Kalman =
    c34_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c34_u, 7)),
    "is_active_c34_SimulationPlantModel_Kalman");
  sf_mex_destroy(&c34_u);
  c34_update_debugger_state_c34_SimulationPlantModel_Kalman(chartInstance);
  sf_mex_destroy(&c34_st);
}

static void finalize_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void sf_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  int32_T c34_i8;
  int32_T c34_i9;
  int32_T c34_i10;
  int32_T c34_i11;
  int32_T c34_i12;
  int32_T c34_i13;
  int32_T c34_i14;
  int32_T c34_i15;
  int32_T c34_i16;
  int32_T c34_i17;
  real_T *c34_delta;
  real_T *c34_omega;
  real_T *c34_t_m;
  real_T *c34_i_f;
  real_T *c34_r1;
  real_T *c34_r2;
  real_T *c34_r3;
  real_T *c34_d_delta;
  real_T *c34_d_omega;
  real_T *c34_d_t_m;
  real_T *c34_d_i_f;
  real_T (*c34_u_vector)[4];
  real_T (*c34_y)[3];
  c34_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c34_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c34_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c34_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c34_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c34_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c34_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c34_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c34_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c34_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c34_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c34_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c34_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 33U, chartInstance->c34_sfEvent);
  for (c34_i8 = 0; c34_i8 < 3; c34_i8++) {
    _SFD_DATA_RANGE_CHECK((*c34_y)[c34_i8], 0U);
  }

  for (c34_i9 = 0; c34_i9 < 4; c34_i9++) {
    _SFD_DATA_RANGE_CHECK((*c34_u_vector)[c34_i9], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c34_delta, 2U);
  _SFD_DATA_RANGE_CHECK(*c34_omega, 3U);
  _SFD_DATA_RANGE_CHECK(*c34_t_m, 4U);
  _SFD_DATA_RANGE_CHECK(*c34_i_f, 5U);
  _SFD_DATA_RANGE_CHECK(*c34_r1, 6U);
  _SFD_DATA_RANGE_CHECK(*c34_r2, 7U);
  _SFD_DATA_RANGE_CHECK(*c34_r3, 8U);
  _SFD_DATA_RANGE_CHECK(*c34_d_delta, 9U);
  _SFD_DATA_RANGE_CHECK(*c34_d_omega, 10U);
  _SFD_DATA_RANGE_CHECK(*c34_d_t_m, 11U);
  _SFD_DATA_RANGE_CHECK(*c34_d_i_f, 12U);
  for (c34_i10 = 0; c34_i10 < 4; c34_i10++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_x_0[c34_i10], 13U);
  }

  for (c34_i11 = 0; c34_i11 < 4; c34_i11++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_u_0[c34_i11], 14U);
  }

  for (c34_i12 = 0; c34_i12 < 3; c34_i12++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_H_G[c34_i12], 15U);
  }

  for (c34_i13 = 0; c34_i13 < 3; c34_i13++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_D_fw_G[c34_i13], 16U);
  }

  for (c34_i14 = 0; c34_i14 < 6; c34_i14++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_z_G[c34_i14], 17U);
  }

  for (c34_i15 = 0; c34_i15 < 3; c34_i15++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_tau_e_G[c34_i15], 18U);
  }

  for (c34_i16 = 0; c34_i16 < 3; c34_i16++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_tau_f_G[c34_i16], 19U);
  }

  for (c34_i17 = 0; c34_i17 < 3; c34_i17++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c34_r_f_G[c34_i17], 20U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c34_GeneratorNumber, 21U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c34_omega_b, 22U);
  chartInstance->c34_sfEvent = CALL_EVENT;
  c34_chartstep_c34_SimulationPlantModel_Kalman(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_SimulationPlantModel_KalmanMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c34_chartstep_c34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c34_hoistedGlobal;
  real_T c34_b_hoistedGlobal;
  real_T c34_c_hoistedGlobal;
  real_T c34_d_hoistedGlobal;
  real_T c34_e_hoistedGlobal;
  real_T c34_f_hoistedGlobal;
  int32_T c34_i18;
  real_T c34_y[3];
  int32_T c34_i19;
  real_T c34_u_vector[4];
  real_T c34_delta;
  real_T c34_omega;
  real_T c34_t_m;
  real_T c34_i_f;
  int32_T c34_i20;
  real_T c34_b_x_0[4];
  int32_T c34_i21;
  real_T c34_b_u_0[4];
  int32_T c34_i22;
  real_T c34_b_H_G[3];
  int32_T c34_i23;
  real_T c34_b_D_fw_G[3];
  int32_T c34_i24;
  real_T c34_b_z_G[6];
  int32_T c34_i25;
  real_T c34_b_tau_e_G[3];
  int32_T c34_i26;
  real_T c34_b_tau_f_G[3];
  int32_T c34_i27;
  real_T c34_b_r_f_G[3];
  real_T c34_b_GeneratorNumber;
  real_T c34_b_omega_b;
  uint32_T c34_debug_family_var_map[55];
  real_T c34_a;
  real_T c34_b;
  real_T c34_c;
  real_T c34_d;
  real_T c34_e;
  real_T c34_g;
  real_T c34_h;
  real_T c34_k;
  real_T c34_m;
  real_T c34_n;
  real_T c34_x_01;
  real_T c34_x_02;
  real_T c34_x_03;
  real_T c34_x_04;
  real_T c34_u_01;
  real_T c34_u_02;
  real_T c34_u_03;
  real_T c34_u_04;
  real_T c34_x1;
  real_T c34_x2;
  real_T c34_x3;
  real_T c34_x4;
  real_T c34_x[4];
  real_T c34_A[16];
  real_T c34_B[16];
  real_T c34_C[12];
  real_T c34_D[12];
  real_T c34_K[12];
  real_T c34_d_x[4];
  real_T c34_r[3];
  real_T c34_nargin = 16.0;
  real_T c34_nargout = 7.0;
  real_T c34_r1;
  real_T c34_r2;
  real_T c34_r3;
  real_T c34_d_delta;
  real_T c34_d_omega;
  real_T c34_d_t_m;
  real_T c34_d_i_f;
  real_T c34_b_a;
  real_T c34_b_b;
  real_T c34_b_y;
  real_T c34_b_B;
  real_T c34_c_y;
  real_T c34_d_y;
  real_T c34_c_b;
  real_T c34_e_y;
  real_T c34_c_B;
  real_T c34_f_y;
  real_T c34_g_y;
  real_T c34_d_B;
  real_T c34_h_y;
  real_T c34_i_y;
  real_T c34_e_B;
  real_T c34_j_y;
  real_T c34_k_y;
  real_T c34_b_A;
  real_T c34_f_B;
  real_T c34_b_x;
  real_T c34_l_y;
  real_T c34_c_x;
  real_T c34_m_y;
  real_T c34_g_B;
  real_T c34_n_y;
  real_T c34_o_y;
  real_T c34_c_A;
  real_T c34_h_B;
  real_T c34_e_x;
  real_T c34_p_y;
  real_T c34_f_x;
  real_T c34_q_y;
  real_T c34_c_a;
  real_T c34_d_b;
  real_T c34_r_y;
  real_T c34_d_a;
  real_T c34_e_b;
  real_T c34_s_y;
  real_T c34_f_b;
  real_T c34_t_y;
  real_T c34_e_a;
  real_T c34_g_b;
  real_T c34_u_y;
  real_T c34_f_a;
  real_T c34_h_b;
  real_T c34_v_y;
  real_T c34_g_a;
  real_T c34_i_b;
  real_T c34_w_y;
  real_T c34_h_a;
  real_T c34_j_b;
  real_T c34_x_y;
  real_T c34_i_a;
  real_T c34_k_b;
  real_T c34_y_y;
  real_T c34_d_A;
  real_T c34_i_B;
  real_T c34_g_x;
  real_T c34_ab_y;
  real_T c34_h_x;
  real_T c34_bb_y;
  real_T c34_cb_y;
  real_T c34_j_a;
  real_T c34_l_b;
  real_T c34_db_y;
  real_T c34_k_a;
  real_T c34_m_b;
  real_T c34_eb_y;
  real_T c34_l_a;
  real_T c34_n_b;
  real_T c34_fb_y;
  real_T c34_m_a;
  real_T c34_o_b;
  real_T c34_gb_y;
  real_T c34_n_a;
  real_T c34_p_b;
  real_T c34_hb_y;
  real_T c34_o_a;
  real_T c34_q_b;
  real_T c34_ib_y;
  real_T c34_p_a;
  real_T c34_r_b;
  real_T c34_jb_y;
  real_T c34_q_a;
  real_T c34_s_b;
  real_T c34_kb_y;
  real_T c34_r_a;
  real_T c34_t_b;
  real_T c34_lb_y;
  real_T c34_s_a;
  real_T c34_u_b;
  real_T c34_mb_y;
  real_T c34_t_a;
  real_T c34_v_b;
  real_T c34_nb_y;
  real_T c34_u_a;
  real_T c34_w_b;
  real_T c34_ob_y;
  real_T c34_v_a;
  real_T c34_x_b;
  real_T c34_pb_y;
  real_T c34_e_A;
  real_T c34_j_B;
  real_T c34_i_x;
  real_T c34_qb_y;
  real_T c34_j_x;
  real_T c34_rb_y;
  real_T c34_sb_y;
  real_T c34_y_b;
  real_T c34_tb_y;
  real_T c34_w_a;
  real_T c34_ab_b;
  real_T c34_ub_y;
  real_T c34_x_a;
  real_T c34_bb_b;
  real_T c34_vb_y;
  real_T c34_y_a;
  real_T c34_cb_b;
  real_T c34_wb_y;
  real_T c34_ab_a;
  real_T c34_db_b;
  real_T c34_xb_y;
  real_T c34_eb_b;
  real_T c34_yb_y;
  real_T c34_bb_a;
  real_T c34_fb_b;
  real_T c34_ac_y;
  real_T c34_cb_a;
  real_T c34_gb_b;
  real_T c34_bc_y;
  real_T c34_db_a;
  real_T c34_hb_b;
  real_T c34_cc_y;
  real_T c34_eb_a;
  real_T c34_ib_b;
  real_T c34_dc_y;
  real_T c34_fb_a;
  real_T c34_jb_b;
  real_T c34_ec_y;
  real_T c34_f_A;
  real_T c34_k_B;
  real_T c34_k_x;
  real_T c34_fc_y;
  real_T c34_l_x;
  real_T c34_gc_y;
  real_T c34_hc_y;
  real_T c34_kb_b;
  real_T c34_ic_y;
  real_T c34_gb_a;
  real_T c34_lb_b;
  real_T c34_jc_y;
  real_T c34_hb_a;
  real_T c34_mb_b;
  real_T c34_kc_y;
  real_T c34_ib_a;
  real_T c34_nb_b;
  real_T c34_lc_y;
  real_T c34_ob_b;
  real_T c34_mc_y;
  real_T c34_jb_a;
  real_T c34_pb_b;
  real_T c34_nc_y;
  real_T c34_kb_a;
  real_T c34_qb_b;
  real_T c34_oc_y;
  real_T c34_lb_a;
  real_T c34_rb_b;
  real_T c34_pc_y;
  real_T c34_mb_a;
  real_T c34_sb_b;
  real_T c34_qc_y;
  real_T c34_tb_b;
  real_T c34_rc_y;
  real_T c34_nb_a;
  real_T c34_ub_b;
  real_T c34_sc_y;
  real_T c34_ob_a;
  real_T c34_vb_b;
  real_T c34_tc_y;
  real_T c34_pb_a;
  real_T c34_wb_b;
  real_T c34_uc_y;
  real_T c34_qb_a;
  real_T c34_xb_b;
  real_T c34_vc_y;
  real_T c34_g_A;
  real_T c34_l_B;
  real_T c34_m_x;
  real_T c34_wc_y;
  real_T c34_n_x;
  real_T c34_xc_y;
  real_T c34_yc_y;
  real_T c34_rb_a;
  real_T c34_yb_b;
  real_T c34_ad_y;
  real_T c34_sb_a;
  real_T c34_ac_b;
  real_T c34_bd_y;
  real_T c34_tb_a;
  real_T c34_bc_b;
  real_T c34_cd_y;
  real_T c34_ub_a;
  real_T c34_cc_b;
  real_T c34_dd_y;
  int32_T c34_i28;
  int32_T c34_i29;
  static real_T c34_dv8[4] = { 0.0, 1.0, 0.0, 0.0 };

  int32_T c34_i30;
  int32_T c34_i31;
  int32_T c34_i32;
  int32_T c34_i33;
  int32_T c34_i34;
  int32_T c34_i35;
  real_T c34_dc_b[12];
  int32_T c34_i36;
  int32_T c34_i37;
  int32_T c34_i38;
  int32_T c34_i39;
  real_T c34_ed_y[16];
  int32_T c34_i40;
  int32_T c34_i41;
  int32_T c34_i42;
  real_T c34_ec_b[4];
  int32_T c34_i43;
  real_T c34_fd_y[4];
  int32_T c34_i44;
  int32_T c34_i45;
  int32_T c34_i46;
  int32_T c34_i47;
  int32_T c34_i48;
  int32_T c34_i49;
  int32_T c34_i50;
  int32_T c34_i51;
  int32_T c34_i52;
  int32_T c34_i53;
  int32_T c34_i54;
  real_T c34_gd_y[4];
  int32_T c34_i55;
  int32_T c34_i56;
  int32_T c34_i57;
  real_T c34_fc_b[3];
  int32_T c34_i58;
  int32_T c34_i59;
  int32_T c34_i60;
  int32_T c34_i61;
  int32_T c34_i62;
  int32_T c34_i63;
  int32_T c34_i64;
  int32_T c34_i65;
  int32_T c34_i66;
  int32_T c34_i67;
  int32_T c34_i68;
  real_T c34_hd_y[3];
  int32_T c34_i69;
  int32_T c34_i70;
  int32_T c34_i71;
  real_T *c34_b_delta;
  real_T *c34_b_omega;
  real_T *c34_b_t_m;
  real_T *c34_b_i_f;
  real_T *c34_b_r1;
  real_T *c34_b_r2;
  real_T *c34_b_r3;
  real_T *c34_b_d_delta;
  real_T *c34_b_d_omega;
  real_T *c34_b_d_t_m;
  real_T *c34_b_d_i_f;
  real_T (*c34_b_u_vector)[4];
  real_T (*c34_id_y)[3];
  c34_b_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c34_b_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c34_b_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c34_b_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c34_b_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c34_b_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c34_b_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c34_b_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c34_b_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c34_b_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c34_b_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c34_b_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c34_id_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 33U, chartInstance->c34_sfEvent);
  c34_hoistedGlobal = *c34_b_delta;
  c34_b_hoistedGlobal = *c34_b_omega;
  c34_c_hoistedGlobal = *c34_b_t_m;
  c34_d_hoistedGlobal = *c34_b_i_f;
  c34_e_hoistedGlobal = chartInstance->c34_GeneratorNumber;
  c34_f_hoistedGlobal = chartInstance->c34_omega_b;
  for (c34_i18 = 0; c34_i18 < 3; c34_i18++) {
    c34_y[c34_i18] = (*c34_id_y)[c34_i18];
  }

  for (c34_i19 = 0; c34_i19 < 4; c34_i19++) {
    c34_u_vector[c34_i19] = (*c34_b_u_vector)[c34_i19];
  }

  c34_delta = c34_hoistedGlobal;
  c34_omega = c34_b_hoistedGlobal;
  c34_t_m = c34_c_hoistedGlobal;
  c34_i_f = c34_d_hoistedGlobal;
  for (c34_i20 = 0; c34_i20 < 4; c34_i20++) {
    c34_b_x_0[c34_i20] = chartInstance->c34_x_0[c34_i20];
  }

  for (c34_i21 = 0; c34_i21 < 4; c34_i21++) {
    c34_b_u_0[c34_i21] = chartInstance->c34_u_0[c34_i21];
  }

  for (c34_i22 = 0; c34_i22 < 3; c34_i22++) {
    c34_b_H_G[c34_i22] = chartInstance->c34_H_G[c34_i22];
  }

  for (c34_i23 = 0; c34_i23 < 3; c34_i23++) {
    c34_b_D_fw_G[c34_i23] = chartInstance->c34_D_fw_G[c34_i23];
  }

  for (c34_i24 = 0; c34_i24 < 6; c34_i24++) {
    c34_b_z_G[c34_i24] = chartInstance->c34_z_G[c34_i24];
  }

  for (c34_i25 = 0; c34_i25 < 3; c34_i25++) {
    c34_b_tau_e_G[c34_i25] = chartInstance->c34_tau_e_G[c34_i25];
  }

  for (c34_i26 = 0; c34_i26 < 3; c34_i26++) {
    c34_b_tau_f_G[c34_i26] = chartInstance->c34_tau_f_G[c34_i26];
  }

  for (c34_i27 = 0; c34_i27 < 3; c34_i27++) {
    c34_b_r_f_G[c34_i27] = chartInstance->c34_r_f_G[c34_i27];
  }

  c34_b_GeneratorNumber = c34_e_hoistedGlobal;
  c34_b_omega_b = c34_f_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 55U, 55U, c34_debug_family_names,
    c34_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_a, 0U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_b, 1U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_c, 2U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_d, 3U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_e, 4U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_g, 5U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_h, 6U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_k, 7U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_m, 8U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_n, 9U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x_01, 10U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x_02, 11U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x_03, 12U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x_04, 13U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_u_01, 14U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_u_02, 15U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_u_03, 16U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_u_04, 17U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x1, 18U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x2, 19U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x3, 20U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_x4, 21U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_x, 22U, c34_d_sf_marshallOut,
    c34_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_A, 23U, c34_g_sf_marshallOut,
    c34_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_B, 24U, c34_g_sf_marshallOut,
    c34_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_C, 25U, c34_f_sf_marshallOut,
    c34_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_D, 26U, c34_f_sf_marshallOut,
    c34_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c34_K, 27U, c34_e_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_d_x, 28U, c34_d_sf_marshallOut,
    c34_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_r, 29U, c34_b_sf_marshallOut,
    c34_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_nargin, 30U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_nargout, 31U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c34_y, 32U, c34_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c34_u_vector, 33U, c34_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c34_delta, 34U, c34_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c34_omega, 35U, c34_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c34_t_m, 36U, c34_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c34_i_f, 37U, c34_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_x_0, 38U, c34_d_sf_marshallOut,
    c34_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_u_0, 39U, c34_d_sf_marshallOut,
    c34_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_H_G, 40U, c34_b_sf_marshallOut,
    c34_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_D_fw_G, 41U, c34_b_sf_marshallOut,
    c34_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_z_G, 42U, c34_c_sf_marshallOut,
    c34_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_tau_e_G, 43U, c34_b_sf_marshallOut,
    c34_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_tau_f_G, 44U, c34_b_sf_marshallOut,
    c34_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c34_b_r_f_G, 45U, c34_b_sf_marshallOut,
    c34_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_b_GeneratorNumber, 46U,
    c34_sf_marshallOut, c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_b_omega_b, 47U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_r1, 48U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_r2, 49U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_r3, 50U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_d_delta, 51U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_d_omega, 52U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_d_t_m, 53U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c34_d_i_f, 54U, c34_sf_marshallOut,
    c34_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 4);
  c34_a = c34_b_omega_b;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 5);
  c34_b_a = c34_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_b_b = c34_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_b_y = c34_b_a * c34_b_b;
  c34_b_B = c34_b_y;
  c34_c_y = c34_b_B;
  c34_d_y = c34_c_y;
  c34_b = 1.0 / c34_d_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 6);
  c34_c_b = c34_b_H_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("H_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_e_y = 2.0 * c34_c_b;
  c34_c_B = c34_e_y;
  c34_f_y = c34_c_B;
  c34_g_y = c34_f_y;
  c34_c = 1.0 / c34_g_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 7);
  c34_d = c34_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 8);
  c34_d_B = c34_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) + 2];
  c34_h_y = c34_d_B;
  c34_i_y = c34_h_y;
  c34_e = 1.0 / c34_i_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 9);
  c34_g = c34_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 10);
  c34_e_B = c34_b_tau_e_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_e_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_j_y = c34_e_B;
  c34_k_y = c34_j_y;
  c34_h = 1.0 / c34_k_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 11);
  c34_b_A = c34_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1] + 1.0;
  c34_f_B = c34_b_tau_e_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_e_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_b_x = c34_b_A;
  c34_l_y = c34_f_B;
  c34_c_x = c34_b_x;
  c34_m_y = c34_l_y;
  c34_k = c34_c_x / c34_m_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 12);
  c34_g_B = c34_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_n_y = c34_g_B;
  c34_o_y = c34_n_y;
  c34_m = 1.0 / c34_o_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 13);
  c34_c_A = c34_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c34_h_B = c34_mpower(chartInstance, c34_b_z_G[(int32_T)(real_T)
                       _SFD_EML_ARRAY_BOUNDS_CHECK("z_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c34_b_GeneratorNumber), 1, 3, 1, 0) +
                       2]);
  c34_e_x = c34_c_A;
  c34_p_y = c34_h_B;
  c34_f_x = c34_e_x;
  c34_q_y = c34_p_y;
  c34_n = c34_f_x / c34_q_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 15);
  c34_x_01 = c34_b_x_0[0];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 16);
  c34_x_02 = c34_b_x_0[1];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 17);
  c34_x_03 = c34_b_x_0[2];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 18);
  c34_x_04 = c34_b_x_0[3];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 20);
  c34_u_01 = c34_b_u_0[0];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 21);
  c34_u_02 = c34_b_u_0[1];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 22);
  c34_u_03 = c34_b_u_0[2];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 23);
  c34_u_04 = c34_b_u_0[3];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 25);
  c34_x1 = c34_delta;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 26);
  c34_x2 = c34_omega;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 27);
  c34_x3 = c34_t_m;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 28);
  c34_x4 = c34_i_f;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 29);
  c34_x[0] = c34_x1;
  c34_x[1] = c34_x2;
  c34_x[2] = c34_x3;
  c34_x[3] = c34_x4;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 31);
  c34_c_a = c34_e;
  c34_d_b = c34_x_02;
  c34_r_y = c34_c_a * c34_d_b;
  c34_d_a = c34_r_y;
  c34_e_b = c34_b_mpower(chartInstance, c34_u_02);
  c34_s_y = c34_d_a * c34_e_b;
  c34_f_b = c34_n;
  c34_t_y = 2.0 * c34_f_b;
  c34_e_a = c34_t_y;
  c34_g_b = c34_x_01;
  c34_u_y = c34_e_a * c34_g_b;
  c34_f_a = c34_u_y;
  c34_h_b = c34_x_02;
  c34_v_y = c34_f_a * c34_h_b;
  c34_g_a = c34_v_y;
  c34_i_b = c34_u_02;
  c34_w_y = c34_g_a * c34_i_b;
  c34_h_a = c34_c;
  c34_j_b = c34_s_y + c34_w_y;
  c34_x_y = c34_h_a * c34_j_b;
  c34_i_a = c34_b_mpower(chartInstance, c34_u_02);
  c34_k_b = c34_mpower(chartInstance, c34_x_02);
  c34_y_y = c34_i_a * c34_k_b;
  c34_d_A = -c34_x_y;
  c34_i_B = c34_y_y;
  c34_g_x = c34_d_A;
  c34_ab_y = c34_i_B;
  c34_h_x = c34_g_x;
  c34_bb_y = c34_ab_y;
  c34_cb_y = c34_h_x / c34_bb_y;
  c34_j_a = -c34_n;
  c34_l_b = c34_mpower(chartInstance, c34_g);
  c34_db_y = c34_j_a * c34_l_b;
  c34_k_a = c34_db_y;
  c34_m_b = c34_u_02;
  c34_eb_y = c34_k_a * c34_m_b;
  c34_l_a = c34_eb_y;
  c34_n_b = c34_mpower(chartInstance, c34_x_02);
  c34_fb_y = c34_l_a * c34_n_b;
  c34_m_a = c34_fb_y;
  c34_o_b = c34_mpower(chartInstance, c34_x_04);
  c34_gb_y = c34_m_a * c34_o_b;
  c34_n_a = c34_e;
  c34_p_b = c34_b_mpower(chartInstance, c34_u_02);
  c34_hb_y = c34_n_a * c34_p_b;
  c34_o_a = c34_hb_y;
  c34_q_b = c34_x_01;
  c34_ib_y = c34_o_a * c34_q_b;
  c34_p_a = c34_d;
  c34_r_b = c34_b_mpower(chartInstance, c34_u_02);
  c34_jb_y = c34_p_a * c34_r_b;
  c34_q_a = c34_jb_y;
  c34_s_b = c34_mpower(chartInstance, c34_x_02);
  c34_kb_y = c34_q_a * c34_s_b;
  c34_r_a = c34_n;
  c34_t_b = c34_b_mpower(chartInstance, c34_u_02);
  c34_lb_y = c34_r_a * c34_t_b;
  c34_s_a = c34_n;
  c34_u_b = c34_u_02;
  c34_mb_y = c34_s_a * c34_u_b;
  c34_t_a = c34_mb_y;
  c34_v_b = c34_mpower(chartInstance, c34_x_01);
  c34_nb_y = c34_t_a * c34_v_b;
  c34_u_a = c34_c;
  c34_w_b = (((c34_gb_y + c34_ib_y) - c34_kb_y) + c34_lb_y) + c34_nb_y;
  c34_ob_y = c34_u_a * c34_w_b;
  c34_v_a = c34_b_mpower(chartInstance, c34_u_02);
  c34_x_b = c34_mpower(chartInstance, c34_x_02);
  c34_pb_y = c34_v_a * c34_x_b;
  c34_e_A = c34_ob_y;
  c34_j_B = c34_pb_y;
  c34_i_x = c34_e_A;
  c34_qb_y = c34_j_B;
  c34_j_x = c34_i_x;
  c34_rb_y = c34_qb_y;
  c34_sb_y = c34_j_x / c34_rb_y;
  c34_y_b = c34_n;
  c34_tb_y = -2.0 * c34_y_b;
  c34_w_a = c34_tb_y;
  c34_ab_b = c34_x_04;
  c34_ub_y = c34_w_a * c34_ab_b;
  c34_x_a = c34_ub_y;
  c34_bb_b = c34_mpower(chartInstance, c34_g);
  c34_vb_y = c34_x_a * c34_bb_b;
  c34_y_a = c34_vb_y;
  c34_cb_b = c34_u_02;
  c34_wb_y = c34_y_a * c34_cb_b;
  c34_ab_a = c34_wb_y;
  c34_db_b = c34_b_mpower(chartInstance, c34_x_02);
  c34_xb_y = c34_ab_a * c34_db_b;
  c34_eb_b = c34_n;
  c34_yb_y = 2.0 * c34_eb_b;
  c34_bb_a = c34_yb_y;
  c34_fb_b = c34_g;
  c34_ac_y = c34_bb_a * c34_fb_b;
  c34_cb_a = c34_ac_y;
  c34_gb_b = c34_mpower(chartInstance, c34_u_02);
  c34_bc_y = c34_cb_a * c34_gb_b;
  c34_db_a = c34_bc_y;
  c34_hb_b = c34_mpower(chartInstance, c34_x_02);
  c34_cc_y = c34_db_a * c34_hb_b;
  c34_eb_a = c34_c;
  c34_ib_b = c34_xb_y + c34_cc_y;
  c34_dc_y = c34_eb_a * c34_ib_b;
  c34_fb_a = c34_b_mpower(chartInstance, c34_u_02);
  c34_jb_b = c34_mpower(chartInstance, c34_x_02);
  c34_ec_y = c34_fb_a * c34_jb_b;
  c34_f_A = c34_dc_y;
  c34_k_B = c34_ec_y;
  c34_k_x = c34_f_A;
  c34_fc_y = c34_k_B;
  c34_l_x = c34_k_x;
  c34_gc_y = c34_fc_y;
  c34_hc_y = c34_l_x / c34_gc_y;
  c34_A[0] = 0.0;
  c34_A[4] = c34_a;
  c34_A[8] = 0.0;
  c34_A[12] = 0.0;
  c34_A[1] = c34_cb_y;
  c34_A[5] = c34_sb_y;
  c34_A[9] = c34_c;
  c34_A[13] = c34_hc_y;
  c34_A[2] = 0.0;
  c34_A[6] = 0.0;
  c34_A[10] = -c34_h;
  c34_A[14] = 0.0;
  c34_A[3] = 0.0;
  c34_A[7] = 0.0;
  c34_A[11] = 0.0;
  c34_A[15] = -c34_m;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 36);
  c34_kb_b = c34_n;
  c34_ic_y = 2.0 * c34_kb_b;
  c34_gb_a = c34_ic_y;
  c34_lb_b = c34_mpower(chartInstance, c34_g);
  c34_jc_y = c34_gb_a * c34_lb_b;
  c34_hb_a = c34_jc_y;
  c34_mb_b = c34_b_mpower(chartInstance, c34_x_02);
  c34_kc_y = c34_hb_a * c34_mb_b;
  c34_ib_a = c34_kc_y;
  c34_nb_b = c34_mpower(chartInstance, c34_x_04);
  c34_lc_y = c34_ib_a * c34_nb_b;
  c34_ob_b = c34_n;
  c34_mc_y = 2.0 * c34_ob_b;
  c34_jb_a = c34_mc_y;
  c34_pb_b = c34_u_02;
  c34_nc_y = c34_jb_a * c34_pb_b;
  c34_kb_a = c34_nc_y;
  c34_qb_b = c34_g;
  c34_oc_y = c34_kb_a * c34_qb_b;
  c34_lb_a = c34_oc_y;
  c34_rb_b = c34_mpower(chartInstance, c34_x_02);
  c34_pc_y = c34_lb_a * c34_rb_b;
  c34_mb_a = c34_pc_y;
  c34_sb_b = c34_x_04;
  c34_qc_y = c34_mb_a * c34_sb_b;
  c34_tb_b = c34_n;
  c34_rc_y = 2.0 * c34_tb_b;
  c34_nb_a = c34_rc_y;
  c34_ub_b = c34_mpower(chartInstance, c34_x_01);
  c34_sc_y = c34_nb_a * c34_ub_b;
  c34_ob_a = c34_sc_y;
  c34_vb_b = c34_x_02;
  c34_tc_y = c34_ob_a * c34_vb_b;
  c34_pb_a = c34_c;
  c34_wb_b = (c34_lc_y - c34_qc_y) + c34_tc_y;
  c34_uc_y = c34_pb_a * c34_wb_b;
  c34_qb_a = c34_b_mpower(chartInstance, c34_u_02);
  c34_xb_b = c34_mpower(chartInstance, c34_x_02);
  c34_vc_y = c34_qb_a * c34_xb_b;
  c34_g_A = c34_uc_y;
  c34_l_B = c34_vc_y;
  c34_m_x = c34_g_A;
  c34_wc_y = c34_l_B;
  c34_n_x = c34_m_x;
  c34_xc_y = c34_wc_y;
  c34_yc_y = c34_n_x / c34_xc_y;
  c34_B[0] = -c34_a;
  c34_B[4] = 0.0;
  c34_B[8] = 0.0;
  c34_B[12] = 0.0;
  c34_B[1] = 0.0;
  c34_B[5] = c34_yc_y;
  c34_B[9] = 0.0;
  c34_B[13] = 0.0;
  c34_B[2] = 0.0;
  c34_B[6] = 0.0;
  c34_B[10] = c34_k;
  c34_B[14] = 0.0;
  c34_B[3] = 0.0;
  c34_B[7] = 0.0;
  c34_B[11] = 0.0;
  c34_B[15] = c34_b;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 41);
  c34_rb_a = c34_e;
  c34_yb_b = c34_g;
  c34_ad_y = c34_rb_a * c34_yb_b;
  c34_sb_a = c34_ad_y;
  c34_ac_b = c34_x_04;
  c34_bd_y = c34_sb_a * c34_ac_b;
  c34_tb_a = c34_e;
  c34_bc_b = c34_g;
  c34_cd_y = c34_tb_a * c34_bc_b;
  c34_ub_a = c34_cd_y;
  c34_cc_b = c34_x_02;
  c34_dd_y = c34_ub_a * c34_cc_b;
  c34_i28 = 0;
  for (c34_i29 = 0; c34_i29 < 4; c34_i29++) {
    c34_C[c34_i28] = c34_dv8[c34_i29];
    c34_i28 += 3;
  }

  c34_C[1] = c34_e;
  c34_C[4] = 0.0;
  c34_C[7] = 0.0;
  c34_C[10] = 0.0;
  c34_C[2] = 0.0;
  c34_C[5] = c34_bd_y;
  c34_C[8] = 0.0;
  c34_C[11] = c34_dd_y;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 46);
  c34_i30 = 0;
  for (c34_i31 = 0; c34_i31 < 4; c34_i31++) {
    c34_D[c34_i30] = 0.0;
    c34_i30 += 3;
  }

  c34_i32 = 0;
  for (c34_i33 = 0; c34_i33 < 4; c34_i33++) {
    c34_D[c34_i32 + 1] = 0.0;
    c34_i32 += 3;
  }

  c34_D[2] = 0.0;
  c34_D[5] = -c34_e;
  c34_D[8] = 0.0;
  c34_D[11] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 50);
  for (c34_i34 = 0; c34_i34 < 12; c34_i34++) {
    c34_K[c34_i34] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 52);
  for (c34_i35 = 0; c34_i35 < 12; c34_i35++) {
    c34_dc_b[c34_i35] = c34_C[c34_i35];
  }

  c34_b_eml_scalar_eg(chartInstance);
  c34_b_eml_scalar_eg(chartInstance);
  for (c34_i36 = 0; c34_i36 < 4; c34_i36++) {
    c34_i37 = 0;
    c34_i38 = 0;
    for (c34_i39 = 0; c34_i39 < 4; c34_i39++) {
      c34_ed_y[c34_i37 + c34_i36] = 0.0;
      for (c34_i40 = 0; c34_i40 < 3; c34_i40++) {
        c34_ed_y[c34_i37 + c34_i36] += 0.0 * c34_dc_b[c34_i40 + c34_i38];
      }

      c34_i37 += 4;
      c34_i38 += 3;
    }
  }

  for (c34_i41 = 0; c34_i41 < 16; c34_i41++) {
    c34_ed_y[c34_i41] += c34_A[c34_i41];
  }

  for (c34_i42 = 0; c34_i42 < 4; c34_i42++) {
    c34_ec_b[c34_i42] = c34_x[c34_i42];
  }

  c34_c_eml_scalar_eg(chartInstance);
  c34_c_eml_scalar_eg(chartInstance);
  for (c34_i43 = 0; c34_i43 < 4; c34_i43++) {
    c34_fd_y[c34_i43] = 0.0;
    c34_i44 = 0;
    for (c34_i45 = 0; c34_i45 < 4; c34_i45++) {
      c34_fd_y[c34_i43] += c34_ed_y[c34_i44 + c34_i43] * c34_ec_b[c34_i45];
      c34_i44 += 4;
    }
  }

  for (c34_i46 = 0; c34_i46 < 12; c34_i46++) {
    c34_dc_b[c34_i46] = c34_D[c34_i46];
  }

  c34_b_eml_scalar_eg(chartInstance);
  c34_b_eml_scalar_eg(chartInstance);
  for (c34_i47 = 0; c34_i47 < 4; c34_i47++) {
    c34_i48 = 0;
    c34_i49 = 0;
    for (c34_i50 = 0; c34_i50 < 4; c34_i50++) {
      c34_ed_y[c34_i48 + c34_i47] = 0.0;
      for (c34_i51 = 0; c34_i51 < 3; c34_i51++) {
        c34_ed_y[c34_i48 + c34_i47] += 0.0 * c34_dc_b[c34_i51 + c34_i49];
      }

      c34_i48 += 4;
      c34_i49 += 3;
    }
  }

  for (c34_i52 = 0; c34_i52 < 16; c34_i52++) {
    c34_ed_y[c34_i52] += c34_B[c34_i52];
  }

  for (c34_i53 = 0; c34_i53 < 4; c34_i53++) {
    c34_ec_b[c34_i53] = c34_u_vector[c34_i53];
  }

  c34_c_eml_scalar_eg(chartInstance);
  c34_c_eml_scalar_eg(chartInstance);
  for (c34_i54 = 0; c34_i54 < 4; c34_i54++) {
    c34_gd_y[c34_i54] = 0.0;
    c34_i55 = 0;
    for (c34_i56 = 0; c34_i56 < 4; c34_i56++) {
      c34_gd_y[c34_i54] += c34_ed_y[c34_i55 + c34_i54] * c34_ec_b[c34_i56];
      c34_i55 += 4;
    }
  }

  for (c34_i57 = 0; c34_i57 < 3; c34_i57++) {
    c34_fc_b[c34_i57] = c34_y[c34_i57];
  }

  c34_d_eml_scalar_eg(chartInstance);
  c34_d_eml_scalar_eg(chartInstance);
  for (c34_i58 = 0; c34_i58 < 4; c34_i58++) {
    c34_ec_b[c34_i58] = 0.0;
    for (c34_i59 = 0; c34_i59 < 3; c34_i59++) {
      c34_ec_b[c34_i58] += 0.0 * c34_fc_b[c34_i59];
    }
  }

  for (c34_i60 = 0; c34_i60 < 4; c34_i60++) {
    c34_d_x[c34_i60] = (c34_fd_y[c34_i60] + c34_gd_y[c34_i60]) -
      c34_ec_b[c34_i60];
  }

  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 54);
  c34_d_delta = c34_d_x[0];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 55);
  c34_d_omega = c34_d_x[1];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 56);
  c34_d_t_m = c34_d_x[2];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 57);
  c34_d_i_f = c34_d_x[3];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 59);
  for (c34_i61 = 0; c34_i61 < 12; c34_i61++) {
    c34_dc_b[c34_i61] = c34_C[c34_i61];
  }

  for (c34_i62 = 0; c34_i62 < 4; c34_i62++) {
    c34_ec_b[c34_i62] = c34_x[c34_i62];
  }

  c34_e_eml_scalar_eg(chartInstance);
  c34_e_eml_scalar_eg(chartInstance);
  for (c34_i63 = 0; c34_i63 < 3; c34_i63++) {
    c34_fc_b[c34_i63] = 0.0;
    c34_i64 = 0;
    for (c34_i65 = 0; c34_i65 < 4; c34_i65++) {
      c34_fc_b[c34_i63] += c34_dc_b[c34_i64 + c34_i63] * c34_ec_b[c34_i65];
      c34_i64 += 3;
    }
  }

  for (c34_i66 = 0; c34_i66 < 12; c34_i66++) {
    c34_dc_b[c34_i66] = c34_D[c34_i66];
  }

  for (c34_i67 = 0; c34_i67 < 4; c34_i67++) {
    c34_ec_b[c34_i67] = c34_u_vector[c34_i67];
  }

  c34_e_eml_scalar_eg(chartInstance);
  c34_e_eml_scalar_eg(chartInstance);
  for (c34_i68 = 0; c34_i68 < 3; c34_i68++) {
    c34_hd_y[c34_i68] = 0.0;
    c34_i69 = 0;
    for (c34_i70 = 0; c34_i70 < 4; c34_i70++) {
      c34_hd_y[c34_i68] += c34_dc_b[c34_i69 + c34_i68] * c34_ec_b[c34_i70];
      c34_i69 += 3;
    }
  }

  for (c34_i71 = 0; c34_i71 < 3; c34_i71++) {
    c34_r[c34_i71] = (c34_y[c34_i71] - c34_fc_b[c34_i71]) - c34_hd_y[c34_i71];
  }

  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 60);
  c34_r1 = c34_r[0];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 61);
  c34_r2 = c34_r[1];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, 62);
  c34_r3 = c34_r[2];
  _SFD_EML_CALL(0U, chartInstance->c34_sfEvent, -62);
  _SFD_SYMBOL_SCOPE_POP();
  *c34_b_r1 = c34_r1;
  *c34_b_r2 = c34_r2;
  *c34_b_r3 = c34_r3;
  *c34_b_d_delta = c34_d_delta;
  *c34_b_d_omega = c34_d_omega;
  *c34_b_d_t_m = c34_d_t_m;
  *c34_b_d_i_f = c34_d_i_f;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 33U, chartInstance->c34_sfEvent);
}

static void initSimStructsc34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void registerMessagesc34_SimulationPlantModel_Kalman
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c34_machineNumber, uint32_T
  c34_chartNumber)
{
}

static const mxArray *c34_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  real_T c34_u;
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  c34_u = *(real_T *)c34_inData;
  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", &c34_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static real_T c34_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_d_i_f, const char_T *c34_identifier)
{
  real_T c34_y;
  emlrtMsgIdentifier c34_thisId;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_y = c34_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_d_i_f),
    &c34_thisId);
  sf_mex_destroy(&c34_d_i_f);
  return c34_y;
}

static real_T c34_b_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId)
{
  real_T c34_y;
  real_T c34_d2;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), &c34_d2, 1, 0, 0U, 0, 0U, 0);
  c34_y = c34_d2;
  sf_mex_destroy(&c34_u);
  return c34_y;
}

static void c34_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_d_i_f;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  real_T c34_y;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_d_i_f = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_y = c34_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_d_i_f),
    &c34_thisId);
  sf_mex_destroy(&c34_d_i_f);
  *(real_T *)c34_outData = c34_y;
  sf_mex_destroy(&c34_mxArrayInData);
}

static const mxArray *c34_b_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_i72;
  real_T c34_b_inData[3];
  int32_T c34_i73;
  real_T c34_u[3];
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  for (c34_i72 = 0; c34_i72 < 3; c34_i72++) {
    c34_b_inData[c34_i72] = (*(real_T (*)[3])c34_inData)[c34_i72];
  }

  for (c34_i73 = 0; c34_i73 < 3; c34_i73++) {
    c34_u[c34_i73] = c34_b_inData[c34_i73];
  }

  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", c34_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static void c34_c_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[3])
{
  real_T c34_dv9[3];
  int32_T c34_i74;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), c34_dv9, 1, 0, 0U, 1, 0U, 1, 3);
  for (c34_i74 = 0; c34_i74 < 3; c34_i74++) {
    c34_y[c34_i74] = c34_dv9[c34_i74];
  }

  sf_mex_destroy(&c34_u);
}

static void c34_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_b_r_f_G;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  real_T c34_y[3];
  int32_T c34_i75;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_b_r_f_G = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_b_r_f_G), &c34_thisId,
    c34_y);
  sf_mex_destroy(&c34_b_r_f_G);
  for (c34_i75 = 0; c34_i75 < 3; c34_i75++) {
    (*(real_T (*)[3])c34_outData)[c34_i75] = c34_y[c34_i75];
  }

  sf_mex_destroy(&c34_mxArrayInData);
}

static const mxArray *c34_c_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_i76;
  int32_T c34_i77;
  int32_T c34_i78;
  real_T c34_b_inData[6];
  int32_T c34_i79;
  int32_T c34_i80;
  int32_T c34_i81;
  real_T c34_u[6];
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  c34_i76 = 0;
  for (c34_i77 = 0; c34_i77 < 2; c34_i77++) {
    for (c34_i78 = 0; c34_i78 < 3; c34_i78++) {
      c34_b_inData[c34_i78 + c34_i76] = (*(real_T (*)[6])c34_inData)[c34_i78 +
        c34_i76];
    }

    c34_i76 += 3;
  }

  c34_i79 = 0;
  for (c34_i80 = 0; c34_i80 < 2; c34_i80++) {
    for (c34_i81 = 0; c34_i81 < 3; c34_i81++) {
      c34_u[c34_i81 + c34_i79] = c34_b_inData[c34_i81 + c34_i79];
    }

    c34_i79 += 3;
  }

  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", c34_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static void c34_d_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[6])
{
  real_T c34_dv10[6];
  int32_T c34_i82;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), c34_dv10, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c34_i82 = 0; c34_i82 < 6; c34_i82++) {
    c34_y[c34_i82] = c34_dv10[c34_i82];
  }

  sf_mex_destroy(&c34_u);
}

static void c34_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_b_z_G;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  real_T c34_y[6];
  int32_T c34_i83;
  int32_T c34_i84;
  int32_T c34_i85;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_b_z_G = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_b_z_G), &c34_thisId,
    c34_y);
  sf_mex_destroy(&c34_b_z_G);
  c34_i83 = 0;
  for (c34_i84 = 0; c34_i84 < 2; c34_i84++) {
    for (c34_i85 = 0; c34_i85 < 3; c34_i85++) {
      (*(real_T (*)[6])c34_outData)[c34_i85 + c34_i83] = c34_y[c34_i85 + c34_i83];
    }

    c34_i83 += 3;
  }

  sf_mex_destroy(&c34_mxArrayInData);
}

static const mxArray *c34_d_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_i86;
  real_T c34_b_inData[4];
  int32_T c34_i87;
  real_T c34_u[4];
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  for (c34_i86 = 0; c34_i86 < 4; c34_i86++) {
    c34_b_inData[c34_i86] = (*(real_T (*)[4])c34_inData)[c34_i86];
  }

  for (c34_i87 = 0; c34_i87 < 4; c34_i87++) {
    c34_u[c34_i87] = c34_b_inData[c34_i87];
  }

  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", c34_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static void c34_e_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[4])
{
  real_T c34_dv11[4];
  int32_T c34_i88;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), c34_dv11, 1, 0, 0U, 1, 0U, 1, 4);
  for (c34_i88 = 0; c34_i88 < 4; c34_i88++) {
    c34_y[c34_i88] = c34_dv11[c34_i88];
  }

  sf_mex_destroy(&c34_u);
}

static void c34_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_b_u_0;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  real_T c34_y[4];
  int32_T c34_i89;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_b_u_0 = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_b_u_0), &c34_thisId,
    c34_y);
  sf_mex_destroy(&c34_b_u_0);
  for (c34_i89 = 0; c34_i89 < 4; c34_i89++) {
    (*(real_T (*)[4])c34_outData)[c34_i89] = c34_y[c34_i89];
  }

  sf_mex_destroy(&c34_mxArrayInData);
}

static const mxArray *c34_e_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_i90;
  int32_T c34_i91;
  int32_T c34_i92;
  real_T c34_b_inData[12];
  int32_T c34_i93;
  int32_T c34_i94;
  int32_T c34_i95;
  real_T c34_u[12];
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  c34_i90 = 0;
  for (c34_i91 = 0; c34_i91 < 3; c34_i91++) {
    for (c34_i92 = 0; c34_i92 < 4; c34_i92++) {
      c34_b_inData[c34_i92 + c34_i90] = (*(real_T (*)[12])c34_inData)[c34_i92 +
        c34_i90];
    }

    c34_i90 += 4;
  }

  c34_i93 = 0;
  for (c34_i94 = 0; c34_i94 < 3; c34_i94++) {
    for (c34_i95 = 0; c34_i95 < 4; c34_i95++) {
      c34_u[c34_i95 + c34_i93] = c34_b_inData[c34_i95 + c34_i93];
    }

    c34_i93 += 4;
  }

  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", c34_u, 0, 0U, 1U, 0U, 2, 4, 3), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static const mxArray *c34_f_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_i96;
  int32_T c34_i97;
  int32_T c34_i98;
  real_T c34_b_inData[12];
  int32_T c34_i99;
  int32_T c34_i100;
  int32_T c34_i101;
  real_T c34_u[12];
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  c34_i96 = 0;
  for (c34_i97 = 0; c34_i97 < 4; c34_i97++) {
    for (c34_i98 = 0; c34_i98 < 3; c34_i98++) {
      c34_b_inData[c34_i98 + c34_i96] = (*(real_T (*)[12])c34_inData)[c34_i98 +
        c34_i96];
    }

    c34_i96 += 3;
  }

  c34_i99 = 0;
  for (c34_i100 = 0; c34_i100 < 4; c34_i100++) {
    for (c34_i101 = 0; c34_i101 < 3; c34_i101++) {
      c34_u[c34_i101 + c34_i99] = c34_b_inData[c34_i101 + c34_i99];
    }

    c34_i99 += 3;
  }

  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", c34_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static void c34_f_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[12])
{
  real_T c34_dv12[12];
  int32_T c34_i102;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), c34_dv12, 1, 0, 0U, 1, 0U, 2, 3,
                4);
  for (c34_i102 = 0; c34_i102 < 12; c34_i102++) {
    c34_y[c34_i102] = c34_dv12[c34_i102];
  }

  sf_mex_destroy(&c34_u);
}

static void c34_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_D;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  real_T c34_y[12];
  int32_T c34_i103;
  int32_T c34_i104;
  int32_T c34_i105;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_D = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_D), &c34_thisId, c34_y);
  sf_mex_destroy(&c34_D);
  c34_i103 = 0;
  for (c34_i104 = 0; c34_i104 < 4; c34_i104++) {
    for (c34_i105 = 0; c34_i105 < 3; c34_i105++) {
      (*(real_T (*)[12])c34_outData)[c34_i105 + c34_i103] = c34_y[c34_i105 +
        c34_i103];
    }

    c34_i103 += 3;
  }

  sf_mex_destroy(&c34_mxArrayInData);
}

static const mxArray *c34_g_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_i106;
  int32_T c34_i107;
  int32_T c34_i108;
  real_T c34_b_inData[16];
  int32_T c34_i109;
  int32_T c34_i110;
  int32_T c34_i111;
  real_T c34_u[16];
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  c34_i106 = 0;
  for (c34_i107 = 0; c34_i107 < 4; c34_i107++) {
    for (c34_i108 = 0; c34_i108 < 4; c34_i108++) {
      c34_b_inData[c34_i108 + c34_i106] = (*(real_T (*)[16])c34_inData)[c34_i108
        + c34_i106];
    }

    c34_i106 += 4;
  }

  c34_i109 = 0;
  for (c34_i110 = 0; c34_i110 < 4; c34_i110++) {
    for (c34_i111 = 0; c34_i111 < 4; c34_i111++) {
      c34_u[c34_i111 + c34_i109] = c34_b_inData[c34_i111 + c34_i109];
    }

    c34_i109 += 4;
  }

  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", c34_u, 0, 0U, 1U, 0U, 2, 4, 4), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static void c34_g_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId, real_T c34_y[16])
{
  real_T c34_dv13[16];
  int32_T c34_i112;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), c34_dv13, 1, 0, 0U, 1, 0U, 2, 4,
                4);
  for (c34_i112 = 0; c34_i112 < 16; c34_i112++) {
    c34_y[c34_i112] = c34_dv13[c34_i112];
  }

  sf_mex_destroy(&c34_u);
}

static void c34_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_B;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  real_T c34_y[16];
  int32_T c34_i113;
  int32_T c34_i114;
  int32_T c34_i115;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_B = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_B), &c34_thisId, c34_y);
  sf_mex_destroy(&c34_B);
  c34_i113 = 0;
  for (c34_i114 = 0; c34_i114 < 4; c34_i114++) {
    for (c34_i115 = 0; c34_i115 < 4; c34_i115++) {
      (*(real_T (*)[16])c34_outData)[c34_i115 + c34_i113] = c34_y[c34_i115 +
        c34_i113];
    }

    c34_i113 += 4;
  }

  sf_mex_destroy(&c34_mxArrayInData);
}

const mxArray
  *sf_c34_SimulationPlantModel_Kalman_get_eml_resolved_functions_info(void)
{
  const mxArray *c34_nameCaptureInfo;
  c34_ResolvedFunctionInfo c34_info[21];
  const mxArray *c34_m0 = NULL;
  int32_T c34_i116;
  c34_ResolvedFunctionInfo *c34_r0;
  c34_nameCaptureInfo = NULL;
  c34_nameCaptureInfo = NULL;
  c34_info_helper(c34_info);
  sf_mex_assign(&c34_m0, sf_mex_createstruct("nameCaptureInfo", 1, 21), FALSE);
  for (c34_i116 = 0; c34_i116 < 21; c34_i116++) {
    c34_r0 = &c34_info[c34_i116];
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo", c34_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c34_r0->context)), "context", "nameCaptureInfo",
                    c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo", c34_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c34_r0->name)), "name", "nameCaptureInfo",
                    c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo",
      c34_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c34_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo", c34_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c34_r0->resolved)), "resolved",
                    "nameCaptureInfo", c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo", &c34_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo", &c34_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo",
      &c34_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c34_i116);
    sf_mex_addfield(c34_m0, sf_mex_create("nameCaptureInfo",
      &c34_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c34_i116);
  }

  sf_mex_assign(&c34_nameCaptureInfo, c34_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c34_nameCaptureInfo);
  return c34_nameCaptureInfo;
}

static void c34_info_helper(c34_ResolvedFunctionInfo c34_info[21])
{
  c34_info[0].context = "";
  c34_info[0].name = "mtimes";
  c34_info[0].dominantType = "double";
  c34_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c34_info[0].fileTimeLo = 1289519692U;
  c34_info[0].fileTimeHi = 0U;
  c34_info[0].mFileTimeLo = 0U;
  c34_info[0].mFileTimeHi = 0U;
  c34_info[1].context = "";
  c34_info[1].name = "mrdivide";
  c34_info[1].dominantType = "double";
  c34_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c34_info[1].fileTimeLo = 1357951548U;
  c34_info[1].fileTimeHi = 0U;
  c34_info[1].mFileTimeLo = 1319729966U;
  c34_info[1].mFileTimeHi = 0U;
  c34_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c34_info[2].name = "rdivide";
  c34_info[2].dominantType = "double";
  c34_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c34_info[2].fileTimeLo = 1346510388U;
  c34_info[2].fileTimeHi = 0U;
  c34_info[2].mFileTimeLo = 0U;
  c34_info[2].mFileTimeHi = 0U;
  c34_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c34_info[3].name = "eml_scalexp_compatible";
  c34_info[3].dominantType = "double";
  c34_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c34_info[3].fileTimeLo = 1286818796U;
  c34_info[3].fileTimeHi = 0U;
  c34_info[3].mFileTimeLo = 0U;
  c34_info[3].mFileTimeHi = 0U;
  c34_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c34_info[4].name = "eml_div";
  c34_info[4].dominantType = "double";
  c34_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c34_info[4].fileTimeLo = 1313347810U;
  c34_info[4].fileTimeHi = 0U;
  c34_info[4].mFileTimeLo = 0U;
  c34_info[4].mFileTimeHi = 0U;
  c34_info[5].context = "";
  c34_info[5].name = "mpower";
  c34_info[5].dominantType = "double";
  c34_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c34_info[5].fileTimeLo = 1286818842U;
  c34_info[5].fileTimeHi = 0U;
  c34_info[5].mFileTimeLo = 0U;
  c34_info[5].mFileTimeHi = 0U;
  c34_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c34_info[6].name = "power";
  c34_info[6].dominantType = "double";
  c34_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c34_info[6].fileTimeLo = 1348191930U;
  c34_info[6].fileTimeHi = 0U;
  c34_info[6].mFileTimeLo = 0U;
  c34_info[6].mFileTimeHi = 0U;
  c34_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c34_info[7].name = "eml_scalar_eg";
  c34_info[7].dominantType = "double";
  c34_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c34_info[7].fileTimeLo = 1286818796U;
  c34_info[7].fileTimeHi = 0U;
  c34_info[7].mFileTimeLo = 0U;
  c34_info[7].mFileTimeHi = 0U;
  c34_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c34_info[8].name = "eml_scalexp_alloc";
  c34_info[8].dominantType = "double";
  c34_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c34_info[8].fileTimeLo = 1352424860U;
  c34_info[8].fileTimeHi = 0U;
  c34_info[8].mFileTimeLo = 0U;
  c34_info[8].mFileTimeHi = 0U;
  c34_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c34_info[9].name = "floor";
  c34_info[9].dominantType = "double";
  c34_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c34_info[9].fileTimeLo = 1343830380U;
  c34_info[9].fileTimeHi = 0U;
  c34_info[9].mFileTimeLo = 0U;
  c34_info[9].mFileTimeHi = 0U;
  c34_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c34_info[10].name = "eml_scalar_floor";
  c34_info[10].dominantType = "double";
  c34_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c34_info[10].fileTimeLo = 1286818726U;
  c34_info[10].fileTimeHi = 0U;
  c34_info[10].mFileTimeLo = 0U;
  c34_info[10].mFileTimeHi = 0U;
  c34_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c34_info[11].name = "eml_scalar_eg";
  c34_info[11].dominantType = "double";
  c34_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c34_info[11].fileTimeLo = 1286818796U;
  c34_info[11].fileTimeHi = 0U;
  c34_info[11].mFileTimeLo = 0U;
  c34_info[11].mFileTimeHi = 0U;
  c34_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c34_info[12].name = "mtimes";
  c34_info[12].dominantType = "double";
  c34_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c34_info[12].fileTimeLo = 1289519692U;
  c34_info[12].fileTimeHi = 0U;
  c34_info[12].mFileTimeLo = 0U;
  c34_info[12].mFileTimeHi = 0U;
  c34_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c34_info[13].name = "eml_index_class";
  c34_info[13].dominantType = "";
  c34_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c34_info[13].fileTimeLo = 1323170578U;
  c34_info[13].fileTimeHi = 0U;
  c34_info[13].mFileTimeLo = 0U;
  c34_info[13].mFileTimeHi = 0U;
  c34_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c34_info[14].name = "eml_scalar_eg";
  c34_info[14].dominantType = "double";
  c34_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c34_info[14].fileTimeLo = 1286818796U;
  c34_info[14].fileTimeHi = 0U;
  c34_info[14].mFileTimeLo = 0U;
  c34_info[14].mFileTimeHi = 0U;
  c34_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c34_info[15].name = "eml_xgemm";
  c34_info[15].dominantType = "char";
  c34_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c34_info[15].fileTimeLo = 1299076772U;
  c34_info[15].fileTimeHi = 0U;
  c34_info[15].mFileTimeLo = 0U;
  c34_info[15].mFileTimeHi = 0U;
  c34_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c34_info[16].name = "eml_blas_inline";
  c34_info[16].dominantType = "";
  c34_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c34_info[16].fileTimeLo = 1299076768U;
  c34_info[16].fileTimeHi = 0U;
  c34_info[16].mFileTimeLo = 0U;
  c34_info[16].mFileTimeHi = 0U;
  c34_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c34_info[17].name = "mtimes";
  c34_info[17].dominantType = "double";
  c34_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c34_info[17].fileTimeLo = 1289519692U;
  c34_info[17].fileTimeHi = 0U;
  c34_info[17].mFileTimeLo = 0U;
  c34_info[17].mFileTimeHi = 0U;
  c34_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c34_info[18].name = "eml_index_class";
  c34_info[18].dominantType = "";
  c34_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c34_info[18].fileTimeLo = 1323170578U;
  c34_info[18].fileTimeHi = 0U;
  c34_info[18].mFileTimeLo = 0U;
  c34_info[18].mFileTimeHi = 0U;
  c34_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c34_info[19].name = "eml_scalar_eg";
  c34_info[19].dominantType = "double";
  c34_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c34_info[19].fileTimeLo = 1286818796U;
  c34_info[19].fileTimeHi = 0U;
  c34_info[19].mFileTimeLo = 0U;
  c34_info[19].mFileTimeHi = 0U;
  c34_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c34_info[20].name = "eml_refblas_xgemm";
  c34_info[20].dominantType = "char";
  c34_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c34_info[20].fileTimeLo = 1299076774U;
  c34_info[20].fileTimeHi = 0U;
  c34_info[20].mFileTimeLo = 0U;
  c34_info[20].mFileTimeHi = 0U;
}

static real_T c34_mpower(SFc34_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c34_a)
{
  real_T c34_b_a;
  real_T c34_c_a;
  real_T c34_ak;
  real_T c34_d_a;
  real_T c34_e_a;
  real_T c34_b;
  c34_b_a = c34_a;
  c34_c_a = c34_b_a;
  c34_eml_scalar_eg(chartInstance);
  c34_ak = c34_c_a;
  c34_d_a = c34_ak;
  c34_eml_scalar_eg(chartInstance);
  c34_e_a = c34_d_a;
  c34_b = c34_d_a;
  return c34_e_a * c34_b;
}

static void c34_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance)
{
}

static real_T c34_b_mpower(SFc34_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c34_a)
{
  real_T c34_b_a;
  real_T c34_c_a;
  real_T c34_ak;
  real_T c34_d_a;
  real_T c34_ar;
  c34_b_a = c34_a;
  c34_c_a = c34_b_a;
  c34_eml_scalar_eg(chartInstance);
  c34_ak = c34_c_a;
  c34_d_a = c34_ak;
  c34_eml_scalar_eg(chartInstance);
  c34_ar = c34_d_a;
  return muDoubleScalarPower(c34_ar, 3.0);
}

static void c34_b_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static void c34_c_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static void c34_d_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static void c34_e_eml_scalar_eg(SFc34_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static const mxArray *c34_h_sf_marshallOut(void *chartInstanceVoid, void
  *c34_inData)
{
  const mxArray *c34_mxArrayOutData = NULL;
  int32_T c34_u;
  const mxArray *c34_y = NULL;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_mxArrayOutData = NULL;
  c34_u = *(int32_T *)c34_inData;
  c34_y = NULL;
  sf_mex_assign(&c34_y, sf_mex_create("y", &c34_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c34_mxArrayOutData, c34_y, FALSE);
  return c34_mxArrayOutData;
}

static int32_T c34_h_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId)
{
  int32_T c34_y;
  int32_T c34_i117;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), &c34_i117, 1, 6, 0U, 0, 0U, 0);
  c34_y = c34_i117;
  sf_mex_destroy(&c34_u);
  return c34_y;
}

static void c34_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c34_mxArrayInData, const char_T *c34_varName, void *c34_outData)
{
  const mxArray *c34_b_sfEvent;
  const char_T *c34_identifier;
  emlrtMsgIdentifier c34_thisId;
  int32_T c34_y;
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c34_b_sfEvent = sf_mex_dup(c34_mxArrayInData);
  c34_identifier = c34_varName;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_y = c34_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c34_b_sfEvent),
    &c34_thisId);
  sf_mex_destroy(&c34_b_sfEvent);
  *(int32_T *)c34_outData = c34_y;
  sf_mex_destroy(&c34_mxArrayInData);
}

static uint8_T c34_i_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_b_is_active_c34_SimulationPlantModel_Kalman, const char_T
   *c34_identifier)
{
  uint8_T c34_y;
  emlrtMsgIdentifier c34_thisId;
  c34_thisId.fIdentifier = c34_identifier;
  c34_thisId.fParent = NULL;
  c34_y = c34_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c34_b_is_active_c34_SimulationPlantModel_Kalman), &c34_thisId);
  sf_mex_destroy(&c34_b_is_active_c34_SimulationPlantModel_Kalman);
  return c34_y;
}

static uint8_T c34_j_emlrt_marshallIn
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c34_u, const emlrtMsgIdentifier *c34_parentId)
{
  uint8_T c34_y;
  uint8_T c34_u0;
  sf_mex_import(c34_parentId, sf_mex_dup(c34_u), &c34_u0, 1, 3, 0U, 0, 0U, 0);
  c34_y = c34_u0;
  sf_mex_destroy(&c34_u);
  return c34_y;
}

static void init_dsm_address_info
  (SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c34_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(784116032U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3049622575U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2730806761U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1772532514U);
}

mxArray *sf_c34_SimulationPlantModel_Kalman_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("tX1haeiFa1eYLF43l8L1KB");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,10,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c34_SimulationPlantModel_Kalman_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c34_SimulationPlantModel_Kalman(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[31],T\"d_delta\",},{M[1],M[34],T\"d_i_f\",},{M[1],M[32],T\"d_omega\",},{M[1],M[33],T\"d_t_m\",},{M[1],M[28],T\"r1\",},{M[1],M[29],T\"r2\",},{M[1],M[30],T\"r3\",},{M[8],M[0],T\"is_active_c34_SimulationPlantModel_Kalman\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c34_SimulationPlantModel_Kalman_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
    chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_KalmanMachineNumber_,
           34,
           1,
           1,
           23,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_KalmanMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"y");
          _SFD_SET_DATA_PROPS(1,1,1,0,"u_vector");
          _SFD_SET_DATA_PROPS(2,1,1,0,"delta");
          _SFD_SET_DATA_PROPS(3,1,1,0,"omega");
          _SFD_SET_DATA_PROPS(4,1,1,0,"t_m");
          _SFD_SET_DATA_PROPS(5,1,1,0,"i_f");
          _SFD_SET_DATA_PROPS(6,2,0,1,"r1");
          _SFD_SET_DATA_PROPS(7,2,0,1,"r2");
          _SFD_SET_DATA_PROPS(8,2,0,1,"r3");
          _SFD_SET_DATA_PROPS(9,2,0,1,"d_delta");
          _SFD_SET_DATA_PROPS(10,2,0,1,"d_omega");
          _SFD_SET_DATA_PROPS(11,2,0,1,"d_t_m");
          _SFD_SET_DATA_PROPS(12,2,0,1,"d_i_f");
          _SFD_SET_DATA_PROPS(13,10,0,0,"x_0");
          _SFD_SET_DATA_PROPS(14,10,0,0,"u_0");
          _SFD_SET_DATA_PROPS(15,10,0,0,"H_G");
          _SFD_SET_DATA_PROPS(16,10,0,0,"D_fw_G");
          _SFD_SET_DATA_PROPS(17,10,0,0,"z_G");
          _SFD_SET_DATA_PROPS(18,10,0,0,"tau_e_G");
          _SFD_SET_DATA_PROPS(19,10,0,0,"tau_f_G");
          _SFD_SET_DATA_PROPS(20,10,0,0,"r_f_G");
          _SFD_SET_DATA_PROPS(21,10,0,0,"GeneratorNumber");
          _SFD_SET_DATA_PROPS(22,10,0,0,"omega_b");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1476);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_d_sf_marshallOut,(MexInFcnForType)
            c34_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_d_sf_marshallOut,(MexInFcnForType)
            c34_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_b_sf_marshallOut,(MexInFcnForType)
            c34_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_b_sf_marshallOut,(MexInFcnForType)
            c34_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_c_sf_marshallOut,(MexInFcnForType)
            c34_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(18,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_b_sf_marshallOut,(MexInFcnForType)
            c34_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(19,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_b_sf_marshallOut,(MexInFcnForType)
            c34_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(20,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c34_b_sf_marshallOut,(MexInFcnForType)
            c34_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(21,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(22,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c34_sf_marshallOut,(MexInFcnForType)c34_sf_marshallIn);

        {
          real_T *c34_delta;
          real_T *c34_omega;
          real_T *c34_t_m;
          real_T *c34_i_f;
          real_T *c34_r1;
          real_T *c34_r2;
          real_T *c34_r3;
          real_T *c34_d_delta;
          real_T *c34_d_omega;
          real_T *c34_d_t_m;
          real_T *c34_d_i_f;
          real_T (*c34_y)[3];
          real_T (*c34_u_vector)[4];
          c34_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
          c34_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c34_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c34_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c34_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c34_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c34_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c34_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c34_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c34_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c34_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c34_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c34_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c34_y);
          _SFD_SET_DATA_VALUE_PTR(1U, *c34_u_vector);
          _SFD_SET_DATA_VALUE_PTR(2U, c34_delta);
          _SFD_SET_DATA_VALUE_PTR(3U, c34_omega);
          _SFD_SET_DATA_VALUE_PTR(4U, c34_t_m);
          _SFD_SET_DATA_VALUE_PTR(5U, c34_i_f);
          _SFD_SET_DATA_VALUE_PTR(6U, c34_r1);
          _SFD_SET_DATA_VALUE_PTR(7U, c34_r2);
          _SFD_SET_DATA_VALUE_PTR(8U, c34_r3);
          _SFD_SET_DATA_VALUE_PTR(9U, c34_d_delta);
          _SFD_SET_DATA_VALUE_PTR(10U, c34_d_omega);
          _SFD_SET_DATA_VALUE_PTR(11U, c34_d_t_m);
          _SFD_SET_DATA_VALUE_PTR(12U, c34_d_i_f);
          _SFD_SET_DATA_VALUE_PTR(13U, chartInstance->c34_x_0);
          _SFD_SET_DATA_VALUE_PTR(14U, chartInstance->c34_u_0);
          _SFD_SET_DATA_VALUE_PTR(15U, chartInstance->c34_H_G);
          _SFD_SET_DATA_VALUE_PTR(16U, chartInstance->c34_D_fw_G);
          _SFD_SET_DATA_VALUE_PTR(17U, chartInstance->c34_z_G);
          _SFD_SET_DATA_VALUE_PTR(18U, chartInstance->c34_tau_e_G);
          _SFD_SET_DATA_VALUE_PTR(19U, chartInstance->c34_tau_f_G);
          _SFD_SET_DATA_VALUE_PTR(20U, chartInstance->c34_r_f_G);
          _SFD_SET_DATA_VALUE_PTR(21U, &chartInstance->c34_GeneratorNumber);
          _SFD_SET_DATA_VALUE_PTR(22U, &chartInstance->c34_omega_b);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_KalmanMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "XZfkIXCW3eH7IsXbMUHwlD";
}

static void sf_opaque_initialize_c34_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc34_SimulationPlantModel_KalmanInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
  initialize_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c34_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  enable_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c34_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  disable_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c34_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  sf_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c34_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c34_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c34_SimulationPlantModel_Kalman(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c34_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c34_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c34_SimulationPlantModel_Kalman(S);
}

static void sf_opaque_set_sim_state_c34_SimulationPlantModel_Kalman(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c34_SimulationPlantModel_Kalman(S, st);
}

static void sf_opaque_terminate_c34_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc34_SimulationPlantModel_KalmanInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Kalman_optimization_info();
    }

    finalize_c34_SimulationPlantModel_Kalman
      ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc34_SimulationPlantModel_Kalman
    ((SFc34_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c34_SimulationPlantModel_Kalman(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c34_SimulationPlantModel_Kalman
      ((SFc34_SimulationPlantModel_KalmanInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c34_SimulationPlantModel_Kalman(SimStruct *S)
{
  /* Actual parameters from chart:
     D_fw_G GeneratorNumber H_G omega_b r_f_G tau_e_G tau_f_G u_0 x_0 z_G
   */
  const char_T *rtParamNames[] = { "D_fw_G", "GeneratorNumber", "H_G", "omega_b",
    "r_f_G", "tau_e_G", "tau_f_G", "u_0", "x_0", "z_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for D_fw_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for H_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for omega_b*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for r_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for tau_e_G*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);

  /* registration for tau_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 6, 6, rtParamNames[6], SS_DOUBLE);

  /* registration for u_0*/
  ssRegDlgParamAsRunTimeParam(S, 7, 7, rtParamNames[7], SS_DOUBLE);

  /* registration for x_0*/
  ssRegDlgParamAsRunTimeParam(S, 8, 8, rtParamNames[8], SS_DOUBLE);

  /* registration for z_G*/
  ssRegDlgParamAsRunTimeParam(S, 9, 9, rtParamNames[9], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Kalman_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      34);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,34,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,34,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,34);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,34,6);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,34,7);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=7; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 6; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,34);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2636614823U));
  ssSetChecksum1(S,(3458539673U));
  ssSetChecksum2(S,(1302847399U));
  ssSetChecksum3(S,(1186624958U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c34_SimulationPlantModel_Kalman(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c34_SimulationPlantModel_Kalman(SimStruct *S)
{
  SFc34_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc34_SimulationPlantModel_KalmanInstanceStruct *)utMalloc
    (sizeof(SFc34_SimulationPlantModel_KalmanInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc34_SimulationPlantModel_KalmanInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlStart = mdlStart_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c34_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c34_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c34_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c34_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c34_SimulationPlantModel_Kalman(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c34_SimulationPlantModel_Kalman_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
