/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c27_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c27_debug_family_names[11] = { "N_faults", "u_0", "u_min",
  "u_max", "nargin", "nargout", "u", "f_u_matrix", "f_u_magnitudes",
  "GeneratorNumber", "f_u" };

/* Function Declarations */
static void initialize_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c27_update_debugger_state_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_st);
static void finalize_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c27_machineNumber, uint32_T
  c27_chartNumber);
static const mxArray *c27_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData);
static real_T c27_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_f_u, const char_T *c27_identifier);
static real_T c27_b_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId);
static void c27_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData);
static const mxArray *c27_b_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData);
static void c27_c_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId, real_T c27_y[9]);
static void c27_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData);
static const mxArray *c27_c_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData);
static void c27_d_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId, real_T c27_y[12]);
static void c27_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData);
static const mxArray *c27_d_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData);
static int32_T c27_e_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId);
static void c27_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData);
static uint8_T c27_f_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_b_is_active_c27_SimulationPlantModel_Luenberg, const char_T
   *c27_identifier);
static uint8_T c27_g_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId);
static void init_dsm_address_info
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c27_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c27_is_active_c27_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  real_T c27_dv0[12];
  int32_T c27_i0;
  real_T c27_dv1[9];
  int32_T c27_i1;
  real_T c27_d0;
  sf_set_error_prefix_string(
    "Error evaluating data 'f_u_matrix' in the parent workspace.\n");
  sf_mex_import_named("f_u_matrix", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c27_dv0, 0, 0, 0U, 1, 0U, 2, 3, 4);
  for (c27_i0 = 0; c27_i0 < 12; c27_i0++) {
    chartInstance->c27_f_u_matrix[c27_i0] = c27_dv0[c27_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'f_u_magnitudes' in the parent workspace.\n");
  sf_mex_import_named("f_u_magnitudes", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), c27_dv1, 0, 0, 0U, 1, 0U, 2, 3, 3);
  for (c27_i1 = 0; c27_i1 < 9; c27_i1++) {
    chartInstance->c27_f_u_magnitudes[c27_i1] = c27_dv1[c27_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    0, 0), &c27_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c27_GeneratorNumber = c27_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c27_update_debugger_state_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c27_st;
  const mxArray *c27_y = NULL;
  real_T c27_hoistedGlobal;
  real_T c27_u;
  const mxArray *c27_b_y = NULL;
  uint8_T c27_b_hoistedGlobal;
  uint8_T c27_b_u;
  const mxArray *c27_c_y = NULL;
  real_T *c27_f_u;
  c27_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c27_st = NULL;
  c27_st = NULL;
  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_createcellarray(2), FALSE);
  c27_hoistedGlobal = *c27_f_u;
  c27_u = c27_hoistedGlobal;
  c27_b_y = NULL;
  sf_mex_assign(&c27_b_y, sf_mex_create("y", &c27_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c27_y, 0, c27_b_y);
  c27_b_hoistedGlobal =
    chartInstance->c27_is_active_c27_SimulationPlantModel_Luenberg;
  c27_b_u = c27_b_hoistedGlobal;
  c27_c_y = NULL;
  sf_mex_assign(&c27_c_y, sf_mex_create("y", &c27_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c27_y, 1, c27_c_y);
  sf_mex_assign(&c27_st, c27_y, FALSE);
  return c27_st;
}

static void set_sim_state_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_st)
{
  const mxArray *c27_u;
  real_T *c27_f_u;
  c27_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c27_doneDoubleBufferReInit = TRUE;
  c27_u = sf_mex_dup(c27_st);
  *c27_f_u = c27_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c27_u,
    0)), "f_u");
  chartInstance->c27_is_active_c27_SimulationPlantModel_Luenberg =
    c27_f_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c27_u, 1)),
    "is_active_c27_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c27_u);
  c27_update_debugger_state_c27_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c27_st);
}

static void finalize_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  int32_T c27_i2;
  int32_T c27_i3;
  real_T c27_hoistedGlobal;
  real_T c27_b_hoistedGlobal;
  real_T c27_u;
  int32_T c27_i4;
  real_T c27_b_f_u_matrix[12];
  int32_T c27_i5;
  real_T c27_b_f_u_magnitudes[9];
  real_T c27_b_GeneratorNumber;
  uint32_T c27_debug_family_var_map[11];
  real_T c27_N_faults;
  real_T c27_u_0;
  real_T c27_u_min;
  real_T c27_u_max;
  real_T c27_nargin = 4.0;
  real_T c27_nargout = 1.0;
  real_T c27_f_u;
  real_T *c27_b_u;
  real_T *c27_b_f_u;
  c27_b_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c27_b_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 26U, chartInstance->c27_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c27_b_u, 0U);
  for (c27_i2 = 0; c27_i2 < 12; c27_i2++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c27_f_u_matrix[c27_i2], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c27_b_f_u, 2U);
  for (c27_i3 = 0; c27_i3 < 9; c27_i3++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c27_f_u_magnitudes[c27_i3], 3U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c27_GeneratorNumber, 4U);
  chartInstance->c27_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 26U, chartInstance->c27_sfEvent);
  c27_hoistedGlobal = *c27_b_u;
  c27_b_hoistedGlobal = chartInstance->c27_GeneratorNumber;
  c27_u = c27_hoistedGlobal;
  for (c27_i4 = 0; c27_i4 < 12; c27_i4++) {
    c27_b_f_u_matrix[c27_i4] = chartInstance->c27_f_u_matrix[c27_i4];
  }

  for (c27_i5 = 0; c27_i5 < 9; c27_i5++) {
    c27_b_f_u_magnitudes[c27_i5] = chartInstance->c27_f_u_magnitudes[c27_i5];
  }

  c27_b_GeneratorNumber = c27_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c27_debug_family_names,
    c27_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_N_faults, 0U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_u_0, 1U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_u_min, 2U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_u_max, 3U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_nargin, 4U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_nargout, 5U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c27_u, 6U, c27_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c27_b_f_u_matrix, 7U,
    c27_c_sf_marshallOut, c27_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c27_b_f_u_magnitudes, 8U,
    c27_b_sf_marshallOut, c27_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_b_GeneratorNumber, 9U,
    c27_sf_marshallOut, c27_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c27_f_u, 10U, c27_sf_marshallOut,
    c27_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 5);
  c27_N_faults = ((c27_b_f_u_matrix[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK
                   ("f_u_matrix", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c27_b_GeneratorNumber), 1, 3, 1, 0) - 1] + c27_b_f_u_matrix[(int32_T)(real_T)
                   _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c27_b_GeneratorNumber), 1, 3, 1, 0) +
                   2]) + c27_b_f_u_matrix[(int32_T)(real_T)
                  _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c27_b_GeneratorNumber), 1, 3, 1, 0) +
                  5]) + c27_b_f_u_matrix[(int32_T)(real_T)
    _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)_SFD_INTEGER_CHECK(
    "GeneratorNumber", c27_b_GeneratorNumber), 1, 3, 1, 0) + 8];
  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 6);
  c27_u_0 = c27_b_f_u_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_u_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c27_b_GeneratorNumber), 1, 3, 1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 7);
  c27_u_min = c27_b_f_u_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_u_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c27_b_GeneratorNumber), 1, 3, 1, 0) + 2];
  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 8);
  c27_u_max = c27_b_f_u_magnitudes[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK(
    "f_u_magnitudes", (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber",
    c27_b_GeneratorNumber), 1, 3, 1, 0) + 5];
  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 11);
  c27_f_u = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 12);
  if (CV_EML_IF(0, 1, 0, c27_N_faults >= 2.0)) {
    _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 13);
    c27_f_u = 0.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 14);
    if (CV_EML_IF(0, 1, 1, c27_b_f_u_matrix[(int32_T)(real_T)
                  _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
          _SFD_INTEGER_CHECK("GeneratorNumber", c27_b_GeneratorNumber), 1, 3, 1,
          0) - 1] == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 15);
      c27_f_u = 0.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 16);
      if (CV_EML_IF(0, 1, 2, c27_b_f_u_matrix[(int32_T)(real_T)
                    _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
            _SFD_INTEGER_CHECK("GeneratorNumber", c27_b_GeneratorNumber), 1, 3,
            1, 0) + 2] == 1.0)) {
        _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 17);
        c27_f_u = c27_u_0 - c27_u;
      } else {
        _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 18);
        if (CV_EML_IF(0, 1, 3, c27_b_f_u_matrix[(int32_T)(real_T)
                      _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
              _SFD_INTEGER_CHECK("GeneratorNumber", c27_b_GeneratorNumber), 1, 3,
              1, 0) + 5] == 1.0)) {
          _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 19);
          c27_f_u = c27_u_min - c27_u;
        } else {
          _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 20);
          if (CV_EML_IF(0, 1, 4, c27_b_f_u_matrix[(int32_T)(real_T)
                        _SFD_EML_ARRAY_BOUNDS_CHECK("f_u_matrix", (int32_T)
                _SFD_INTEGER_CHECK("GeneratorNumber", c27_b_GeneratorNumber), 1,
                3, 1, 0) + 8] == 1.0)) {
            _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, 21);
            c27_f_u = c27_u_max - c27_u;
          }
        }
      }
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c27_sfEvent, -21);
  _SFD_SYMBOL_SCOPE_POP();
  *c27_b_f_u = c27_f_u;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 26U, chartInstance->c27_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc27_SimulationPlantModel_Luenberg
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c27_machineNumber, uint32_T
  c27_chartNumber)
{
}

static const mxArray *c27_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData)
{
  const mxArray *c27_mxArrayOutData = NULL;
  real_T c27_u;
  const mxArray *c27_y = NULL;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_mxArrayOutData = NULL;
  c27_u = *(real_T *)c27_inData;
  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_create("y", &c27_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c27_mxArrayOutData, c27_y, FALSE);
  return c27_mxArrayOutData;
}

static real_T c27_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_f_u, const char_T *c27_identifier)
{
  real_T c27_y;
  emlrtMsgIdentifier c27_thisId;
  c27_thisId.fIdentifier = c27_identifier;
  c27_thisId.fParent = NULL;
  c27_y = c27_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c27_f_u), &c27_thisId);
  sf_mex_destroy(&c27_f_u);
  return c27_y;
}

static real_T c27_b_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId)
{
  real_T c27_y;
  real_T c27_d1;
  sf_mex_import(c27_parentId, sf_mex_dup(c27_u), &c27_d1, 1, 0, 0U, 0, 0U, 0);
  c27_y = c27_d1;
  sf_mex_destroy(&c27_u);
  return c27_y;
}

static void c27_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData)
{
  const mxArray *c27_f_u;
  const char_T *c27_identifier;
  emlrtMsgIdentifier c27_thisId;
  real_T c27_y;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_f_u = sf_mex_dup(c27_mxArrayInData);
  c27_identifier = c27_varName;
  c27_thisId.fIdentifier = c27_identifier;
  c27_thisId.fParent = NULL;
  c27_y = c27_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c27_f_u), &c27_thisId);
  sf_mex_destroy(&c27_f_u);
  *(real_T *)c27_outData = c27_y;
  sf_mex_destroy(&c27_mxArrayInData);
}

static const mxArray *c27_b_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData)
{
  const mxArray *c27_mxArrayOutData = NULL;
  int32_T c27_i6;
  int32_T c27_i7;
  int32_T c27_i8;
  real_T c27_b_inData[9];
  int32_T c27_i9;
  int32_T c27_i10;
  int32_T c27_i11;
  real_T c27_u[9];
  const mxArray *c27_y = NULL;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_mxArrayOutData = NULL;
  c27_i6 = 0;
  for (c27_i7 = 0; c27_i7 < 3; c27_i7++) {
    for (c27_i8 = 0; c27_i8 < 3; c27_i8++) {
      c27_b_inData[c27_i8 + c27_i6] = (*(real_T (*)[9])c27_inData)[c27_i8 +
        c27_i6];
    }

    c27_i6 += 3;
  }

  c27_i9 = 0;
  for (c27_i10 = 0; c27_i10 < 3; c27_i10++) {
    for (c27_i11 = 0; c27_i11 < 3; c27_i11++) {
      c27_u[c27_i11 + c27_i9] = c27_b_inData[c27_i11 + c27_i9];
    }

    c27_i9 += 3;
  }

  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_create("y", c27_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c27_mxArrayOutData, c27_y, FALSE);
  return c27_mxArrayOutData;
}

static void c27_c_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId, real_T c27_y[9])
{
  real_T c27_dv2[9];
  int32_T c27_i12;
  sf_mex_import(c27_parentId, sf_mex_dup(c27_u), c27_dv2, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c27_i12 = 0; c27_i12 < 9; c27_i12++) {
    c27_y[c27_i12] = c27_dv2[c27_i12];
  }

  sf_mex_destroy(&c27_u);
}

static void c27_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData)
{
  const mxArray *c27_b_f_u_magnitudes;
  const char_T *c27_identifier;
  emlrtMsgIdentifier c27_thisId;
  real_T c27_y[9];
  int32_T c27_i13;
  int32_T c27_i14;
  int32_T c27_i15;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_b_f_u_magnitudes = sf_mex_dup(c27_mxArrayInData);
  c27_identifier = c27_varName;
  c27_thisId.fIdentifier = c27_identifier;
  c27_thisId.fParent = NULL;
  c27_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c27_b_f_u_magnitudes),
    &c27_thisId, c27_y);
  sf_mex_destroy(&c27_b_f_u_magnitudes);
  c27_i13 = 0;
  for (c27_i14 = 0; c27_i14 < 3; c27_i14++) {
    for (c27_i15 = 0; c27_i15 < 3; c27_i15++) {
      (*(real_T (*)[9])c27_outData)[c27_i15 + c27_i13] = c27_y[c27_i15 + c27_i13];
    }

    c27_i13 += 3;
  }

  sf_mex_destroy(&c27_mxArrayInData);
}

static const mxArray *c27_c_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData)
{
  const mxArray *c27_mxArrayOutData = NULL;
  int32_T c27_i16;
  int32_T c27_i17;
  int32_T c27_i18;
  real_T c27_b_inData[12];
  int32_T c27_i19;
  int32_T c27_i20;
  int32_T c27_i21;
  real_T c27_u[12];
  const mxArray *c27_y = NULL;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_mxArrayOutData = NULL;
  c27_i16 = 0;
  for (c27_i17 = 0; c27_i17 < 4; c27_i17++) {
    for (c27_i18 = 0; c27_i18 < 3; c27_i18++) {
      c27_b_inData[c27_i18 + c27_i16] = (*(real_T (*)[12])c27_inData)[c27_i18 +
        c27_i16];
    }

    c27_i16 += 3;
  }

  c27_i19 = 0;
  for (c27_i20 = 0; c27_i20 < 4; c27_i20++) {
    for (c27_i21 = 0; c27_i21 < 3; c27_i21++) {
      c27_u[c27_i21 + c27_i19] = c27_b_inData[c27_i21 + c27_i19];
    }

    c27_i19 += 3;
  }

  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_create("y", c27_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c27_mxArrayOutData, c27_y, FALSE);
  return c27_mxArrayOutData;
}

static void c27_d_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId, real_T c27_y[12])
{
  real_T c27_dv3[12];
  int32_T c27_i22;
  sf_mex_import(c27_parentId, sf_mex_dup(c27_u), c27_dv3, 1, 0, 0U, 1, 0U, 2, 3,
                4);
  for (c27_i22 = 0; c27_i22 < 12; c27_i22++) {
    c27_y[c27_i22] = c27_dv3[c27_i22];
  }

  sf_mex_destroy(&c27_u);
}

static void c27_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData)
{
  const mxArray *c27_b_f_u_matrix;
  const char_T *c27_identifier;
  emlrtMsgIdentifier c27_thisId;
  real_T c27_y[12];
  int32_T c27_i23;
  int32_T c27_i24;
  int32_T c27_i25;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_b_f_u_matrix = sf_mex_dup(c27_mxArrayInData);
  c27_identifier = c27_varName;
  c27_thisId.fIdentifier = c27_identifier;
  c27_thisId.fParent = NULL;
  c27_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c27_b_f_u_matrix),
    &c27_thisId, c27_y);
  sf_mex_destroy(&c27_b_f_u_matrix);
  c27_i23 = 0;
  for (c27_i24 = 0; c27_i24 < 4; c27_i24++) {
    for (c27_i25 = 0; c27_i25 < 3; c27_i25++) {
      (*(real_T (*)[12])c27_outData)[c27_i25 + c27_i23] = c27_y[c27_i25 +
        c27_i23];
    }

    c27_i23 += 3;
  }

  sf_mex_destroy(&c27_mxArrayInData);
}

const mxArray
  *sf_c27_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c27_nameCaptureInfo = NULL;
  c27_nameCaptureInfo = NULL;
  sf_mex_assign(&c27_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c27_nameCaptureInfo;
}

static const mxArray *c27_d_sf_marshallOut(void *chartInstanceVoid, void
  *c27_inData)
{
  const mxArray *c27_mxArrayOutData = NULL;
  int32_T c27_u;
  const mxArray *c27_y = NULL;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_mxArrayOutData = NULL;
  c27_u = *(int32_T *)c27_inData;
  c27_y = NULL;
  sf_mex_assign(&c27_y, sf_mex_create("y", &c27_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c27_mxArrayOutData, c27_y, FALSE);
  return c27_mxArrayOutData;
}

static int32_T c27_e_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId)
{
  int32_T c27_y;
  int32_T c27_i26;
  sf_mex_import(c27_parentId, sf_mex_dup(c27_u), &c27_i26, 1, 6, 0U, 0, 0U, 0);
  c27_y = c27_i26;
  sf_mex_destroy(&c27_u);
  return c27_y;
}

static void c27_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c27_mxArrayInData, const char_T *c27_varName, void *c27_outData)
{
  const mxArray *c27_b_sfEvent;
  const char_T *c27_identifier;
  emlrtMsgIdentifier c27_thisId;
  int32_T c27_y;
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c27_b_sfEvent = sf_mex_dup(c27_mxArrayInData);
  c27_identifier = c27_varName;
  c27_thisId.fIdentifier = c27_identifier;
  c27_thisId.fParent = NULL;
  c27_y = c27_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c27_b_sfEvent),
    &c27_thisId);
  sf_mex_destroy(&c27_b_sfEvent);
  *(int32_T *)c27_outData = c27_y;
  sf_mex_destroy(&c27_mxArrayInData);
}

static uint8_T c27_f_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_b_is_active_c27_SimulationPlantModel_Luenberg, const char_T
   *c27_identifier)
{
  uint8_T c27_y;
  emlrtMsgIdentifier c27_thisId;
  c27_thisId.fIdentifier = c27_identifier;
  c27_thisId.fParent = NULL;
  c27_y = c27_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c27_b_is_active_c27_SimulationPlantModel_Luenberg), &c27_thisId);
  sf_mex_destroy(&c27_b_is_active_c27_SimulationPlantModel_Luenberg);
  return c27_y;
}

static uint8_T c27_g_emlrt_marshallIn
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c27_u, const emlrtMsgIdentifier *c27_parentId)
{
  uint8_T c27_y;
  uint8_T c27_u0;
  sf_mex_import(c27_parentId, sf_mex_dup(c27_u), &c27_u0, 1, 3, 0U, 0, 0U, 0);
  c27_y = c27_u0;
  sf_mex_destroy(&c27_u);
  return c27_y;
}

static void init_dsm_address_info
  (SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c27_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1966940270U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(114620451U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3021224464U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3737718114U);
}

mxArray *sf_c27_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("u89xqnGgjiZysvC9cmrAq");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(4);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c27_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c27_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"f_u\",},{M[8],M[0],T\"is_active_c27_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c27_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           27,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"u");
          _SFD_SET_DATA_PROPS(1,10,0,0,"f_u_matrix");
          _SFD_SET_DATA_PROPS(2,2,0,1,"f_u");
          _SFD_SET_DATA_PROPS(3,10,0,0,"f_u_magnitudes");
          _SFD_SET_DATA_PROPS(4,10,0,0,"GeneratorNumber");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,5,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,738);
        _SFD_CV_INIT_EML_IF(0,1,0,462,478,492,533);
        _SFD_CV_INIT_EML_IF(0,1,1,492,533,547,737);
        _SFD_CV_INIT_EML_IF(0,1,2,547,588,608,737);
        _SFD_CV_INIT_EML_IF(0,1,3,608,649,671,737);
        _SFD_CV_INIT_EML_IF(0,1,4,671,712,-1,712);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c27_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c27_c_sf_marshallOut,(MexInFcnForType)
            c27_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c27_sf_marshallOut,(MexInFcnForType)c27_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c27_b_sf_marshallOut,(MexInFcnForType)
            c27_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c27_sf_marshallOut,(MexInFcnForType)c27_sf_marshallIn);

        {
          real_T *c27_u;
          real_T *c27_f_u;
          c27_f_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c27_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c27_u);
          _SFD_SET_DATA_VALUE_PTR(1U, chartInstance->c27_f_u_matrix);
          _SFD_SET_DATA_VALUE_PTR(2U, c27_f_u);
          _SFD_SET_DATA_VALUE_PTR(3U, chartInstance->c27_f_u_magnitudes);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c27_GeneratorNumber);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "CFMsXbEyXt0MXfeRQnxlpH";
}

static void sf_opaque_initialize_c27_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc27_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c27_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c27_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c27_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c27_SimulationPlantModel_Luenberg(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c27_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c27_SimulationPlantModel_Luenberg
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c27_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c27_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c27_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c27_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c27_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c27_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c27_SimulationPlantModel_Luenberg
      ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc27_SimulationPlantModel_Luenberg
    ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c27_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c27_SimulationPlantModel_Luenberg
      ((SFc27_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c27_SimulationPlantModel_Luenberg(SimStruct *S)
{
  /* Actual parameters from chart:
     GeneratorNumber f_u_magnitudes f_u_matrix
   */
  const char_T *rtParamNames[] = { "GeneratorNumber", "f_u_magnitudes",
    "f_u_matrix" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for f_u_magnitudes*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for f_u_matrix*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      27);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,27,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,27,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,27);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,27,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,27,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 1; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,27);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2717600963U));
  ssSetChecksum1(S,(68735232U));
  ssSetChecksum2(S,(1109376266U));
  ssSetChecksum3(S,(2466876541U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c27_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c27_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc27_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc27_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc27_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc27_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c27_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c27_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c27_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c27_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c27_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c27_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
