/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Kalman_sfun.h"
#include "c35_SimulationPlantModel_Kalman.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Kalman_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c35_debug_family_names[55] = { "a", "b", "c", "d", "e", "g",
  "h", "k", "m", "n", "x_01", "x_02", "x_03", "x_04", "u_01", "u_02", "u_03",
  "u_04", "x1", "x2", "x3", "x4", "x", "A", "B", "C", "D", "K", "d_x", "r",
  "nargin", "nargout", "y", "u_vector", "delta", "omega", "t_m", "i_f", "x_0",
  "u_0", "H_G", "D_fw_G", "z_G", "tau_e_G", "tau_f_G", "r_f_G",
  "GeneratorNumber", "omega_b", "r1", "r2", "r3", "d_delta", "d_omega", "d_t_m",
  "d_i_f" };

/* Function Declarations */
static void initialize_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initialize_params_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void enable_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void disable_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c35_update_debugger_state_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void set_sim_state_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_st);
static void finalize_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void sf_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void c35_chartstep_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void initSimStructsc35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void registerMessagesc35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c35_machineNumber, uint32_T
  c35_chartNumber);
static const mxArray *c35_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static real_T c35_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_d_i_f, const char_T *c35_identifier);
static real_T c35_b_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId);
static void c35_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static const mxArray *c35_b_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static void c35_c_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[3]);
static void c35_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static const mxArray *c35_c_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static void c35_d_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[6]);
static void c35_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static const mxArray *c35_d_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static void c35_e_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[4]);
static void c35_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static const mxArray *c35_e_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static const mxArray *c35_f_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static void c35_f_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[12]);
static void c35_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static const mxArray *c35_g_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static void c35_g_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[16]);
static void c35_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static void c35_info_helper(c35_ResolvedFunctionInfo c35_info[21]);
static real_T c35_mpower(SFc35_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c35_a);
static void c35_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance);
static real_T c35_b_mpower(SFc35_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c35_a);
static void c35_b_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static void c35_c_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static void c35_d_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static void c35_e_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance);
static const mxArray *c35_h_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData);
static int32_T c35_h_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId);
static void c35_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData);
static uint8_T c35_i_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_b_is_active_c35_SimulationPlantModel_Kalman, const char_T
   *c35_identifier);
static uint8_T c35_j_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId);
static void init_dsm_address_info
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  chartInstance->c35_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c35_is_active_c35_SimulationPlantModel_Kalman = 0U;
}

static void initialize_params_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c35_dv0[4];
  int32_T c35_i0;
  real_T c35_dv1[4];
  int32_T c35_i1;
  real_T c35_dv2[3];
  int32_T c35_i2;
  real_T c35_dv3[3];
  int32_T c35_i3;
  real_T c35_dv4[6];
  int32_T c35_i4;
  real_T c35_dv5[3];
  int32_T c35_i5;
  real_T c35_dv6[3];
  int32_T c35_i6;
  real_T c35_dv7[3];
  int32_T c35_i7;
  real_T c35_d0;
  real_T c35_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'x_0' in the parent workspace.\n");
  sf_mex_import_named("x_0", sf_mex_get_sfun_param(chartInstance->S, 8, 0),
                      c35_dv0, 0, 0, 0U, 1, 0U, 1, 4);
  for (c35_i0 = 0; c35_i0 < 4; c35_i0++) {
    chartInstance->c35_x_0[c35_i0] = c35_dv0[c35_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'u_0' in the parent workspace.\n");
  sf_mex_import_named("u_0", sf_mex_get_sfun_param(chartInstance->S, 7, 0),
                      c35_dv1, 0, 0, 0U, 1, 0U, 1, 4);
  for (c35_i1 = 0; c35_i1 < 4; c35_i1++) {
    chartInstance->c35_u_0[c35_i1] = c35_dv1[c35_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'H_G' in the parent workspace.\n");
  sf_mex_import_named("H_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c35_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c35_i2 = 0; c35_i2 < 3; c35_i2++) {
    chartInstance->c35_H_G[c35_i2] = c35_dv2[c35_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_fw_G' in the parent workspace.\n");
  sf_mex_import_named("D_fw_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c35_dv3, 0, 0, 0U, 1, 0U, 1, 3);
  for (c35_i3 = 0; c35_i3 < 3; c35_i3++) {
    chartInstance->c35_D_fw_G[c35_i3] = c35_dv3[c35_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'z_G' in the parent workspace.\n");
  sf_mex_import_named("z_G", sf_mex_get_sfun_param(chartInstance->S, 9, 0),
                      c35_dv4, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c35_i4 = 0; c35_i4 < 6; c35_i4++) {
    chartInstance->c35_z_G[c35_i4] = c35_dv4[c35_i4];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_e_G' in the parent workspace.\n");
  sf_mex_import_named("tau_e_G", sf_mex_get_sfun_param(chartInstance->S, 5, 0),
                      c35_dv5, 0, 0, 0U, 1, 0U, 1, 3);
  for (c35_i5 = 0; c35_i5 < 3; c35_i5++) {
    chartInstance->c35_tau_e_G[c35_i5] = c35_dv5[c35_i5];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_f_G' in the parent workspace.\n");
  sf_mex_import_named("tau_f_G", sf_mex_get_sfun_param(chartInstance->S, 6, 0),
                      c35_dv6, 0, 0, 0U, 1, 0U, 1, 3);
  for (c35_i6 = 0; c35_i6 < 3; c35_i6++) {
    chartInstance->c35_tau_f_G[c35_i6] = c35_dv6[c35_i6];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'r_f_G' in the parent workspace.\n");
  sf_mex_import_named("r_f_G", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      c35_dv7, 0, 0, 0U, 1, 0U, 1, 3);
  for (c35_i7 = 0; c35_i7 < 3; c35_i7++) {
    chartInstance->c35_r_f_G[c35_i7] = c35_dv7[c35_i7];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), &c35_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c35_GeneratorNumber = c35_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'omega_b' in the parent workspace.\n");
  sf_mex_import_named("omega_b", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      &c35_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c35_omega_b = c35_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c35_update_debugger_state_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  const mxArray *c35_st;
  const mxArray *c35_y = NULL;
  real_T c35_hoistedGlobal;
  real_T c35_u;
  const mxArray *c35_b_y = NULL;
  real_T c35_b_hoistedGlobal;
  real_T c35_b_u;
  const mxArray *c35_c_y = NULL;
  real_T c35_c_hoistedGlobal;
  real_T c35_c_u;
  const mxArray *c35_d_y = NULL;
  real_T c35_d_hoistedGlobal;
  real_T c35_d_u;
  const mxArray *c35_e_y = NULL;
  real_T c35_e_hoistedGlobal;
  real_T c35_e_u;
  const mxArray *c35_f_y = NULL;
  real_T c35_f_hoistedGlobal;
  real_T c35_f_u;
  const mxArray *c35_g_y = NULL;
  real_T c35_g_hoistedGlobal;
  real_T c35_g_u;
  const mxArray *c35_h_y = NULL;
  uint8_T c35_h_hoistedGlobal;
  uint8_T c35_h_u;
  const mxArray *c35_i_y = NULL;
  real_T *c35_d_delta;
  real_T *c35_d_i_f;
  real_T *c35_d_omega;
  real_T *c35_d_t_m;
  real_T *c35_r1;
  real_T *c35_r2;
  real_T *c35_r3;
  c35_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c35_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c35_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c35_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c35_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c35_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c35_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c35_st = NULL;
  c35_st = NULL;
  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_createcellarray(8), FALSE);
  c35_hoistedGlobal = *c35_d_delta;
  c35_u = c35_hoistedGlobal;
  c35_b_y = NULL;
  sf_mex_assign(&c35_b_y, sf_mex_create("y", &c35_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 0, c35_b_y);
  c35_b_hoistedGlobal = *c35_d_i_f;
  c35_b_u = c35_b_hoistedGlobal;
  c35_c_y = NULL;
  sf_mex_assign(&c35_c_y, sf_mex_create("y", &c35_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 1, c35_c_y);
  c35_c_hoistedGlobal = *c35_d_omega;
  c35_c_u = c35_c_hoistedGlobal;
  c35_d_y = NULL;
  sf_mex_assign(&c35_d_y, sf_mex_create("y", &c35_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 2, c35_d_y);
  c35_d_hoistedGlobal = *c35_d_t_m;
  c35_d_u = c35_d_hoistedGlobal;
  c35_e_y = NULL;
  sf_mex_assign(&c35_e_y, sf_mex_create("y", &c35_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 3, c35_e_y);
  c35_e_hoistedGlobal = *c35_r1;
  c35_e_u = c35_e_hoistedGlobal;
  c35_f_y = NULL;
  sf_mex_assign(&c35_f_y, sf_mex_create("y", &c35_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 4, c35_f_y);
  c35_f_hoistedGlobal = *c35_r2;
  c35_f_u = c35_f_hoistedGlobal;
  c35_g_y = NULL;
  sf_mex_assign(&c35_g_y, sf_mex_create("y", &c35_f_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 5, c35_g_y);
  c35_g_hoistedGlobal = *c35_r3;
  c35_g_u = c35_g_hoistedGlobal;
  c35_h_y = NULL;
  sf_mex_assign(&c35_h_y, sf_mex_create("y", &c35_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 6, c35_h_y);
  c35_h_hoistedGlobal =
    chartInstance->c35_is_active_c35_SimulationPlantModel_Kalman;
  c35_h_u = c35_h_hoistedGlobal;
  c35_i_y = NULL;
  sf_mex_assign(&c35_i_y, sf_mex_create("y", &c35_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c35_y, 7, c35_i_y);
  sf_mex_assign(&c35_st, c35_y, FALSE);
  return c35_st;
}

static void set_sim_state_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_st)
{
  const mxArray *c35_u;
  real_T *c35_d_delta;
  real_T *c35_d_i_f;
  real_T *c35_d_omega;
  real_T *c35_d_t_m;
  real_T *c35_r1;
  real_T *c35_r2;
  real_T *c35_r3;
  c35_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c35_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c35_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c35_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c35_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c35_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c35_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c35_doneDoubleBufferReInit = TRUE;
  c35_u = sf_mex_dup(c35_st);
  *c35_d_delta = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c35_u, 0)), "d_delta");
  *c35_d_i_f = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c35_u, 1)), "d_i_f");
  *c35_d_omega = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c35_u, 2)), "d_omega");
  *c35_d_t_m = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c35_u, 3)), "d_t_m");
  *c35_r1 = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c35_u,
    4)), "r1");
  *c35_r2 = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c35_u,
    5)), "r2");
  *c35_r3 = c35_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c35_u,
    6)), "r3");
  chartInstance->c35_is_active_c35_SimulationPlantModel_Kalman =
    c35_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c35_u, 7)),
    "is_active_c35_SimulationPlantModel_Kalman");
  sf_mex_destroy(&c35_u);
  c35_update_debugger_state_c35_SimulationPlantModel_Kalman(chartInstance);
  sf_mex_destroy(&c35_st);
}

static void finalize_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void sf_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  int32_T c35_i8;
  int32_T c35_i9;
  int32_T c35_i10;
  int32_T c35_i11;
  int32_T c35_i12;
  int32_T c35_i13;
  int32_T c35_i14;
  int32_T c35_i15;
  int32_T c35_i16;
  int32_T c35_i17;
  real_T *c35_delta;
  real_T *c35_omega;
  real_T *c35_t_m;
  real_T *c35_i_f;
  real_T *c35_r1;
  real_T *c35_r2;
  real_T *c35_r3;
  real_T *c35_d_delta;
  real_T *c35_d_omega;
  real_T *c35_d_t_m;
  real_T *c35_d_i_f;
  real_T (*c35_u_vector)[4];
  real_T (*c35_y)[3];
  c35_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c35_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c35_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c35_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c35_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c35_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c35_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c35_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c35_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c35_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c35_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c35_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c35_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 34U, chartInstance->c35_sfEvent);
  for (c35_i8 = 0; c35_i8 < 3; c35_i8++) {
    _SFD_DATA_RANGE_CHECK((*c35_y)[c35_i8], 0U);
  }

  for (c35_i9 = 0; c35_i9 < 4; c35_i9++) {
    _SFD_DATA_RANGE_CHECK((*c35_u_vector)[c35_i9], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c35_delta, 2U);
  _SFD_DATA_RANGE_CHECK(*c35_omega, 3U);
  _SFD_DATA_RANGE_CHECK(*c35_t_m, 4U);
  _SFD_DATA_RANGE_CHECK(*c35_i_f, 5U);
  _SFD_DATA_RANGE_CHECK(*c35_r1, 6U);
  _SFD_DATA_RANGE_CHECK(*c35_r2, 7U);
  _SFD_DATA_RANGE_CHECK(*c35_r3, 8U);
  _SFD_DATA_RANGE_CHECK(*c35_d_delta, 9U);
  _SFD_DATA_RANGE_CHECK(*c35_d_omega, 10U);
  _SFD_DATA_RANGE_CHECK(*c35_d_t_m, 11U);
  _SFD_DATA_RANGE_CHECK(*c35_d_i_f, 12U);
  for (c35_i10 = 0; c35_i10 < 4; c35_i10++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_x_0[c35_i10], 13U);
  }

  for (c35_i11 = 0; c35_i11 < 4; c35_i11++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_u_0[c35_i11], 14U);
  }

  for (c35_i12 = 0; c35_i12 < 3; c35_i12++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_H_G[c35_i12], 15U);
  }

  for (c35_i13 = 0; c35_i13 < 3; c35_i13++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_D_fw_G[c35_i13], 16U);
  }

  for (c35_i14 = 0; c35_i14 < 6; c35_i14++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_z_G[c35_i14], 17U);
  }

  for (c35_i15 = 0; c35_i15 < 3; c35_i15++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_tau_e_G[c35_i15], 18U);
  }

  for (c35_i16 = 0; c35_i16 < 3; c35_i16++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_tau_f_G[c35_i16], 19U);
  }

  for (c35_i17 = 0; c35_i17 < 3; c35_i17++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c35_r_f_G[c35_i17], 20U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c35_GeneratorNumber, 21U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c35_omega_b, 22U);
  chartInstance->c35_sfEvent = CALL_EVENT;
  c35_chartstep_c35_SimulationPlantModel_Kalman(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_SimulationPlantModel_KalmanMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c35_chartstep_c35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
  real_T c35_hoistedGlobal;
  real_T c35_b_hoistedGlobal;
  real_T c35_c_hoistedGlobal;
  real_T c35_d_hoistedGlobal;
  real_T c35_e_hoistedGlobal;
  real_T c35_f_hoistedGlobal;
  int32_T c35_i18;
  real_T c35_y[3];
  int32_T c35_i19;
  real_T c35_u_vector[4];
  real_T c35_delta;
  real_T c35_omega;
  real_T c35_t_m;
  real_T c35_i_f;
  int32_T c35_i20;
  real_T c35_b_x_0[4];
  int32_T c35_i21;
  real_T c35_b_u_0[4];
  int32_T c35_i22;
  real_T c35_b_H_G[3];
  int32_T c35_i23;
  real_T c35_b_D_fw_G[3];
  int32_T c35_i24;
  real_T c35_b_z_G[6];
  int32_T c35_i25;
  real_T c35_b_tau_e_G[3];
  int32_T c35_i26;
  real_T c35_b_tau_f_G[3];
  int32_T c35_i27;
  real_T c35_b_r_f_G[3];
  real_T c35_b_GeneratorNumber;
  real_T c35_b_omega_b;
  uint32_T c35_debug_family_var_map[55];
  real_T c35_a;
  real_T c35_b;
  real_T c35_c;
  real_T c35_d;
  real_T c35_e;
  real_T c35_g;
  real_T c35_h;
  real_T c35_k;
  real_T c35_m;
  real_T c35_n;
  real_T c35_x_01;
  real_T c35_x_02;
  real_T c35_x_03;
  real_T c35_x_04;
  real_T c35_u_01;
  real_T c35_u_02;
  real_T c35_u_03;
  real_T c35_u_04;
  real_T c35_x1;
  real_T c35_x2;
  real_T c35_x3;
  real_T c35_x4;
  real_T c35_x[4];
  real_T c35_A[16];
  real_T c35_B[16];
  real_T c35_C[12];
  real_T c35_D[12];
  real_T c35_K[12];
  real_T c35_d_x[4];
  real_T c35_r[3];
  real_T c35_nargin = 16.0;
  real_T c35_nargout = 7.0;
  real_T c35_r1;
  real_T c35_r2;
  real_T c35_r3;
  real_T c35_d_delta;
  real_T c35_d_omega;
  real_T c35_d_t_m;
  real_T c35_d_i_f;
  real_T c35_b_a;
  real_T c35_b_b;
  real_T c35_b_y;
  real_T c35_b_B;
  real_T c35_c_y;
  real_T c35_d_y;
  real_T c35_c_b;
  real_T c35_e_y;
  real_T c35_c_B;
  real_T c35_f_y;
  real_T c35_g_y;
  real_T c35_d_B;
  real_T c35_h_y;
  real_T c35_i_y;
  real_T c35_e_B;
  real_T c35_j_y;
  real_T c35_k_y;
  real_T c35_b_A;
  real_T c35_f_B;
  real_T c35_b_x;
  real_T c35_l_y;
  real_T c35_c_x;
  real_T c35_m_y;
  real_T c35_g_B;
  real_T c35_n_y;
  real_T c35_o_y;
  real_T c35_c_A;
  real_T c35_h_B;
  real_T c35_e_x;
  real_T c35_p_y;
  real_T c35_f_x;
  real_T c35_q_y;
  real_T c35_c_a;
  real_T c35_d_b;
  real_T c35_r_y;
  real_T c35_d_a;
  real_T c35_e_b;
  real_T c35_s_y;
  real_T c35_f_b;
  real_T c35_t_y;
  real_T c35_e_a;
  real_T c35_g_b;
  real_T c35_u_y;
  real_T c35_f_a;
  real_T c35_h_b;
  real_T c35_v_y;
  real_T c35_g_a;
  real_T c35_i_b;
  real_T c35_w_y;
  real_T c35_h_a;
  real_T c35_j_b;
  real_T c35_x_y;
  real_T c35_i_a;
  real_T c35_k_b;
  real_T c35_y_y;
  real_T c35_d_A;
  real_T c35_i_B;
  real_T c35_g_x;
  real_T c35_ab_y;
  real_T c35_h_x;
  real_T c35_bb_y;
  real_T c35_cb_y;
  real_T c35_j_a;
  real_T c35_l_b;
  real_T c35_db_y;
  real_T c35_k_a;
  real_T c35_m_b;
  real_T c35_eb_y;
  real_T c35_l_a;
  real_T c35_n_b;
  real_T c35_fb_y;
  real_T c35_m_a;
  real_T c35_o_b;
  real_T c35_gb_y;
  real_T c35_n_a;
  real_T c35_p_b;
  real_T c35_hb_y;
  real_T c35_o_a;
  real_T c35_q_b;
  real_T c35_ib_y;
  real_T c35_p_a;
  real_T c35_r_b;
  real_T c35_jb_y;
  real_T c35_q_a;
  real_T c35_s_b;
  real_T c35_kb_y;
  real_T c35_r_a;
  real_T c35_t_b;
  real_T c35_lb_y;
  real_T c35_s_a;
  real_T c35_u_b;
  real_T c35_mb_y;
  real_T c35_t_a;
  real_T c35_v_b;
  real_T c35_nb_y;
  real_T c35_u_a;
  real_T c35_w_b;
  real_T c35_ob_y;
  real_T c35_v_a;
  real_T c35_x_b;
  real_T c35_pb_y;
  real_T c35_e_A;
  real_T c35_j_B;
  real_T c35_i_x;
  real_T c35_qb_y;
  real_T c35_j_x;
  real_T c35_rb_y;
  real_T c35_sb_y;
  real_T c35_y_b;
  real_T c35_tb_y;
  real_T c35_w_a;
  real_T c35_ab_b;
  real_T c35_ub_y;
  real_T c35_x_a;
  real_T c35_bb_b;
  real_T c35_vb_y;
  real_T c35_y_a;
  real_T c35_cb_b;
  real_T c35_wb_y;
  real_T c35_ab_a;
  real_T c35_db_b;
  real_T c35_xb_y;
  real_T c35_eb_b;
  real_T c35_yb_y;
  real_T c35_bb_a;
  real_T c35_fb_b;
  real_T c35_ac_y;
  real_T c35_cb_a;
  real_T c35_gb_b;
  real_T c35_bc_y;
  real_T c35_db_a;
  real_T c35_hb_b;
  real_T c35_cc_y;
  real_T c35_eb_a;
  real_T c35_ib_b;
  real_T c35_dc_y;
  real_T c35_fb_a;
  real_T c35_jb_b;
  real_T c35_ec_y;
  real_T c35_f_A;
  real_T c35_k_B;
  real_T c35_k_x;
  real_T c35_fc_y;
  real_T c35_l_x;
  real_T c35_gc_y;
  real_T c35_hc_y;
  real_T c35_kb_b;
  real_T c35_ic_y;
  real_T c35_gb_a;
  real_T c35_lb_b;
  real_T c35_jc_y;
  real_T c35_hb_a;
  real_T c35_mb_b;
  real_T c35_kc_y;
  real_T c35_ib_a;
  real_T c35_nb_b;
  real_T c35_lc_y;
  real_T c35_ob_b;
  real_T c35_mc_y;
  real_T c35_jb_a;
  real_T c35_pb_b;
  real_T c35_nc_y;
  real_T c35_kb_a;
  real_T c35_qb_b;
  real_T c35_oc_y;
  real_T c35_lb_a;
  real_T c35_rb_b;
  real_T c35_pc_y;
  real_T c35_mb_a;
  real_T c35_sb_b;
  real_T c35_qc_y;
  real_T c35_tb_b;
  real_T c35_rc_y;
  real_T c35_nb_a;
  real_T c35_ub_b;
  real_T c35_sc_y;
  real_T c35_ob_a;
  real_T c35_vb_b;
  real_T c35_tc_y;
  real_T c35_pb_a;
  real_T c35_wb_b;
  real_T c35_uc_y;
  real_T c35_qb_a;
  real_T c35_xb_b;
  real_T c35_vc_y;
  real_T c35_g_A;
  real_T c35_l_B;
  real_T c35_m_x;
  real_T c35_wc_y;
  real_T c35_n_x;
  real_T c35_xc_y;
  real_T c35_yc_y;
  real_T c35_rb_a;
  real_T c35_yb_b;
  real_T c35_ad_y;
  real_T c35_sb_a;
  real_T c35_ac_b;
  real_T c35_bd_y;
  real_T c35_tb_a;
  real_T c35_bc_b;
  real_T c35_cd_y;
  real_T c35_ub_a;
  real_T c35_cc_b;
  real_T c35_dd_y;
  int32_T c35_i28;
  int32_T c35_i29;
  static real_T c35_dv8[4] = { 0.0, 1.0, 0.0, 0.0 };

  int32_T c35_i30;
  int32_T c35_i31;
  int32_T c35_i32;
  int32_T c35_i33;
  int32_T c35_i34;
  int32_T c35_i35;
  real_T c35_dc_b[12];
  int32_T c35_i36;
  int32_T c35_i37;
  int32_T c35_i38;
  int32_T c35_i39;
  real_T c35_ed_y[16];
  int32_T c35_i40;
  int32_T c35_i41;
  int32_T c35_i42;
  real_T c35_ec_b[4];
  int32_T c35_i43;
  real_T c35_fd_y[4];
  int32_T c35_i44;
  int32_T c35_i45;
  int32_T c35_i46;
  int32_T c35_i47;
  int32_T c35_i48;
  int32_T c35_i49;
  int32_T c35_i50;
  int32_T c35_i51;
  int32_T c35_i52;
  int32_T c35_i53;
  int32_T c35_i54;
  real_T c35_gd_y[4];
  int32_T c35_i55;
  int32_T c35_i56;
  int32_T c35_i57;
  real_T c35_fc_b[3];
  int32_T c35_i58;
  int32_T c35_i59;
  int32_T c35_i60;
  int32_T c35_i61;
  int32_T c35_i62;
  int32_T c35_i63;
  int32_T c35_i64;
  int32_T c35_i65;
  int32_T c35_i66;
  int32_T c35_i67;
  int32_T c35_i68;
  real_T c35_hd_y[3];
  int32_T c35_i69;
  int32_T c35_i70;
  int32_T c35_i71;
  real_T *c35_b_delta;
  real_T *c35_b_omega;
  real_T *c35_b_t_m;
  real_T *c35_b_i_f;
  real_T *c35_b_r1;
  real_T *c35_b_r2;
  real_T *c35_b_r3;
  real_T *c35_b_d_delta;
  real_T *c35_b_d_omega;
  real_T *c35_b_d_t_m;
  real_T *c35_b_d_i_f;
  real_T (*c35_b_u_vector)[4];
  real_T (*c35_id_y)[3];
  c35_b_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c35_b_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c35_b_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c35_b_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c35_b_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c35_b_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c35_b_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c35_b_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c35_b_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c35_b_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c35_b_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c35_b_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c35_id_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 34U, chartInstance->c35_sfEvent);
  c35_hoistedGlobal = *c35_b_delta;
  c35_b_hoistedGlobal = *c35_b_omega;
  c35_c_hoistedGlobal = *c35_b_t_m;
  c35_d_hoistedGlobal = *c35_b_i_f;
  c35_e_hoistedGlobal = chartInstance->c35_GeneratorNumber;
  c35_f_hoistedGlobal = chartInstance->c35_omega_b;
  for (c35_i18 = 0; c35_i18 < 3; c35_i18++) {
    c35_y[c35_i18] = (*c35_id_y)[c35_i18];
  }

  for (c35_i19 = 0; c35_i19 < 4; c35_i19++) {
    c35_u_vector[c35_i19] = (*c35_b_u_vector)[c35_i19];
  }

  c35_delta = c35_hoistedGlobal;
  c35_omega = c35_b_hoistedGlobal;
  c35_t_m = c35_c_hoistedGlobal;
  c35_i_f = c35_d_hoistedGlobal;
  for (c35_i20 = 0; c35_i20 < 4; c35_i20++) {
    c35_b_x_0[c35_i20] = chartInstance->c35_x_0[c35_i20];
  }

  for (c35_i21 = 0; c35_i21 < 4; c35_i21++) {
    c35_b_u_0[c35_i21] = chartInstance->c35_u_0[c35_i21];
  }

  for (c35_i22 = 0; c35_i22 < 3; c35_i22++) {
    c35_b_H_G[c35_i22] = chartInstance->c35_H_G[c35_i22];
  }

  for (c35_i23 = 0; c35_i23 < 3; c35_i23++) {
    c35_b_D_fw_G[c35_i23] = chartInstance->c35_D_fw_G[c35_i23];
  }

  for (c35_i24 = 0; c35_i24 < 6; c35_i24++) {
    c35_b_z_G[c35_i24] = chartInstance->c35_z_G[c35_i24];
  }

  for (c35_i25 = 0; c35_i25 < 3; c35_i25++) {
    c35_b_tau_e_G[c35_i25] = chartInstance->c35_tau_e_G[c35_i25];
  }

  for (c35_i26 = 0; c35_i26 < 3; c35_i26++) {
    c35_b_tau_f_G[c35_i26] = chartInstance->c35_tau_f_G[c35_i26];
  }

  for (c35_i27 = 0; c35_i27 < 3; c35_i27++) {
    c35_b_r_f_G[c35_i27] = chartInstance->c35_r_f_G[c35_i27];
  }

  c35_b_GeneratorNumber = c35_e_hoistedGlobal;
  c35_b_omega_b = c35_f_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 55U, 55U, c35_debug_family_names,
    c35_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_a, 0U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_b, 1U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_c, 2U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_d, 3U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_e, 4U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_g, 5U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_h, 6U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_k, 7U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_m, 8U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_n, 9U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x_01, 10U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x_02, 11U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x_03, 12U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x_04, 13U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_u_01, 14U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_u_02, 15U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_u_03, 16U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_u_04, 17U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x1, 18U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x2, 19U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x3, 20U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_x4, 21U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_x, 22U, c35_d_sf_marshallOut,
    c35_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_A, 23U, c35_g_sf_marshallOut,
    c35_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_B, 24U, c35_g_sf_marshallOut,
    c35_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_C, 25U, c35_f_sf_marshallOut,
    c35_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_D, 26U, c35_f_sf_marshallOut,
    c35_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c35_K, 27U, c35_e_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_d_x, 28U, c35_d_sf_marshallOut,
    c35_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_r, 29U, c35_b_sf_marshallOut,
    c35_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_nargin, 30U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_nargout, 31U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c35_y, 32U, c35_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c35_u_vector, 33U, c35_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c35_delta, 34U, c35_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c35_omega, 35U, c35_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c35_t_m, 36U, c35_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c35_i_f, 37U, c35_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_x_0, 38U, c35_d_sf_marshallOut,
    c35_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_u_0, 39U, c35_d_sf_marshallOut,
    c35_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_H_G, 40U, c35_b_sf_marshallOut,
    c35_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_D_fw_G, 41U, c35_b_sf_marshallOut,
    c35_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_z_G, 42U, c35_c_sf_marshallOut,
    c35_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_tau_e_G, 43U, c35_b_sf_marshallOut,
    c35_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_tau_f_G, 44U, c35_b_sf_marshallOut,
    c35_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c35_b_r_f_G, 45U, c35_b_sf_marshallOut,
    c35_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_b_GeneratorNumber, 46U,
    c35_sf_marshallOut, c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_b_omega_b, 47U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_r1, 48U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_r2, 49U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_r3, 50U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_d_delta, 51U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_d_omega, 52U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_d_t_m, 53U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c35_d_i_f, 54U, c35_sf_marshallOut,
    c35_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 4);
  c35_a = c35_b_omega_b;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 5);
  c35_b_a = c35_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_b_b = c35_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_b_y = c35_b_a * c35_b_b;
  c35_b_B = c35_b_y;
  c35_c_y = c35_b_B;
  c35_d_y = c35_c_y;
  c35_b = 1.0 / c35_d_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 6);
  c35_c_b = c35_b_H_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("H_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_e_y = 2.0 * c35_c_b;
  c35_c_B = c35_e_y;
  c35_f_y = c35_c_B;
  c35_g_y = c35_f_y;
  c35_c = 1.0 / c35_g_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 7);
  c35_d = c35_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 8);
  c35_d_B = c35_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) + 2];
  c35_h_y = c35_d_B;
  c35_i_y = c35_h_y;
  c35_e = 1.0 / c35_i_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 9);
  c35_g = c35_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 10);
  c35_e_B = c35_b_tau_e_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_e_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_j_y = c35_e_B;
  c35_k_y = c35_j_y;
  c35_h = 1.0 / c35_k_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 11);
  c35_b_A = c35_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1] + 1.0;
  c35_f_B = c35_b_tau_e_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_e_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_b_x = c35_b_A;
  c35_l_y = c35_f_B;
  c35_c_x = c35_b_x;
  c35_m_y = c35_l_y;
  c35_k = c35_c_x / c35_m_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 12);
  c35_g_B = c35_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_n_y = c35_g_B;
  c35_o_y = c35_n_y;
  c35_m = 1.0 / c35_o_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 13);
  c35_c_A = c35_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  c35_h_B = c35_mpower(chartInstance, c35_b_z_G[(int32_T)(real_T)
                       _SFD_EML_ARRAY_BOUNDS_CHECK("z_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c35_b_GeneratorNumber), 1, 3, 1, 0) +
                       2]);
  c35_e_x = c35_c_A;
  c35_p_y = c35_h_B;
  c35_f_x = c35_e_x;
  c35_q_y = c35_p_y;
  c35_n = c35_f_x / c35_q_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 15);
  c35_x_01 = c35_b_x_0[0];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 16);
  c35_x_02 = c35_b_x_0[1];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 17);
  c35_x_03 = c35_b_x_0[2];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 18);
  c35_x_04 = c35_b_x_0[3];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 20);
  c35_u_01 = c35_b_u_0[0];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 21);
  c35_u_02 = c35_b_u_0[1];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 22);
  c35_u_03 = c35_b_u_0[2];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 23);
  c35_u_04 = c35_b_u_0[3];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 25);
  c35_x1 = c35_delta;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 26);
  c35_x2 = c35_omega;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 27);
  c35_x3 = c35_t_m;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 28);
  c35_x4 = c35_i_f;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 29);
  c35_x[0] = c35_x1;
  c35_x[1] = c35_x2;
  c35_x[2] = c35_x3;
  c35_x[3] = c35_x4;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 31);
  c35_c_a = c35_e;
  c35_d_b = c35_x_02;
  c35_r_y = c35_c_a * c35_d_b;
  c35_d_a = c35_r_y;
  c35_e_b = c35_b_mpower(chartInstance, c35_u_02);
  c35_s_y = c35_d_a * c35_e_b;
  c35_f_b = c35_n;
  c35_t_y = 2.0 * c35_f_b;
  c35_e_a = c35_t_y;
  c35_g_b = c35_x_01;
  c35_u_y = c35_e_a * c35_g_b;
  c35_f_a = c35_u_y;
  c35_h_b = c35_x_02;
  c35_v_y = c35_f_a * c35_h_b;
  c35_g_a = c35_v_y;
  c35_i_b = c35_u_02;
  c35_w_y = c35_g_a * c35_i_b;
  c35_h_a = c35_c;
  c35_j_b = c35_s_y + c35_w_y;
  c35_x_y = c35_h_a * c35_j_b;
  c35_i_a = c35_b_mpower(chartInstance, c35_u_02);
  c35_k_b = c35_mpower(chartInstance, c35_x_02);
  c35_y_y = c35_i_a * c35_k_b;
  c35_d_A = -c35_x_y;
  c35_i_B = c35_y_y;
  c35_g_x = c35_d_A;
  c35_ab_y = c35_i_B;
  c35_h_x = c35_g_x;
  c35_bb_y = c35_ab_y;
  c35_cb_y = c35_h_x / c35_bb_y;
  c35_j_a = -c35_n;
  c35_l_b = c35_mpower(chartInstance, c35_g);
  c35_db_y = c35_j_a * c35_l_b;
  c35_k_a = c35_db_y;
  c35_m_b = c35_u_02;
  c35_eb_y = c35_k_a * c35_m_b;
  c35_l_a = c35_eb_y;
  c35_n_b = c35_mpower(chartInstance, c35_x_02);
  c35_fb_y = c35_l_a * c35_n_b;
  c35_m_a = c35_fb_y;
  c35_o_b = c35_mpower(chartInstance, c35_x_04);
  c35_gb_y = c35_m_a * c35_o_b;
  c35_n_a = c35_e;
  c35_p_b = c35_b_mpower(chartInstance, c35_u_02);
  c35_hb_y = c35_n_a * c35_p_b;
  c35_o_a = c35_hb_y;
  c35_q_b = c35_x_01;
  c35_ib_y = c35_o_a * c35_q_b;
  c35_p_a = c35_d;
  c35_r_b = c35_b_mpower(chartInstance, c35_u_02);
  c35_jb_y = c35_p_a * c35_r_b;
  c35_q_a = c35_jb_y;
  c35_s_b = c35_mpower(chartInstance, c35_x_02);
  c35_kb_y = c35_q_a * c35_s_b;
  c35_r_a = c35_n;
  c35_t_b = c35_b_mpower(chartInstance, c35_u_02);
  c35_lb_y = c35_r_a * c35_t_b;
  c35_s_a = c35_n;
  c35_u_b = c35_u_02;
  c35_mb_y = c35_s_a * c35_u_b;
  c35_t_a = c35_mb_y;
  c35_v_b = c35_mpower(chartInstance, c35_x_01);
  c35_nb_y = c35_t_a * c35_v_b;
  c35_u_a = c35_c;
  c35_w_b = (((c35_gb_y + c35_ib_y) - c35_kb_y) + c35_lb_y) + c35_nb_y;
  c35_ob_y = c35_u_a * c35_w_b;
  c35_v_a = c35_b_mpower(chartInstance, c35_u_02);
  c35_x_b = c35_mpower(chartInstance, c35_x_02);
  c35_pb_y = c35_v_a * c35_x_b;
  c35_e_A = c35_ob_y;
  c35_j_B = c35_pb_y;
  c35_i_x = c35_e_A;
  c35_qb_y = c35_j_B;
  c35_j_x = c35_i_x;
  c35_rb_y = c35_qb_y;
  c35_sb_y = c35_j_x / c35_rb_y;
  c35_y_b = c35_n;
  c35_tb_y = -2.0 * c35_y_b;
  c35_w_a = c35_tb_y;
  c35_ab_b = c35_x_04;
  c35_ub_y = c35_w_a * c35_ab_b;
  c35_x_a = c35_ub_y;
  c35_bb_b = c35_mpower(chartInstance, c35_g);
  c35_vb_y = c35_x_a * c35_bb_b;
  c35_y_a = c35_vb_y;
  c35_cb_b = c35_u_02;
  c35_wb_y = c35_y_a * c35_cb_b;
  c35_ab_a = c35_wb_y;
  c35_db_b = c35_b_mpower(chartInstance, c35_x_02);
  c35_xb_y = c35_ab_a * c35_db_b;
  c35_eb_b = c35_n;
  c35_yb_y = 2.0 * c35_eb_b;
  c35_bb_a = c35_yb_y;
  c35_fb_b = c35_g;
  c35_ac_y = c35_bb_a * c35_fb_b;
  c35_cb_a = c35_ac_y;
  c35_gb_b = c35_mpower(chartInstance, c35_u_02);
  c35_bc_y = c35_cb_a * c35_gb_b;
  c35_db_a = c35_bc_y;
  c35_hb_b = c35_mpower(chartInstance, c35_x_02);
  c35_cc_y = c35_db_a * c35_hb_b;
  c35_eb_a = c35_c;
  c35_ib_b = c35_xb_y + c35_cc_y;
  c35_dc_y = c35_eb_a * c35_ib_b;
  c35_fb_a = c35_b_mpower(chartInstance, c35_u_02);
  c35_jb_b = c35_mpower(chartInstance, c35_x_02);
  c35_ec_y = c35_fb_a * c35_jb_b;
  c35_f_A = c35_dc_y;
  c35_k_B = c35_ec_y;
  c35_k_x = c35_f_A;
  c35_fc_y = c35_k_B;
  c35_l_x = c35_k_x;
  c35_gc_y = c35_fc_y;
  c35_hc_y = c35_l_x / c35_gc_y;
  c35_A[0] = 0.0;
  c35_A[4] = c35_a;
  c35_A[8] = 0.0;
  c35_A[12] = 0.0;
  c35_A[1] = c35_cb_y;
  c35_A[5] = c35_sb_y;
  c35_A[9] = c35_c;
  c35_A[13] = c35_hc_y;
  c35_A[2] = 0.0;
  c35_A[6] = 0.0;
  c35_A[10] = -c35_h;
  c35_A[14] = 0.0;
  c35_A[3] = 0.0;
  c35_A[7] = 0.0;
  c35_A[11] = 0.0;
  c35_A[15] = -c35_m;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 36);
  c35_kb_b = c35_n;
  c35_ic_y = 2.0 * c35_kb_b;
  c35_gb_a = c35_ic_y;
  c35_lb_b = c35_mpower(chartInstance, c35_g);
  c35_jc_y = c35_gb_a * c35_lb_b;
  c35_hb_a = c35_jc_y;
  c35_mb_b = c35_b_mpower(chartInstance, c35_x_02);
  c35_kc_y = c35_hb_a * c35_mb_b;
  c35_ib_a = c35_kc_y;
  c35_nb_b = c35_mpower(chartInstance, c35_x_04);
  c35_lc_y = c35_ib_a * c35_nb_b;
  c35_ob_b = c35_n;
  c35_mc_y = 2.0 * c35_ob_b;
  c35_jb_a = c35_mc_y;
  c35_pb_b = c35_u_02;
  c35_nc_y = c35_jb_a * c35_pb_b;
  c35_kb_a = c35_nc_y;
  c35_qb_b = c35_g;
  c35_oc_y = c35_kb_a * c35_qb_b;
  c35_lb_a = c35_oc_y;
  c35_rb_b = c35_mpower(chartInstance, c35_x_02);
  c35_pc_y = c35_lb_a * c35_rb_b;
  c35_mb_a = c35_pc_y;
  c35_sb_b = c35_x_04;
  c35_qc_y = c35_mb_a * c35_sb_b;
  c35_tb_b = c35_n;
  c35_rc_y = 2.0 * c35_tb_b;
  c35_nb_a = c35_rc_y;
  c35_ub_b = c35_mpower(chartInstance, c35_x_01);
  c35_sc_y = c35_nb_a * c35_ub_b;
  c35_ob_a = c35_sc_y;
  c35_vb_b = c35_x_02;
  c35_tc_y = c35_ob_a * c35_vb_b;
  c35_pb_a = c35_c;
  c35_wb_b = (c35_lc_y - c35_qc_y) + c35_tc_y;
  c35_uc_y = c35_pb_a * c35_wb_b;
  c35_qb_a = c35_b_mpower(chartInstance, c35_u_02);
  c35_xb_b = c35_mpower(chartInstance, c35_x_02);
  c35_vc_y = c35_qb_a * c35_xb_b;
  c35_g_A = c35_uc_y;
  c35_l_B = c35_vc_y;
  c35_m_x = c35_g_A;
  c35_wc_y = c35_l_B;
  c35_n_x = c35_m_x;
  c35_xc_y = c35_wc_y;
  c35_yc_y = c35_n_x / c35_xc_y;
  c35_B[0] = -c35_a;
  c35_B[4] = 0.0;
  c35_B[8] = 0.0;
  c35_B[12] = 0.0;
  c35_B[1] = 0.0;
  c35_B[5] = c35_yc_y;
  c35_B[9] = 0.0;
  c35_B[13] = 0.0;
  c35_B[2] = 0.0;
  c35_B[6] = 0.0;
  c35_B[10] = c35_k;
  c35_B[14] = 0.0;
  c35_B[3] = 0.0;
  c35_B[7] = 0.0;
  c35_B[11] = 0.0;
  c35_B[15] = c35_b;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 41);
  c35_rb_a = c35_e;
  c35_yb_b = c35_g;
  c35_ad_y = c35_rb_a * c35_yb_b;
  c35_sb_a = c35_ad_y;
  c35_ac_b = c35_x_04;
  c35_bd_y = c35_sb_a * c35_ac_b;
  c35_tb_a = c35_e;
  c35_bc_b = c35_g;
  c35_cd_y = c35_tb_a * c35_bc_b;
  c35_ub_a = c35_cd_y;
  c35_cc_b = c35_x_02;
  c35_dd_y = c35_ub_a * c35_cc_b;
  c35_i28 = 0;
  for (c35_i29 = 0; c35_i29 < 4; c35_i29++) {
    c35_C[c35_i28] = c35_dv8[c35_i29];
    c35_i28 += 3;
  }

  c35_C[1] = c35_e;
  c35_C[4] = 0.0;
  c35_C[7] = 0.0;
  c35_C[10] = 0.0;
  c35_C[2] = 0.0;
  c35_C[5] = c35_bd_y;
  c35_C[8] = 0.0;
  c35_C[11] = c35_dd_y;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 46);
  c35_i30 = 0;
  for (c35_i31 = 0; c35_i31 < 4; c35_i31++) {
    c35_D[c35_i30] = 0.0;
    c35_i30 += 3;
  }

  c35_i32 = 0;
  for (c35_i33 = 0; c35_i33 < 4; c35_i33++) {
    c35_D[c35_i32 + 1] = 0.0;
    c35_i32 += 3;
  }

  c35_D[2] = 0.0;
  c35_D[5] = -c35_e;
  c35_D[8] = 0.0;
  c35_D[11] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 50);
  for (c35_i34 = 0; c35_i34 < 12; c35_i34++) {
    c35_K[c35_i34] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 52);
  for (c35_i35 = 0; c35_i35 < 12; c35_i35++) {
    c35_dc_b[c35_i35] = c35_C[c35_i35];
  }

  c35_b_eml_scalar_eg(chartInstance);
  c35_b_eml_scalar_eg(chartInstance);
  for (c35_i36 = 0; c35_i36 < 4; c35_i36++) {
    c35_i37 = 0;
    c35_i38 = 0;
    for (c35_i39 = 0; c35_i39 < 4; c35_i39++) {
      c35_ed_y[c35_i37 + c35_i36] = 0.0;
      for (c35_i40 = 0; c35_i40 < 3; c35_i40++) {
        c35_ed_y[c35_i37 + c35_i36] += 0.0 * c35_dc_b[c35_i40 + c35_i38];
      }

      c35_i37 += 4;
      c35_i38 += 3;
    }
  }

  for (c35_i41 = 0; c35_i41 < 16; c35_i41++) {
    c35_ed_y[c35_i41] += c35_A[c35_i41];
  }

  for (c35_i42 = 0; c35_i42 < 4; c35_i42++) {
    c35_ec_b[c35_i42] = c35_x[c35_i42];
  }

  c35_c_eml_scalar_eg(chartInstance);
  c35_c_eml_scalar_eg(chartInstance);
  for (c35_i43 = 0; c35_i43 < 4; c35_i43++) {
    c35_fd_y[c35_i43] = 0.0;
    c35_i44 = 0;
    for (c35_i45 = 0; c35_i45 < 4; c35_i45++) {
      c35_fd_y[c35_i43] += c35_ed_y[c35_i44 + c35_i43] * c35_ec_b[c35_i45];
      c35_i44 += 4;
    }
  }

  for (c35_i46 = 0; c35_i46 < 12; c35_i46++) {
    c35_dc_b[c35_i46] = c35_D[c35_i46];
  }

  c35_b_eml_scalar_eg(chartInstance);
  c35_b_eml_scalar_eg(chartInstance);
  for (c35_i47 = 0; c35_i47 < 4; c35_i47++) {
    c35_i48 = 0;
    c35_i49 = 0;
    for (c35_i50 = 0; c35_i50 < 4; c35_i50++) {
      c35_ed_y[c35_i48 + c35_i47] = 0.0;
      for (c35_i51 = 0; c35_i51 < 3; c35_i51++) {
        c35_ed_y[c35_i48 + c35_i47] += 0.0 * c35_dc_b[c35_i51 + c35_i49];
      }

      c35_i48 += 4;
      c35_i49 += 3;
    }
  }

  for (c35_i52 = 0; c35_i52 < 16; c35_i52++) {
    c35_ed_y[c35_i52] += c35_B[c35_i52];
  }

  for (c35_i53 = 0; c35_i53 < 4; c35_i53++) {
    c35_ec_b[c35_i53] = c35_u_vector[c35_i53];
  }

  c35_c_eml_scalar_eg(chartInstance);
  c35_c_eml_scalar_eg(chartInstance);
  for (c35_i54 = 0; c35_i54 < 4; c35_i54++) {
    c35_gd_y[c35_i54] = 0.0;
    c35_i55 = 0;
    for (c35_i56 = 0; c35_i56 < 4; c35_i56++) {
      c35_gd_y[c35_i54] += c35_ed_y[c35_i55 + c35_i54] * c35_ec_b[c35_i56];
      c35_i55 += 4;
    }
  }

  for (c35_i57 = 0; c35_i57 < 3; c35_i57++) {
    c35_fc_b[c35_i57] = c35_y[c35_i57];
  }

  c35_d_eml_scalar_eg(chartInstance);
  c35_d_eml_scalar_eg(chartInstance);
  for (c35_i58 = 0; c35_i58 < 4; c35_i58++) {
    c35_ec_b[c35_i58] = 0.0;
    for (c35_i59 = 0; c35_i59 < 3; c35_i59++) {
      c35_ec_b[c35_i58] += 0.0 * c35_fc_b[c35_i59];
    }
  }

  for (c35_i60 = 0; c35_i60 < 4; c35_i60++) {
    c35_d_x[c35_i60] = (c35_fd_y[c35_i60] + c35_gd_y[c35_i60]) -
      c35_ec_b[c35_i60];
  }

  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 54);
  c35_d_delta = c35_d_x[0];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 55);
  c35_d_omega = c35_d_x[1];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 56);
  c35_d_t_m = c35_d_x[2];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 57);
  c35_d_i_f = c35_d_x[3];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 59);
  for (c35_i61 = 0; c35_i61 < 12; c35_i61++) {
    c35_dc_b[c35_i61] = c35_C[c35_i61];
  }

  for (c35_i62 = 0; c35_i62 < 4; c35_i62++) {
    c35_ec_b[c35_i62] = c35_x[c35_i62];
  }

  c35_e_eml_scalar_eg(chartInstance);
  c35_e_eml_scalar_eg(chartInstance);
  for (c35_i63 = 0; c35_i63 < 3; c35_i63++) {
    c35_fc_b[c35_i63] = 0.0;
    c35_i64 = 0;
    for (c35_i65 = 0; c35_i65 < 4; c35_i65++) {
      c35_fc_b[c35_i63] += c35_dc_b[c35_i64 + c35_i63] * c35_ec_b[c35_i65];
      c35_i64 += 3;
    }
  }

  for (c35_i66 = 0; c35_i66 < 12; c35_i66++) {
    c35_dc_b[c35_i66] = c35_D[c35_i66];
  }

  for (c35_i67 = 0; c35_i67 < 4; c35_i67++) {
    c35_ec_b[c35_i67] = c35_u_vector[c35_i67];
  }

  c35_e_eml_scalar_eg(chartInstance);
  c35_e_eml_scalar_eg(chartInstance);
  for (c35_i68 = 0; c35_i68 < 3; c35_i68++) {
    c35_hd_y[c35_i68] = 0.0;
    c35_i69 = 0;
    for (c35_i70 = 0; c35_i70 < 4; c35_i70++) {
      c35_hd_y[c35_i68] += c35_dc_b[c35_i69 + c35_i68] * c35_ec_b[c35_i70];
      c35_i69 += 3;
    }
  }

  for (c35_i71 = 0; c35_i71 < 3; c35_i71++) {
    c35_r[c35_i71] = (c35_y[c35_i71] - c35_fc_b[c35_i71]) - c35_hd_y[c35_i71];
  }

  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 60);
  c35_r1 = c35_r[0];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 61);
  c35_r2 = c35_r[1];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, 62);
  c35_r3 = c35_r[2];
  _SFD_EML_CALL(0U, chartInstance->c35_sfEvent, -62);
  _SFD_SYMBOL_SCOPE_POP();
  *c35_b_r1 = c35_r1;
  *c35_b_r2 = c35_r2;
  *c35_b_r3 = c35_r3;
  *c35_b_d_delta = c35_d_delta;
  *c35_b_d_omega = c35_d_omega;
  *c35_b_d_t_m = c35_d_t_m;
  *c35_b_d_i_f = c35_d_i_f;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 34U, chartInstance->c35_sfEvent);
}

static void initSimStructsc35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void registerMessagesc35_SimulationPlantModel_Kalman
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c35_machineNumber, uint32_T
  c35_chartNumber)
{
}

static const mxArray *c35_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  real_T c35_u;
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  c35_u = *(real_T *)c35_inData;
  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", &c35_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static real_T c35_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_d_i_f, const char_T *c35_identifier)
{
  real_T c35_y;
  emlrtMsgIdentifier c35_thisId;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_y = c35_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_d_i_f),
    &c35_thisId);
  sf_mex_destroy(&c35_d_i_f);
  return c35_y;
}

static real_T c35_b_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId)
{
  real_T c35_y;
  real_T c35_d2;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), &c35_d2, 1, 0, 0U, 0, 0U, 0);
  c35_y = c35_d2;
  sf_mex_destroy(&c35_u);
  return c35_y;
}

static void c35_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_d_i_f;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  real_T c35_y;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_d_i_f = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_y = c35_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_d_i_f),
    &c35_thisId);
  sf_mex_destroy(&c35_d_i_f);
  *(real_T *)c35_outData = c35_y;
  sf_mex_destroy(&c35_mxArrayInData);
}

static const mxArray *c35_b_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_i72;
  real_T c35_b_inData[3];
  int32_T c35_i73;
  real_T c35_u[3];
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  for (c35_i72 = 0; c35_i72 < 3; c35_i72++) {
    c35_b_inData[c35_i72] = (*(real_T (*)[3])c35_inData)[c35_i72];
  }

  for (c35_i73 = 0; c35_i73 < 3; c35_i73++) {
    c35_u[c35_i73] = c35_b_inData[c35_i73];
  }

  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", c35_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static void c35_c_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[3])
{
  real_T c35_dv9[3];
  int32_T c35_i74;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), c35_dv9, 1, 0, 0U, 1, 0U, 1, 3);
  for (c35_i74 = 0; c35_i74 < 3; c35_i74++) {
    c35_y[c35_i74] = c35_dv9[c35_i74];
  }

  sf_mex_destroy(&c35_u);
}

static void c35_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_b_r_f_G;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  real_T c35_y[3];
  int32_T c35_i75;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_b_r_f_G = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_b_r_f_G), &c35_thisId,
    c35_y);
  sf_mex_destroy(&c35_b_r_f_G);
  for (c35_i75 = 0; c35_i75 < 3; c35_i75++) {
    (*(real_T (*)[3])c35_outData)[c35_i75] = c35_y[c35_i75];
  }

  sf_mex_destroy(&c35_mxArrayInData);
}

static const mxArray *c35_c_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_i76;
  int32_T c35_i77;
  int32_T c35_i78;
  real_T c35_b_inData[6];
  int32_T c35_i79;
  int32_T c35_i80;
  int32_T c35_i81;
  real_T c35_u[6];
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  c35_i76 = 0;
  for (c35_i77 = 0; c35_i77 < 2; c35_i77++) {
    for (c35_i78 = 0; c35_i78 < 3; c35_i78++) {
      c35_b_inData[c35_i78 + c35_i76] = (*(real_T (*)[6])c35_inData)[c35_i78 +
        c35_i76];
    }

    c35_i76 += 3;
  }

  c35_i79 = 0;
  for (c35_i80 = 0; c35_i80 < 2; c35_i80++) {
    for (c35_i81 = 0; c35_i81 < 3; c35_i81++) {
      c35_u[c35_i81 + c35_i79] = c35_b_inData[c35_i81 + c35_i79];
    }

    c35_i79 += 3;
  }

  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", c35_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static void c35_d_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[6])
{
  real_T c35_dv10[6];
  int32_T c35_i82;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), c35_dv10, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c35_i82 = 0; c35_i82 < 6; c35_i82++) {
    c35_y[c35_i82] = c35_dv10[c35_i82];
  }

  sf_mex_destroy(&c35_u);
}

static void c35_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_b_z_G;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  real_T c35_y[6];
  int32_T c35_i83;
  int32_T c35_i84;
  int32_T c35_i85;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_b_z_G = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_b_z_G), &c35_thisId,
    c35_y);
  sf_mex_destroy(&c35_b_z_G);
  c35_i83 = 0;
  for (c35_i84 = 0; c35_i84 < 2; c35_i84++) {
    for (c35_i85 = 0; c35_i85 < 3; c35_i85++) {
      (*(real_T (*)[6])c35_outData)[c35_i85 + c35_i83] = c35_y[c35_i85 + c35_i83];
    }

    c35_i83 += 3;
  }

  sf_mex_destroy(&c35_mxArrayInData);
}

static const mxArray *c35_d_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_i86;
  real_T c35_b_inData[4];
  int32_T c35_i87;
  real_T c35_u[4];
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  for (c35_i86 = 0; c35_i86 < 4; c35_i86++) {
    c35_b_inData[c35_i86] = (*(real_T (*)[4])c35_inData)[c35_i86];
  }

  for (c35_i87 = 0; c35_i87 < 4; c35_i87++) {
    c35_u[c35_i87] = c35_b_inData[c35_i87];
  }

  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", c35_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static void c35_e_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[4])
{
  real_T c35_dv11[4];
  int32_T c35_i88;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), c35_dv11, 1, 0, 0U, 1, 0U, 1, 4);
  for (c35_i88 = 0; c35_i88 < 4; c35_i88++) {
    c35_y[c35_i88] = c35_dv11[c35_i88];
  }

  sf_mex_destroy(&c35_u);
}

static void c35_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_b_u_0;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  real_T c35_y[4];
  int32_T c35_i89;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_b_u_0 = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_b_u_0), &c35_thisId,
    c35_y);
  sf_mex_destroy(&c35_b_u_0);
  for (c35_i89 = 0; c35_i89 < 4; c35_i89++) {
    (*(real_T (*)[4])c35_outData)[c35_i89] = c35_y[c35_i89];
  }

  sf_mex_destroy(&c35_mxArrayInData);
}

static const mxArray *c35_e_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_i90;
  int32_T c35_i91;
  int32_T c35_i92;
  real_T c35_b_inData[12];
  int32_T c35_i93;
  int32_T c35_i94;
  int32_T c35_i95;
  real_T c35_u[12];
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  c35_i90 = 0;
  for (c35_i91 = 0; c35_i91 < 3; c35_i91++) {
    for (c35_i92 = 0; c35_i92 < 4; c35_i92++) {
      c35_b_inData[c35_i92 + c35_i90] = (*(real_T (*)[12])c35_inData)[c35_i92 +
        c35_i90];
    }

    c35_i90 += 4;
  }

  c35_i93 = 0;
  for (c35_i94 = 0; c35_i94 < 3; c35_i94++) {
    for (c35_i95 = 0; c35_i95 < 4; c35_i95++) {
      c35_u[c35_i95 + c35_i93] = c35_b_inData[c35_i95 + c35_i93];
    }

    c35_i93 += 4;
  }

  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", c35_u, 0, 0U, 1U, 0U, 2, 4, 3), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static const mxArray *c35_f_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_i96;
  int32_T c35_i97;
  int32_T c35_i98;
  real_T c35_b_inData[12];
  int32_T c35_i99;
  int32_T c35_i100;
  int32_T c35_i101;
  real_T c35_u[12];
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  c35_i96 = 0;
  for (c35_i97 = 0; c35_i97 < 4; c35_i97++) {
    for (c35_i98 = 0; c35_i98 < 3; c35_i98++) {
      c35_b_inData[c35_i98 + c35_i96] = (*(real_T (*)[12])c35_inData)[c35_i98 +
        c35_i96];
    }

    c35_i96 += 3;
  }

  c35_i99 = 0;
  for (c35_i100 = 0; c35_i100 < 4; c35_i100++) {
    for (c35_i101 = 0; c35_i101 < 3; c35_i101++) {
      c35_u[c35_i101 + c35_i99] = c35_b_inData[c35_i101 + c35_i99];
    }

    c35_i99 += 3;
  }

  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", c35_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static void c35_f_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[12])
{
  real_T c35_dv12[12];
  int32_T c35_i102;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), c35_dv12, 1, 0, 0U, 1, 0U, 2, 3,
                4);
  for (c35_i102 = 0; c35_i102 < 12; c35_i102++) {
    c35_y[c35_i102] = c35_dv12[c35_i102];
  }

  sf_mex_destroy(&c35_u);
}

static void c35_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_D;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  real_T c35_y[12];
  int32_T c35_i103;
  int32_T c35_i104;
  int32_T c35_i105;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_D = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_D), &c35_thisId, c35_y);
  sf_mex_destroy(&c35_D);
  c35_i103 = 0;
  for (c35_i104 = 0; c35_i104 < 4; c35_i104++) {
    for (c35_i105 = 0; c35_i105 < 3; c35_i105++) {
      (*(real_T (*)[12])c35_outData)[c35_i105 + c35_i103] = c35_y[c35_i105 +
        c35_i103];
    }

    c35_i103 += 3;
  }

  sf_mex_destroy(&c35_mxArrayInData);
}

static const mxArray *c35_g_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_i106;
  int32_T c35_i107;
  int32_T c35_i108;
  real_T c35_b_inData[16];
  int32_T c35_i109;
  int32_T c35_i110;
  int32_T c35_i111;
  real_T c35_u[16];
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  c35_i106 = 0;
  for (c35_i107 = 0; c35_i107 < 4; c35_i107++) {
    for (c35_i108 = 0; c35_i108 < 4; c35_i108++) {
      c35_b_inData[c35_i108 + c35_i106] = (*(real_T (*)[16])c35_inData)[c35_i108
        + c35_i106];
    }

    c35_i106 += 4;
  }

  c35_i109 = 0;
  for (c35_i110 = 0; c35_i110 < 4; c35_i110++) {
    for (c35_i111 = 0; c35_i111 < 4; c35_i111++) {
      c35_u[c35_i111 + c35_i109] = c35_b_inData[c35_i111 + c35_i109];
    }

    c35_i109 += 4;
  }

  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", c35_u, 0, 0U, 1U, 0U, 2, 4, 4), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static void c35_g_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId, real_T c35_y[16])
{
  real_T c35_dv13[16];
  int32_T c35_i112;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), c35_dv13, 1, 0, 0U, 1, 0U, 2, 4,
                4);
  for (c35_i112 = 0; c35_i112 < 16; c35_i112++) {
    c35_y[c35_i112] = c35_dv13[c35_i112];
  }

  sf_mex_destroy(&c35_u);
}

static void c35_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_B;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  real_T c35_y[16];
  int32_T c35_i113;
  int32_T c35_i114;
  int32_T c35_i115;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_B = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_B), &c35_thisId, c35_y);
  sf_mex_destroy(&c35_B);
  c35_i113 = 0;
  for (c35_i114 = 0; c35_i114 < 4; c35_i114++) {
    for (c35_i115 = 0; c35_i115 < 4; c35_i115++) {
      (*(real_T (*)[16])c35_outData)[c35_i115 + c35_i113] = c35_y[c35_i115 +
        c35_i113];
    }

    c35_i113 += 4;
  }

  sf_mex_destroy(&c35_mxArrayInData);
}

const mxArray
  *sf_c35_SimulationPlantModel_Kalman_get_eml_resolved_functions_info(void)
{
  const mxArray *c35_nameCaptureInfo;
  c35_ResolvedFunctionInfo c35_info[21];
  const mxArray *c35_m0 = NULL;
  int32_T c35_i116;
  c35_ResolvedFunctionInfo *c35_r0;
  c35_nameCaptureInfo = NULL;
  c35_nameCaptureInfo = NULL;
  c35_info_helper(c35_info);
  sf_mex_assign(&c35_m0, sf_mex_createstruct("nameCaptureInfo", 1, 21), FALSE);
  for (c35_i116 = 0; c35_i116 < 21; c35_i116++) {
    c35_r0 = &c35_info[c35_i116];
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo", c35_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c35_r0->context)), "context", "nameCaptureInfo",
                    c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo", c35_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c35_r0->name)), "name", "nameCaptureInfo",
                    c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo",
      c35_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c35_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo", c35_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c35_r0->resolved)), "resolved",
                    "nameCaptureInfo", c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo", &c35_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo", &c35_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo",
      &c35_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c35_i116);
    sf_mex_addfield(c35_m0, sf_mex_create("nameCaptureInfo",
      &c35_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c35_i116);
  }

  sf_mex_assign(&c35_nameCaptureInfo, c35_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c35_nameCaptureInfo);
  return c35_nameCaptureInfo;
}

static void c35_info_helper(c35_ResolvedFunctionInfo c35_info[21])
{
  c35_info[0].context = "";
  c35_info[0].name = "mtimes";
  c35_info[0].dominantType = "double";
  c35_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c35_info[0].fileTimeLo = 1289519692U;
  c35_info[0].fileTimeHi = 0U;
  c35_info[0].mFileTimeLo = 0U;
  c35_info[0].mFileTimeHi = 0U;
  c35_info[1].context = "";
  c35_info[1].name = "mrdivide";
  c35_info[1].dominantType = "double";
  c35_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c35_info[1].fileTimeLo = 1357951548U;
  c35_info[1].fileTimeHi = 0U;
  c35_info[1].mFileTimeLo = 1319729966U;
  c35_info[1].mFileTimeHi = 0U;
  c35_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c35_info[2].name = "rdivide";
  c35_info[2].dominantType = "double";
  c35_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c35_info[2].fileTimeLo = 1346510388U;
  c35_info[2].fileTimeHi = 0U;
  c35_info[2].mFileTimeLo = 0U;
  c35_info[2].mFileTimeHi = 0U;
  c35_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c35_info[3].name = "eml_scalexp_compatible";
  c35_info[3].dominantType = "double";
  c35_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c35_info[3].fileTimeLo = 1286818796U;
  c35_info[3].fileTimeHi = 0U;
  c35_info[3].mFileTimeLo = 0U;
  c35_info[3].mFileTimeHi = 0U;
  c35_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c35_info[4].name = "eml_div";
  c35_info[4].dominantType = "double";
  c35_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c35_info[4].fileTimeLo = 1313347810U;
  c35_info[4].fileTimeHi = 0U;
  c35_info[4].mFileTimeLo = 0U;
  c35_info[4].mFileTimeHi = 0U;
  c35_info[5].context = "";
  c35_info[5].name = "mpower";
  c35_info[5].dominantType = "double";
  c35_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c35_info[5].fileTimeLo = 1286818842U;
  c35_info[5].fileTimeHi = 0U;
  c35_info[5].mFileTimeLo = 0U;
  c35_info[5].mFileTimeHi = 0U;
  c35_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c35_info[6].name = "power";
  c35_info[6].dominantType = "double";
  c35_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c35_info[6].fileTimeLo = 1348191930U;
  c35_info[6].fileTimeHi = 0U;
  c35_info[6].mFileTimeLo = 0U;
  c35_info[6].mFileTimeHi = 0U;
  c35_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c35_info[7].name = "eml_scalar_eg";
  c35_info[7].dominantType = "double";
  c35_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c35_info[7].fileTimeLo = 1286818796U;
  c35_info[7].fileTimeHi = 0U;
  c35_info[7].mFileTimeLo = 0U;
  c35_info[7].mFileTimeHi = 0U;
  c35_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c35_info[8].name = "eml_scalexp_alloc";
  c35_info[8].dominantType = "double";
  c35_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c35_info[8].fileTimeLo = 1352424860U;
  c35_info[8].fileTimeHi = 0U;
  c35_info[8].mFileTimeLo = 0U;
  c35_info[8].mFileTimeHi = 0U;
  c35_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c35_info[9].name = "floor";
  c35_info[9].dominantType = "double";
  c35_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c35_info[9].fileTimeLo = 1343830380U;
  c35_info[9].fileTimeHi = 0U;
  c35_info[9].mFileTimeLo = 0U;
  c35_info[9].mFileTimeHi = 0U;
  c35_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c35_info[10].name = "eml_scalar_floor";
  c35_info[10].dominantType = "double";
  c35_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c35_info[10].fileTimeLo = 1286818726U;
  c35_info[10].fileTimeHi = 0U;
  c35_info[10].mFileTimeLo = 0U;
  c35_info[10].mFileTimeHi = 0U;
  c35_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c35_info[11].name = "eml_scalar_eg";
  c35_info[11].dominantType = "double";
  c35_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c35_info[11].fileTimeLo = 1286818796U;
  c35_info[11].fileTimeHi = 0U;
  c35_info[11].mFileTimeLo = 0U;
  c35_info[11].mFileTimeHi = 0U;
  c35_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c35_info[12].name = "mtimes";
  c35_info[12].dominantType = "double";
  c35_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c35_info[12].fileTimeLo = 1289519692U;
  c35_info[12].fileTimeHi = 0U;
  c35_info[12].mFileTimeLo = 0U;
  c35_info[12].mFileTimeHi = 0U;
  c35_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c35_info[13].name = "eml_index_class";
  c35_info[13].dominantType = "";
  c35_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c35_info[13].fileTimeLo = 1323170578U;
  c35_info[13].fileTimeHi = 0U;
  c35_info[13].mFileTimeLo = 0U;
  c35_info[13].mFileTimeHi = 0U;
  c35_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c35_info[14].name = "eml_scalar_eg";
  c35_info[14].dominantType = "double";
  c35_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c35_info[14].fileTimeLo = 1286818796U;
  c35_info[14].fileTimeHi = 0U;
  c35_info[14].mFileTimeLo = 0U;
  c35_info[14].mFileTimeHi = 0U;
  c35_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c35_info[15].name = "eml_xgemm";
  c35_info[15].dominantType = "char";
  c35_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c35_info[15].fileTimeLo = 1299076772U;
  c35_info[15].fileTimeHi = 0U;
  c35_info[15].mFileTimeLo = 0U;
  c35_info[15].mFileTimeHi = 0U;
  c35_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c35_info[16].name = "eml_blas_inline";
  c35_info[16].dominantType = "";
  c35_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c35_info[16].fileTimeLo = 1299076768U;
  c35_info[16].fileTimeHi = 0U;
  c35_info[16].mFileTimeLo = 0U;
  c35_info[16].mFileTimeHi = 0U;
  c35_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c35_info[17].name = "mtimes";
  c35_info[17].dominantType = "double";
  c35_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c35_info[17].fileTimeLo = 1289519692U;
  c35_info[17].fileTimeHi = 0U;
  c35_info[17].mFileTimeLo = 0U;
  c35_info[17].mFileTimeHi = 0U;
  c35_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c35_info[18].name = "eml_index_class";
  c35_info[18].dominantType = "";
  c35_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c35_info[18].fileTimeLo = 1323170578U;
  c35_info[18].fileTimeHi = 0U;
  c35_info[18].mFileTimeLo = 0U;
  c35_info[18].mFileTimeHi = 0U;
  c35_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c35_info[19].name = "eml_scalar_eg";
  c35_info[19].dominantType = "double";
  c35_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c35_info[19].fileTimeLo = 1286818796U;
  c35_info[19].fileTimeHi = 0U;
  c35_info[19].mFileTimeLo = 0U;
  c35_info[19].mFileTimeHi = 0U;
  c35_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c35_info[20].name = "eml_refblas_xgemm";
  c35_info[20].dominantType = "char";
  c35_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c35_info[20].fileTimeLo = 1299076774U;
  c35_info[20].fileTimeHi = 0U;
  c35_info[20].mFileTimeLo = 0U;
  c35_info[20].mFileTimeHi = 0U;
}

static real_T c35_mpower(SFc35_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c35_a)
{
  real_T c35_b_a;
  real_T c35_c_a;
  real_T c35_ak;
  real_T c35_d_a;
  real_T c35_e_a;
  real_T c35_b;
  c35_b_a = c35_a;
  c35_c_a = c35_b_a;
  c35_eml_scalar_eg(chartInstance);
  c35_ak = c35_c_a;
  c35_d_a = c35_ak;
  c35_eml_scalar_eg(chartInstance);
  c35_e_a = c35_d_a;
  c35_b = c35_d_a;
  return c35_e_a * c35_b;
}

static void c35_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance)
{
}

static real_T c35_b_mpower(SFc35_SimulationPlantModel_KalmanInstanceStruct
  *chartInstance, real_T c35_a)
{
  real_T c35_b_a;
  real_T c35_c_a;
  real_T c35_ak;
  real_T c35_d_a;
  real_T c35_ar;
  c35_b_a = c35_a;
  c35_c_a = c35_b_a;
  c35_eml_scalar_eg(chartInstance);
  c35_ak = c35_c_a;
  c35_d_a = c35_ak;
  c35_eml_scalar_eg(chartInstance);
  c35_ar = c35_d_a;
  return muDoubleScalarPower(c35_ar, 3.0);
}

static void c35_b_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static void c35_c_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static void c35_d_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static void c35_e_eml_scalar_eg(SFc35_SimulationPlantModel_KalmanInstanceStruct *
  chartInstance)
{
}

static const mxArray *c35_h_sf_marshallOut(void *chartInstanceVoid, void
  *c35_inData)
{
  const mxArray *c35_mxArrayOutData = NULL;
  int32_T c35_u;
  const mxArray *c35_y = NULL;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_mxArrayOutData = NULL;
  c35_u = *(int32_T *)c35_inData;
  c35_y = NULL;
  sf_mex_assign(&c35_y, sf_mex_create("y", &c35_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c35_mxArrayOutData, c35_y, FALSE);
  return c35_mxArrayOutData;
}

static int32_T c35_h_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId)
{
  int32_T c35_y;
  int32_T c35_i117;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), &c35_i117, 1, 6, 0U, 0, 0U, 0);
  c35_y = c35_i117;
  sf_mex_destroy(&c35_u);
  return c35_y;
}

static void c35_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c35_mxArrayInData, const char_T *c35_varName, void *c35_outData)
{
  const mxArray *c35_b_sfEvent;
  const char_T *c35_identifier;
  emlrtMsgIdentifier c35_thisId;
  int32_T c35_y;
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
    chartInstanceVoid;
  c35_b_sfEvent = sf_mex_dup(c35_mxArrayInData);
  c35_identifier = c35_varName;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_y = c35_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c35_b_sfEvent),
    &c35_thisId);
  sf_mex_destroy(&c35_b_sfEvent);
  *(int32_T *)c35_outData = c35_y;
  sf_mex_destroy(&c35_mxArrayInData);
}

static uint8_T c35_i_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_b_is_active_c35_SimulationPlantModel_Kalman, const char_T
   *c35_identifier)
{
  uint8_T c35_y;
  emlrtMsgIdentifier c35_thisId;
  c35_thisId.fIdentifier = c35_identifier;
  c35_thisId.fParent = NULL;
  c35_y = c35_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c35_b_is_active_c35_SimulationPlantModel_Kalman), &c35_thisId);
  sf_mex_destroy(&c35_b_is_active_c35_SimulationPlantModel_Kalman);
  return c35_y;
}

static uint8_T c35_j_emlrt_marshallIn
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance, const mxArray
   *c35_u, const emlrtMsgIdentifier *c35_parentId)
{
  uint8_T c35_y;
  uint8_T c35_u0;
  sf_mex_import(c35_parentId, sf_mex_dup(c35_u), &c35_u0, 1, 3, 0U, 0, 0U, 0);
  c35_y = c35_u0;
  sf_mex_destroy(&c35_u);
  return c35_y;
}

static void init_dsm_address_info
  (SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c35_SimulationPlantModel_Kalman_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(784116032U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3049622575U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2730806761U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1772532514U);
}

mxArray *sf_c35_SimulationPlantModel_Kalman_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("tX1haeiFa1eYLF43l8L1KB");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,10,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c35_SimulationPlantModel_Kalman_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c35_SimulationPlantModel_Kalman(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[31],T\"d_delta\",},{M[1],M[34],T\"d_i_f\",},{M[1],M[32],T\"d_omega\",},{M[1],M[33],T\"d_t_m\",},{M[1],M[28],T\"r1\",},{M[1],M[29],T\"r2\",},{M[1],M[30],T\"r3\",},{M[8],M[0],T\"is_active_c35_SimulationPlantModel_Kalman\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c35_SimulationPlantModel_Kalman_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
    chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_KalmanMachineNumber_,
           35,
           1,
           1,
           23,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_KalmanMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_KalmanMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"y");
          _SFD_SET_DATA_PROPS(1,1,1,0,"u_vector");
          _SFD_SET_DATA_PROPS(2,1,1,0,"delta");
          _SFD_SET_DATA_PROPS(3,1,1,0,"omega");
          _SFD_SET_DATA_PROPS(4,1,1,0,"t_m");
          _SFD_SET_DATA_PROPS(5,1,1,0,"i_f");
          _SFD_SET_DATA_PROPS(6,2,0,1,"r1");
          _SFD_SET_DATA_PROPS(7,2,0,1,"r2");
          _SFD_SET_DATA_PROPS(8,2,0,1,"r3");
          _SFD_SET_DATA_PROPS(9,2,0,1,"d_delta");
          _SFD_SET_DATA_PROPS(10,2,0,1,"d_omega");
          _SFD_SET_DATA_PROPS(11,2,0,1,"d_t_m");
          _SFD_SET_DATA_PROPS(12,2,0,1,"d_i_f");
          _SFD_SET_DATA_PROPS(13,10,0,0,"x_0");
          _SFD_SET_DATA_PROPS(14,10,0,0,"u_0");
          _SFD_SET_DATA_PROPS(15,10,0,0,"H_G");
          _SFD_SET_DATA_PROPS(16,10,0,0,"D_fw_G");
          _SFD_SET_DATA_PROPS(17,10,0,0,"z_G");
          _SFD_SET_DATA_PROPS(18,10,0,0,"tau_e_G");
          _SFD_SET_DATA_PROPS(19,10,0,0,"tau_f_G");
          _SFD_SET_DATA_PROPS(20,10,0,0,"r_f_G");
          _SFD_SET_DATA_PROPS(21,10,0,0,"GeneratorNumber");
          _SFD_SET_DATA_PROPS(22,10,0,0,"omega_b");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1476);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_d_sf_marshallOut,(MexInFcnForType)
            c35_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_d_sf_marshallOut,(MexInFcnForType)
            c35_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_b_sf_marshallOut,(MexInFcnForType)
            c35_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_b_sf_marshallOut,(MexInFcnForType)
            c35_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_c_sf_marshallOut,(MexInFcnForType)
            c35_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(18,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_b_sf_marshallOut,(MexInFcnForType)
            c35_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(19,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_b_sf_marshallOut,(MexInFcnForType)
            c35_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(20,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c35_b_sf_marshallOut,(MexInFcnForType)
            c35_b_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(21,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(22,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c35_sf_marshallOut,(MexInFcnForType)c35_sf_marshallIn);

        {
          real_T *c35_delta;
          real_T *c35_omega;
          real_T *c35_t_m;
          real_T *c35_i_f;
          real_T *c35_r1;
          real_T *c35_r2;
          real_T *c35_r3;
          real_T *c35_d_delta;
          real_T *c35_d_omega;
          real_T *c35_d_t_m;
          real_T *c35_d_i_f;
          real_T (*c35_y)[3];
          real_T (*c35_u_vector)[4];
          c35_d_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
          c35_d_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c35_d_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c35_d_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c35_r3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c35_r2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c35_r1 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c35_i_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c35_t_m = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c35_omega = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c35_delta = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c35_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c35_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c35_y);
          _SFD_SET_DATA_VALUE_PTR(1U, *c35_u_vector);
          _SFD_SET_DATA_VALUE_PTR(2U, c35_delta);
          _SFD_SET_DATA_VALUE_PTR(3U, c35_omega);
          _SFD_SET_DATA_VALUE_PTR(4U, c35_t_m);
          _SFD_SET_DATA_VALUE_PTR(5U, c35_i_f);
          _SFD_SET_DATA_VALUE_PTR(6U, c35_r1);
          _SFD_SET_DATA_VALUE_PTR(7U, c35_r2);
          _SFD_SET_DATA_VALUE_PTR(8U, c35_r3);
          _SFD_SET_DATA_VALUE_PTR(9U, c35_d_delta);
          _SFD_SET_DATA_VALUE_PTR(10U, c35_d_omega);
          _SFD_SET_DATA_VALUE_PTR(11U, c35_d_t_m);
          _SFD_SET_DATA_VALUE_PTR(12U, c35_d_i_f);
          _SFD_SET_DATA_VALUE_PTR(13U, chartInstance->c35_x_0);
          _SFD_SET_DATA_VALUE_PTR(14U, chartInstance->c35_u_0);
          _SFD_SET_DATA_VALUE_PTR(15U, chartInstance->c35_H_G);
          _SFD_SET_DATA_VALUE_PTR(16U, chartInstance->c35_D_fw_G);
          _SFD_SET_DATA_VALUE_PTR(17U, chartInstance->c35_z_G);
          _SFD_SET_DATA_VALUE_PTR(18U, chartInstance->c35_tau_e_G);
          _SFD_SET_DATA_VALUE_PTR(19U, chartInstance->c35_tau_f_G);
          _SFD_SET_DATA_VALUE_PTR(20U, chartInstance->c35_r_f_G);
          _SFD_SET_DATA_VALUE_PTR(21U, &chartInstance->c35_GeneratorNumber);
          _SFD_SET_DATA_VALUE_PTR(22U, &chartInstance->c35_omega_b);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_KalmanMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "XZfkIXCW3eH7IsXbMUHwlD";
}

static void sf_opaque_initialize_c35_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc35_SimulationPlantModel_KalmanInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
  initialize_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c35_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  enable_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c35_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  disable_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c35_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  sf_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c35_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c35_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c35_SimulationPlantModel_Kalman(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c35_SimulationPlantModel_Kalman();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c35_SimulationPlantModel_Kalman
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c35_SimulationPlantModel_Kalman(S);
}

static void sf_opaque_set_sim_state_c35_SimulationPlantModel_Kalman(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c35_SimulationPlantModel_Kalman(S, st);
}

static void sf_opaque_terminate_c35_SimulationPlantModel_Kalman(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc35_SimulationPlantModel_KalmanInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Kalman_optimization_info();
    }

    finalize_c35_SimulationPlantModel_Kalman
      ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc35_SimulationPlantModel_Kalman
    ((SFc35_SimulationPlantModel_KalmanInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c35_SimulationPlantModel_Kalman(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c35_SimulationPlantModel_Kalman
      ((SFc35_SimulationPlantModel_KalmanInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c35_SimulationPlantModel_Kalman(SimStruct *S)
{
  /* Actual parameters from chart:
     D_fw_G GeneratorNumber H_G omega_b r_f_G tau_e_G tau_f_G u_0 x_0 z_G
   */
  const char_T *rtParamNames[] = { "D_fw_G", "GeneratorNumber", "H_G", "omega_b",
    "r_f_G", "tau_e_G", "tau_f_G", "u_0", "x_0", "z_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for D_fw_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for H_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for omega_b*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for r_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for tau_e_G*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);

  /* registration for tau_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 6, 6, rtParamNames[6], SS_DOUBLE);

  /* registration for u_0*/
  ssRegDlgParamAsRunTimeParam(S, 7, 7, rtParamNames[7], SS_DOUBLE);

  /* registration for x_0*/
  ssRegDlgParamAsRunTimeParam(S, 8, 8, rtParamNames[8], SS_DOUBLE);

  /* registration for z_G*/
  ssRegDlgParamAsRunTimeParam(S, 9, 9, rtParamNames[9], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Kalman_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      35);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,35,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,35,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,35);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,35,6);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,35,7);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=7; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 6; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,35);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2636614823U));
  ssSetChecksum1(S,(3458539673U));
  ssSetChecksum2(S,(1302847399U));
  ssSetChecksum3(S,(1186624958U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c35_SimulationPlantModel_Kalman(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c35_SimulationPlantModel_Kalman(SimStruct *S)
{
  SFc35_SimulationPlantModel_KalmanInstanceStruct *chartInstance;
  chartInstance = (SFc35_SimulationPlantModel_KalmanInstanceStruct *)utMalloc
    (sizeof(SFc35_SimulationPlantModel_KalmanInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc35_SimulationPlantModel_KalmanInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlStart = mdlStart_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c35_SimulationPlantModel_Kalman;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c35_SimulationPlantModel_Kalman_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c35_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c35_SimulationPlantModel_Kalman(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c35_SimulationPlantModel_Kalman(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c35_SimulationPlantModel_Kalman_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
