/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c28_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c28_debug_family_names[42] = { "H", "D_fw", "T_e", "T_f",
  "r_f", "r_s", "x_s", "omega0", "i_f0", "omega", "p", "q", "abs_v_ll", "A", "B",
  "f_uy", "C", "D", "hat_y", "tilde_y", "nargin", "nargout", "y", "u_vector",
  "hat_x", "L", "x_0", "H_G", "D_fw_G", "z_G", "tau_e_G", "tau_f_G", "r_f_G",
  "GeneratorNumber", "omega_b", "hat_omega", "hat_p", "hat_q", "tilde_omega",
  "tilde_p", "tilde_q", "d_hat_x" };

/* Function Declarations */
static void initialize_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c28_update_debugger_state_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_st);
static void finalize_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c28_chartstep_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c28_machineNumber, uint32_T
  c28_chartNumber);
static const mxArray *c28_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_d_hat_x, const char_T *c28_identifier, real_T c28_y[4]);
static void c28_b_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[4]);
static void c28_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_b_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static real_T c28_c_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_tilde_q, const char_T *c28_identifier);
static real_T c28_d_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void c28_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_c_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_e_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[3]);
static void c28_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_d_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_f_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[6]);
static void c28_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_e_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_g_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[12]);
static void c28_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_f_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_h_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[12]);
static void c28_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_g_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static void c28_i_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[16]);
static void c28_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static void c28_info_helper(c28_ResolvedFunctionInfo c28_info[21]);
static real_T c28_mpower(SFc28_SimulationPlantModel_LuenbergInstanceStruct
  *chartInstance, real_T c28_a);
static void c28_eml_scalar_eg(SFc28_SimulationPlantModel_LuenbergInstanceStruct *
  chartInstance);
static void c28_b_eml_scalar_eg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c28_c_eml_scalar_eg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c28_d_eml_scalar_eg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *c28_h_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static int32_T c28_j_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void c28_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static uint8_T c28_k_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_b_is_active_c28_SimulationPlantModel_Luenberg, const char_T
   *c28_identifier);
static uint8_T c28_l_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void init_dsm_address_info
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c28_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c28_is_active_c28_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  real_T c28_dv0[12];
  int32_T c28_i0;
  real_T c28_dv1[4];
  int32_T c28_i1;
  real_T c28_dv2[3];
  int32_T c28_i2;
  real_T c28_dv3[3];
  int32_T c28_i3;
  real_T c28_dv4[6];
  int32_T c28_i4;
  real_T c28_dv5[3];
  int32_T c28_i5;
  real_T c28_dv6[3];
  int32_T c28_i6;
  real_T c28_dv7[3];
  int32_T c28_i7;
  real_T c28_d0;
  real_T c28_d1;
  sf_set_error_prefix_string(
    "Error evaluating data 'L' in the parent workspace.\n");
  sf_mex_import_named("L", sf_mex_get_sfun_param(chartInstance->S, 3, 0),
                      c28_dv0, 0, 0, 0U, 1, 0U, 2, 4, 3);
  for (c28_i0 = 0; c28_i0 < 12; c28_i0++) {
    chartInstance->c28_L[c28_i0] = c28_dv0[c28_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'x_0' in the parent workspace.\n");
  sf_mex_import_named("x_0", sf_mex_get_sfun_param(chartInstance->S, 8, 0),
                      c28_dv1, 0, 0, 0U, 1, 0U, 1, 4);
  for (c28_i1 = 0; c28_i1 < 4; c28_i1++) {
    chartInstance->c28_x_0[c28_i1] = c28_dv1[c28_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'H_G' in the parent workspace.\n");
  sf_mex_import_named("H_G", sf_mex_get_sfun_param(chartInstance->S, 2, 0),
                      c28_dv2, 0, 0, 0U, 1, 0U, 1, 3);
  for (c28_i2 = 0; c28_i2 < 3; c28_i2++) {
    chartInstance->c28_H_G[c28_i2] = c28_dv2[c28_i2];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'D_fw_G' in the parent workspace.\n");
  sf_mex_import_named("D_fw_G", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                      c28_dv3, 0, 0, 0U, 1, 0U, 1, 3);
  for (c28_i3 = 0; c28_i3 < 3; c28_i3++) {
    chartInstance->c28_D_fw_G[c28_i3] = c28_dv3[c28_i3];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'z_G' in the parent workspace.\n");
  sf_mex_import_named("z_G", sf_mex_get_sfun_param(chartInstance->S, 9, 0),
                      c28_dv4, 0, 0, 0U, 1, 0U, 2, 3, 2);
  for (c28_i4 = 0; c28_i4 < 6; c28_i4++) {
    chartInstance->c28_z_G[c28_i4] = c28_dv4[c28_i4];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_e_G' in the parent workspace.\n");
  sf_mex_import_named("tau_e_G", sf_mex_get_sfun_param(chartInstance->S, 6, 0),
                      c28_dv5, 0, 0, 0U, 1, 0U, 1, 3);
  for (c28_i5 = 0; c28_i5 < 3; c28_i5++) {
    chartInstance->c28_tau_e_G[c28_i5] = c28_dv5[c28_i5];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'tau_f_G' in the parent workspace.\n");
  sf_mex_import_named("tau_f_G", sf_mex_get_sfun_param(chartInstance->S, 7, 0),
                      c28_dv6, 0, 0, 0U, 1, 0U, 1, 3);
  for (c28_i6 = 0; c28_i6 < 3; c28_i6++) {
    chartInstance->c28_tau_f_G[c28_i6] = c28_dv6[c28_i6];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'r_f_G' in the parent workspace.\n");
  sf_mex_import_named("r_f_G", sf_mex_get_sfun_param(chartInstance->S, 5, 0),
                      c28_dv7, 0, 0, 0U, 1, 0U, 1, 3);
  for (c28_i7 = 0; c28_i7 < 3; c28_i7++) {
    chartInstance->c28_r_f_G[c28_i7] = c28_dv7[c28_i7];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'GeneratorNumber' in the parent workspace.\n");
  sf_mex_import_named("GeneratorNumber", sf_mex_get_sfun_param(chartInstance->S,
    1, 0), &c28_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_GeneratorNumber = c28_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Error evaluating data 'omega_b' in the parent workspace.\n");
  sf_mex_import_named("omega_b", sf_mex_get_sfun_param(chartInstance->S, 4, 0),
                      &c28_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c28_omega_b = c28_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c28_update_debugger_state_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c28_st;
  const mxArray *c28_y = NULL;
  int32_T c28_i8;
  real_T c28_u[4];
  const mxArray *c28_b_y = NULL;
  real_T c28_hoistedGlobal;
  real_T c28_b_u;
  const mxArray *c28_c_y = NULL;
  real_T c28_b_hoistedGlobal;
  real_T c28_c_u;
  const mxArray *c28_d_y = NULL;
  real_T c28_c_hoistedGlobal;
  real_T c28_d_u;
  const mxArray *c28_e_y = NULL;
  real_T c28_d_hoistedGlobal;
  real_T c28_e_u;
  const mxArray *c28_f_y = NULL;
  real_T c28_e_hoistedGlobal;
  real_T c28_f_u;
  const mxArray *c28_g_y = NULL;
  real_T c28_f_hoistedGlobal;
  real_T c28_g_u;
  const mxArray *c28_h_y = NULL;
  uint8_T c28_g_hoistedGlobal;
  uint8_T c28_h_u;
  const mxArray *c28_i_y = NULL;
  real_T *c28_hat_omega;
  real_T *c28_hat_p;
  real_T *c28_hat_q;
  real_T *c28_tilde_omega;
  real_T *c28_tilde_p;
  real_T *c28_tilde_q;
  real_T (*c28_d_hat_x)[4];
  c28_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c28_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c28_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c28_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c28_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c28_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c28_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c28_st = NULL;
  c28_st = NULL;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_createcellarray(8), FALSE);
  for (c28_i8 = 0; c28_i8 < 4; c28_i8++) {
    c28_u[c28_i8] = (*c28_d_hat_x)[c28_i8];
  }

  c28_b_y = NULL;
  sf_mex_assign(&c28_b_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_setcell(c28_y, 0, c28_b_y);
  c28_hoistedGlobal = *c28_hat_omega;
  c28_b_u = c28_hoistedGlobal;
  c28_c_y = NULL;
  sf_mex_assign(&c28_c_y, sf_mex_create("y", &c28_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 1, c28_c_y);
  c28_b_hoistedGlobal = *c28_hat_p;
  c28_c_u = c28_b_hoistedGlobal;
  c28_d_y = NULL;
  sf_mex_assign(&c28_d_y, sf_mex_create("y", &c28_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 2, c28_d_y);
  c28_c_hoistedGlobal = *c28_hat_q;
  c28_d_u = c28_c_hoistedGlobal;
  c28_e_y = NULL;
  sf_mex_assign(&c28_e_y, sf_mex_create("y", &c28_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 3, c28_e_y);
  c28_d_hoistedGlobal = *c28_tilde_omega;
  c28_e_u = c28_d_hoistedGlobal;
  c28_f_y = NULL;
  sf_mex_assign(&c28_f_y, sf_mex_create("y", &c28_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 4, c28_f_y);
  c28_e_hoistedGlobal = *c28_tilde_p;
  c28_f_u = c28_e_hoistedGlobal;
  c28_g_y = NULL;
  sf_mex_assign(&c28_g_y, sf_mex_create("y", &c28_f_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 5, c28_g_y);
  c28_f_hoistedGlobal = *c28_tilde_q;
  c28_g_u = c28_f_hoistedGlobal;
  c28_h_y = NULL;
  sf_mex_assign(&c28_h_y, sf_mex_create("y", &c28_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 6, c28_h_y);
  c28_g_hoistedGlobal =
    chartInstance->c28_is_active_c28_SimulationPlantModel_Luenberg;
  c28_h_u = c28_g_hoistedGlobal;
  c28_i_y = NULL;
  sf_mex_assign(&c28_i_y, sf_mex_create("y", &c28_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c28_y, 7, c28_i_y);
  sf_mex_assign(&c28_st, c28_y, FALSE);
  return c28_st;
}

static void set_sim_state_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_st)
{
  const mxArray *c28_u;
  real_T c28_dv8[4];
  int32_T c28_i9;
  real_T *c28_hat_omega;
  real_T *c28_hat_p;
  real_T *c28_hat_q;
  real_T *c28_tilde_omega;
  real_T *c28_tilde_p;
  real_T *c28_tilde_q;
  real_T (*c28_d_hat_x)[4];
  c28_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c28_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c28_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c28_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c28_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c28_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c28_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c28_doneDoubleBufferReInit = TRUE;
  c28_u = sf_mex_dup(c28_st);
  c28_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c28_u, 0)),
                       "d_hat_x", c28_dv8);
  for (c28_i9 = 0; c28_i9 < 4; c28_i9++) {
    (*c28_d_hat_x)[c28_i9] = c28_dv8[c28_i9];
  }

  *c28_hat_omega = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c28_u, 1)), "hat_omega");
  *c28_hat_p = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c28_u, 2)), "hat_p");
  *c28_hat_q = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c28_u, 3)), "hat_q");
  *c28_tilde_omega = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c28_u, 4)), "tilde_omega");
  *c28_tilde_p = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c28_u, 5)), "tilde_p");
  *c28_tilde_q = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c28_u, 6)), "tilde_q");
  chartInstance->c28_is_active_c28_SimulationPlantModel_Luenberg =
    c28_k_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c28_u, 7)),
    "is_active_c28_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c28_u);
  c28_update_debugger_state_c28_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c28_st);
}

static void finalize_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  int32_T c28_i10;
  int32_T c28_i11;
  int32_T c28_i12;
  int32_T c28_i13;
  int32_T c28_i14;
  int32_T c28_i15;
  int32_T c28_i16;
  int32_T c28_i17;
  int32_T c28_i18;
  int32_T c28_i19;
  int32_T c28_i20;
  int32_T c28_i21;
  real_T *c28_hat_omega;
  real_T *c28_hat_p;
  real_T *c28_hat_q;
  real_T *c28_tilde_omega;
  real_T *c28_tilde_p;
  real_T *c28_tilde_q;
  real_T (*c28_d_hat_x)[4];
  real_T (*c28_hat_x)[4];
  real_T (*c28_u_vector)[4];
  real_T (*c28_y)[3];
  c28_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c28_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c28_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c28_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c28_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c28_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c28_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c28_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c28_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c28_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 27U, chartInstance->c28_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c28_hat_omega, 0U);
  _SFD_DATA_RANGE_CHECK(*c28_hat_p, 1U);
  _SFD_DATA_RANGE_CHECK(*c28_hat_q, 2U);
  _SFD_DATA_RANGE_CHECK(*c28_tilde_omega, 3U);
  _SFD_DATA_RANGE_CHECK(*c28_tilde_p, 4U);
  _SFD_DATA_RANGE_CHECK(*c28_tilde_q, 5U);
  for (c28_i10 = 0; c28_i10 < 3; c28_i10++) {
    _SFD_DATA_RANGE_CHECK((*c28_y)[c28_i10], 6U);
  }

  for (c28_i11 = 0; c28_i11 < 4; c28_i11++) {
    _SFD_DATA_RANGE_CHECK((*c28_u_vector)[c28_i11], 7U);
  }

  for (c28_i12 = 0; c28_i12 < 4; c28_i12++) {
    _SFD_DATA_RANGE_CHECK((*c28_hat_x)[c28_i12], 8U);
  }

  for (c28_i13 = 0; c28_i13 < 12; c28_i13++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_L[c28_i13], 9U);
  }

  for (c28_i14 = 0; c28_i14 < 4; c28_i14++) {
    _SFD_DATA_RANGE_CHECK((*c28_d_hat_x)[c28_i14], 10U);
  }

  for (c28_i15 = 0; c28_i15 < 4; c28_i15++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_x_0[c28_i15], 11U);
  }

  for (c28_i16 = 0; c28_i16 < 3; c28_i16++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_H_G[c28_i16], 12U);
  }

  for (c28_i17 = 0; c28_i17 < 3; c28_i17++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_D_fw_G[c28_i17], 13U);
  }

  for (c28_i18 = 0; c28_i18 < 6; c28_i18++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_z_G[c28_i18], 14U);
  }

  for (c28_i19 = 0; c28_i19 < 3; c28_i19++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_tau_e_G[c28_i19], 15U);
  }

  for (c28_i20 = 0; c28_i20 < 3; c28_i20++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_tau_f_G[c28_i20], 16U);
  }

  for (c28_i21 = 0; c28_i21 < 3; c28_i21++) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c28_r_f_G[c28_i21], 17U);
  }

  _SFD_DATA_RANGE_CHECK(chartInstance->c28_GeneratorNumber, 18U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c28_omega_b, 19U);
  chartInstance->c28_sfEvent = CALL_EVENT;
  c28_chartstep_c28_SimulationPlantModel_Luenberg(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void c28_chartstep_c28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  real_T c28_hoistedGlobal;
  real_T c28_b_hoistedGlobal;
  int32_T c28_i22;
  real_T c28_y[3];
  int32_T c28_i23;
  real_T c28_u_vector[4];
  int32_T c28_i24;
  real_T c28_hat_x[4];
  int32_T c28_i25;
  real_T c28_b_L[12];
  int32_T c28_i26;
  real_T c28_b_x_0[4];
  int32_T c28_i27;
  real_T c28_b_H_G[3];
  int32_T c28_i28;
  real_T c28_b_D_fw_G[3];
  int32_T c28_i29;
  real_T c28_b_z_G[6];
  int32_T c28_i30;
  real_T c28_b_tau_e_G[3];
  int32_T c28_i31;
  real_T c28_b_tau_f_G[3];
  int32_T c28_i32;
  real_T c28_b_r_f_G[3];
  real_T c28_b_GeneratorNumber;
  real_T c28_b_omega_b;
  uint32_T c28_debug_family_var_map[42];
  real_T c28_H;
  real_T c28_D_fw;
  real_T c28_T_e;
  real_T c28_T_f;
  real_T c28_r_f;
  real_T c28_r_s;
  real_T c28_x_s;
  real_T c28_omega0;
  real_T c28_i_f0;
  real_T c28_omega;
  real_T c28_p;
  real_T c28_q;
  real_T c28_abs_v_ll;
  real_T c28_A[16];
  real_T c28_B[16];
  real_T c28_f_uy[4];
  real_T c28_C[12];
  real_T c28_D[12];
  real_T c28_hat_y[3];
  real_T c28_tilde_y[3];
  real_T c28_nargin = 13.0;
  real_T c28_nargout = 7.0;
  real_T c28_hat_omega;
  real_T c28_hat_p;
  real_T c28_hat_q;
  real_T c28_tilde_omega;
  real_T c28_tilde_p;
  real_T c28_tilde_q;
  real_T c28_d_hat_x[4];
  real_T c28_b;
  real_T c28_b_y;
  real_T c28_b_B;
  real_T c28_c_y;
  real_T c28_d_y;
  real_T c28_e_y;
  real_T c28_a;
  real_T c28_b_b;
  real_T c28_f_y;
  real_T c28_c_b;
  real_T c28_g_y;
  real_T c28_c_B;
  real_T c28_h_y;
  real_T c28_i_y;
  real_T c28_j_y;
  real_T c28_d_B;
  real_T c28_k_y;
  real_T c28_l_y;
  real_T c28_m_y;
  real_T c28_e_B;
  real_T c28_n_y;
  real_T c28_o_y;
  real_T c28_p_y;
  real_T c28_b_A;
  real_T c28_f_B;
  real_T c28_x;
  real_T c28_q_y;
  real_T c28_b_x;
  real_T c28_r_y;
  real_T c28_s_y;
  real_T c28_b_a;
  real_T c28_d_b;
  real_T c28_t_y;
  real_T c28_g_B;
  real_T c28_u_y;
  real_T c28_v_y;
  real_T c28_w_y;
  int32_T c28_i33;
  int32_T c28_i34;
  real_T c28_e_b;
  real_T c28_x_y;
  real_T c28_h_B;
  real_T c28_y_y;
  real_T c28_ab_y;
  real_T c28_bb_y;
  real_T c28_c_A;
  real_T c28_i_B;
  real_T c28_c_x;
  real_T c28_cb_y;
  real_T c28_d_x;
  real_T c28_db_y;
  real_T c28_eb_y;
  real_T c28_c_a;
  real_T c28_f_b;
  real_T c28_fb_y;
  real_T c28_d_a;
  real_T c28_g_b;
  real_T c28_gb_y;
  real_T c28_d_A;
  real_T c28_j_B;
  real_T c28_e_x;
  real_T c28_hb_y;
  real_T c28_f_x;
  real_T c28_ib_y;
  real_T c28_jb_y;
  real_T c28_e_a;
  real_T c28_h_b;
  real_T c28_kb_y;
  real_T c28_k_B;
  real_T c28_lb_y;
  real_T c28_mb_y;
  real_T c28_nb_y;
  real_T c28_l_B;
  real_T c28_ob_y;
  real_T c28_pb_y;
  real_T c28_qb_y;
  real_T c28_f_a;
  real_T c28_i_b;
  real_T c28_rb_y;
  real_T c28_g_a;
  real_T c28_j_b;
  real_T c28_sb_y;
  real_T c28_m_B;
  real_T c28_tb_y;
  real_T c28_ub_y;
  real_T c28_vb_y;
  real_T c28_h_a;
  real_T c28_k_b;
  real_T c28_wb_y;
  real_T c28_i_a;
  real_T c28_l_b;
  real_T c28_xb_y;
  int32_T c28_i35;
  int32_T c28_i36;
  static real_T c28_dv9[4] = { 0.0, 1.0, 0.0, 0.0 };

  real_T c28_n_B;
  real_T c28_yb_y;
  real_T c28_ac_y;
  real_T c28_bc_y;
  int32_T c28_i37;
  int32_T c28_i38;
  int32_T c28_i39;
  int32_T c28_i40;
  int32_T c28_i41;
  real_T c28_j_a[12];
  int32_T c28_i42;
  real_T c28_m_b[4];
  int32_T c28_i43;
  real_T c28_cc_y[3];
  int32_T c28_i44;
  int32_T c28_i45;
  int32_T c28_i46;
  int32_T c28_i47;
  int32_T c28_i48;
  real_T c28_dc_y[3];
  int32_T c28_i49;
  int32_T c28_i50;
  int32_T c28_i51;
  int32_T c28_i52;
  int32_T c28_i53;
  real_T c28_k_a[16];
  int32_T c28_i54;
  int32_T c28_i55;
  real_T c28_ec_y[4];
  int32_T c28_i56;
  int32_T c28_i57;
  int32_T c28_i58;
  int32_T c28_i59;
  int32_T c28_i60;
  real_T c28_fc_y[4];
  int32_T c28_i61;
  int32_T c28_i62;
  int32_T c28_i63;
  real_T c28_l_a[12];
  int32_T c28_i64;
  int32_T c28_i65;
  int32_T c28_i66;
  int32_T c28_i67;
  int32_T c28_i68;
  int32_T c28_i69;
  real_T *c28_b_hat_omega;
  real_T *c28_b_hat_p;
  real_T *c28_b_hat_q;
  real_T *c28_b_tilde_omega;
  real_T *c28_b_tilde_p;
  real_T *c28_b_tilde_q;
  real_T (*c28_b_d_hat_x)[4];
  real_T (*c28_b_hat_x)[4];
  real_T (*c28_b_u_vector)[4];
  real_T (*c28_gc_y)[3];
  c28_b_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
  c28_b_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
  c28_b_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
  c28_gc_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  c28_b_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c28_b_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c28_b_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c28_b_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c28_b_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c28_b_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 27U, chartInstance->c28_sfEvent);
  c28_hoistedGlobal = chartInstance->c28_GeneratorNumber;
  c28_b_hoistedGlobal = chartInstance->c28_omega_b;
  for (c28_i22 = 0; c28_i22 < 3; c28_i22++) {
    c28_y[c28_i22] = (*c28_gc_y)[c28_i22];
  }

  for (c28_i23 = 0; c28_i23 < 4; c28_i23++) {
    c28_u_vector[c28_i23] = (*c28_b_u_vector)[c28_i23];
  }

  for (c28_i24 = 0; c28_i24 < 4; c28_i24++) {
    c28_hat_x[c28_i24] = (*c28_b_hat_x)[c28_i24];
  }

  for (c28_i25 = 0; c28_i25 < 12; c28_i25++) {
    c28_b_L[c28_i25] = chartInstance->c28_L[c28_i25];
  }

  for (c28_i26 = 0; c28_i26 < 4; c28_i26++) {
    c28_b_x_0[c28_i26] = chartInstance->c28_x_0[c28_i26];
  }

  for (c28_i27 = 0; c28_i27 < 3; c28_i27++) {
    c28_b_H_G[c28_i27] = chartInstance->c28_H_G[c28_i27];
  }

  for (c28_i28 = 0; c28_i28 < 3; c28_i28++) {
    c28_b_D_fw_G[c28_i28] = chartInstance->c28_D_fw_G[c28_i28];
  }

  for (c28_i29 = 0; c28_i29 < 6; c28_i29++) {
    c28_b_z_G[c28_i29] = chartInstance->c28_z_G[c28_i29];
  }

  for (c28_i30 = 0; c28_i30 < 3; c28_i30++) {
    c28_b_tau_e_G[c28_i30] = chartInstance->c28_tau_e_G[c28_i30];
  }

  for (c28_i31 = 0; c28_i31 < 3; c28_i31++) {
    c28_b_tau_f_G[c28_i31] = chartInstance->c28_tau_f_G[c28_i31];
  }

  for (c28_i32 = 0; c28_i32 < 3; c28_i32++) {
    c28_b_r_f_G[c28_i32] = chartInstance->c28_r_f_G[c28_i32];
  }

  c28_b_GeneratorNumber = c28_hoistedGlobal;
  c28_b_omega_b = c28_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 42U, 42U, c28_debug_family_names,
    c28_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_H, 0U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_D_fw, 1U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_T_e, 2U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_T_f, 3U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_r_f, 4U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_r_s, 5U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_x_s, 6U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_omega0, 7U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_i_f0, 8U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_omega, 9U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_p, 10U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_q, 11U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_abs_v_ll, 12U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_A, 13U, c28_g_sf_marshallOut,
    c28_g_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_B, 14U, c28_g_sf_marshallOut,
    c28_g_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_f_uy, 15U, c28_sf_marshallOut,
    c28_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_C, 16U, c28_f_sf_marshallOut,
    c28_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_D, 17U, c28_f_sf_marshallOut,
    c28_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_hat_y, 18U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_tilde_y, 19U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_nargin, 20U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_nargout, 21U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c28_y, 22U, c28_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c28_u_vector, 23U, c28_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c28_hat_x, 24U, c28_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_L, 25U, c28_e_sf_marshallOut,
    c28_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_x_0, 26U, c28_sf_marshallOut,
    c28_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_H_G, 27U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_D_fw_G, 28U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_z_G, 29U, c28_d_sf_marshallOut,
    c28_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_tau_e_G, 30U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_tau_f_G, 31U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_b_r_f_G, 32U, c28_c_sf_marshallOut,
    c28_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_b_GeneratorNumber, 33U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_b_omega_b, 34U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_hat_omega, 35U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_hat_p, 36U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_hat_q, 37U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_tilde_omega, 38U,
    c28_b_sf_marshallOut, c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_tilde_p, 39U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c28_tilde_q, 40U, c28_b_sf_marshallOut,
    c28_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c28_d_hat_x, 41U, c28_sf_marshallOut,
    c28_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 5);
  c28_H = c28_b_H_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("H_G", (int32_T)
    _SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3, 1, 0) -
    1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 6);
  c28_D_fw = c28_b_D_fw_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("D_fw_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 7);
  c28_T_e = c28_b_tau_e_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_e_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 8);
  c28_T_f = c28_b_tau_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("tau_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 9);
  c28_r_f = c28_b_r_f_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("r_f_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 10);
  c28_r_s = c28_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3,
    1, 0) - 1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 11);
  c28_x_s = c28_b_z_G[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("z_G",
    (int32_T)_SFD_INTEGER_CHECK("GeneratorNumber", c28_b_GeneratorNumber), 1, 3,
    1, 0) + 2];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 12);
  c28_omega0 = c28_b_x_0[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 13);
  c28_i_f0 = c28_b_x_0[3];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 15);
  c28_omega = c28_y[0];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 16);
  c28_p = c28_y[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 17);
  c28_q = c28_y[2];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 18);
  c28_abs_v_ll = c28_u_vector[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 21);
  c28_b = c28_H;
  c28_b_y = 2.0 * c28_b;
  c28_b_B = c28_b_y;
  c28_c_y = c28_b_B;
  c28_d_y = c28_c_y;
  c28_e_y = 1.0 / c28_d_y;
  c28_a = -c28_e_y;
  c28_b_b = c28_D_fw;
  c28_f_y = c28_a * c28_b_b;
  c28_c_b = c28_H;
  c28_g_y = 2.0 * c28_c_b;
  c28_c_B = c28_g_y;
  c28_h_y = c28_c_B;
  c28_i_y = c28_h_y;
  c28_j_y = 1.0 / c28_i_y;
  c28_d_B = c28_T_e;
  c28_k_y = c28_d_B;
  c28_l_y = c28_k_y;
  c28_m_y = -1.0 / c28_l_y;
  c28_e_B = c28_T_f;
  c28_n_y = c28_e_B;
  c28_o_y = c28_n_y;
  c28_p_y = -1.0 / c28_o_y;
  c28_A[0] = 0.0;
  c28_A[4] = c28_b_omega_b;
  c28_A[8] = 0.0;
  c28_A[12] = 0.0;
  c28_A[1] = 0.0;
  c28_A[5] = c28_f_y;
  c28_A[9] = c28_j_y;
  c28_A[13] = 0.0;
  c28_A[2] = 0.0;
  c28_A[6] = 0.0;
  c28_A[10] = c28_m_y;
  c28_A[14] = 0.0;
  c28_A[3] = 0.0;
  c28_A[7] = 0.0;
  c28_A[11] = 0.0;
  c28_A[15] = c28_p_y;
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 26);
  c28_b_A = c28_D_fw + 1.0;
  c28_f_B = c28_T_e;
  c28_x = c28_b_A;
  c28_q_y = c28_f_B;
  c28_b_x = c28_x;
  c28_r_y = c28_q_y;
  c28_s_y = c28_b_x / c28_r_y;
  c28_b_a = c28_T_f;
  c28_d_b = c28_r_f;
  c28_t_y = c28_b_a * c28_d_b;
  c28_g_B = c28_t_y;
  c28_u_y = c28_g_B;
  c28_v_y = c28_u_y;
  c28_w_y = 1.0 / c28_v_y;
  c28_B[0] = -c28_b_omega_b;
  c28_B[4] = 0.0;
  c28_B[8] = 0.0;
  c28_B[12] = 0.0;
  c28_i33 = 0;
  for (c28_i34 = 0; c28_i34 < 4; c28_i34++) {
    c28_B[c28_i33 + 1] = 0.0;
    c28_i33 += 4;
  }

  c28_B[2] = 0.0;
  c28_B[6] = 0.0;
  c28_B[10] = c28_s_y;
  c28_B[14] = 0.0;
  c28_B[3] = 0.0;
  c28_B[7] = 0.0;
  c28_B[11] = 0.0;
  c28_B[15] = c28_w_y;
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 31);
  c28_e_b = c28_H;
  c28_x_y = 2.0 * c28_e_b;
  c28_h_B = c28_x_y;
  c28_y_y = c28_h_B;
  c28_ab_y = c28_y_y;
  c28_bb_y = 1.0 / c28_ab_y;
  c28_c_A = -c28_p;
  c28_i_B = c28_omega;
  c28_c_x = c28_c_A;
  c28_cb_y = c28_i_B;
  c28_d_x = c28_c_x;
  c28_db_y = c28_cb_y;
  c28_eb_y = c28_d_x / c28_db_y;
  c28_c_a = c28_r_s;
  c28_f_b = c28_mpower(chartInstance, c28_p) + c28_mpower(chartInstance, c28_q);
  c28_fb_y = c28_c_a * c28_f_b;
  c28_d_a = c28_omega;
  c28_g_b = c28_mpower(chartInstance, c28_abs_v_ll);
  c28_gb_y = c28_d_a * c28_g_b;
  c28_d_A = c28_fb_y;
  c28_j_B = c28_gb_y;
  c28_e_x = c28_d_A;
  c28_hb_y = c28_j_B;
  c28_f_x = c28_e_x;
  c28_ib_y = c28_hb_y;
  c28_jb_y = c28_f_x / c28_ib_y;
  c28_e_a = c28_bb_y;
  c28_h_b = c28_eb_y - c28_jb_y;
  c28_kb_y = c28_e_a * c28_h_b;
  c28_f_uy[0] = 0.0;
  c28_f_uy[1] = c28_kb_y;
  c28_f_uy[2] = 0.0;
  c28_f_uy[3] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 33);
  c28_k_B = c28_x_s;
  c28_lb_y = c28_k_B;
  c28_mb_y = c28_lb_y;
  c28_nb_y = 1.0 / c28_mb_y;
  c28_l_B = c28_x_s;
  c28_ob_y = c28_l_B;
  c28_pb_y = c28_ob_y;
  c28_qb_y = 1.0 / c28_pb_y;
  c28_f_a = c28_qb_y;
  c28_i_b = c28_r_f;
  c28_rb_y = c28_f_a * c28_i_b;
  c28_g_a = c28_rb_y;
  c28_j_b = c28_i_f0;
  c28_sb_y = c28_g_a * c28_j_b;
  c28_m_B = c28_x_s;
  c28_tb_y = c28_m_B;
  c28_ub_y = c28_tb_y;
  c28_vb_y = 1.0 / c28_ub_y;
  c28_h_a = c28_vb_y;
  c28_k_b = c28_r_f;
  c28_wb_y = c28_h_a * c28_k_b;
  c28_i_a = c28_wb_y;
  c28_l_b = c28_omega0;
  c28_xb_y = c28_i_a * c28_l_b;
  c28_i35 = 0;
  for (c28_i36 = 0; c28_i36 < 4; c28_i36++) {
    c28_C[c28_i35] = c28_dv9[c28_i36];
    c28_i35 += 3;
  }

  c28_C[1] = c28_nb_y;
  c28_C[4] = 0.0;
  c28_C[7] = 0.0;
  c28_C[10] = 0.0;
  c28_C[2] = 0.0;
  c28_C[5] = c28_sb_y;
  c28_C[8] = 0.0;
  c28_C[11] = c28_xb_y;
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 37);
  c28_n_B = c28_x_s;
  c28_yb_y = c28_n_B;
  c28_ac_y = c28_yb_y;
  c28_bc_y = -1.0 / c28_ac_y;
  c28_i37 = 0;
  for (c28_i38 = 0; c28_i38 < 4; c28_i38++) {
    c28_D[c28_i37] = 0.0;
    c28_i37 += 3;
  }

  c28_i39 = 0;
  for (c28_i40 = 0; c28_i40 < 4; c28_i40++) {
    c28_D[c28_i39 + 1] = 0.0;
    c28_i39 += 3;
  }

  c28_D[2] = 0.0;
  c28_D[5] = c28_bc_y;
  c28_D[8] = 0.0;
  c28_D[11] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 41);
  for (c28_i41 = 0; c28_i41 < 12; c28_i41++) {
    c28_j_a[c28_i41] = c28_C[c28_i41];
  }

  for (c28_i42 = 0; c28_i42 < 4; c28_i42++) {
    c28_m_b[c28_i42] = c28_hat_x[c28_i42];
  }

  c28_b_eml_scalar_eg(chartInstance);
  c28_b_eml_scalar_eg(chartInstance);
  for (c28_i43 = 0; c28_i43 < 3; c28_i43++) {
    c28_cc_y[c28_i43] = 0.0;
    c28_i44 = 0;
    for (c28_i45 = 0; c28_i45 < 4; c28_i45++) {
      c28_cc_y[c28_i43] += c28_j_a[c28_i44 + c28_i43] * c28_m_b[c28_i45];
      c28_i44 += 3;
    }
  }

  for (c28_i46 = 0; c28_i46 < 12; c28_i46++) {
    c28_j_a[c28_i46] = c28_D[c28_i46];
  }

  for (c28_i47 = 0; c28_i47 < 4; c28_i47++) {
    c28_m_b[c28_i47] = c28_u_vector[c28_i47];
  }

  c28_b_eml_scalar_eg(chartInstance);
  c28_b_eml_scalar_eg(chartInstance);
  for (c28_i48 = 0; c28_i48 < 3; c28_i48++) {
    c28_dc_y[c28_i48] = 0.0;
    c28_i49 = 0;
    for (c28_i50 = 0; c28_i50 < 4; c28_i50++) {
      c28_dc_y[c28_i48] += c28_j_a[c28_i49 + c28_i48] * c28_m_b[c28_i50];
      c28_i49 += 3;
    }
  }

  for (c28_i51 = 0; c28_i51 < 3; c28_i51++) {
    c28_hat_y[c28_i51] = c28_cc_y[c28_i51] + c28_dc_y[c28_i51];
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 42);
  for (c28_i52 = 0; c28_i52 < 3; c28_i52++) {
    c28_tilde_y[c28_i52] = c28_y[c28_i52] - c28_hat_y[c28_i52];
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 44);
  for (c28_i53 = 0; c28_i53 < 16; c28_i53++) {
    c28_k_a[c28_i53] = c28_A[c28_i53];
  }

  for (c28_i54 = 0; c28_i54 < 4; c28_i54++) {
    c28_m_b[c28_i54] = c28_hat_x[c28_i54];
  }

  c28_c_eml_scalar_eg(chartInstance);
  c28_c_eml_scalar_eg(chartInstance);
  for (c28_i55 = 0; c28_i55 < 4; c28_i55++) {
    c28_ec_y[c28_i55] = 0.0;
    c28_i56 = 0;
    for (c28_i57 = 0; c28_i57 < 4; c28_i57++) {
      c28_ec_y[c28_i55] += c28_k_a[c28_i56 + c28_i55] * c28_m_b[c28_i57];
      c28_i56 += 4;
    }
  }

  for (c28_i58 = 0; c28_i58 < 16; c28_i58++) {
    c28_k_a[c28_i58] = c28_B[c28_i58];
  }

  for (c28_i59 = 0; c28_i59 < 4; c28_i59++) {
    c28_m_b[c28_i59] = c28_u_vector[c28_i59];
  }

  c28_c_eml_scalar_eg(chartInstance);
  c28_c_eml_scalar_eg(chartInstance);
  for (c28_i60 = 0; c28_i60 < 4; c28_i60++) {
    c28_fc_y[c28_i60] = 0.0;
    c28_i61 = 0;
    for (c28_i62 = 0; c28_i62 < 4; c28_i62++) {
      c28_fc_y[c28_i60] += c28_k_a[c28_i61 + c28_i60] * c28_m_b[c28_i62];
      c28_i61 += 4;
    }
  }

  for (c28_i63 = 0; c28_i63 < 12; c28_i63++) {
    c28_l_a[c28_i63] = c28_b_L[c28_i63];
  }

  for (c28_i64 = 0; c28_i64 < 3; c28_i64++) {
    c28_cc_y[c28_i64] = c28_tilde_y[c28_i64];
  }

  c28_d_eml_scalar_eg(chartInstance);
  c28_d_eml_scalar_eg(chartInstance);
  for (c28_i65 = 0; c28_i65 < 4; c28_i65++) {
    c28_m_b[c28_i65] = 0.0;
    c28_i66 = 0;
    for (c28_i67 = 0; c28_i67 < 3; c28_i67++) {
      c28_m_b[c28_i65] += c28_l_a[c28_i66 + c28_i65] * c28_cc_y[c28_i67];
      c28_i66 += 4;
    }
  }

  for (c28_i68 = 0; c28_i68 < 4; c28_i68++) {
    c28_d_hat_x[c28_i68] = ((c28_ec_y[c28_i68] + c28_fc_y[c28_i68]) +
      c28_f_uy[c28_i68]) + c28_m_b[c28_i68];
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 46);
  c28_hat_omega = c28_hat_y[0];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 47);
  c28_hat_p = c28_hat_y[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 48);
  c28_hat_q = c28_hat_y[2];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 50);
  c28_tilde_omega = c28_tilde_y[0];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 51);
  c28_tilde_p = c28_tilde_y[1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 52);
  c28_tilde_q = c28_tilde_y[2];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, -52);
  _SFD_SYMBOL_SCOPE_POP();
  *c28_b_hat_omega = c28_hat_omega;
  *c28_b_hat_p = c28_hat_p;
  *c28_b_hat_q = c28_hat_q;
  *c28_b_tilde_omega = c28_tilde_omega;
  *c28_b_tilde_p = c28_tilde_p;
  *c28_b_tilde_q = c28_tilde_q;
  for (c28_i69 = 0; c28_i69 < 4; c28_i69++) {
    (*c28_b_d_hat_x)[c28_i69] = c28_d_hat_x[c28_i69];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 27U, chartInstance->c28_sfEvent);
}

static void initSimStructsc28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc28_SimulationPlantModel_Luenberg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c28_machineNumber, uint32_T
  c28_chartNumber)
{
}

static const mxArray *c28_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i70;
  real_T c28_b_inData[4];
  int32_T c28_i71;
  real_T c28_u[4];
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  for (c28_i70 = 0; c28_i70 < 4; c28_i70++) {
    c28_b_inData[c28_i70] = (*(real_T (*)[4])c28_inData)[c28_i70];
  }

  for (c28_i71 = 0; c28_i71 < 4; c28_i71++) {
    c28_u[c28_i71] = c28_b_inData[c28_i71];
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_d_hat_x, const char_T *c28_identifier, real_T c28_y[4])
{
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_d_hat_x), &c28_thisId,
    c28_y);
  sf_mex_destroy(&c28_d_hat_x);
}

static void c28_b_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[4])
{
  real_T c28_dv10[4];
  int32_T c28_i72;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv10, 1, 0, 0U, 1, 0U, 1, 4);
  for (c28_i72 = 0; c28_i72 < 4; c28_i72++) {
    c28_y[c28_i72] = c28_dv10[c28_i72];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_d_hat_x;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[4];
  int32_T c28_i73;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_d_hat_x = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_d_hat_x), &c28_thisId,
    c28_y);
  sf_mex_destroy(&c28_d_hat_x);
  for (c28_i73 = 0; c28_i73 < 4; c28_i73++) {
    (*(real_T (*)[4])c28_outData)[c28_i73] = c28_y[c28_i73];
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_b_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  real_T c28_u;
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_u = *(real_T *)c28_inData;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", &c28_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static real_T c28_c_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_tilde_q, const char_T *c28_identifier)
{
  real_T c28_y;
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_tilde_q),
    &c28_thisId);
  sf_mex_destroy(&c28_tilde_q);
  return c28_y;
}

static real_T c28_d_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  real_T c28_y;
  real_T c28_d2;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_d2, 1, 0, 0U, 0, 0U, 0);
  c28_y = c28_d2;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void c28_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_tilde_q;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_tilde_q = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_tilde_q),
    &c28_thisId);
  sf_mex_destroy(&c28_tilde_q);
  *(real_T *)c28_outData = c28_y;
  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_c_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i74;
  real_T c28_b_inData[3];
  int32_T c28_i75;
  real_T c28_u[3];
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  for (c28_i74 = 0; c28_i74 < 3; c28_i74++) {
    c28_b_inData[c28_i74] = (*(real_T (*)[3])c28_inData)[c28_i74];
  }

  for (c28_i75 = 0; c28_i75 < 3; c28_i75++) {
    c28_u[c28_i75] = c28_b_inData[c28_i75];
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_e_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[3])
{
  real_T c28_dv11[3];
  int32_T c28_i76;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv11, 1, 0, 0U, 1, 0U, 1, 3);
  for (c28_i76 = 0; c28_i76 < 3; c28_i76++) {
    c28_y[c28_i76] = c28_dv11[c28_i76];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_b_r_f_G;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[3];
  int32_T c28_i77;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_b_r_f_G = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_b_r_f_G), &c28_thisId,
    c28_y);
  sf_mex_destroy(&c28_b_r_f_G);
  for (c28_i77 = 0; c28_i77 < 3; c28_i77++) {
    (*(real_T (*)[3])c28_outData)[c28_i77] = c28_y[c28_i77];
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_d_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i78;
  int32_T c28_i79;
  int32_T c28_i80;
  real_T c28_b_inData[6];
  int32_T c28_i81;
  int32_T c28_i82;
  int32_T c28_i83;
  real_T c28_u[6];
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_i78 = 0;
  for (c28_i79 = 0; c28_i79 < 2; c28_i79++) {
    for (c28_i80 = 0; c28_i80 < 3; c28_i80++) {
      c28_b_inData[c28_i80 + c28_i78] = (*(real_T (*)[6])c28_inData)[c28_i80 +
        c28_i78];
    }

    c28_i78 += 3;
  }

  c28_i81 = 0;
  for (c28_i82 = 0; c28_i82 < 2; c28_i82++) {
    for (c28_i83 = 0; c28_i83 < 3; c28_i83++) {
      c28_u[c28_i83 + c28_i81] = c28_b_inData[c28_i83 + c28_i81];
    }

    c28_i81 += 3;
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_f_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[6])
{
  real_T c28_dv12[6];
  int32_T c28_i84;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv12, 1, 0, 0U, 1, 0U, 2, 3,
                2);
  for (c28_i84 = 0; c28_i84 < 6; c28_i84++) {
    c28_y[c28_i84] = c28_dv12[c28_i84];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_b_z_G;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[6];
  int32_T c28_i85;
  int32_T c28_i86;
  int32_T c28_i87;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_b_z_G = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_b_z_G), &c28_thisId,
    c28_y);
  sf_mex_destroy(&c28_b_z_G);
  c28_i85 = 0;
  for (c28_i86 = 0; c28_i86 < 2; c28_i86++) {
    for (c28_i87 = 0; c28_i87 < 3; c28_i87++) {
      (*(real_T (*)[6])c28_outData)[c28_i87 + c28_i85] = c28_y[c28_i87 + c28_i85];
    }

    c28_i85 += 3;
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_e_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i88;
  int32_T c28_i89;
  int32_T c28_i90;
  real_T c28_b_inData[12];
  int32_T c28_i91;
  int32_T c28_i92;
  int32_T c28_i93;
  real_T c28_u[12];
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_i88 = 0;
  for (c28_i89 = 0; c28_i89 < 3; c28_i89++) {
    for (c28_i90 = 0; c28_i90 < 4; c28_i90++) {
      c28_b_inData[c28_i90 + c28_i88] = (*(real_T (*)[12])c28_inData)[c28_i90 +
        c28_i88];
    }

    c28_i88 += 4;
  }

  c28_i91 = 0;
  for (c28_i92 = 0; c28_i92 < 3; c28_i92++) {
    for (c28_i93 = 0; c28_i93 < 4; c28_i93++) {
      c28_u[c28_i93 + c28_i91] = c28_b_inData[c28_i93 + c28_i91];
    }

    c28_i91 += 4;
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 2, 4, 3), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_g_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[12])
{
  real_T c28_dv13[12];
  int32_T c28_i94;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv13, 1, 0, 0U, 1, 0U, 2, 4,
                3);
  for (c28_i94 = 0; c28_i94 < 12; c28_i94++) {
    c28_y[c28_i94] = c28_dv13[c28_i94];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_b_L;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[12];
  int32_T c28_i95;
  int32_T c28_i96;
  int32_T c28_i97;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_b_L = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_b_L), &c28_thisId, c28_y);
  sf_mex_destroy(&c28_b_L);
  c28_i95 = 0;
  for (c28_i96 = 0; c28_i96 < 3; c28_i96++) {
    for (c28_i97 = 0; c28_i97 < 4; c28_i97++) {
      (*(real_T (*)[12])c28_outData)[c28_i97 + c28_i95] = c28_y[c28_i97 +
        c28_i95];
    }

    c28_i95 += 4;
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_f_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i98;
  int32_T c28_i99;
  int32_T c28_i100;
  real_T c28_b_inData[12];
  int32_T c28_i101;
  int32_T c28_i102;
  int32_T c28_i103;
  real_T c28_u[12];
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_i98 = 0;
  for (c28_i99 = 0; c28_i99 < 4; c28_i99++) {
    for (c28_i100 = 0; c28_i100 < 3; c28_i100++) {
      c28_b_inData[c28_i100 + c28_i98] = (*(real_T (*)[12])c28_inData)[c28_i100
        + c28_i98];
    }

    c28_i98 += 3;
  }

  c28_i101 = 0;
  for (c28_i102 = 0; c28_i102 < 4; c28_i102++) {
    for (c28_i103 = 0; c28_i103 < 3; c28_i103++) {
      c28_u[c28_i103 + c28_i101] = c28_b_inData[c28_i103 + c28_i101];
    }

    c28_i101 += 3;
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_h_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[12])
{
  real_T c28_dv14[12];
  int32_T c28_i104;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv14, 1, 0, 0U, 1, 0U, 2, 3,
                4);
  for (c28_i104 = 0; c28_i104 < 12; c28_i104++) {
    c28_y[c28_i104] = c28_dv14[c28_i104];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_D;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[12];
  int32_T c28_i105;
  int32_T c28_i106;
  int32_T c28_i107;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_D = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_D), &c28_thisId, c28_y);
  sf_mex_destroy(&c28_D);
  c28_i105 = 0;
  for (c28_i106 = 0; c28_i106 < 4; c28_i106++) {
    for (c28_i107 = 0; c28_i107 < 3; c28_i107++) {
      (*(real_T (*)[12])c28_outData)[c28_i107 + c28_i105] = c28_y[c28_i107 +
        c28_i105];
    }

    c28_i105 += 3;
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_g_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i108;
  int32_T c28_i109;
  int32_T c28_i110;
  real_T c28_b_inData[16];
  int32_T c28_i111;
  int32_T c28_i112;
  int32_T c28_i113;
  real_T c28_u[16];
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_i108 = 0;
  for (c28_i109 = 0; c28_i109 < 4; c28_i109++) {
    for (c28_i110 = 0; c28_i110 < 4; c28_i110++) {
      c28_b_inData[c28_i110 + c28_i108] = (*(real_T (*)[16])c28_inData)[c28_i110
        + c28_i108];
    }

    c28_i108 += 4;
  }

  c28_i111 = 0;
  for (c28_i112 = 0; c28_i112 < 4; c28_i112++) {
    for (c28_i113 = 0; c28_i113 < 4; c28_i113++) {
      c28_u[c28_i113 + c28_i111] = c28_b_inData[c28_i113 + c28_i111];
    }

    c28_i111 += 4;
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 2, 4, 4), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static void c28_i_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId, real_T c28_y[16])
{
  real_T c28_dv15[16];
  int32_T c28_i114;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), c28_dv15, 1, 0, 0U, 1, 0U, 2, 4,
                4);
  for (c28_i114 = 0; c28_i114 < 16; c28_i114++) {
    c28_y[c28_i114] = c28_dv15[c28_i114];
  }

  sf_mex_destroy(&c28_u);
}

static void c28_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_B;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y[16];
  int32_T c28_i115;
  int32_T c28_i116;
  int32_T c28_i117;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_B = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_i_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_B), &c28_thisId, c28_y);
  sf_mex_destroy(&c28_B);
  c28_i115 = 0;
  for (c28_i116 = 0; c28_i116 < 4; c28_i116++) {
    for (c28_i117 = 0; c28_i117 < 4; c28_i117++) {
      (*(real_T (*)[16])c28_outData)[c28_i117 + c28_i115] = c28_y[c28_i117 +
        c28_i115];
    }

    c28_i115 += 4;
  }

  sf_mex_destroy(&c28_mxArrayInData);
}

const mxArray
  *sf_c28_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c28_nameCaptureInfo;
  c28_ResolvedFunctionInfo c28_info[21];
  const mxArray *c28_m0 = NULL;
  int32_T c28_i118;
  c28_ResolvedFunctionInfo *c28_r0;
  c28_nameCaptureInfo = NULL;
  c28_nameCaptureInfo = NULL;
  c28_info_helper(c28_info);
  sf_mex_assign(&c28_m0, sf_mex_createstruct("nameCaptureInfo", 1, 21), FALSE);
  for (c28_i118 = 0; c28_i118 < 21; c28_i118++) {
    c28_r0 = &c28_info[c28_i118];
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c28_r0->context)), "context", "nameCaptureInfo",
                    c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c28_r0->name)), "name", "nameCaptureInfo",
                    c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      c28_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c28_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c28_r0->resolved)), "resolved",
                    "nameCaptureInfo", c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", &c28_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", &c28_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      &c28_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c28_i118);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      &c28_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c28_i118);
  }

  sf_mex_assign(&c28_nameCaptureInfo, c28_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c28_nameCaptureInfo);
  return c28_nameCaptureInfo;
}

static void c28_info_helper(c28_ResolvedFunctionInfo c28_info[21])
{
  c28_info[0].context = "";
  c28_info[0].name = "mtimes";
  c28_info[0].dominantType = "double";
  c28_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c28_info[0].fileTimeLo = 1289519692U;
  c28_info[0].fileTimeHi = 0U;
  c28_info[0].mFileTimeLo = 0U;
  c28_info[0].mFileTimeHi = 0U;
  c28_info[1].context = "";
  c28_info[1].name = "mrdivide";
  c28_info[1].dominantType = "double";
  c28_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c28_info[1].fileTimeLo = 1357951548U;
  c28_info[1].fileTimeHi = 0U;
  c28_info[1].mFileTimeLo = 1319729966U;
  c28_info[1].mFileTimeHi = 0U;
  c28_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c28_info[2].name = "rdivide";
  c28_info[2].dominantType = "double";
  c28_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c28_info[2].fileTimeLo = 1346510388U;
  c28_info[2].fileTimeHi = 0U;
  c28_info[2].mFileTimeLo = 0U;
  c28_info[2].mFileTimeHi = 0U;
  c28_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c28_info[3].name = "eml_scalexp_compatible";
  c28_info[3].dominantType = "double";
  c28_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c28_info[3].fileTimeLo = 1286818796U;
  c28_info[3].fileTimeHi = 0U;
  c28_info[3].mFileTimeLo = 0U;
  c28_info[3].mFileTimeHi = 0U;
  c28_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c28_info[4].name = "eml_div";
  c28_info[4].dominantType = "double";
  c28_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c28_info[4].fileTimeLo = 1313347810U;
  c28_info[4].fileTimeHi = 0U;
  c28_info[4].mFileTimeLo = 0U;
  c28_info[4].mFileTimeHi = 0U;
  c28_info[5].context = "";
  c28_info[5].name = "mpower";
  c28_info[5].dominantType = "double";
  c28_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c28_info[5].fileTimeLo = 1286818842U;
  c28_info[5].fileTimeHi = 0U;
  c28_info[5].mFileTimeLo = 0U;
  c28_info[5].mFileTimeHi = 0U;
  c28_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c28_info[6].name = "power";
  c28_info[6].dominantType = "double";
  c28_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c28_info[6].fileTimeLo = 1348191930U;
  c28_info[6].fileTimeHi = 0U;
  c28_info[6].mFileTimeLo = 0U;
  c28_info[6].mFileTimeHi = 0U;
  c28_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c28_info[7].name = "eml_scalar_eg";
  c28_info[7].dominantType = "double";
  c28_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c28_info[7].fileTimeLo = 1286818796U;
  c28_info[7].fileTimeHi = 0U;
  c28_info[7].mFileTimeLo = 0U;
  c28_info[7].mFileTimeHi = 0U;
  c28_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c28_info[8].name = "eml_scalexp_alloc";
  c28_info[8].dominantType = "double";
  c28_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c28_info[8].fileTimeLo = 1352424860U;
  c28_info[8].fileTimeHi = 0U;
  c28_info[8].mFileTimeLo = 0U;
  c28_info[8].mFileTimeHi = 0U;
  c28_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c28_info[9].name = "floor";
  c28_info[9].dominantType = "double";
  c28_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c28_info[9].fileTimeLo = 1343830380U;
  c28_info[9].fileTimeHi = 0U;
  c28_info[9].mFileTimeLo = 0U;
  c28_info[9].mFileTimeHi = 0U;
  c28_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c28_info[10].name = "eml_scalar_floor";
  c28_info[10].dominantType = "double";
  c28_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c28_info[10].fileTimeLo = 1286818726U;
  c28_info[10].fileTimeHi = 0U;
  c28_info[10].mFileTimeLo = 0U;
  c28_info[10].mFileTimeHi = 0U;
  c28_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c28_info[11].name = "eml_scalar_eg";
  c28_info[11].dominantType = "double";
  c28_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c28_info[11].fileTimeLo = 1286818796U;
  c28_info[11].fileTimeHi = 0U;
  c28_info[11].mFileTimeLo = 0U;
  c28_info[11].mFileTimeHi = 0U;
  c28_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c28_info[12].name = "mtimes";
  c28_info[12].dominantType = "double";
  c28_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c28_info[12].fileTimeLo = 1289519692U;
  c28_info[12].fileTimeHi = 0U;
  c28_info[12].mFileTimeLo = 0U;
  c28_info[12].mFileTimeHi = 0U;
  c28_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c28_info[13].name = "eml_index_class";
  c28_info[13].dominantType = "";
  c28_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c28_info[13].fileTimeLo = 1323170578U;
  c28_info[13].fileTimeHi = 0U;
  c28_info[13].mFileTimeLo = 0U;
  c28_info[13].mFileTimeHi = 0U;
  c28_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c28_info[14].name = "eml_scalar_eg";
  c28_info[14].dominantType = "double";
  c28_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c28_info[14].fileTimeLo = 1286818796U;
  c28_info[14].fileTimeHi = 0U;
  c28_info[14].mFileTimeLo = 0U;
  c28_info[14].mFileTimeHi = 0U;
  c28_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c28_info[15].name = "eml_xgemm";
  c28_info[15].dominantType = "char";
  c28_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c28_info[15].fileTimeLo = 1299076772U;
  c28_info[15].fileTimeHi = 0U;
  c28_info[15].mFileTimeLo = 0U;
  c28_info[15].mFileTimeHi = 0U;
  c28_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c28_info[16].name = "eml_blas_inline";
  c28_info[16].dominantType = "";
  c28_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c28_info[16].fileTimeLo = 1299076768U;
  c28_info[16].fileTimeHi = 0U;
  c28_info[16].mFileTimeLo = 0U;
  c28_info[16].mFileTimeHi = 0U;
  c28_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c28_info[17].name = "mtimes";
  c28_info[17].dominantType = "double";
  c28_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c28_info[17].fileTimeLo = 1289519692U;
  c28_info[17].fileTimeHi = 0U;
  c28_info[17].mFileTimeLo = 0U;
  c28_info[17].mFileTimeHi = 0U;
  c28_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c28_info[18].name = "eml_index_class";
  c28_info[18].dominantType = "";
  c28_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c28_info[18].fileTimeLo = 1323170578U;
  c28_info[18].fileTimeHi = 0U;
  c28_info[18].mFileTimeLo = 0U;
  c28_info[18].mFileTimeHi = 0U;
  c28_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c28_info[19].name = "eml_scalar_eg";
  c28_info[19].dominantType = "double";
  c28_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c28_info[19].fileTimeLo = 1286818796U;
  c28_info[19].fileTimeHi = 0U;
  c28_info[19].mFileTimeLo = 0U;
  c28_info[19].mFileTimeHi = 0U;
  c28_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c28_info[20].name = "eml_refblas_xgemm";
  c28_info[20].dominantType = "char";
  c28_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c28_info[20].fileTimeLo = 1299076774U;
  c28_info[20].fileTimeHi = 0U;
  c28_info[20].mFileTimeLo = 0U;
  c28_info[20].mFileTimeHi = 0U;
}

static real_T c28_mpower(SFc28_SimulationPlantModel_LuenbergInstanceStruct
  *chartInstance, real_T c28_a)
{
  real_T c28_b_a;
  real_T c28_c_a;
  real_T c28_ak;
  real_T c28_d_a;
  real_T c28_e_a;
  real_T c28_b;
  c28_b_a = c28_a;
  c28_c_a = c28_b_a;
  c28_eml_scalar_eg(chartInstance);
  c28_ak = c28_c_a;
  c28_d_a = c28_ak;
  c28_eml_scalar_eg(chartInstance);
  c28_e_a = c28_d_a;
  c28_b = c28_d_a;
  return c28_e_a * c28_b;
}

static void c28_eml_scalar_eg(SFc28_SimulationPlantModel_LuenbergInstanceStruct *
  chartInstance)
{
}

static void c28_b_eml_scalar_eg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void c28_c_eml_scalar_eg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void c28_d_eml_scalar_eg
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *c28_h_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_u;
  const mxArray *c28_y = NULL;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_u = *(int32_T *)c28_inData;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", &c28_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c28_mxArrayOutData, c28_y, FALSE);
  return c28_mxArrayOutData;
}

static int32_T c28_j_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  int32_T c28_y;
  int32_T c28_i119;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_i119, 1, 6, 0U, 0, 0U, 0);
  c28_y = c28_i119;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void c28_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_b_sfEvent;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  int32_T c28_y;
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c28_b_sfEvent = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_b_sfEvent),
    &c28_thisId);
  sf_mex_destroy(&c28_b_sfEvent);
  *(int32_T *)c28_outData = c28_y;
  sf_mex_destroy(&c28_mxArrayInData);
}

static uint8_T c28_k_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_b_is_active_c28_SimulationPlantModel_Luenberg, const char_T
   *c28_identifier)
{
  uint8_T c28_y;
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_l_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c28_b_is_active_c28_SimulationPlantModel_Luenberg), &c28_thisId);
  sf_mex_destroy(&c28_b_is_active_c28_SimulationPlantModel_Luenberg);
  return c28_y;
}

static uint8_T c28_l_emlrt_marshallIn
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  uint8_T c28_y;
  uint8_T c28_u0;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_u0, 1, 3, 0U, 0, 0U, 0);
  c28_y = c28_u0;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void init_dsm_address_info
  (SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c28_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2506658281U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(72155855U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(604242292U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(436774425U);
}

mxArray *sf_c28_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("j0Xipc5nttM4r5hwHj2ZiC");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,10,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(3);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(2);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c28_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c28_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[21],T\"d_hat_x\",},{M[1],M[51],T\"hat_omega\",},{M[1],M[52],T\"hat_p\",},{M[1],M[53],T\"hat_q\",},{M[1],M[47],T\"tilde_omega\",},{M[1],M[49],T\"tilde_p\",},{M[1],M[50],T\"tilde_q\",},{M[8],M[0],T\"is_active_c28_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c28_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           28,
           1,
           1,
           20,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"hat_omega");
          _SFD_SET_DATA_PROPS(1,2,0,1,"hat_p");
          _SFD_SET_DATA_PROPS(2,2,0,1,"hat_q");
          _SFD_SET_DATA_PROPS(3,2,0,1,"tilde_omega");
          _SFD_SET_DATA_PROPS(4,2,0,1,"tilde_p");
          _SFD_SET_DATA_PROPS(5,2,0,1,"tilde_q");
          _SFD_SET_DATA_PROPS(6,1,1,0,"y");
          _SFD_SET_DATA_PROPS(7,1,1,0,"u_vector");
          _SFD_SET_DATA_PROPS(8,1,1,0,"hat_x");
          _SFD_SET_DATA_PROPS(9,10,0,0,"L");
          _SFD_SET_DATA_PROPS(10,2,0,1,"d_hat_x");
          _SFD_SET_DATA_PROPS(11,10,0,0,"x_0");
          _SFD_SET_DATA_PROPS(12,10,0,0,"H_G");
          _SFD_SET_DATA_PROPS(13,10,0,0,"D_fw_G");
          _SFD_SET_DATA_PROPS(14,10,0,0,"z_G");
          _SFD_SET_DATA_PROPS(15,10,0,0,"tau_e_G");
          _SFD_SET_DATA_PROPS(16,10,0,0,"tau_f_G");
          _SFD_SET_DATA_PROPS(17,10,0,0,"r_f_G");
          _SFD_SET_DATA_PROPS(18,10,0,0,"GeneratorNumber");
          _SFD_SET_DATA_PROPS(19,10,0,0,"omega_b");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1136);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 4;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_e_sf_marshallOut,(MexInFcnForType)
            c28_e_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)
            c28_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)
            c28_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_c_sf_marshallOut,(MexInFcnForType)
            c28_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_c_sf_marshallOut,(MexInFcnForType)
            c28_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_d_sf_marshallOut,(MexInFcnForType)
            c28_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_c_sf_marshallOut,(MexInFcnForType)
            c28_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_c_sf_marshallOut,(MexInFcnForType)
            c28_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_c_sf_marshallOut,(MexInFcnForType)
            c28_c_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(18,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(19,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)
          c28_b_sf_marshallIn);

        {
          real_T *c28_hat_omega;
          real_T *c28_hat_p;
          real_T *c28_hat_q;
          real_T *c28_tilde_omega;
          real_T *c28_tilde_p;
          real_T *c28_tilde_q;
          real_T (*c28_y)[3];
          real_T (*c28_u_vector)[4];
          real_T (*c28_hat_x)[4];
          real_T (*c28_d_hat_x)[4];
          c28_d_hat_x = (real_T (*)[4])ssGetOutputPortSignal(chartInstance->S, 7);
          c28_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 2);
          c28_u_vector = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 1);
          c28_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          c28_tilde_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c28_tilde_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c28_tilde_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c28_hat_q = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c28_hat_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c28_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c28_hat_omega);
          _SFD_SET_DATA_VALUE_PTR(1U, c28_hat_p);
          _SFD_SET_DATA_VALUE_PTR(2U, c28_hat_q);
          _SFD_SET_DATA_VALUE_PTR(3U, c28_tilde_omega);
          _SFD_SET_DATA_VALUE_PTR(4U, c28_tilde_p);
          _SFD_SET_DATA_VALUE_PTR(5U, c28_tilde_q);
          _SFD_SET_DATA_VALUE_PTR(6U, *c28_y);
          _SFD_SET_DATA_VALUE_PTR(7U, *c28_u_vector);
          _SFD_SET_DATA_VALUE_PTR(8U, *c28_hat_x);
          _SFD_SET_DATA_VALUE_PTR(9U, chartInstance->c28_L);
          _SFD_SET_DATA_VALUE_PTR(10U, *c28_d_hat_x);
          _SFD_SET_DATA_VALUE_PTR(11U, chartInstance->c28_x_0);
          _SFD_SET_DATA_VALUE_PTR(12U, chartInstance->c28_H_G);
          _SFD_SET_DATA_VALUE_PTR(13U, chartInstance->c28_D_fw_G);
          _SFD_SET_DATA_VALUE_PTR(14U, chartInstance->c28_z_G);
          _SFD_SET_DATA_VALUE_PTR(15U, chartInstance->c28_tau_e_G);
          _SFD_SET_DATA_VALUE_PTR(16U, chartInstance->c28_tau_f_G);
          _SFD_SET_DATA_VALUE_PTR(17U, chartInstance->c28_r_f_G);
          _SFD_SET_DATA_VALUE_PTR(18U, &chartInstance->c28_GeneratorNumber);
          _SFD_SET_DATA_VALUE_PTR(19U, &chartInstance->c28_omega_b);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "qW65me94dHMMvBpqvhla6";
}

static void sf_opaque_initialize_c28_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc28_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c28_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c28_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c28_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c28_SimulationPlantModel_Luenberg(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c28_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c28_SimulationPlantModel_Luenberg
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c28_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c28_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c28_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c28_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c28_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c28_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c28_SimulationPlantModel_Luenberg
      ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc28_SimulationPlantModel_Luenberg
    ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c28_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c28_SimulationPlantModel_Luenberg
      ((SFc28_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c28_SimulationPlantModel_Luenberg(SimStruct *S)
{
  /* Actual parameters from chart:
     D_fw_G GeneratorNumber H_G L omega_b r_f_G tau_e_G tau_f_G x_0 z_G
   */
  const char_T *rtParamNames[] = { "D_fw_G", "GeneratorNumber", "H_G", "L",
    "omega_b", "r_f_G", "tau_e_G", "tau_f_G", "x_0", "z_G" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for D_fw_G*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for GeneratorNumber*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);

  /* registration for H_G*/
  ssRegDlgParamAsRunTimeParam(S, 2, 2, rtParamNames[2], SS_DOUBLE);

  /* registration for L*/
  ssRegDlgParamAsRunTimeParam(S, 3, 3, rtParamNames[3], SS_DOUBLE);

  /* registration for omega_b*/
  ssRegDlgParamAsRunTimeParam(S, 4, 4, rtParamNames[4], SS_DOUBLE);

  /* registration for r_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 5, 5, rtParamNames[5], SS_DOUBLE);

  /* registration for tau_e_G*/
  ssRegDlgParamAsRunTimeParam(S, 6, 6, rtParamNames[6], SS_DOUBLE);

  /* registration for tau_f_G*/
  ssRegDlgParamAsRunTimeParam(S, 7, 7, rtParamNames[7], SS_DOUBLE);

  /* registration for x_0*/
  ssRegDlgParamAsRunTimeParam(S, 8, 8, rtParamNames[8], SS_DOUBLE);

  /* registration for z_G*/
  ssRegDlgParamAsRunTimeParam(S, 9, 9, rtParamNames[9], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      28);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,28,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,28,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,28);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,28,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,28,7);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=7; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,28);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1945247930U));
  ssSetChecksum1(S,(3503578567U));
  ssSetChecksum2(S,(1995140500U));
  ssSetChecksum3(S,(474380219U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c28_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c28_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc28_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc28_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc28_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc28_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c28_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c28_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c28_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c28_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c28_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c28_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
