#ifndef __c39_SimulationPlantModel_Luenberg_h__
#define __c39_SimulationPlantModel_Luenberg_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c39_ResolvedFunctionInfo
#define typedef_c39_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c39_ResolvedFunctionInfo;

#endif                                 /*typedef_c39_ResolvedFunctionInfo*/

#ifndef typedef_SFc39_SimulationPlantModel_LuenbergInstanceStruct
#define typedef_SFc39_SimulationPlantModel_LuenbergInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c39_sfEvent;
  boolean_T c39_isStable;
  boolean_T c39_doneDoubleBufferReInit;
  uint8_T c39_is_active_c39_SimulationPlantModel_Luenberg;
  real_T c39_x_0[4];
  real_T c39_L[12];
  real_T c39_H_G[3];
  real_T c39_D_fw_G[3];
  real_T c39_z_G[6];
  real_T c39_tau_e_G[3];
  real_T c39_tau_f_G[3];
  real_T c39_r_f_G[3];
  real_T c39_GeneratorNumber;
  real_T c39_omega_b;
} SFc39_SimulationPlantModel_LuenbergInstanceStruct;

#endif                                 /*typedef_SFc39_SimulationPlantModel_LuenbergInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c39_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c39_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[]);
extern void c39_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
