/* Include files */

#include <stddef.h>
#include "blas.h"
#include "SimulationPlantModel_Luenberg_sfun.h"
#include "c40_SimulationPlantModel_Luenberg.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "SimulationPlantModel_Luenberg_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c40_debug_family_names[7] = { "nargin", "nargout", "d_hat_x",
  "hat_delta", "hat_omega", "hat_t_m", "hat_i_f" };

/* Function Declarations */
static void initialize_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initialize_params_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void enable_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void disable_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void c40_update_debugger_state_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void set_sim_state_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_st);
static void finalize_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void sf_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void initSimStructsc40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void registerMessagesc40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c40_machineNumber, uint32_T
  c40_chartNumber);
static const mxArray *c40_sf_marshallOut(void *chartInstanceVoid, void
  *c40_inData);
static real_T c40_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_hat_i_f, const char_T *c40_identifier);
static real_T c40_b_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_u, const emlrtMsgIdentifier *c40_parentId);
static void c40_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c40_mxArrayInData, const char_T *c40_varName, void *c40_outData);
static const mxArray *c40_b_sf_marshallOut(void *chartInstanceVoid, void
  *c40_inData);
static const mxArray *c40_c_sf_marshallOut(void *chartInstanceVoid, void
  *c40_inData);
static int32_T c40_c_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_u, const emlrtMsgIdentifier *c40_parentId);
static void c40_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c40_mxArrayInData, const char_T *c40_varName, void *c40_outData);
static uint8_T c40_d_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_b_is_active_c40_SimulationPlantModel_Luenberg, const char_T
   *c40_identifier);
static uint8_T c40_e_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_u, const emlrtMsgIdentifier *c40_parentId);
static void init_dsm_address_info
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  chartInstance->c40_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c40_is_active_c40_SimulationPlantModel_Luenberg = 0U;
}

static void initialize_params_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void enable_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c40_update_debugger_state_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  const mxArray *c40_st;
  const mxArray *c40_y = NULL;
  real_T c40_hoistedGlobal;
  real_T c40_u;
  const mxArray *c40_b_y = NULL;
  real_T c40_b_hoistedGlobal;
  real_T c40_b_u;
  const mxArray *c40_c_y = NULL;
  real_T c40_c_hoistedGlobal;
  real_T c40_c_u;
  const mxArray *c40_d_y = NULL;
  real_T c40_d_hoistedGlobal;
  real_T c40_d_u;
  const mxArray *c40_e_y = NULL;
  uint8_T c40_e_hoistedGlobal;
  uint8_T c40_e_u;
  const mxArray *c40_f_y = NULL;
  real_T *c40_hat_delta;
  real_T *c40_hat_i_f;
  real_T *c40_hat_omega;
  real_T *c40_hat_t_m;
  c40_hat_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c40_hat_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c40_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c40_hat_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c40_st = NULL;
  c40_st = NULL;
  c40_y = NULL;
  sf_mex_assign(&c40_y, sf_mex_createcellarray(5), FALSE);
  c40_hoistedGlobal = *c40_hat_delta;
  c40_u = c40_hoistedGlobal;
  c40_b_y = NULL;
  sf_mex_assign(&c40_b_y, sf_mex_create("y", &c40_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c40_y, 0, c40_b_y);
  c40_b_hoistedGlobal = *c40_hat_i_f;
  c40_b_u = c40_b_hoistedGlobal;
  c40_c_y = NULL;
  sf_mex_assign(&c40_c_y, sf_mex_create("y", &c40_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c40_y, 1, c40_c_y);
  c40_c_hoistedGlobal = *c40_hat_omega;
  c40_c_u = c40_c_hoistedGlobal;
  c40_d_y = NULL;
  sf_mex_assign(&c40_d_y, sf_mex_create("y", &c40_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c40_y, 2, c40_d_y);
  c40_d_hoistedGlobal = *c40_hat_t_m;
  c40_d_u = c40_d_hoistedGlobal;
  c40_e_y = NULL;
  sf_mex_assign(&c40_e_y, sf_mex_create("y", &c40_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c40_y, 3, c40_e_y);
  c40_e_hoistedGlobal =
    chartInstance->c40_is_active_c40_SimulationPlantModel_Luenberg;
  c40_e_u = c40_e_hoistedGlobal;
  c40_f_y = NULL;
  sf_mex_assign(&c40_f_y, sf_mex_create("y", &c40_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c40_y, 4, c40_f_y);
  sf_mex_assign(&c40_st, c40_y, FALSE);
  return c40_st;
}

static void set_sim_state_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_st)
{
  const mxArray *c40_u;
  real_T *c40_hat_delta;
  real_T *c40_hat_i_f;
  real_T *c40_hat_omega;
  real_T *c40_hat_t_m;
  c40_hat_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c40_hat_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c40_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c40_hat_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c40_doneDoubleBufferReInit = TRUE;
  c40_u = sf_mex_dup(c40_st);
  *c40_hat_delta = c40_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c40_u, 0)), "hat_delta");
  *c40_hat_i_f = c40_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c40_u, 1)), "hat_i_f");
  *c40_hat_omega = c40_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c40_u, 2)), "hat_omega");
  *c40_hat_t_m = c40_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c40_u, 3)), "hat_t_m");
  chartInstance->c40_is_active_c40_SimulationPlantModel_Luenberg =
    c40_d_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c40_u, 4)),
    "is_active_c40_SimulationPlantModel_Luenberg");
  sf_mex_destroy(&c40_u);
  c40_update_debugger_state_c40_SimulationPlantModel_Luenberg(chartInstance);
  sf_mex_destroy(&c40_st);
}

static void finalize_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void sf_c40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
  int32_T c40_i0;
  int32_T c40_i1;
  real_T c40_d_hat_x[4];
  uint32_T c40_debug_family_var_map[7];
  real_T c40_nargin = 1.0;
  real_T c40_nargout = 4.0;
  real_T c40_hat_delta;
  real_T c40_hat_omega;
  real_T c40_hat_t_m;
  real_T c40_hat_i_f;
  real_T *c40_b_hat_delta;
  real_T *c40_b_hat_omega;
  real_T *c40_b_hat_t_m;
  real_T *c40_b_hat_i_f;
  real_T (*c40_b_d_hat_x)[4];
  c40_b_hat_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c40_b_hat_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c40_b_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c40_b_hat_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c40_b_d_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 39U, chartInstance->c40_sfEvent);
  for (c40_i0 = 0; c40_i0 < 4; c40_i0++) {
    _SFD_DATA_RANGE_CHECK((*c40_b_d_hat_x)[c40_i0], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c40_b_hat_delta, 1U);
  _SFD_DATA_RANGE_CHECK(*c40_b_hat_omega, 2U);
  _SFD_DATA_RANGE_CHECK(*c40_b_hat_t_m, 3U);
  _SFD_DATA_RANGE_CHECK(*c40_b_hat_i_f, 4U);
  chartInstance->c40_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 39U, chartInstance->c40_sfEvent);
  for (c40_i1 = 0; c40_i1 < 4; c40_i1++) {
    c40_d_hat_x[c40_i1] = (*c40_b_d_hat_x)[c40_i1];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 7U, 7U, c40_debug_family_names,
    c40_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c40_nargin, 0U, c40_sf_marshallOut,
    c40_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c40_nargout, 1U, c40_sf_marshallOut,
    c40_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c40_d_hat_x, 2U, c40_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c40_hat_delta, 3U, c40_sf_marshallOut,
    c40_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c40_hat_omega, 4U, c40_sf_marshallOut,
    c40_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c40_hat_t_m, 5U, c40_sf_marshallOut,
    c40_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c40_hat_i_f, 6U, c40_sf_marshallOut,
    c40_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c40_sfEvent, 3);
  c40_hat_delta = c40_d_hat_x[0];
  _SFD_EML_CALL(0U, chartInstance->c40_sfEvent, 4);
  c40_hat_omega = c40_d_hat_x[1];
  _SFD_EML_CALL(0U, chartInstance->c40_sfEvent, 5);
  c40_hat_t_m = c40_d_hat_x[2];
  _SFD_EML_CALL(0U, chartInstance->c40_sfEvent, 6);
  c40_hat_i_f = c40_d_hat_x[3];
  _SFD_EML_CALL(0U, chartInstance->c40_sfEvent, -6);
  _SFD_SYMBOL_SCOPE_POP();
  *c40_b_hat_delta = c40_hat_delta;
  *c40_b_hat_omega = c40_hat_omega;
  *c40_b_hat_t_m = c40_hat_t_m;
  *c40_b_hat_i_f = c40_hat_i_f;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 39U, chartInstance->c40_sfEvent);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_SimulationPlantModel_LuenbergMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void initSimStructsc40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void registerMessagesc40_SimulationPlantModel_Luenberg
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c40_machineNumber, uint32_T
  c40_chartNumber)
{
}

static const mxArray *c40_sf_marshallOut(void *chartInstanceVoid, void
  *c40_inData)
{
  const mxArray *c40_mxArrayOutData = NULL;
  real_T c40_u;
  const mxArray *c40_y = NULL;
  SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c40_mxArrayOutData = NULL;
  c40_u = *(real_T *)c40_inData;
  c40_y = NULL;
  sf_mex_assign(&c40_y, sf_mex_create("y", &c40_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c40_mxArrayOutData, c40_y, FALSE);
  return c40_mxArrayOutData;
}

static real_T c40_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_hat_i_f, const char_T *c40_identifier)
{
  real_T c40_y;
  emlrtMsgIdentifier c40_thisId;
  c40_thisId.fIdentifier = c40_identifier;
  c40_thisId.fParent = NULL;
  c40_y = c40_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c40_hat_i_f),
    &c40_thisId);
  sf_mex_destroy(&c40_hat_i_f);
  return c40_y;
}

static real_T c40_b_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_u, const emlrtMsgIdentifier *c40_parentId)
{
  real_T c40_y;
  real_T c40_d0;
  sf_mex_import(c40_parentId, sf_mex_dup(c40_u), &c40_d0, 1, 0, 0U, 0, 0U, 0);
  c40_y = c40_d0;
  sf_mex_destroy(&c40_u);
  return c40_y;
}

static void c40_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c40_mxArrayInData, const char_T *c40_varName, void *c40_outData)
{
  const mxArray *c40_hat_i_f;
  const char_T *c40_identifier;
  emlrtMsgIdentifier c40_thisId;
  real_T c40_y;
  SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c40_hat_i_f = sf_mex_dup(c40_mxArrayInData);
  c40_identifier = c40_varName;
  c40_thisId.fIdentifier = c40_identifier;
  c40_thisId.fParent = NULL;
  c40_y = c40_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c40_hat_i_f),
    &c40_thisId);
  sf_mex_destroy(&c40_hat_i_f);
  *(real_T *)c40_outData = c40_y;
  sf_mex_destroy(&c40_mxArrayInData);
}

static const mxArray *c40_b_sf_marshallOut(void *chartInstanceVoid, void
  *c40_inData)
{
  const mxArray *c40_mxArrayOutData = NULL;
  int32_T c40_i2;
  real_T c40_b_inData[4];
  int32_T c40_i3;
  real_T c40_u[4];
  const mxArray *c40_y = NULL;
  SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c40_mxArrayOutData = NULL;
  for (c40_i2 = 0; c40_i2 < 4; c40_i2++) {
    c40_b_inData[c40_i2] = (*(real_T (*)[4])c40_inData)[c40_i2];
  }

  for (c40_i3 = 0; c40_i3 < 4; c40_i3++) {
    c40_u[c40_i3] = c40_b_inData[c40_i3];
  }

  c40_y = NULL;
  sf_mex_assign(&c40_y, sf_mex_create("y", c40_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c40_mxArrayOutData, c40_y, FALSE);
  return c40_mxArrayOutData;
}

const mxArray
  *sf_c40_SimulationPlantModel_Luenberg_get_eml_resolved_functions_info(void)
{
  const mxArray *c40_nameCaptureInfo = NULL;
  c40_nameCaptureInfo = NULL;
  sf_mex_assign(&c40_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1), FALSE);
  return c40_nameCaptureInfo;
}

static const mxArray *c40_c_sf_marshallOut(void *chartInstanceVoid, void
  *c40_inData)
{
  const mxArray *c40_mxArrayOutData = NULL;
  int32_T c40_u;
  const mxArray *c40_y = NULL;
  SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c40_mxArrayOutData = NULL;
  c40_u = *(int32_T *)c40_inData;
  c40_y = NULL;
  sf_mex_assign(&c40_y, sf_mex_create("y", &c40_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c40_mxArrayOutData, c40_y, FALSE);
  return c40_mxArrayOutData;
}

static int32_T c40_c_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_u, const emlrtMsgIdentifier *c40_parentId)
{
  int32_T c40_y;
  int32_T c40_i4;
  sf_mex_import(c40_parentId, sf_mex_dup(c40_u), &c40_i4, 1, 6, 0U, 0, 0U, 0);
  c40_y = c40_i4;
  sf_mex_destroy(&c40_u);
  return c40_y;
}

static void c40_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c40_mxArrayInData, const char_T *c40_varName, void *c40_outData)
{
  const mxArray *c40_b_sfEvent;
  const char_T *c40_identifier;
  emlrtMsgIdentifier c40_thisId;
  int32_T c40_y;
  SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)
    chartInstanceVoid;
  c40_b_sfEvent = sf_mex_dup(c40_mxArrayInData);
  c40_identifier = c40_varName;
  c40_thisId.fIdentifier = c40_identifier;
  c40_thisId.fParent = NULL;
  c40_y = c40_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c40_b_sfEvent),
    &c40_thisId);
  sf_mex_destroy(&c40_b_sfEvent);
  *(int32_T *)c40_outData = c40_y;
  sf_mex_destroy(&c40_mxArrayInData);
}

static uint8_T c40_d_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_b_is_active_c40_SimulationPlantModel_Luenberg, const char_T
   *c40_identifier)
{
  uint8_T c40_y;
  emlrtMsgIdentifier c40_thisId;
  c40_thisId.fIdentifier = c40_identifier;
  c40_thisId.fParent = NULL;
  c40_y = c40_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c40_b_is_active_c40_SimulationPlantModel_Luenberg), &c40_thisId);
  sf_mex_destroy(&c40_b_is_active_c40_SimulationPlantModel_Luenberg);
  return c40_y;
}

static uint8_T c40_e_emlrt_marshallIn
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance, const
   mxArray *c40_u, const emlrtMsgIdentifier *c40_parentId)
{
  uint8_T c40_y;
  uint8_T c40_u0;
  sf_mex_import(c40_parentId, sf_mex_dup(c40_u), &c40_u0, 1, 3, 0U, 0, 0U, 0);
  c40_y = c40_u0;
  sf_mex_destroy(&c40_u);
  return c40_y;
}

static void init_dsm_address_info
  (SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c40_SimulationPlantModel_Luenberg_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(238531569U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2924707964U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2053155847U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3917976270U);
}

mxArray *sf_c40_SimulationPlantModel_Luenberg_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("1PR9WiUpGvbN1dLKvpHfdD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c40_SimulationPlantModel_Luenberg_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c40_SimulationPlantModel_Luenberg
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[4],T\"hat_delta\",},{M[1],M[12],T\"hat_i_f\",},{M[1],M[10],T\"hat_omega\",},{M[1],M[11],T\"hat_t_m\",},{M[8],M[0],T\"is_active_c40_SimulationPlantModel_Luenberg\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c40_SimulationPlantModel_Luenberg_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
    chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _SimulationPlantModel_LuenbergMachineNumber_,
           40,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _SimulationPlantModel_LuenbergMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _SimulationPlantModel_LuenbergMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"d_hat_x");
          _SFD_SET_DATA_PROPS(1,2,0,1,"hat_delta");
          _SFD_SET_DATA_PROPS(2,2,0,1,"hat_omega");
          _SFD_SET_DATA_PROPS(3,2,0,1,"hat_t_m");
          _SFD_SET_DATA_PROPS(4,2,0,1,"hat_i_f");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,159);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c40_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c40_sf_marshallOut,(MexInFcnForType)c40_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c40_sf_marshallOut,(MexInFcnForType)c40_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c40_sf_marshallOut,(MexInFcnForType)c40_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c40_sf_marshallOut,(MexInFcnForType)c40_sf_marshallIn);

        {
          real_T *c40_hat_delta;
          real_T *c40_hat_omega;
          real_T *c40_hat_t_m;
          real_T *c40_hat_i_f;
          real_T (*c40_d_hat_x)[4];
          c40_hat_i_f = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c40_hat_t_m = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c40_hat_omega = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c40_hat_delta = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c40_d_hat_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c40_d_hat_x);
          _SFD_SET_DATA_VALUE_PTR(1U, c40_hat_delta);
          _SFD_SET_DATA_VALUE_PTR(2U, c40_hat_omega);
          _SFD_SET_DATA_VALUE_PTR(3U, c40_hat_t_m);
          _SFD_SET_DATA_VALUE_PTR(4U, c40_hat_i_f);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _SimulationPlantModel_LuenbergMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "Dq9zP2ysvvVSk17bU9W2tH";
}

static void sf_opaque_initialize_c40_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc40_SimulationPlantModel_LuenbergInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
  initialize_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c40_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  enable_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c40_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  disable_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c40_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  sf_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c40_SimulationPlantModel_Luenberg(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c40_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c40_SimulationPlantModel_Luenberg
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c40_SimulationPlantModel_Luenberg();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c40_SimulationPlantModel_Luenberg
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c40_SimulationPlantModel_Luenberg(S);
}

static void sf_opaque_set_sim_state_c40_SimulationPlantModel_Luenberg(SimStruct*
  S, const mxArray *st)
{
  sf_internal_set_sim_state_c40_SimulationPlantModel_Luenberg(S, st);
}

static void sf_opaque_terminate_c40_SimulationPlantModel_Luenberg(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_SimulationPlantModel_Luenberg_optimization_info();
    }

    finalize_c40_SimulationPlantModel_Luenberg
      ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc40_SimulationPlantModel_Luenberg
    ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c40_SimulationPlantModel_Luenberg(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c40_SimulationPlantModel_Luenberg
      ((SFc40_SimulationPlantModel_LuenbergInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c40_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_SimulationPlantModel_Luenberg_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      40);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,40,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,40,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,40);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,40,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,40,4);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=4; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 1; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,40);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(969520351U));
  ssSetChecksum1(S,(2054726545U));
  ssSetChecksum2(S,(3877610148U));
  ssSetChecksum3(S,(878042500U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c40_SimulationPlantModel_Luenberg(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c40_SimulationPlantModel_Luenberg(SimStruct *S)
{
  SFc40_SimulationPlantModel_LuenbergInstanceStruct *chartInstance;
  chartInstance = (SFc40_SimulationPlantModel_LuenbergInstanceStruct *)utMalloc
    (sizeof(SFc40_SimulationPlantModel_LuenbergInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc40_SimulationPlantModel_LuenbergInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlStart = mdlStart_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c40_SimulationPlantModel_Luenberg;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c40_SimulationPlantModel_Luenberg_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c40_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c40_SimulationPlantModel_Luenberg(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c40_SimulationPlantModel_Luenberg(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c40_SimulationPlantModel_Luenberg_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
