#ifndef __c42_SimulationPlantModel_NonlinRR_h__
#define __c42_SimulationPlantModel_NonlinRR_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c42_ResolvedFunctionInfo
#define typedef_c42_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c42_ResolvedFunctionInfo;

#endif                                 /*typedef_c42_ResolvedFunctionInfo*/

#ifndef typedef_SFc42_SimulationPlantModel_NonlinRRInstanceStruct
#define typedef_SFc42_SimulationPlantModel_NonlinRRInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c42_sfEvent;
  boolean_T c42_isStable;
  boolean_T c42_doneDoubleBufferReInit;
  uint8_T c42_is_active_c42_SimulationPlantModel_NonlinRR;
  real_T c42_omega_b;
  real_T c42_tau_f_G[3];
  real_T c42_r_f_G[3];
  real_T c42_H_G[3];
  real_T c42_D_fw_G[3];
  real_T c42_z_G[6];
  real_T c42_tau_e_G[3];
  real_T c42_GeneratorNumber;
} SFc42_SimulationPlantModel_NonlinRRInstanceStruct;

#endif                                 /*typedef_SFc42_SimulationPlantModel_NonlinRRInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c42_SimulationPlantModel_NonlinRR_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c42_SimulationPlantModel_NonlinRR_get_check_sum(mxArray *plhs[]);
extern void c42_SimulationPlantModel_NonlinRR_method_dispatcher(SimStruct *S,
  int_T method, void *data);

#endif
