#ifndef __c24_SimulationPlantModel_h__
#define __c24_SimulationPlantModel_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_SFc24_SimulationPlantModelInstanceStruct
#define typedef_SFc24_SimulationPlantModelInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c24_sfEvent;
  boolean_T c24_isStable;
  boolean_T c24_doneDoubleBufferReInit;
  uint8_T c24_is_active_c24_SimulationPlantModel;
  real_T c24_f_u_matrix[12];
  real_T c24_f_u_magnitudes[9];
  real_T c24_GeneratorNumber;
} SFc24_SimulationPlantModelInstanceStruct;

#endif                                 /*typedef_SFc24_SimulationPlantModelInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray
  *sf_c24_SimulationPlantModel_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c24_SimulationPlantModel_get_check_sum(mxArray *plhs[]);
extern void c24_SimulationPlantModel_method_dispatcher(SimStruct *S, int_T
  method, void *data);

#endif
